diff -pruN 5.4.3-1/.github/dependabot.yml 5.5.0-1/.github/dependabot.yml
--- 5.4.3-1/.github/dependabot.yml	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/.github/dependabot.yml	2024-07-24 02:21:26.000000000 +0000
@@ -1,6 +1,18 @@
 version: 2
 updates:
-  - package-ecosystem: "pip"
-    directory: "/requirements/"
+  - package-ecosystem: github-actions
+    directory: /
     schedule:
-      interval: "daily"
+      interval: weekly
+    groups:
+      github-actions:
+        patterns:
+          - '*'
+  - package-ecosystem: pip
+    directory: /requirements/
+    schedule:
+      interval: weekly
+    groups:
+      python-requirements:
+        patterns:
+          - '*'
diff -pruN 5.4.3-1/.github/workflows/release.yml 5.5.0-1/.github/workflows/release.yml
--- 5.4.3-1/.github/workflows/release.yml	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/.github/workflows/release.yml	2024-07-24 02:21:26.000000000 +0000
@@ -9,8 +9,8 @@ jobs:
   sdist:
     runs-on: ubuntu-latest
     steps:
-      - uses: actions/checkout@v3
-      - uses: actions/setup-python@v4
+      - uses: actions/checkout@v4
+      - uses: actions/setup-python@v5
         with:
           python-version: "3.11"
       - name: update pip
diff -pruN 5.4.3-1/.github/workflows/tests.yml 5.5.0-1/.github/workflows/tests.yml
--- 5.4.3-1/.github/workflows/tests.yml	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/.github/workflows/tests.yml	2024-07-24 02:21:26.000000000 +0000
@@ -21,8 +21,6 @@ jobs:
       fail-fast: false
       matrix:
         include:
-          - {python: '3.8', tox: 'py38-release'}
-          - {python: '3.8', tox: 'py38-low'}
           - {python: '3.9', tox: 'py39-release'}
           - {python: '3.9', tox: 'py39-low'}
           - {python: '3.10', tox: 'py310-release'}
@@ -43,7 +41,7 @@ jobs:
         run: |
           python -m pip install -U pip
       - name: cache pip
-        uses: actions/cache@v3
+        uses: actions/cache@v4
         with:
           path: ~/.cache/pip
           key: pip-${{ runner.os }}-${{ matrix.tox }}-${{ hashFiles('pyproject.toml') }}-${{ hashFiles('tox.ini') }}-${{ hashFiles('requirements/*.txt') }}
@@ -77,10 +75,10 @@ jobs:
         - name: update pip
           run: |
             python -m pip install -U pip
-        - name: nobabel, nowebauthn, noauthlib, async
+        - name: nobabel, nowebauthn, noauthlib, noflasksqlalchemy, async
           run: |
             pip install tox
-            tox -e nobabel,nowebauthn,noauthlib,async
+            tox -e nobabel,nowebauthn,noauthlib,noflasksqlalchemy,async
   cov:
       runs-on: ubuntu-latest
       steps:
@@ -96,10 +94,11 @@ jobs:
             pip install tox coverage
             tox -e coverage
         - name: Upload coverage to Codecov
-          uses: codecov/codecov-action@v3
+          uses: codecov/codecov-action@v4
           with:
-            fail_ci_if_error: false
+            fail_ci_if_error: true
             verbose: true
+            token: ${{ secrets.codecov_token }}
   realdb:
       runs-on: ubuntu-latest
 
@@ -121,12 +120,12 @@ jobs:
         - uses: actions/checkout@v4
         - uses: actions/setup-python@v5
           with:
-            python-version: "3.9"
+            python-version: "3.11"
         - name: update pip
           run: |
             python -m pip install -U pip
         - name: cache pip
-          uses: actions/cache@v3
+          uses: actions/cache@v4
           with:
             path: ~/.cache/pip
             key: pip-${{ runner.os }}-${{ hashFiles('pyproject.toml') }}-${{ hashFiles('tox.ini') }}-${{ hashFiles('requirements/*.txt') }}
diff -pruN 5.4.3-1/.pre-commit-config.yaml 5.5.0-1/.pre-commit-config.yaml
--- 5.4.3-1/.pre-commit-config.yaml	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/.pre-commit-config.yaml	2024-07-24 02:21:26.000000000 +0000
@@ -4,9 +4,10 @@ default_language_version:
     python: python3.11
 repos:
 -   repo: https://github.com/pre-commit/pre-commit-hooks
-    rev: v4.5.0
+    rev: v4.6.0
     hooks:
     -   id: trailing-whitespace
+    -   id: debug-statements
     -   id: end-of-file-fixer
     -   id: check-yaml
     -   id: check-added-large-files
@@ -14,16 +15,16 @@ repos:
     -   id: check-merge-conflict
     -   id: fix-byte-order-marker
 -   repo: https://github.com/asottile/pyupgrade
-    rev: v3.15.1
+    rev: v3.16.0
     hooks:
     -   id: pyupgrade
-        args: [--py38-plus]
+        args: [--py39-plus]
 -   repo: https://github.com/psf/black
-    rev: 24.3.0
+    rev: 24.4.2
     hooks:
     -   id: black
 -   repo: https://github.com/pycqa/flake8
-    rev: 7.0.0
+    rev: 7.1.0
     hooks:
       - id: flake8
         additional_dependencies:
diff -pruN 5.4.3-1/CHANGES.rst 5.5.0-1/CHANGES.rst
--- 5.4.3-1/CHANGES.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/CHANGES.rst	2024-07-24 02:21:26.000000000 +0000
@@ -3,6 +3,53 @@ Flask-Security Changelog
 
 Here you can see the full list of changes between each Flask-Security release.
 
+Version 5.5.0
+-------------
+
+Released July 24, 2024
+
+Features & Improvements
++++++++++++++++++++++++
+- (:issue:`956`) Add support for changing registered user's email (:py:data:`SECURITY_CHANGE_EMAIL`).
+- (:issue:`944`) Change default password hash to argon2 (was bcrypt). See below for details.
+- (:pr:`990`) Add freshness capability to auth tokens (enables /us-setup to function w/ just auth tokens).
+- (:pr:`991`) Add support to /tf-setup to not require sessions (use a state token).
+- (:issue:`994`) Add support for Flask-SQLAlchemy-Lite - including new all-inclusive models
+  that conform to sqlalchemy latest best-practice (type-annotated).
+- (:pr:`1007`) Convert other sqlalchemy-based datastores from legacy 'model.query' to best-practice 'select'
+- (:issue:`983`) Allow applications more flexibility defining allowable redirects.
+
+Fixes
++++++
+- (:pr:`972`) Set :py:data:`SECURITY_CSRF_COOKIE` at beginning (GET /login) of authentication
+  ritual - just as we return the CSRF token. (thanks @e-goto)
+- (:issue:`973`) login and unified sign in should handle GET for authenticated user consistently.
+- (:pr:`995`) Don't show sms options if not defined in US_ENABLED_METHODS. (fredipevcin)
+- (:pr:`1009`) Change :py:data:`SECURITY_DEPRECATED_HASHING_SCHEMES` to ``["auto"]``.
+
+Docs and Chores
++++++++++++++++
+- (:pr:`979`) Update Russian translations (ademaro)
+- (:pr:`1004`) Update ES and IT translations (gissimo)
+- (:pr:`981` and :pr:`977`) Improve docs
+- (:pr:`992`) The long deprecated `get_token_status` is no longer exported
+- (:pr:`992`) Drop Python 3.8 support.
+- (:issue:`1001`) Try a different approach to typing User and Role models.
+
+Backwards Compatibility Concerns
++++++++++++++++++++++++++++++++++
+- Notes around the change to argon2 as the default password hash:
+    - applications should add the argon2_cffi package to their requirements (it is included in the flask_security[common] extras).
+    - leave bcrypt installed so that old passwords still work.
+    - the default configuration will re-hash passwords with argon2 upon first use.
+- Changes to /tf-setup
+    The old path - using state set in the session still works as before. The new path is
+    just for the case an authenticated user wants to change their 2FA setup.
+- Changes to sqlalchemy-based datastores
+    Flask-Security no longer uses the legacy model.query - all DB access is done via
+    `select(xx).where(xx)`. As a result the find_user() method now only takes a SINGLE
+    column:value from its kwargs - in prior releases all kwargs were passed into the query.filter.
+
 Version 5.4.3
 -------------
 
@@ -11,10 +58,10 @@ Released March 23, 2024
 Fixes
 +++++
 - (:issue:`950`) Regression - some templates no longer getting correct config (thanks pete7863).
-- (:issue:`954`) CSRF not properly ignored for application forms using SECURITY_CSRF_PROTECT_MECHANISMS.
+- (:issue:`954`) CSRF not properly ignored for application forms using :py:data:`SECURITY_CSRF_PROTECT_MECHANISMS`.
 - (:pr:`957`) Improve jp translations (e-goto)
 - (:issue:`959`) Regression - datetime_factory should still be an attribute (thanks TimotheeJeannin)
-- (:issue:`942`) GENERIC_RESPONSES hide email validation/syntax errors.
+- (:issue:`942`) :py:data:`SECURITY_RETURN_GENERIC_RESPONSES` hid email validation/syntax errors.
 
 Version 5.4.2
 -------------
@@ -111,7 +158,7 @@ Backwards Compatibility Concerns
     - Flask-Login's FORCE_HOST_FOR_REDIRECTS configuration isn't honored
     - Flask-Login's USE_SESSION_FOR_NEXT configuration isn't honored
     - The flashed message is SECURITY_MSG_UNAUTHENTICATED rather than SECURITY_MSG_LOGIN.
-      Furthermore SECURITY_MSG_UNAUTHENTICATED was reworded to read better.
+      Furthermore, SECURITY_MSG_UNAUTHENTICATED was reworded to read better.
     - Flask-Login uses `urlencode` to encode the `next` query param - which quotes the '/' character.
       Werkzeug (which Flask-Security uses to build the URL) uses `quote`
       which considers '/' a safe character and isn't encoded.
@@ -129,7 +176,7 @@ Backwards Compatibility Concerns
   Flask-Security now changes any `None` key to `""`.
 - The default unauthorized handler behavior has changed slightly and is now documented. The default
   (:data:`SECURITY_UNAUTHORIZED_VIEW` == ``None``) has not changed (a default HTTP 403 response).
-  The precise behavior when :data:`SECURITY_UNAUTHORIZED_VIEW` was set was never documented.
+  The precise behavior when :data:`SECURITY_UNAUTHORIZED_VIEW` is set was never documented.
   The important change is that Flask-Security no longer ever looks at the request.referrer header and
   will never redirect to it. If an application needs that, it can provide a callable that can return
   that or any other header.
@@ -954,7 +1001,7 @@ Released March 31, 2020
 
 Features
 ++++++++
-- (:pr:`257`) Support a unified sign in feature. Please see :ref:`unified-sign-in`.
+- (:pr:`257`) Support a unified sign in feature. Please see :ref:`configuration:unified signin`.
 - (:pr:`265`) Add phone number validation class. This is used in both unified sign in
   as well as two-factor when using ``sms``.
 - (:pr:`274`) Add support for 'freshness' of caller's authentication. This permits endpoints
diff -pruN 5.4.3-1/README.rst 5.5.0-1/README.rst
--- 5.4.3-1/README.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/README.rst	2024-07-24 02:21:26.000000000 +0000
@@ -40,7 +40,7 @@ version of the `Original <https://github
 Goals
 +++++
 * Regain momentum for this critical piece of the Flask eco-system. To that end the
-  the plan is to put out small, frequent releases starting with pulling the simplest
+  plan is to put out small, frequent releases starting with pulling the simplest
   and most obvious changes that have already been vetted in the upstream version, as
   well as other pull requests. This was completed with the June 29 2019 3.2.0 release.
 * Continue work to get Flask-Security to be usable from Single Page Applications,
@@ -56,7 +56,7 @@ Goals
     * WebAuthn support (5.0)
     * Two-Factor recovery codes (5.0)
     * First-class support for username as identity (4.1)
-    * Support for fresheness decorator to ensure sensitive operations have new authentication (4.0)
+    * Support for freshness decorator to ensure sensitive operations have new authentication (4.0)
     * Support for email normalization and validation (4.0)
     * Unified signin (username, phone, passwordless) feature (3.4)
 
diff -pruN 5.4.3-1/debian/changelog 5.5.0-1/debian/changelog
--- 5.4.3-1/debian/changelog	2024-03-27 18:38:08.000000000 +0000
+++ 5.5.0-1/debian/changelog	2024-07-26 11:15:00.000000000 +0000
@@ -1,3 +1,14 @@
+flask-security (5.5.0-1) unstable; urgency=medium
+
+  * Team upload.
+  * [31a96f5] New upstream version 5.5.0
+  * [3312cc5] Rebuild patch queue from patch-queue branch
+    Updated patch:
+    docs-Use-local-Python-intersphinx-inventary.patch
+  * [149b03c] d/control: Add python3-sqlalchemy to Build-Depends
+
+ -- Carsten Schoenert <c.schoenert@t-online.de>  Fri, 26 Jul 2024 20:15:00 +0900
+
 flask-security (5.4.3-1) unstable; urgency=medium
 
   * Team upload.
diff -pruN 5.4.3-1/debian/control 5.5.0-1/debian/control
--- 5.4.3-1/debian/control	2024-03-01 20:00:39.000000000 +0000
+++ 5.5.0-1/debian/control	2024-07-26 11:10:36.000000000 +0000
@@ -46,6 +46,7 @@ Build-Depends:
  python3-setuptools,
  python3-sphinx <!nodoc>,
  python3-sphinx-issues <!nodoc>,
+ python3-sqlalchemy <!nodoc>,
 Rules-Requires-Root: no
 Standards-Version: 4.6.2
 Homepage: https://github.com/Flask-Middleware/flask-security
diff -pruN 5.4.3-1/debian/patches/d-conf.py-Add-a-trailing-whitespace-to-copyright-fields.patch 5.5.0-1/debian/patches/d-conf.py-Add-a-trailing-whitespace-to-copyright-fields.patch
--- 5.4.3-1/debian/patches/d-conf.py-Add-a-trailing-whitespace-to-copyright-fields.patch	2024-03-01 19:58:37.000000000 +0000
+++ 5.5.0-1/debian/patches/d-conf.py-Add-a-trailing-whitespace-to-copyright-fields.patch	2024-07-26 11:01:41.000000000 +0000
@@ -37,10 +37,10 @@ def _substitute_copyright_year(copyright
  1 file changed, 1 insertion(+), 1 deletion(-)
 
 diff --git a/docs/conf.py b/docs/conf.py
-index 9d7b855..af99b78 100644
+index 4b725c2..b4fd745 100644
 --- a/docs/conf.py
 +++ b/docs/conf.py
-@@ -50,7 +50,7 @@ master_doc = "index"
+@@ -51,7 +51,7 @@ master_doc = "index"
  
  # General information about the project.
  project = "Flask-Security"
diff -pruN 5.4.3-1/debian/patches/docs-Use-local-Python-intersphinx-inventary.patch 5.5.0-1/debian/patches/docs-Use-local-Python-intersphinx-inventary.patch
--- 5.4.3-1/debian/patches/docs-Use-local-Python-intersphinx-inventary.patch	2024-03-01 19:58:37.000000000 +0000
+++ 5.5.0-1/debian/patches/docs-Use-local-Python-intersphinx-inventary.patch	2024-07-26 11:01:41.000000000 +0000
@@ -5,17 +5,19 @@ Subject: docs: Use local Python intersph
 The package src:python-passlib isn't providing a -doc package, so we
 can't reference to some local inventary.
 
+flask-sqlalchemy-lite isn't existing Debian.
+
 Forwarded: Not-Needed
 ---
- docs/conf.py | 22 +++++++++++-----------
- 1 file changed, 11 insertions(+), 11 deletions(-)
+ docs/conf.py | 30 +++++++++++++++---------------
+ 1 file changed, 15 insertions(+), 15 deletions(-)
 
 diff --git a/docs/conf.py b/docs/conf.py
-index 25c9371..9d7b855 100644
+index a1779f3..4b725c2 100644
 --- a/docs/conf.py
 +++ b/docs/conf.py
-@@ -116,17 +116,17 @@ autodoc_type_aliases = {
- }
+@@ -119,21 +119,21 @@ autosectionlabel_prefix_document = True
+ autosectionlabel_maxdepth = 2
  
  intersphinx_mapping = {
 -    "python": ("https://docs.python.org/3/", None),
@@ -26,6 +28,10 @@ index 25c9371..9d7b855 100644
 -    "wtforms": ("https://wtforms.readthedocs.io/", None),
 -    "flask_wtforms": ("https://flask-wtf.readthedocs.io", None),
 -    "flask_sqlalchemy": ("https://flask-sqlalchemy.palletsprojects.com/", None),
+-    "flask_sqlalchemy_lite": (
+-        "https://flask-sqlalchemy-lite.readthedocs.io/en/latest/",
+-        None,
+-    ),
 -    "flask_login": ("https://flask-login.readthedocs.io/en/latest/", None),
 -    "passlib": ("https://passlib.readthedocs.io/en/stable", None),
 -    "authlib": ("https://docs.authlib.org/en/latest/", None),
@@ -37,6 +43,10 @@ index 25c9371..9d7b855 100644
 +    "wtforms": ("/usr/share/doc/python-wtforms-doc/html", None),
 +    "flask_wtforms": ("/usr/share/doc/python-flaskext.wtf-doc/html", None),
 +    "flask_sqlalchemy": ("/usr/share/doc/flask-sqlalchemy-doc/html", None),
++#    "flask_sqlalchemy_lite": (
++#        "https://flask-sqlalchemy-lite.readthedocs.io/en/latest/",
++#        None,
++#    ),
 +    "flask_login": ("/usr/share/doc/python-flask-login-doc/html", None),
 +#    "passlib": ("https://passlib.readthedocs.io/en/stable", None),
 +    "authlib": ("/usr/share/doc/python-authlib-doc/html", None),
diff -pruN 5.4.3-1/docs/api.rst 5.5.0-1/docs/api.rst
--- 5.4.3-1/docs/api.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/api.rst	2024-07-24 02:21:26.000000000 +0000
@@ -65,6 +65,9 @@ Datastores
 .. autoclass:: flask_security.SQLAlchemyUserDatastore
     :show-inheritance:
 
+.. autoclass:: flask_security.FSQLALiteUserDatastore
+    :show-inheritance:
+
 .. autoclass:: flask_security.SQLAlchemySessionUserDatastore
     :show-inheritance:
 
@@ -112,6 +115,8 @@ Packaged Models
 ---------------
 .. autoclass:: flask_security.models.fsqla.FsModels
    :members:
+.. autoclass:: flask_security.models.sqla.FsModels
+   :members:
 
 Utils
 -----
@@ -223,6 +228,7 @@ Security() instantiation.
 Forms
 -----
 
+.. autoclass:: flask_security.ChangeEmailForm
 .. autoclass:: flask_security.ChangePasswordForm
 .. autoclass:: flask_security.ConfirmRegisterForm
 .. autoclass:: flask_security.ForgotPasswordForm
@@ -336,6 +342,20 @@ sends the following signals.
    Sent when a user requests a password reset. In addition to the app (which is
    the sender), it is passed `user`, `token` (deprecated), and `reset_token` arguments.
 
+.. data:: change_email_instructions_sent
+
+    Sent when a user requests to change their registered email address. In addition to the
+    app (which is the sender) it is passed `user`, `token`, and `new_email`.
+
+    .. versionadded:: 5.5.0
+
+.. data:: change_email_confirmed
+
+    Sent when a user has confirmed their new email address. In addition to the
+    app (which is the sender) it is passed `user`, `old_email`.
+
+    .. versionadded:: 5.5.0
+
 .. data:: tf_code_confirmed
 
     Sent when a user performs two-factor authentication login on the site. In
diff -pruN 5.4.3-1/docs/conf.py 5.5.0-1/docs/conf.py
--- 5.4.3-1/docs/conf.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/conf.py	2024-07-24 02:21:26.000000000 +0000
@@ -33,6 +33,7 @@ extensions = [
     "pallets_sphinx_themes",
     "sphinx.ext.autodoc",
     "sphinx.ext.intersphinx",
+    "sphinx.ext.autosectionlabel",
     "sphinx_issues",
 ]
 
@@ -114,6 +115,8 @@ autodoc_typehints = "description"
 autodoc_type_aliases = {
     "CbType": "oauth_provider.CbType",
 }
+autosectionlabel_prefix_document = True
+autosectionlabel_maxdepth = 2
 
 intersphinx_mapping = {
     "python": ("https://docs.python.org/3/", None),
@@ -124,6 +127,10 @@ intersphinx_mapping = {
     "wtforms": ("https://wtforms.readthedocs.io/", None),
     "flask_wtforms": ("https://flask-wtf.readthedocs.io", None),
     "flask_sqlalchemy": ("https://flask-sqlalchemy.palletsprojects.com/", None),
+    "flask_sqlalchemy_lite": (
+        "https://flask-sqlalchemy-lite.readthedocs.io/en/latest/",
+        None,
+    ),
     "flask_login": ("https://flask-login.readthedocs.io/en/latest/", None),
     "passlib": ("https://passlib.readthedocs.io/en/stable", None),
     "authlib": ("https://docs.authlib.org/en/latest/", None),
@@ -175,7 +182,7 @@ html_static_path = ["_static", "openapi.
 # Custom sidebar templates, maps document names to template names.
 html_sidebars = {
     "index": ["project.html", "localtoc.html", "searchbox.html"],
-    "**": ["localtoc.html", "relations.html", "searchbox.html"],
+    "**": ["relations.html", "searchbox.html", "localtoc.html"],
 }
 singlehtml_sidebars = {"index": ["project.html", "localtoc.html"]}
 
diff -pruN 5.4.3-1/docs/configuration.rst 5.5.0-1/docs/configuration.rst
--- 5.4.3-1/docs/configuration.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/configuration.rst	2024-07-24 02:21:26.000000000 +0000
@@ -54,7 +54,9 @@ These configuration keys are used global
     Default: ``None``.
 .. py:data:: SECURITY_FLASH_MESSAGES
 
-    Specifies whether or not to flash messages during security procedures.
+    Specifies whether or not to flash messages for actions certain endpoint perform.
+    Normally Flash-Security views will flash informational or error messages only when the operation
+    results in a redirect.
 
     Default: ``True``.
 .. py:data:: SECURITY_I18N_DOMAIN
@@ -75,135 +77,6 @@ These configuration keys are used global
         "builtin" is a special name which will be interpreted as the ``translations``
         directory within the installation of Flask-Security.
 
-.. py:data:: SECURITY_PASSWORD_HASH
-
-    Specifies the password hash algorithm to use when hashing passwords.
-    Recommended values for production systems are ``bcrypt``, ``argon2``, ``sha512_crypt``, or
-    ``pbkdf2_sha512``. Some algorithms require the installation  of a backend package (e.g. `bcrypt`_, `argon2`_).
-
-    Default: ``"bcrypt"``.
-
-.. py:data:: SECURITY_PASSWORD_SCHEMES
-
-    List of support password hash algorithms. ``SECURITY_PASSWORD_HASH``
-    must be from this list. Passwords encrypted with any of these schemes will be honored.
-
-.. py:data:: SECURITY_DEPRECATED_PASSWORD_SCHEMES
-
-    List of password hash algorithms that are considered weak and
-    will be accepted, however on first use, will be re-hashed to the current
-    setting of ``SECURITY_PASSWORD_HASH``.
-
-    Default: ``["auto"]`` which means any password found that wasn't
-    hashed using ``SECURITY_PASSWORD_HASH`` will be re-hashed.
-
-.. py:data:: SECURITY_PASSWORD_SALT
-
-    Specifies the HMAC salt. This is required for all schemes that
-    are configured for double hashing. A good salt can be generated using:
-    ``secrets.SystemRandom().getrandbits(128)``.
-
-    Default: ``None``.
-
-.. py:data:: SECURITY_PASSWORD_SINGLE_HASH
-
-    A list of schemes that should not be hashed twice. By default, passwords are
-    hashed twice, first with ``SECURITY_PASSWORD_SALT``, and then with a random salt.
-
-    Default: a list of known schemes not working with double hashing (`django_{digest}`, `plaintext`).
-
-.. py:data:: SECURITY_HASHING_SCHEMES
-
-    List of algorithms used for encrypting/hashing sensitive data within a token
-    (Such as is sent with confirmation or reset password).
-
-    Default: ``["sha256_crypt", "hex_md5"]``.
-.. py:data:: SECURITY_DEPRECATED_HASHING_SCHEMES
-
-    List of deprecated algorithms used for creating and validating tokens.
-
-    Default: ``["hex_md5"]``.
-
-.. py:data:: SECURITY_PASSWORD_HASH_OPTIONS
-
-    Specifies additional options to be passed to the hashing method. This is deprecated as of passlib 1.7.
-
-    .. deprecated:: 3.4.0 see: :py:data:`SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS`
-
-.. py:data:: SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS
-
-    Pass additional options to the various hashing methods. This is a
-    dict of the form ``{<scheme>__<option>: <value>, ..}``
-    e.g. {"argon2__rounds": 10}.
-
-    .. versionadded:: 3.3.1
-
-.. py:data:: SECURITY_PASSWORD_LENGTH_MIN
-
-    Minimum required length for passwords.
-
-    Default: ``8``
-
-    .. versionadded:: 3.4.0
-.. py:data:: SECURITY_PASSWORD_COMPLEXITY_CHECKER
-
-    Set to complexity checker to use (Only ``zxcvbn`` supported).
-
-    Default: ``None``
-
-    .. versionadded:: 3.4.0
-.. py:data:: SECURITY_ZXCVBN_MINIMUM_SCORE
-
-    Required ``zxcvbn`` password complexity score (0-4).
-    Refer to https://github.com/dropbox/zxcvbn#usage for exact meanings of
-    different score values.
-
-    Default: ``3`` (Good or Strong)
-
-    .. versionadded:: 5.0.0
-.. py:data:: SECURITY_PASSWORD_CHECK_BREACHED
-
-    If not ``None`` new/changed passwords will be checked against the
-    database of breached passwords at https://api.pwnedpasswords.com.
-    If set to ``strict`` then if the site can't be reached, validation will fail.
-    If set to ``best-effort`` failure to reach the site will continue
-    with the rest of password validation.
-
-    Default: ``None``
-
-    .. versionadded:: 3.4.0
-.. py:data:: SECURITY_PASSWORD_BREACHED_COUNT
-
-    Passwords with counts greater than or equal to this value are considered breached.
-
-    Default: 1  - which might be to burdensome for some applications.
-
-    .. versionadded:: 3.4.0
-
-.. py:data:: SECURITY_PASSWORD_NORMALIZE_FORM
-
-    Passwords are normalized prior to changing or comparing. This satisfies
-    the NIST requirement: `5.1.1.2 Memorized Secret Verifiers`_.
-    Normalization is performed using the Python unicodedata.normalize() method.
-
-    Default: ``"NFKD"``
-
-    .. versionadded:: 4.0.0
-
-.. _5.1.1.2 Memorized Secret Verifiers: https://pages.nist.gov/800-63-3/sp800-63b.html#sec5
-
-.. py:data:: SECURITY_PASSWORD_REQUIRED
-
-    If set to ``False`` then a user can register with an empty password.
-    This requires :py:data:`SECURITY_UNIFIED_SIGNIN` to be enabled. By
-    default, the user will be able to authenticate using an email link.
-    Please note: this does not mean a user can sign in with an empty
-    password - it means that they must have some OTHER means of authenticating.
-
-    Default: ``True``
-
-    .. versionadded:: 5.0.0
-
 .. py:data:: SECURITY_TOKEN_AUTHENTICATION_KEY
 
     Specifies the query string parameter to read when using token authentication.
@@ -268,7 +141,7 @@ These configuration keys are used global
 
 .. py:data:: SECURITY_REDIRECT_BEHAVIOR
 
-    Passwordless login, confirmation, reset password, unified signin, and oauth signin
+    Passwordless login, confirmation, reset password, unified signin, change_email, and oauth signin
     have GET endpoints that validate the passed token and redirect to an action form.
     For Single-Page-Applications style UIs which need to control their own internal URL routing these redirects
     need to not contain forms, but contain relevant information as query parameters.
@@ -279,6 +152,8 @@ These configuration keys are used global
     - :py:data:`SECURITY_POST_OAUTH_LOGIN_VIEW`  (if :py:data:`SECURITY_OAUTH_ENABLE` is True)
     - :py:data:`SECURITY_LOGIN_ERROR_VIEW`
     - :py:data:`SECURITY_CONFIRM_ERROR_VIEW`
+    - :py:data:`SECURITY_POST_CHANGE_EMAIL_VIEW`
+    - :py:data:`SECURITY_CHANGE_EMAIL_ERROR_VIEW`
     - :py:data:`SECURITY_POST_CONFIRM_VIEW`
     - :py:data:`SECURITY_RESET_ERROR_VIEW`
     - :py:data:`SECURITY_RESET_VIEW`
@@ -307,13 +182,41 @@ These configuration keys are used global
 
     If ``True`` then subdomains (and the root domain) of the top-level host set
     by Flask's ``SERVER_NAME`` configuration will be allowed as post-view redirect targets.
-    This is beneficial if you wish to place your authentiation on one subdomain and
+    This is beneficial if you wish to place your authentication on one subdomain and
     authenticated content on another, for example ``auth.domain.tld`` and ``app.domain.tld``.
 
     Default: ``False``.
 
     .. versionadded:: 4.0.0
 
+.. py:data:: SECURITY_REDIRECT_BASE_DOMAIN
+
+    Set the base domain for checking allowable redirects. The intent here is to
+    allow an application to be server on e.g. "flaskapp.my.org" and redirect
+    to "myservice.my.org" (which maybe isn't a Flask app). Flask's SERVER_NAME
+    can't be used to verify redirects in this case. Note that in most cases
+    the application will want to set Flask's SESSION_COOKIE_DOMAIN to be this base domain -
+    otherwise authorization information won't be sent.
+
+    Default: ``None``
+
+    .. versionadded:: 5.5.0
+
+.. py:data:: SECURITY_REDIRECT_ALLOWED_SUBDOMAINS
+
+    A list of subdomains. Each will be prepended to
+    ``SECURITY_REDIRECT_BASE_DOMAIN`` and checked against the requested redirect.
+
+    Default: ``[]``
+
+    .. versionadded:: 5.5.0
+
+
+.. note::
+    The above 4 config options apply BOTH to the handling of ``next`` parameter
+    as well as all the ``XXX_VIEW`` URL configuration options
+    for those views that perform a redirect after processing.
+
 .. py:data:: SECURITY_CSRF_PROTECT_MECHANISMS
 
     Authentication mechanisms that require CSRF protection.
@@ -345,7 +248,7 @@ These configuration keys are used global
 
     .. versionchanged:: 4.1.0
         The 'key' attribute was deprecated in favor of a separate configuration
-        variable ``SECURITY_CSRF_COOKIE_NAME``.
+        variable :data:`SECURITY_CSRF_COOKIE_NAME`.
 
 .. py:data:: SECURITY_CSRF_HEADER
 
@@ -383,7 +286,7 @@ These configuration keys are used global
     Mapping functions take a single argument - ``identity`` from the form
     and should return ``None`` if the ``identity`` argument isn't in a format
     suitable for the attribute. If the ``identity`` argument format matches, it
-    should be returned, optionally having had some canonicalization performed.
+    should be returned, optionally having had some normalization performed.
     The returned result will be used to look up the identity in the UserDataStore
     using the column name specified in the key.
 
@@ -391,7 +294,7 @@ These configuration keys are used global
     phone number normalization using the ``phonenumbers`` package.
 
     .. tip::
-        If your mapper performs any sort of canonicalization/normalization,
+        If your mapper performs any sort of normalization,
         make sure you apply the exact same transformation in your form validator
         when setting the field.
 
@@ -463,6 +366,210 @@ These configuration keys are used global
 
     .. versionadded:: 5.0.0
 
+.. py:data:: SECURITY_FRESHNESS
+
+    A timedelta used to protect endpoints that alter sensitive information.
+    This is used to protect the following endpoints:
+
+        - :py:data:`SECURITY_US_SETUP_URL`
+        - :py:data:`SECURITY_TWO_FACTOR_SETUP_URL`
+        - :py:data:`SECURITY_WAN_REGISTER_URL`
+        - :py:data:`SECURITY_WAN_DELETE_URL`
+        - :py:data:`SECURITY_MULTI_FACTOR_RECOVERY_CODES`
+        - :py:data:`SECURITY_CHANGE_EMAIL_URL`
+
+    Setting this to a negative number will disable any freshness checking and
+    the endpoints:
+
+        - :py:data:`SECURITY_VERIFY_URL`
+        - :py:data:`SECURITY_US_VERIFY_URL`
+        - :py:data:`SECURITY_US_VERIFY_SEND_CODE_URL`
+        - :py:data:`SECURITY_WAN_VERIFY_URL`
+
+    won't be registered.
+    Setting this to 0 results in undefined behavior.
+    Please see :meth:`flask_security.check_and_update_authn_fresh` for details.
+
+    .. note::
+        The timestamp of when the caller/user last successfully authenticated is
+        stored in the session as well as authentication token.
+
+    Default: timedelta(hours=24)
+
+    .. versionadded:: 3.4.0
+
+.. py:data:: SECURITY_FRESHNESS_GRACE_PERIOD
+
+    A timedelta that provides a grace period when altering sensitive
+    information. This ensures that multi-step operations don't get denied
+    because the session/token happens to expire mid-step.
+
+    Note that this is not implemented for freshness information carried in the
+    auth token.
+
+    N.B. To avoid strange behavior, be sure to set the grace period less than
+    the freshness period.
+    Please see :meth:`flask_security.check_and_update_authn_fresh` for details.
+
+    Default: timedelta(hours=1)
+
+    .. versionadded:: 3.4.0
+
+.. py:data:: SECURITY_FRESHNESS_ALLOW_AUTH_TOKEN
+
+    Controls whether the freshness data set in the auth token can be used to
+    satisfy freshness checks. Some applications might want to force freshness
+    protected endpoints to always use browser based access with sessions - they
+    should set this to ``False``.
+
+    Default: ``True``
+
+
+    .. versionadded:: 5.5.0
+
+Core - Passwords and Tokens
+----------------------------
+.. py:data:: SECURITY_PASSWORD_HASH
+
+    Specifies the password hash algorithm to use when hashing passwords.
+    Recommended values for production systems are ``argon2``, ``bcrypt``, or
+    ``pbkdf2_sha512``. Some algorithms require the installation  of a backend package (e.g. `bcrypt`_, `argon2`_).
+
+    Default: ``"argon2"``.
+
+    .. versionchanged:: 5.5.0
+        Default changed from ``bcrypt`` to ``argon2``.
+
+.. py:data:: SECURITY_PASSWORD_SCHEMES
+
+    List of supported password hash algorithms. ``SECURITY_PASSWORD_HASH``
+    must be from this list. Passwords encrypted with any of these schemes will be honored.
+    This is passed directly to `passlib's CryptoContext`_.
+
+.. py:data:: SECURITY_DEPRECATED_PASSWORD_SCHEMES
+
+    List of password hash algorithms that are considered weak and
+    will be accepted, however on first use, will be re-hashed to the current
+    setting of ``SECURITY_PASSWORD_HASH``.
+    This is passed directly to `passlib's CryptoContext`_.
+
+    Default: ``["auto"]`` which means any password found that wasn't
+    hashed using ``SECURITY_PASSWORD_HASH`` will be re-hashed.
+
+.. py:data:: SECURITY_PASSWORD_SALT
+
+    Specifies the HMAC salt. This is required for all schemes that
+    are configured for double hashing. A good salt can be generated using:
+    ``secrets.SystemRandom().getrandbits(128)``.
+
+    Default: ``None``.
+
+.. py:data:: SECURITY_PASSWORD_SINGLE_HASH
+
+    A list of schemes that should not be hashed twice. By default, passwords are
+    hashed twice, first with :py:data:`SECURITY_PASSWORD_SALT`, and then with a random salt.
+
+    Default: a list of known schemes not working with double hashing (`django_{digest}`, `plaintext`).
+
+.. py:data:: SECURITY_HASHING_SCHEMES
+
+    List of algorithms used for encrypting/hashing sensitive data within a token
+    (Such as is sent with confirmation or reset password).
+    This is passed directly to `passlib's CryptoContext`_.
+
+    Default: ``["sha256_crypt", "hex_md5"]``.
+.. py:data:: SECURITY_DEPRECATED_HASHING_SCHEMES
+
+    List of deprecated algorithms used for creating and validating tokens.
+    This is passed directly to `passlib's CryptoContext`_.
+
+    Default: ``["auto"]``.
+
+.. versionchanged:: 5.5.0
+        Default changed from ``hex_md5`` to ``auto``.
+
+.. py:data:: SECURITY_PASSWORD_HASH_OPTIONS
+
+    Specifies additional options to be passed to the hashing method. This is deprecated as of passlib 1.7.
+
+    .. deprecated:: 3.4.0 see: :py:data:`SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS`
+
+.. py:data:: SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS
+
+    Pass additional options through ``passlib`` to the various hashing methods.
+    This is a dict of the form ``{<scheme>__<option>: <value>, ..}``
+    e.g. {"argon2__time_cost": 3}.
+
+    Default: ``{}``
+
+    .. versionadded:: 3.3.1
+
+.. py:data:: SECURITY_PASSWORD_LENGTH_MIN
+
+    Minimum required length for passwords.
+
+    Default: ``8``
+
+    .. versionadded:: 3.4.0
+.. py:data:: SECURITY_PASSWORD_COMPLEXITY_CHECKER
+
+    Set to complexity checker to use (Only ``zxcvbn`` supported).
+
+    Default: ``None``
+
+    .. versionadded:: 3.4.0
+.. py:data:: SECURITY_ZXCVBN_MINIMUM_SCORE
+
+    Required ``zxcvbn`` password complexity score (0-4).
+    Refer to https://github.com/dropbox/zxcvbn#usage for exact meanings of
+    different score values.
+
+    Default: ``3`` (Good or Strong)
+
+    .. versionadded:: 5.0.0
+.. py:data:: SECURITY_PASSWORD_CHECK_BREACHED
+
+    If not ``None`` new/changed passwords will be checked against the
+    database of breached passwords at https://api.pwnedpasswords.com.
+    If set to ``strict`` then if the site can't be reached, validation will fail.
+    If set to ``best-effort`` failure to reach the site will continue
+    with the rest of password validation.
+
+    Default: ``None``
+
+    .. versionadded:: 3.4.0
+.. py:data:: SECURITY_PASSWORD_BREACHED_COUNT
+
+    Passwords with counts greater than or equal to this value are considered breached.
+
+    Default: 1  - which might be to burdensome for some applications.
+
+    .. versionadded:: 3.4.0
+
+.. py:data:: SECURITY_PASSWORD_NORMALIZE_FORM
+
+    Passwords are normalized prior to changing or comparing. This satisfies
+    the NIST requirement: `5.1.1.2 Memorized Secret Verifiers`_.
+    Normalization is performed using the Python unicodedata.normalize() method.
+
+    Default: ``"NFKD"``
+
+    .. versionadded:: 4.0.0
+
+.. _5.1.1.2 Memorized Secret Verifiers: https://pages.nist.gov/800-63-3/sp800-63b.html#sec5
+
+.. py:data:: SECURITY_PASSWORD_REQUIRED
+
+    If set to ``False`` then a user can register with an empty password.
+    This requires :py:data:`SECURITY_UNIFIED_SIGNIN` to be enabled. By
+    default, the user will be able to authenticate using an email link.
+    Please note: this does not mean a user can sign in with an empty
+    password - it means that they must have some OTHER means of authenticating.
+
+    Default: ``True``
+
+    .. versionadded:: 5.0.0
+
 Core - Multi-factor
 -------------------
 These are used by the Two-Factor and Unified Signin features.
@@ -523,56 +630,6 @@ These are used by the Two-Factor and Uni
 
     .. versionadded:: 3.4.0
 
-.. py:data:: SECURITY_FRESHNESS
-
-    A timedelta used to protect endpoints that alter sensitive information.
-    This is used to protect the following endpoints:
-
-        - :py:data:`SECURITY_US_SETUP_URL`
-        - :py:data:`SECURITY_TWO_FACTOR_SETUP_URL`
-        - :py:data:`SECURITY_WAN_REGISTER_URL`
-        - :py:data:`SECURITY_MULTI_FACTOR_RECOVERY_CODES`
-
-    Setting this to a negative number will disable any freshness checking and
-    the endpoints:
-
-        - :py:data:`SECURITY_VERIFY_URL`
-        - :py:data:`SECURITY_US_VERIFY_URL`
-        - :py:data:`SECURITY_US_VERIFY_SEND_CODE_URL`
-        - :py:data:`SECURITY_WAN_VERIFY_URL`
-
-    won't be registered.
-    Setting this to 0 results in undefined behavior.
-    Please see :meth:`flask_security.check_and_update_authn_fresh` for details.
-
-    .. note::
-        This stores freshness information in the session - which must be presented
-        (usually via a Cookie) to the above endpoints. To disable this, set it
-        to ``timedelta(minutes=-1)``
-
-    Default: timedelta(hours=24)
-
-    .. versionadded:: 3.4.0
-
-.. py:data:: SECURITY_FRESHNESS_GRACE_PERIOD
-
-    A timedelta that provides a grace period when altering sensitive
-    information.
-    This is used to protect the endpoints:
-
-        - :py:data:`SECURITY_US_SETUP_URL`
-        - :py:data:`SECURITY_TWO_FACTOR_SETUP_URL`
-        - :py:data:`SECURITY_WAN_REGISTER_URL`
-        - :py:data:`SECURITY_MULTI_FACTOR_RECOVERY_CODES`
-
-    N.B. To avoid strange behavior, be sure to set the grace period less than
-    the freshness period.
-    Please see :meth:`flask_security.check_and_update_authn_fresh` for details.
-
-    Default: timedelta(hours=1)
-
-    .. versionadded:: 3.4.0
-
 Core - Compatibility
 ---------------------
 These are flags that change various backwards compatability functionality.
@@ -651,6 +708,14 @@ Core - rarely need changing
 .. py:data:: SECURITY_WAN_SALT
 
     Default: ``"wan-salt"``
+.. py:data:: SECURITY_TWO_FACTOR_SETUP_SALT
+
+    Default: ``"tf-setup-salt"``
+.. py:data:: SECURITY_EMAIL_CHANGE_SALT
+
+    Specifies the salt value when generating change email confirmation links/tokens.
+
+    Default: ``"change-email-salt"``.
 
 .. py:data:: SECURITY_EMAIL_PLAINTEXT
 
@@ -803,7 +868,7 @@ Registerable
 
     Specifies the view to redirect to after a user successfully registers.
     This value can be set to a URL or an endpoint name. If this value is
-    ``None``, the user is redirected to the value of ``SECURITY_POST_LOGIN_VIEW``.
+    ``None``, the user is redirected to the value of :data:`SECURITY_POST_LOGIN_VIEW`.
     Note that if the request URL or form has a ``next`` parameter, that will take precedence.
 
     Default: ``None``.
@@ -820,6 +885,13 @@ Registerable
     a username field added. This requires that your user model contain the
     field ``username``. It MUST be set as 'unique' and if you don't want
     to require a username, it should be set as 'nullable'.
+    The form validators will call :meth:`.UsernameUtil.validate`.
+
+    In addition, :data:`SECURITY_USER_IDENTITY_ATTRIBUTES` will be updated to include::
+
+        {"username": {"mapper": uia_username_mapper}, "case_insensitive": True}
+
+    See :meth:`flask_security.uia_username_mapper` for details.
 
     If you already have added a username field to your forms, don't set this
     option - the system will throw an exception at init_app time.
@@ -902,7 +974,7 @@ Confirmable
     Specifies the view to redirect to if a confirmation error occurs.
     This value can be set to a URL or an endpoint name.
     If this value is ``None``, the user is presented the default view
-    to resend a confirmation link. In the case of ``SECURITY_REDIRECT_BEHAVIOR`` == ``"spa"``
+    to resend a confirmation link. In the case of :py:data:`SECURITY_REDIRECT_BEHAVIOR` == ``"spa"``
     query params in the redirect will contain the error.
 
     Default: ``None``.
@@ -910,14 +982,14 @@ Confirmable
 
     Specifies the view to redirect to after a user successfully confirms their email.
     This value can be set to a URL or an endpoint name. If this value is ``None``, the user is redirected to the
-    value of ``SECURITY_POST_LOGIN_VIEW``.
+    value of :data:`SECURITY_POST_LOGIN_VIEW`.
 
     Default: ``None``.
 .. py:data:: SECURITY_AUTO_LOGIN_AFTER_CONFIRM
 
     If ``True``, then the user corresponding to the confirmation token will be automatically signed in.
-    If ``False`` (the default) then the user will be requires to authenticate using the usual mechanism(s).
-    Note that the confirmation token is not valid after being used once. This is not recommended by OWASP
+    If ``False`` (the default) then the user will be required to authenticate using the usual mechanism(s).
+    Note that the confirmation token is single-use. This is not recommended by OWASP
     however an application that is by invite only (no self-registration) might find this useful.
 
     Default: ``False``.
@@ -925,7 +997,7 @@ Confirmable
 .. py:data:: SECURITY_LOGIN_WITHOUT_CONFIRMATION
 
     Specifies if a user may login before confirming their email when
-    the value of ``SECURITY_CONFIRMABLE`` is set to ``True``.
+    the value of :data:`SECURITY_CONFIRMABLE` is set to ``True``.
 
     Default: ``False``.
 .. py:data:: SECURITY_REQUIRES_CONFIRMATION_ERROR_VIEW
@@ -955,7 +1027,7 @@ Configuration variables for the ``SECURI
     Specifies the view to redirect to after a user successfully changes their password.
     This value can be set to a URL or an endpoint name.
     If this value is ``None``, the user is redirected  to the
-    value of ``SECURITY_POST_LOGIN_VIEW``.
+    value of :data:`SECURITY_POST_LOGIN_VIEW`.
 
     Default: ``None``.
 .. py:data:: SECURITY_CHANGE_PASSWORD_TEMPLATE
@@ -1076,6 +1148,66 @@ Recoverable
 
     Default: ``_("Your password has been reset")``.
 
+Change-Email
+------------
+.. versionadded:: 5.5.0
+
+.. py:data:: SECURITY_CHANGE_EMAIL
+
+    It ``True`` an endpoint is created that allows a user to change their email address.
+
+    Default: ``False``
+.. py:data:: SECURITY_CHANGE_EMAIL_SUBJECT
+
+    Sets the subject for the change email confirmation email.
+
+    Default: ``_("Confirm your new email address")``.
+.. py:data:: SECURITY_CHANGE_EMAIL_TEMPLATE
+
+    Specifies the path to the template for the change email page.
+
+    Default: ``"security/change_email.html"``.
+.. py:data:: SECURITY_CHANGE_EMAIL_WITHIN
+
+    Specifies the amount of time a user has before their change email
+    token expires. Always pluralize the time unit for this value.
+
+    Default: ``"2 hours"``
+.. py:data:: SECURITY_POST_CHANGE_EMAIL_VIEW
+
+    Specifies the view to redirect to after a user successfully confirms their new email address.
+    This value can be set to a URL or an endpoint name. If this value is
+    ``None``, the user is redirected to the value of :py:data:`SECURITY_POST_LOGIN_VIEW`.
+    Note that if the request URL or form has a ``next`` parameter, that will take precedence.
+    In the case of :py:data:`SECURITY_REDIRECT_BEHAVIOR` == ``"spa"`` this value must be set.
+
+    Default: ``None``.
+.. py:data:: SECURITY_CHANGE_EMAIL_ERROR_VIEW
+
+    Specifies the view to redirect to if a change email confirmation error occurs.
+    This value can be set to a URL or an endpoint name.
+    If this value is ``None``, the user is redirected back to the change_email page.
+    In the case of :py:data:`SECURITY_REDIRECT_BEHAVIOR` == ``"spa"``
+    this value must be set, and the query params in the redirect will contain the error.
+
+    Default: ``None``.
+.. py:data:: SECURITY_CHANGE_EMAIL_URL
+
+    Specifies the change-email endpoint URL.
+
+    Default: ``"/change-email"``.
+.. py:data:: SECURITY_CHANGE_EMAIL_CONFIRM_URL
+
+    Specifies the change-email confirmation endpoint URL. This is a GET
+    only endpoint (accessed via a link in an email).
+
+    Default: ``"/change-email-confirm"``.
+
+Additional relevant configuration variables:
+
+    - :py:data:`SECURITY_FRESHNESS` - Used to protect /change-email.
+    - :py:data:`SECURITY_FRESHNESS_GRACE_PERIOD` - Used to protect /change-email.
+
 Two-Factor
 -----------
 Configuration related to the two-factor authentication feature.
@@ -1087,7 +1219,7 @@ Configuration related to the two-factor
     Specifies if Flask-Security should enable the two-factor login feature.
     If set to ``True``, in addition to their passwords, users will be required to
     enter a code that is sent to them. Note that unless
-    ``SECURITY_TWO_FACTOR_REQUIRED`` is set - this is opt-in.
+    :data:`SECURITY_TWO_FACTOR_REQUIRED` is set - this is opt-in.
 
     Default: ``False``.
 .. py:data:: SECURITY_TWO_FACTOR_REQUIRED
@@ -1132,6 +1264,14 @@ Configuration related to the two-factor
     Specifies the number of seconds access token is valid.
 
     Default: ``120``.
+.. py:data:: SECURITY_TWO_FACTOR_SETUP_WITHIN
+
+    Specifies the amount of time a user has before their two factor setup
+    token expires. Always pluralize the time unit for this value.
+
+    Default: ``"30 minutes"``
+
+    .. versionadded:: 5.5.0
 .. py:data:: SECURITY_TWO_FACTOR_RESCUE_MAIL
 
     Specifies the email address users send mail to when they can't complete the
@@ -1337,18 +1477,18 @@ Unified Signin
 .. py:data:: SECURITY_US_ENABLED_METHODS
 
     Specifies the default enabled methods for unified signin authentication.
-    Be aware that ``password`` only affects this ``SECURITY_US_SIGNIN_URL`` endpoint.
-    Removing it from here won't stop users from using the ``SECURITY_LOGIN_URL`` endpoint
+    Be aware that ``password`` only affects this :data:`SECURITY_US_SIGNIN_URL` endpoint.
+    Removing it from here won't stop users from using the :data:`SECURITY_LOGIN_URL` endpoint
     (unless you replace the login endpoint using :py:data:`SECURITY_US_SIGNIN_REPLACES_LOGIN`).
 
-    This config variable defines which methods can be used to provide authentication data.
-    :py:data:`SECURITY_USER_IDENTITY_ATTRIBUTES` controls what sorts of identities can be used.
+    This config variable defines which methods can be used to provide ``passcode`` data.
+    :py:data:`SECURITY_USER_IDENTITY_ATTRIBUTES` defines which user model fields can be used as ``identity``.
 
     Default: ``["password", "email", "authenticator", "sms"]`` - which are the only supported options.
 
 .. py:data:: SECURITY_US_MFA_REQUIRED
 
-    A list of ``US_ENABLED_METHODS`` that will require two-factor
+    A list of :data:`SECURITY_US_ENABLED_METHODS` that will require two-factor
     authentication. This is of course dependent on the settings of :py:data:`SECURITY_TWO_FACTOR`
     and :py:data:`SECURITY_TWO_FACTOR_REQUIRED`. Note that even with REQUIRED, only
     methods listed here will trigger a two-factor cycle.
@@ -1587,15 +1727,15 @@ WebAuthn
         - ``"secondary"`` - just keys registered as "secondary" are allowed
 
     If list is empty or ``None`` WebAuthn keys aren't allowed. This also means that the
-            :py:data:``SECURITY_WAN_VERIFY`` endpoint won't be registered.
+    :py:data:`SECURITY_WAN_VERIFY_URL` endpoint won't be registered.
 
     Default: ``["first", "secondary"]``
 
 
 Additional relevant configuration variables:
 
-    * :py:data:`SECURITY_FRESHNESS` - Used to protect /us-setup.
-    * :py:data:`SECURITY_FRESHNESS_GRACE_PERIOD` - Used to protect /us-setup.
+    * :py:data:`SECURITY_FRESHNESS` - Used to protect /wan-register and /wan-delete.
+    * :py:data:`SECURITY_FRESHNESS_GRACE_PERIOD` - Used to protect /wan-register and /wan-delete.
 
 Recovery Codes
 --------------
@@ -1709,6 +1849,7 @@ Feature Flags
 -------------
 All feature flags. By default all are 'False'/not enabled.
 
+* :py:data:`SECURITY_CHANGE_EMAIL`
 * :py:data:`SECURITY_CONFIRMABLE`
 * :py:data:`SECURITY_REGISTERABLE`
 * :py:data:`SECURITY_RECOVERABLE`
@@ -1729,6 +1870,8 @@ A list of all URLs and Views:
 * :py:data:`SECURITY_LOGOUT_URL`
 * :py:data:`SECURITY_VERIFY_URL`
 * :py:data:`SECURITY_REGISTER_URL`
+* :py:data:`SECURITY_CHANGE_EMAIL_URL`
+* :py:data:`SECURITY_CHANGE_EMAIL_CONFIRM_URL`
 * :py:data:`SECURITY_RESET_URL`
 * :py:data:`SECURITY_CHANGE_URL`
 * :py:data:`SECURITY_CONFIRM_URL`
@@ -1777,6 +1920,7 @@ A list of all templates:
 * :py:data:`SECURITY_REGISTER_USER_TEMPLATE`
 * :py:data:`SECURITY_RESET_PASSWORD_TEMPLATE`
 * :py:data:`SECURITY_CHANGE_PASSWORD_TEMPLATE`
+* :py:data:`SECURITY_CHANGE_EMAIL_TEMPLATE`
 * :py:data:`SECURITY_MULTI_FACTOR_RECOVERY_TEMPLATE`
 * :py:data:`SECURITY_MULTI_FACTOR_RECOVERY_CODES_TEMPLATE`
 * :py:data:`SECURITY_SEND_CONFIRMATION_TEMPLATE`
@@ -1802,6 +1946,9 @@ The default messages and error levels ca
 * ``SECURITY_MSG_ALREADY_CONFIRMED``
 * ``SECURITY_MSG_API_ERROR``
 * ``SECURITY_MSG_ANONYMOUS_USER_REQUIRED``
+* ``SECURITY_MSG_CHANGE_EMAIL_EXPIRED``
+* ``SECURITY_MSG_CHANGE_EMAIL_CONFIRMED``
+* ``SECURITY_MSG_CHANGE_EMAIL_SENT``
 * ``SECURITY_MSG_CODE_HAS_BEEN_SENT``
 * ``SECURITY_MSG_CONFIRMATION_EXPIRED``
 * ``SECURITY_MSG_CONFIRMATION_REQUEST``
@@ -1856,6 +2003,7 @@ The default messages and error levels ca
 * ``SECURITY_MSG_TWO_FACTOR_CHANGE_METHOD_SUCCESSFUL``
 * ``SECURITY_MSG_TWO_FACTOR_PERMISSION_DENIED``
 * ``SECURITY_MSG_TWO_FACTOR_METHOD_NOT_AVAILABLE``
+* ``SECURITY_MSG_TWO_FACTOR_SETUP_EXPIRED``
 * ``SECURITY_MSG_TWO_FACTOR_DISABLED``
 * ``SECURITY_MSG_UNAUTHORIZED``
 * ``SECURITY_MSG_UNAUTHENTICATED``
@@ -1882,3 +2030,5 @@ The default messages and error levels ca
 * ``SECURITY_MSG_WEBAUTHN_NO_VERIFY``
 * ``SECURITY_MSG_WEBAUTHN_CREDENTIAL_WRONG_USAGE``
 * ``SECURITY_MSG_WEBAUTHN_MISMATCH_USER_HANDLE``
+
+.. _passlib's CryptoContext: https://passlib.readthedocs.io/en/stable/lib/passlib.context.html
diff -pruN 5.4.3-1/docs/customizing.rst 5.5.0-1/docs/customizing.rst
--- 5.4.3-1/docs/customizing.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/customizing.rst	2024-07-24 02:21:26.000000000 +0000
@@ -21,6 +21,7 @@ following is a list of view templates:
 * `security/register_user.html`
 * `security/reset_password.html`
 * `security/change_password.html`
+* `security/change_email.html`
 * `security/send_confirmation.html`
 * `security/send_login.html`
 * `security/verify.html`
@@ -47,6 +48,7 @@ Flask application context processor:
 
 * ``<template_name>_form``: A form object for the view.
 * ``security``: The Flask-Security extension object.
+* ``config``: Injected by Flask - this holds all extensions' configuration.
 * ``url_for_security``: A function that returns the configured URL for the passed Security endpoint.
 * ``_fsdomain``: A function used to `tag` strings for extraction and localization.
 * ``_fs_is_user_authenticated``: Returns True if argument (user) is authenticated.
@@ -77,6 +79,7 @@ The following is a list of all the avail
 * ``register_context_processor``: Register view
 * ``reset_password_context_processor``: Reset password view
 * ``change_password_context_processor``: Change password view
+* ``change_email_context_processor``: Change email view
 * ``send_confirmation_context_processor``: Send confirmation view
 * ``send_login_context_processor``: Send login view
 * ``mail_context_processor``: Whenever an email will be sent
@@ -162,6 +165,7 @@ The following is a list of all the avail
 * ``forgot_password_form``: Forgot password form
 * ``reset_password_form``: Reset password form
 * ``change_password_form``: Change password form
+* ``change_email_form``: Change email form
 * ``send_confirmation_form``: Send confirmation form
 * ``mf_recovery_codes_form``: Setup recovery codes form
 * ``mf_recovery_form``: Use recovery code form
@@ -368,6 +372,8 @@ The following is a list of email templat
 * `security/email/reset_notice.txt`
 * `security/email/change_notice.txt`
 * `security/email/change_notice.html`
+* `security/email/change_email_instructions.txt`
+* `security/email/change_email_instructions.html`
 * `security/email/welcome.html`
 * `security/email/welcome.txt`
 * `security/email/welcome_existing.html`
@@ -418,6 +424,9 @@ welcome                         SECURITY
 confirmation_instructions       N/A                                  SECURITY_EMAIL_SUBJECT_CONFIRM                    - user                 confirm_instructions_sent
                                                                                                                        - confirmation_link
                                                                                                                        - confirmation_token
+change_email_instructions       N/A                                  SECURITY_CHANGE_EMAIL_SUBJECT                     - user                 change_email_instructions_sent
+                                                                                                                       - link
+                                                                                                                       - token
 login_instructions              N/A                                  SECURITY_EMAIL_SUBJECT_PASSWORDLESS               - user                 login_instructions_sent
                                                                                                                        - login_link
                                                                                                                        - login_token
diff -pruN 5.4.3-1/docs/features.rst 5.5.0-1/docs/features.rst
--- 5.4.3-1/docs/features.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/features.rst	2024-07-24 02:21:26.000000000 +0000
@@ -40,12 +40,19 @@ control (such as per-object), you can re
 Password Hashing
 ----------------
 
-Password hashing is enabled with `passlib`_. Passwords are hashed with the
-`bcrypt`_ function by default but you can easily configure the hashing
-algorithm. You should **always use a hashing algorithm** in your production
-environment. Hash algorithms not listed in ``SECURITY_PASSWORD_SINGLE_HASH``
+Password hashing is implemented using `passlib`_. Passwords are hashed with the
+`argon2`_ function by default but you can easily configure other hashing
+algorithms.
+For any given hashing algorithm, consult its documentation on what
+options/values are recommended. For argon2, the `argon2_cffi`_ package
+keeps its default options up to date with `RFC9106`_, and should be suitable for most
+applications. The `OWASP Password Storage Cheat Sheet <owasp_pass_cheat>`_ also
+has a lot of useful suggestions.
+
+You should **always use a hashing algorithm** in your production
+environment. Hash algorithms not listed in :data:`SECURITY_PASSWORD_SINGLE_HASH`
 will be double hashed - first an HMAC will be computed, then the selected hash
-function will be used. In this case - you must provide a ``SECURITY_PASSWORD_SALT``.
+function will be used. In this case - you must provide a :data:`SECURITY_PASSWORD_SALT`.
 A good way to generate this is::
 
     secrets.SystemRandom().getrandbits(128)
@@ -70,7 +77,8 @@ Token Authentication
 --------------------
 
 Token based authentication can be used by retrieving the user auth token from an
-authentication endpoint (e.g. ``/login``, ``/us-signin``, ``/wan-signin``).
+authentication endpoint (e.g. ``/login``, ``/us-signin``, ``/wan-signin``, ``/verify``,
+``/us-verify``, ``/wan-verify``).
 Perform an HTTP POST with a query param of ``include_auth_token`` and the authentication details
 as JSON data.
 A successful call will return the authentication token. This token can be used in subsequent
@@ -94,17 +102,71 @@ Authentication tokens have 2 options for
 is applied to ALL authentication tokens. Each authentication token can itself have an embedded
 expiry value (settable via the :data:`SECURITY_TOKEN_EXPIRE_TIMESTAMP` callable).
 
+Authentication tokens also convey freshness by recording the time the token was generated.
+This is used for endpoints protected with :func:`.auth_required` with a ``within``
+value set.
+
 .. note::
     While every Flask-Security endpoint will accept an authentication token header,
     there are some endpoints that require session information (e.g. a session cookie).
-    Please read :ref:`freshness_topic` and :ref:`csrf_topic`
+    This includes entering in a second factor and handling of :ref:`CSRF<csrf_topic>`.
+    As of release 5.5.0, authentication tokens by default carry freshness information.
+
+User Registration
+-----------------
+If :ref:`configured<configuration:Registerable>`, Flask-Security provides a basic user registration view. This view is
+very simple and new users need only supply an email address and their password.
+This view can be overridden if your registration process requires more fields.
+User email is validated and normalized using the
+`email_validator <https://pypi.org/project/email-validator/>`_ package.
+
+The :py:data:`SECURITY_USERNAME_ENABLE` configuration option, when set to ``True``, will add
+support for the user to register a username in addition to an email. By default, the user will be
+able to authenticate with EITHER email or username - however that can be changed via the
+:py:data:`SECURITY_USER_IDENTITY_ATTRIBUTES`.
+
+Email Confirmation
+------------------
+If :ref:`configured<configuration:Confirmable>`, your application
+can require that new users confirm their email address prior to allowing them to authenticate.
+Flask-Security will send an email message to any new users with a confirmation
+link. Upon navigating to the confirmation link, the user's account will be set to
+'confirmed'. The user can then sign in usually the normal mechanisms.
+There is also view for resending a confirmation link to a given email
+if the user happens to try to use an expired token or has lost the previous
+email. Confirmation links can be configured to expire after a specified amount
+of time (default 5 days).
+
+Password Reset/Recovery
+-----------------------
+If :ref:`configured<configuration:Recoverable>`,
+password reset and recovery is available for when a user forgets their
+password. Flask-Security sends an email to the user with a link to a view which
+allows them to reset their password. Once the password is reset they are redirected to
+the login page where they need to authenticate using the new password.
+Password reset links can be configured to expire after a specified amount of time.
+
+As with password change - this will update the the user's ``fs_uniquifier`` attribute
+which will invalidate all existing sessions AND (by default) all authentication tokens.
+
+Password Change
+---------------
+If :ref:`configured<configuration:Changeable>` users can change their password. Unlike password
+recovery, this endpoint is used when the user is already authenticated. The result
+of a successful password change is not only a new password, but a new value for ``fs_uniquifier``.
+This has the effect is immediately invalidating all existing sessions. The change request
+itself effectively re-logs in the user so a new session is created. Note that since the user
+is effectively re-logged in, the same signals are sent as when the user normally authenticates.
 
-.. _two-factor:
+*NOTE*: The ``fs_uniquifier`` by default, controls both sessions and authenticated tokens.
+Thus changing the password also invalidates all authentication tokens. This may not be desirable
+behavior, so if the UserModel contains an attribute ``fs_token_uniquifier``, then that will be used
+when generating authentication tokens and so won't be affected by password changes.
 
 Two-factor Authentication
 ----------------------------------------
-
-Two-factor authentication is enabled by generating time-based one time passwords
+If :ref:`configured<configuration:Two-Factor>`,
+the two-factor authentication feature generates time-based one time passwords
 (Tokens). The tokens are generated using the users `totp secret`_, which is unique
 per user, and is generated both on first login, and when changing the two-factor
 method (doing this causes the previous totp secret to become invalid). The token
@@ -121,13 +183,12 @@ they lose track of their secondary facto
 a one time code via email, send an email to the application admin, and using a previously
 generated and downloaded one-time code (see :py:data:`SECURITY_MULTI_FACTOR_RECOVERY_CODES`).
 
-.. _unified-sign-in:
-
 Unified Sign In
 ---------------
 **This feature is in Beta - mostly due to it being brand new and little to no production soak time**
 
-Unified sign in provides a generalized login endpoint that takes an `identity`
+If :ref:`configured<configuration:Unified Signin>`,
+a generalized login endpoint is provided that takes an `identity`
 and a `passcode`; where (based on configuration):
 
     * `identity` is any of :py:data:`SECURITY_USER_IDENTITY_ATTRIBUTES` (e.g. email, username, phone)
@@ -172,75 +233,21 @@ If you disable the freshness check then
     * Registration and Confirmation only work with email - so while you can enable multiple
       authentication methods, you still have to register with email.
 
-.. _webauthn:
-
 WebAuthn
----------------
+--------
 **This feature is in Beta - mostly due to it being brand new and little to no production soak time**
 
 WebAuthn is a standardized protocol that connects authenticators (such as YubiKey and mobile biometrics)
-with websites. Flask-Security supports using WebAuthn keys as either 'first' or 'secondary'
+with websites. If :ref:`configured<configuration:WebAuthn>`, Flask-Security supports using WebAuthn keys as either 'first' or 'secondary'
 authenticators. Please read :ref:`webauthn_topic` for more details.
 
-Email Confirmation
-------------------
-
-If desired you can require that new users confirm their email address.
-Flask-Security will send an email message to any new users with a confirmation
-link. Upon navigating to the confirmation link, the user's account will be set to
-'confirmed'. The user can then sign in usually the normal mechanisms.
-There is also view for resending a confirmation link to a given email
-if the user happens to try to use an expired token or has lost the previous
-email. Confirmation links can be configured to expire after a specified amount
-of time (default 5 days).
-
-
-Password Reset/Recovery
------------------------
-
-Password reset and recovery is available for when a user forgets their
-password. Flask-Security sends an email to the user with a link to a view which
-allows them to reset their password. Once the password is reset they are redirected to
-the login page where they need to authenticate using the new password.
-Password reset links can be configured to expire after a specified amount of time.
-
-As with password change - this will update the the user's ``fs_uniquifier`` attribute
-which will invalidate all existing sessions AND (by default) all authentication tokens.
-
-
-User Registration
------------------
-
-Flask-Security comes packaged with a basic user registration view. This view is
-very simple and new users need only supply an email address and their password.
-This view can be overridden if your registration process requires more fields.
-User email is validated and normalized using the
-`email_validator <https://pypi.org/project/email-validator/>`_ package.
-
-The :py:data:`SECURITY_USERNAME_ENABLE` configuration option, when set to ``True``, will add
-support for the user to register a username in addition to an email. By default, the user will be
-able to authenticate with EITHER email or username - however that can be changed via the
-:py:data:`SECURITY_USER_IDENTITY_ATTRIBUTES`.
-
-Password Change
----------------
-Flask-Security comes packaged with a basic change user password view. Unlike password
-recovery, this endpoint is used when the user is already authenticated. The result
-of a successful password change is not only a new password, but a new value for ``fs_uniquifier``.
-This has the effect is immediately invalidating all existing sessions. The change request
-itself effectively re-logs in the user so a new session is created. Note that since the user
-is effectively re-logged in, the same signals are sent as when the user normally authenticates.
-
-*NOTE*: The ``fs_uniquifier`` by default, controls both sessions and authenticated tokens.
-Thus changing the password also invalidates all authentication tokens. This may not be desirable
-behavior, so if the UserModel contains an attribute ``fs_token_uniquifier``, then that will be used
-when generating authentication tokens and so won't be affected by password changes.
-
+Email Change
+------------
+If :ref:`configured<configuration:Change-Email>`, users can change the email they registered with. This will send a new confirmation email to the new email address.
 
 Login Tracking
 --------------
-
-Flask-Security can, if configured, keep track of basic login events and
+Flask-Security can, if :ref:`configured<configuration:Trackable>`, keep track of basic login events and
 statistics. They include:
 
 * Last login date
@@ -249,10 +256,8 @@ statistics. They include:
 * Current login IP address
 * Total login count
 
-
 JSON/Ajax Support
 -----------------
-
 Flask-Security supports JSON/Ajax requests where appropriate. Please
 look at :ref:`csrf_topic` for details on how to work with JSON and
 Single Page Applications. More specifically
@@ -262,6 +267,7 @@ JSON is supported for the following oper
 * Unified sign in requests
 * Registration requests
 * Change password requests
+* Change email requests
 * Confirmation requests
 * Forgot password requests
 * Passwordless login requests
@@ -277,7 +283,6 @@ Note: All registration requests done thr
 
 Command Line Interface
 ----------------------
-
 Basic `Click`_ commands for managing users and roles are automatically
 registered. They can be completely disabled or their names can be changed.
 Run ``flask --help`` and look for users and roles.
@@ -316,6 +321,10 @@ in the `examples` directory.
 .. _documentation on this topic: http://packages.python.org/Flask-Principal/#granular-resource-protection
 .. _passlib: https://passlib.readthedocs.io/en/stable/
 .. _totp secret: https://passlib.readthedocs.io/en/stable/narr/totp-tutorial.html#overview
+.. _argon2: https://en.wikipedia.org/wiki/Argon2
+.. _argon2_cffi: https://pypi.org/project/argon2-cffi/
+.. _RFC9106: https://www.rfc-editor.org/rfc/rfc9106.html
+.. _owasp_pass_cheat: https://cheatsheetseries.owasp.org/cheatsheets/Password_Storage_Cheat_Sheet.html
 .. _bcrypt: https://en.wikipedia.org/wiki/Bcrypt
 .. _PyQRCode: https://pypi.python.org/pypi/PyQRCode/
 .. _Wikipedia: https://en.wikipedia.org/wiki/Multi-factor_authentication
diff -pruN 5.4.3-1/docs/index.rst 5.5.0-1/docs/index.rst
--- 5.4.3-1/docs/index.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/index.rst	2024-07-24 02:21:26.000000000 +0000
@@ -14,20 +14,18 @@ Welcome to Flask-Security
 Flask-Security allows you to quickly add common security mechanisms to your
 Flask application. They include:
 
-1. Session based authentication
-2. Role and Permission management
-3. Password hashing
-4. Basic HTTP authentication
-5. Token based authentication
-6. Token based account activation (optional)
-7. Token based password recovery / resetting (optional)
-8. Two-factor authentication (optional)
-9. Unified sign in (optional)
-10. User registration (optional)
-11. Login tracking (optional)
-12. JSON/Ajax Support
-13. WebAuthn Support (optional)
-14. Use 'social'/Oauth for authentication (e.g. google, github, ..) (optional)
+1. Authentication (via session, Basic HTTP, or token)
+2. User registration (optional)
+3. Role and Permission management
+4. Account activation (via email confirmation) (optional)
+5. Password management (recovery and resetting) (optional)
+6. Two-factor authentication (optional)
+7. WebAuthn Support (optional)
+8. Use 'social'/Oauth for authentication (e.g. google, github, ..) (optional)
+9. Change email (optional)
+10. Login tracking (optional)
+11. JSON/Ajax Support
+
 
 Many of these features are made possible by integrating various Flask extensions
 and libraries. They include:
@@ -51,6 +49,7 @@ extensions out of the box for data persi
 3. `Peewee Flask utils <https://docs.peewee-orm.com/en/latest/peewee/playhouse.html#flask-utils>`_
 4. `PonyORM <https://pypi.python.org/pypi/pony/>`_ - NOTE: not currently working - Help needed!.
 5. `SQLAlchemy sessions <https://docs.sqlalchemy.org/en/20/orm/session_basics.html>`_
+6. `Flask-SQLAlchemy-Lite <https://pypi.python.org/pypi/flask-sqlalchemy-lite/>`_
 
 
 Getting Started
diff -pruN 5.4.3-1/docs/installation.rst 5.5.0-1/docs/installation.rst
--- 5.4.3-1/docs/installation.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/installation.rst	2024-07-24 02:21:26.000000000 +0000
@@ -28,7 +28,7 @@ Supported extras are:
 
 * ``babel`` - Translation services. It will install babel and Flask-Babel.
 * ``fsqla`` - Use flask-sqlalchemy and sqlalchemy as your storage interface.
-* ``common`` - Install Flask-Mailman, bcrypt (the default password hash), and bleach.
+* ``common`` - Install Flask-Mailman, argon2 (the default password hash), and bleach.
 * ``mfa`` - Install packages used for multi-factor (two-factor, unified signin, WebAuthn):
   cryptography, qrcode, phonenumberslite (note that for SMS you still need
   to pick an SMS provider and install appropriate packages), and webauthn.
diff -pruN 5.4.3-1/docs/models.rst 5.5.0-1/docs/models.rst
--- 5.4.3-1/docs/models.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/models.rst	2024-07-24 02:21:26.000000000 +0000
@@ -12,6 +12,20 @@ and `Role` data model. The fields on you
 depending on the functionality your app requires. Aside from this, you're free
 to add any additional fields to your model(s) if you want.
 
+.. note::
+    The User, Role, and WebAuthn models MUST subclass their respective mixin (along
+    with any other mixin the datastore requires). The pre-packaged models described
+    below do this for you.
+
+    .. code-block:: python
+
+        from flask_security import UserMixin, RoleMixin, WebAuthMixin
+
+        class User(<db specific base>, UserMixin):
+            ... define columns here
+
+        ... same for Role and WebAuthn
+
 Packaged Models
 ----------------
 As more features are added to Flask-Security, the list of required fields and tables grow.
@@ -20,19 +34,71 @@ which are a bit of a pain. To make thing
 contain ALL the fields and tables required for all features. They also contain
 various `best practice` fields - such as update and create times. These mixins can
 be easily extended to add any sort of custom fields and can be found in the
-`models` module (today there is just one for using Flask-SQLAlchemy).
+`models` module.
 
 The provided models are versioned since they represent actual DB models, and any
 changes require a schema migration (and perhaps a data migration). Applications
 must specifically import the version they want (and handle any required migration).
+
+There are 2 available models - one when using Flask-SQLAlchemy and one when
+using 'raw' sqlalchemy or Flask-SQLAlchemy-Lite.
+
+.. note::
+    Using these models, you can override the tables names (and provide them to .set_db_info()
+    however your model class names MUST be `User`, `Role`, and `WebAuthn`.
+
+Flask-SQLAlchemy
+^^^^^^^^^^^^^^^^
 Your application code should import just the required version e.g.::
 
     from flask_security.models import fsqla_v3 as fsqla
+    from flask_sqlalchemy import SQLAlchemy
+
+    db = SQLAlchemy(app)
+
+    # Define models
+    fsqla.FsModels.set_db_info(db)
+
+    class Role(db.Model, fsqla.FsRoleMixin):
+        pass
+
+    class User(db.Model, fsqla.FsUserMixin):
+        pass
 
 
 A single method ``fsqla.FsModels.set_db_info`` is provided to glue the supplied models to your
 DB instance. This is only needed if you use the packaged models.
 
+Flask-SQLAlchemy-Lite
+^^^^^^^^^^^^^^^^^^^^^
+Your application code should import just the required version e.g.::
+
+    from flask_security.models import sqla as sqla
+    from flask_sqlalchemy_lite import SQLAlchemy
+
+    db = SQLAlchemy(app)
+
+    # Define models
+    class Model(DeclarativeBase):
+        pass
+
+    # NOTE: call this PRIOR to declaring models
+    sqla.FsModels.set_db_info(base_model=Model)
+
+    class Role(Model, sqla.FsRoleMixin):
+        __tablename__ = "Role"
+        pass
+
+    class User(Model, sqla.FsUserMixin):
+        __tablename__ = "User"
+        pass
+
+A single method ``sqla.FsModels.set_db_info`` is provided to glue the supplied mixins to your
+models. This is only needed if you use the packaged models.
+
+.. note::
+    This model requires Python >= 3.10.
+
 Model Specification
 -------------------
 
@@ -42,7 +108,7 @@ foreign relationship between `User` and
 references this primary key (which can be overridden by providing a
 suitable implementation of :py:meth:`flask_security.WebAuthnMixin.get_user_mapping`).
 
-At the bare minimum your `User` and `Role` model should include the following fields:
+At the bare minimum your `User` and `Role` model must include the following fields:
 
 **User**
 
@@ -73,8 +139,8 @@ Confirmable
 ^^^^^^^^^^^
 
 If you enable account confirmation by setting your application's
-:py:data:`SECURITY_CONFIRMABLE` configuration value to `True`, your `User` model will
-require the following additional field:
+:py:data:`SECURITY_CONFIRMABLE` or :py:data:`SECURITY_CHANGE_EMAIL` configuration value to `True`,
+your `User` model will require the following additional field:
 
 * ``confirmed_at`` (datetime)
 
@@ -141,6 +207,8 @@ that are then assigned to users, the ``R
 
 * ``permissions`` (list of UnicodeText, nullable)
 
+.. _webauthn_model:
+
 WebAuthn
 ^^^^^^^^
 Flask Security can act as a WebAuthn Relying Party by enabling
@@ -174,18 +242,18 @@ the User record (since we need to look u
     Add the following to the WebAuthn model (assuming your primary key is named ``id``):
 
         @declared_attr
-        def user_id(cls):
-            return Column(
-                Integer,
-                ForeignKey("user.id", ondelete="CASCADE"),
-                nullable=False,
+        def user_id(cls) -> Mapped[int]:
+            return mapped_column(
+                ForeignKey("user.id", ondelete="CASCADE")
             )
 
     Add the following to the User model:
 
         @declared_attr
         def webauthn(cls):
-            return relationship("WebAuthn", backref="users", cascade="all, delete")
+            return relationship(
+                "WebAuthn", back_populates="user", cascade="all, delete"
+            )
 
 **For mongoengine**::
 
@@ -242,12 +310,7 @@ serializable object:
 .. code-block:: python
 
     class User(db.Model, UserMixin):
-        id = db.Column(db.Integer, primary_key=True)
-        email = TextField()
-        password = TextField()
-        active = BooleanField(default=True)
-        confirmed_at = DateTimeField(null=True)
-        name = db.Column(db.String(80))
+        # ... define columns ...
 
         # Custom User Payload
         def get_security_payload(self):
diff -pruN 5.4.3-1/docs/openapi.yaml 5.5.0-1/docs/openapi.yaml
--- 5.4.3-1/docs/openapi.yaml	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/openapi.yaml	2024-07-24 02:21:26.000000000 +0000
@@ -29,17 +29,22 @@ paths:
         200:
           description: >
             Login form or user information. The JSON response will always
-            carry the csrf_token information. If the caller is logged in, then
-            additional information is returned. This can be very useful for single-page applications where during a force refresh, all state is lost.
+            carry the csrf_token information.
+            If SECURITY_CSRF_COOKIE_NAME is set then a cookie with the csrf token will be set.
+            If the caller is already authenticated, then
+            additional information is returned for JSON requests.
+            This can be very useful for single-page applications where during a force refresh, all state is lost.
             By performing this GET, the session cookie will authenticate the user and the response will contain user information.
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_LOGIN_USER_TEMPLATE)
                 example: render_template(SECURITY_LOGIN_USER_TEMPLATE)
             application/json:
               schema:
                 allOf:
-                  - $ref: '#/components/schemas/BaseJsonResponse'
+                  - $ref: '#/components/schemas/DefaultJsonResponse'
                   - type: object
                     properties:
                       response:
@@ -98,8 +103,8 @@ paths:
                 example: render_template(SECURITY_LOGIN_USER_TEMPLATE) with error values
         302:
           description: >
-            If the caller already authenticated, the form contents is ignored and a
-            redirect is done: redirect(next) or redirect(SECURITY_POST_LOGIN_VIEW).
+            If the caller is already authenticated, the form contents is ignored and a
+            redirect is done: redirect(SECURITY_POST_LOGIN_VIEW) (note that 'next' is ignored).
 
             If the caller is NOT already authenticated, and the form contents are
             validated the caller will be redirected to:
@@ -222,7 +227,7 @@ paths:
                         description: Http status code
   /verify:
     get:
-      summary: GET Basic re-authentication form
+      summary: GET verify/re-authentication form
       description: >
         If an endpoint is protected with @auth_required() with a freshness declaration
         this endpoint will be called to request an already signed in user to re-authenticate.
@@ -232,6 +237,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_VERIFY_TEMPLATE)
                 example: render_template(SECURITY_VERIFY_TEMPLATE)
             application/json:
               schema:
@@ -243,7 +250,7 @@ paths:
                       True if caller has a registered WebAuthn Key which has a `usage` that
                       is allowed by the SECURITY_WAN_ALLOW_AS_VERIFY configuration setting.
     post:
-      summary: Basic re-authentication
+      summary: Verify/re-authentication
       parameters:
         - $ref: "#/components/parameters/include_auth_token"
       requestBody:
@@ -293,6 +300,7 @@ paths:
             text/html:
               schema:
                 type: string
+                description: render_template(SECURITY_REGISTER_USER_TEMPLATE)
                 example: render_template(SECURITY_REGISTER_USER_TEMPLATE)
         302:
           description: Response when already logged in
@@ -355,6 +363,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_CHANGE_PASSWORD_TEMPLATE)
                 example: render_template(SECURITY_CHANGE_PASSWORD_TEMPLATE)
             application/json:
               schema:
@@ -412,6 +422,104 @@ paths:
             application/json:
               schema:
                 $ref: "#/components/schemas/DefaultJsonErrorResponse"
+  /change-email:
+    get:
+      summary: GET change email form
+      responses:
+        200:
+          description: change email form
+          content:
+            text/html:
+              schema:
+                type: string
+                description: render_template(SECURITY_CHANGE_EMAIL_TEMPLATE)
+                example: render_template(SECURITY_CHANGE_EMAIL_TEMPLATE)
+            application/json:
+              schema:
+                allOf:
+                  - $ref: '#/components/schemas/DefaultJsonResponse'
+                  - type: object
+                    properties:
+                      response:
+                        type: object
+                        properties:
+                          current_email:
+                            type: string
+                            description: User's currently registered email
+    post:
+      summary: Generate and send change email confirmation link
+      requestBody:
+        required: true
+        content:
+          application/json:
+            schema:
+              $ref: "#/components/schemas/ChangeEmail"
+          application/x-www-form-urlencoded:
+            schema:
+              $ref: "#/components/schemas/ChangeEmail"
+      responses:
+        200:
+          description: Change email response.
+          content:
+            text/html:
+              schema:
+                description: |
+                  Change email form (errors or not).
+                  If no errors then a confirmation instructions (with link) has been sent to the
+                  requested (new) email.
+                type: string
+                example: render_template(SECURITY_CHANGE_EMAIL_TEMPLATE) with error values
+            application/json:
+              schema:
+                $ref: "#/components/schemas/DefaultJsonResponse"
+        400:
+          description: Errors while validating form
+          content:
+            application/json:
+              schema:
+                allOf:
+                  - $ref: '#/components/schemas/DefaultJsonErrorResponse'
+                  - type: object
+                    properties:
+                      response:
+                        type: object
+                        properties:
+                          current_email:
+                            type: string
+                            description: User's currently registered email
+  /change-email/{token}:
+    parameters:
+      - name: token
+        in: path
+        required: true
+        schema:
+          type: string
+    get:
+      summary: Confirm change of user's registered email
+      description: >
+        This is the result of getting a change-email token and is usually
+        the result of clicking the link from a change-email  email.
+        This always results in a redirect().
+      responses:
+        302:
+          description: >
+            Redirects depending on success/error and whether
+            __SECURITY_REDIRECT_BEHAVIOR__ == 'spa'.
+          headers:
+            Location:
+              description: |
+                On spa-success: SECURITY_POST_CHANGE_EMAIL_VIEW?success={SECURITY_MSG_CHANGE_EMAIL_CONFIRMED}
+
+                On spa-error-expired: SECURITY_CHANGE_EMAIL_ERROR_VIEW?error={SECURITY_MSG_CHANGE_EMAIL_EXPIRED}
+
+                On spa-error-invalid-token: SECURITY_CHANGE_EMAIL_ERROR_VIEW?error={SECURITY_MSG_API_ERROR}
+
+                On default-error: SECURITY_CHANGE_EMAIL_ERROR_VIEW || .change_email
+
+                On default-success: SECURITY_POST_CHANGE_EMAIL_VIEW || SECURITY_POST_LOGIN_VIEW
+              schema:
+                type: string
+
   /reset:
     get:
       summary: GET reset password form
@@ -422,6 +530,7 @@ paths:
             text/html:
               schema:
                 type: string
+                description: render_template(SECURITY_FORGOT_PASSWORD_TEMPLATE)
                 example: render_template(SECURITY_FORGOT_PASSWORD_TEMPLATE)
         302:
           description: Response when already logged in
@@ -546,6 +655,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_SEND_CONFIRMATION_TEMPLATE)
                 example: render_template(SECURITY_SEND_CONFIRMATION_TEMPLATE)
     post:
       summary: Send confirmation email
@@ -624,24 +735,34 @@ paths:
       summary: GET Unified Sign In form
       responses:
         200:
-          description: Sign in form
+          description: >
+            Sign in form
+            If SECURITY_CSRF_COOKIE_NAME is set then a cookie with the csrf token will be set.
+            If the caller is already authenticated, then
+            additional information is returned for JSON requests.
+            This can be very useful for single-page applications where during a force refresh, all state is lost.
+            By performing this GET, the session cookie will authenticate the user and the response will contain user information.
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_US_SIGNIN_TEMPLATE)
                 example: render_template(SECURITY_US_SIGNIN_TEMPLATE)
             application/json:
               schema:
-                type: object
-                properties:
-                  available_methods:
-                    type: string
-                    description: Config setting SECURITY_US_ENABLED_METHODS
-                  code_methods:
-                    type: string
-                    description: All SECURITY_US_ENABLED_METHODS that require a code to be generated and sent.
-                  identity_attributes:
-                    type: string
-                    description: Configuration setting SECURITY_USER_IDENTITY_ATTRIBUTES
+                allOf:
+                  - $ref: '#/components/schemas/DefaultJsonResponse'
+                  - type: object
+                    properties:
+                      available_methods:
+                        type: string
+                        description: Config setting SECURITY_US_ENABLED_METHODS
+                      code_methods:
+                        type: string
+                        description: All SECURITY_US_ENABLED_METHODS that require a code to be generated and sent.
+                      identity_attributes:
+                        type: string
+                        description: Configuration setting SECURITY_USER_IDENTITY_ATTRIBUTES
     post:
       summary: Unified Sign In
       parameters:
@@ -669,13 +790,13 @@ paths:
                   - $ref: "#/components/schemas/LoginJsonResponse"
             text/html:
               schema:
-                description: Unsuccessful sign in
                 type: string
+                description: Unsuccessful sign in - render_template(SECURITY_US_SIGNIN_TEMPLATE) with error values
                 example: render_template(SECURITY_US_SIGNIN_TEMPLATE) with error values
         302:
           description: >
-            If the caller already authenticated, the form contents is ignored and a
-            redirect is done: redirect(next) or redirect(SECURITY_POST_LOGIN_VIEW).
+            If the caller already authenticated, the form contents are ignored and a
+            redirect is done: redirect(SECURITY_POST_LOGIN_VIEW) (note that 'next' is ignored).
 
             If the caller is NOT already authenticated, and the form contents are
             validated the caller will be redirected to:
@@ -709,7 +830,7 @@ paths:
           content:
             application/json:
               schema:
-                description: Code successfully sent
+                $ref: "#/components/schemas/DefaultJsonResponse"
             text/html:
               schema:
                 description: Validation error, code send error, or code successfully sent
@@ -730,7 +851,7 @@ paths:
 
   /us-verify:
     get:
-      summary: GET Unified sign in re-authentication form/information
+      summary: GET Unified sign in verify/re-authentication form/information
       description: >
         If an endpoint is protected with @auth_required() with a freshness declaration
         this endpoint will be called to request an already signed in user to re-authenticate.
@@ -740,6 +861,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_US_VERIFY_TEMPLATE)
                 example: render_template(SECURITY_US_VERIFY_TEMPLATE)
             application/json:
               schema:
@@ -763,7 +886,7 @@ paths:
                       True if caller has a registered WebAuthn Key which has a `usage` that
                       is allowed by the SECURITY_WAN_ALLOW_AS_VERIFY configuration setting.
     post:
-      summary: Unified sign in re-authentication
+      summary: Unified sign in verify/re-authentication
       parameters:
         - $ref: "#/components/parameters/include_auth_token"
       requestBody:
@@ -787,8 +910,8 @@ paths:
                   - $ref: "#/components/schemas/JsonResponseWithToken"
             text/html:
               schema:
-                description: Unsuccessful re-authentication.
                 type: string
+                description: Unsuccessful re-authentication - render_template(SECURITY_US_VERIFY_TEMPLATE) with error values
                 example: render_template(SECURITY_US_VERIFY_TEMPLATE) with error values
         302:
           description: User successfully re-authenticated when using form based request.
@@ -821,7 +944,7 @@ paths:
           content:
             application/json:
               schema:
-                description: Code successfully sent
+                $ref: "#/components/schemas/DefaultJsonResponse"
             text/html:
               schema:
                 description: Validation error, code send error, or code successfully sent
@@ -848,6 +971,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_US_SETUP_TEMPLATE)
                 example: render_template(SECURITY_US_SETUP_TEMPLATE)
             application/json:
               schema:
@@ -924,18 +1049,6 @@ paths:
         required: true
         schema:
           type: string
-    get:
-      summary: Validate unified sign in setup request.
-      description: >
-        This does nothing but redirect back to the setup form.
-      responses:
-        200:
-          description: Get form.
-          content:
-            text/html:
-              schema:
-                example: render_template(SECURITY_US_SETUP_TEMPLATE)
-
     post:
       summary: Validate passcode sent and store setup method.
       requestBody:
@@ -955,15 +1068,19 @@ paths:
               schema:
                 $ref: "#/components/schemas/UsSetupValidateJsonResponse"
         302:
-          description: Successfully validated and persisted sign in method.
+          description: Redirect based on success or failure.
           headers:
             Location:
               description: |
                 On form-success: SECURITY_US_POST_SETUP_VIEW
+
+                On form-error: .us-setup
+
+                Form errors include bad code, expired token, bad token.
               schema:
                 type: string
         400:
-          description: Validation failed.
+          description: Failed - bad code, expired token, bad token.
           content:
             application/json:
               schema:
@@ -1022,6 +1139,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_TWO_FACTOR_SETUP_TEMPLATE)
                 example: render_template(SECURITY_TWO_FACTOR_SETUP_TEMPLATE)
             application/json:
               schema:
@@ -1053,11 +1172,10 @@ paths:
 
         3) An authenticated user wishes to enable or disable 2FA (assuming SECURITY_TWO_FACTOR_REQUIRED is False).
 
-
         Allowed 2FA methods are controlled via the configuration SECURITY_TWO_FACTOR_ENABLED_METHODS.
 
-
-        This endpoint is protected by a 'freshness' check - meaning the caller will be required to have authenticated recently. In addition, to ensure correctness, the newly setup method must be verified by sending and entering a code prior to it being permanently stored.
+        This endpoint is protected by a 'freshness' check - meaning the caller will be required to have authenticated recently.
+        In addition, to ensure correctness, the newly setup method must be verified by sending and entering a code prior to it being permanently stored.
       requestBody:
         required: true
         content:
@@ -1101,6 +1219,49 @@ paths:
             application/json:
               schema:
                 $ref: "#/components/schemas/DefaultJsonErrorResponse"
+  /tf-setup/{token}:
+    parameters:
+      - name: token
+        in: path
+        required: true
+        schema:
+          type: string
+    post:
+      summary: Validate code sent and store setup method.
+      requestBody:
+        required: true
+        content:
+          application/json:
+            schema:
+              $ref: "#/components/schemas/TfSetupValidateRequest"
+          application/x-www-form-urlencoded:
+            schema:
+              $ref: "#/components/schemas/TfSetupValidateRequest"
+      responses:
+        200:
+          description: Successfully validated and persisted two factor method.
+          content:
+            application/json:
+              schema:
+                $ref: "#/components/schemas/TfSetupValidateJsonResponse"
+        302:
+          description: Success or Failure.
+          headers:
+            Location:
+              description: |
+                On form-success: SECURITY_TWO_FACTOR_POST_SETUP_VIEW
+
+                On form-error: .tf-setup
+
+                Form errors include bad code, expired token, bad token.
+              schema:
+                type: string
+        400:
+          description: Failed - bad code, expired token, bad token.
+          content:
+            application/json:
+              schema:
+                $ref: "#/components/schemas/DefaultJsonErrorResponse"
   /tf-validate:
     get:
       summary: GET current two-factor validate code form
@@ -1242,7 +1403,7 @@ paths:
           content:
             text/html:
               schema:
-                description: Select Form (SECURITY_TWO_FACTOR_SELECT_TEMPLATE)
+                description: render_template(SECURITY_TWO_FACTOR_SELECT_TEMPLATE)
                 type: string
                 example: render_template(SECURITY_TWO_FACTOR_SELECT_TEMPLATE)
             application/json:
@@ -1307,18 +1468,27 @@ paths:
               schema:
                 $ref: "#/components/schemas/DefaultJsonErrorResponse"
   /mf-recovery-codes:
+    summary: Generate and retrieve one-time use recovery codes.
     get:
-      summary: Generate and retrieve one-time use recovery codes.
+      summary: Retrieve one-time use recovery codes.
       description: >
         If a user has two-factor authentication enabled, they can generate and
         use a recovery code if they lose or otherwise can't use their second factor
         device.
+      parameters:
+        - name: show_codes
+          in: path
+          required: false
+          schema:
+            type: string
       responses:
         200:
           description: Multi-factor recovery code form
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_MULTI_FACTOR_RECOVERY_CODES_TEMPLATE)
                 example: render_template(SECURITY_MULTI_FACTOR_RECOVERY_CODES_TEMPLATE)
             application/json:
               schema:
@@ -1337,13 +1507,6 @@ paths:
 
     post:
       summary: Generate a new set of one-time recovery codes
-      requestBody:
-        content:
-          application/x-www-form-urlencoded:
-            schema:
-                description: Generate Codes Form
-                type: string
-                example: render_template(SECURITY_MULTI_FACTOR_RECOVERY_CODES_TEMPLATE)
       responses:
         200:
           description: New one-time codes generated.
@@ -1364,7 +1527,7 @@ paths:
                               type: string
             text/html:
               schema:
-                description: New codes generated.
+                description: New codes generated - render_template(SECURITY_MULTI_FACTOR_RECOVERY_CODES_TEMPLATE)
                 type: string
                 example: render_template(SECURITY_MULTI_FACTOR_RECOVERY_CODES_TEMPLATE)
         400:
@@ -1387,6 +1550,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_MULTI_FACTOR_RECOVERY_TEMPLATE)
                 example: render_template(SECURITY_MULTI_FACTOR_RECOVERY_TEMPLATE)
             application/json:
               schema:
@@ -1439,6 +1604,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_WAN_REGISTER_TEMPLATE)
                 example: render_template(SECURITY_WAN_REGISTER_TEMPLATE)
             application/json:
               schema:
@@ -1486,7 +1653,7 @@ paths:
                 $ref: "#/components/schemas/WanRegisterJsonResponse"
             text/html:
               schema:
-                description: Validation failed
+                description: Validation failed - render_template(SECURITY_WAN_REGISTER_TEMPLATE)
                 type: string
                 example: render_template(SECURITY_WAN_REGISTER_TEMPLATE) with error values
         400:
@@ -1552,6 +1719,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_WAN_SIGNIN_TEMPLATE)
                 example: render_template(SECURITY_WAN_SIGNIN_TEMPLATE)
             application/json:
               schema:
@@ -1655,7 +1824,7 @@ paths:
                 $ref: "#/components/schemas/DefaultJsonErrorResponse"
   /wan-delete:
     get:
-      summary: GET Delete WebAuthn key form
+      summary: GET Delete WebAuthn key - this method isn't very useful.
       responses:
         200:
           description: Delete an existing WebAuthn Key
@@ -1716,6 +1885,8 @@ paths:
           content:
             text/html:
               schema:
+                type: string
+                description: render_template(SECURITY_WAN_VERIFY_TEMPLATE)
                 example: render_template(SECURITY_WAN_VERIFY_TEMPLATE)
             application/json:
               schema:
@@ -2044,6 +2215,14 @@ components:
         new_password_confirm:
           type: string
           description: New password - again
+    ChangeEmail:
+      type: object
+      required: [email]
+      properties:
+        email:
+          type: string
+          description: New email requested
+
     EmailLink:
       type: object
       required: [email]
@@ -2177,7 +2356,14 @@ components:
                   description: >
                     Current state of Two Factor configuration. Not present when disabling 2FA. This will be set to 'validating_profile'
                     indicating the caller needs to call '/tf-validate' with the correct code.
+                    N.B. as of 5.5.0 this is only used for setting up as part of initial login when 2FA is required.
+                    See tf_state_token below for use when an authenticated user wants to change their 2FA method.
                   example: validating_profile
+                tf_state_token:
+                  type: string
+                  description: >
+                    Timed and signed token containing necessary state to complete the setup. To validate the method POST
+                    the code to '/tf-setup/<tf_state_token>'.
                 tf_primary_method:
                   type: string
                   description: Current method being configured (deprecated).
@@ -2235,7 +2421,30 @@ components:
                   tf_signin_url:
                     type: string
                     description: The value of SECURITY_WAN_SIGNIN_URL
-
+    TfSetupValidateRequest:
+      type: object
+      required: [code]
+      properties:
+        code:
+          type: string
+          description: Code as received from method being setup.
+    TfSetupValidateJsonResponse:
+      allOf:
+        - $ref: '#/components/schemas/BaseJsonResponse'
+        - type: object
+          properties:
+            response:
+              type: object
+              properties:
+                tf_method:
+                  type: string
+                  description: The method as passed into API.
+                tf_primary_method:
+                  type: string
+                  description: The method as passed into API.
+                tf_phone:
+                  type: string
+                  description: Phone number if set.
     WanRegister:
       type: object
       required: [ name, usage ]
diff -pruN 5.4.3-1/docs/patterns.rst 5.5.0-1/docs/patterns.rst
--- 5.4.3-1/docs/patterns.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/patterns.rst	2024-07-24 02:21:26.000000000 +0000
@@ -101,13 +101,16 @@ Flask-Security itself uses this as part
     - .tf_setup ("/tf-setup")
     - .us_setup ("/us-setup")
     - .mf_recovery_codes ("/mf-recovery-codes")
+    - .change_email ("/change-email")
 
-Using the :py:data:`SECURITY_FRESHNESS` and :py:data:`SECURITY_FRESHNESS_GRACE_PERIOD` configuration variables.
+using the :py:data:`SECURITY_FRESHNESS` and :py:data:`SECURITY_FRESHNESS_GRACE_PERIOD` configuration variables.
 
 .. tip::
-    Freshness requires a session (cookie) be sent as part of the request. Without
-    a session, freshness will fail. If your application doesn't/can't send session cookies
-    you can disable freshness by setting ``SECURITY_FRESHNESS`` to ``timedelta(minutes=-1)``
+    The timestamp of the users last successful authentication is stored in the session
+    as well as in the authentication token. One of these must be presented or freshness
+    will fail. You can disallow using the value in the authentication token by setting
+    :py:data:`SECURITY_FRESHNESS_ALLOW_AUTH_TOKEN` to ``False``.
+    You can disable freshness by setting ``SECURITY_FRESHNESS`` to ``timedelta(minutes=-1)``
 
 .. _redirect_topic:
 
@@ -234,12 +237,12 @@ Behind-The-Scenes
 ++++++++++++++++++
 Depending on configuration, there are 3 places CSRF tokens can be checked:
   #) As part of form validation for any form derived from FlaskForm (which all Flask-Security
-     forms are. An error here is recorded in the ``csrf_token`` field and the calling view
-     decided whether to return 200 or 400 (all Flask-Security views return 200 with form field errors).
+     forms are). An error here is recorded in the ``csrf_token`` field and the calling view
+     decides whether to return 200 or 400.
      This is the default if no other configuration changes are made.
   #) As part of an @before_request handler that Flask-WTF sets up if CSRFprotect() is called. On error
      this always returns HTTP 400 and small snippet of HTML. This can be disabled
-     by setting config["WTF_CSRF_CHECK_DEFAULT"] = True.
+     by setting config["WTF_CSRF_CHECK_DEFAULT"] = False.
   #) As part of a Flask-Security decorator (:func:`.unauth_csrf`, :func:`.auth_required`). On
      error either a JSON response is returned OR CSRFError exception is raised and 400 is returned with the small snippet of HTML
      (the exception and default response is part of Flask-WTF).
@@ -325,11 +328,16 @@ Be aware that if you enable this it will
     is to set `WTF_CSRF_CHECK_DEFAULT` to `False` - which will disable the @before_request and let Flask-Security handle CSRF protection
     including properly returning a JSON response if the caller asks for it.
 
+.. danger::
+    If you set `WTF_CSRF_CHECK_DEFAULT` to `False` this will turn off CSRF checking for all your endpoints unless they are protected with
+    @auth_required() or have explicit CSRF checking.
+
 
 Using a Cookie
 --------------
-You can instruct Flask-Security to send a cookie that contains the csrf token. This can be very
-convenient since various javascript AJAX packages are pre-configured to extract the contents of a cookie
+You can instruct Flask-Security to send a cookie that contains the csrf token.
+The cookie will be set on a call to ``GET /login`` or ``GET /us-signin`` - as well as after a successful authentication.
+This can be very convenient since various javascript AJAX packages are pre-configured to extract the contents of a cookie
 and send it on every mutating request as an HTTP header. `axios`_ for example has a default configuration
 that it will look for a cookie named ``XSRF-TOKEN`` and will send the contents of that back
 in an HTTP header called ``X-XSRF-Token``. This means that if you use that package you don't need to make
@@ -341,9 +349,6 @@ any changes to your UI and just need the
     # Don't have csrf tokens expire (they are invalid after logout)
     app.config["WTF_CSRF_TIME_LIMIT"] = None
 
-    # You can't get the cookie until you are logged in.
-    app.config["SECURITY_CSRF_IGNORE_UNAUTH_ENDPOINTS"] = True
-
     # Enable CSRF protection
     flask_wtf.CSRFProtect(app)
 
diff -pruN 5.4.3-1/docs/quickstart.rst 5.5.0-1/docs/quickstart.rst
--- 5.4.3-1/docs/quickstart.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/quickstart.rst	2024-07-24 02:21:26.000000000 +0000
@@ -11,19 +11,24 @@ There are some complete (but simple) exa
     and will need to be added to your requirements.txt (or equivalent) file.
     Flask-Security does some configuration validation and will output error messages to the console
     for some missing packages.
+.. note::
+    The sqlalchemy based quickstarts all use the pre-packaged models - because, well, that's
+    the quickest and easiest way to get started. There is NO REQUIREMENT that your application
+    use these - as long as the required fields are in your models.
 
 .. note::
-    The default ``SECURITY_PASSWORD_HASH`` is "bcrypt" - so be sure to install bcrypt.
-    If you opt for a different hash e.g. "argon2" you will need to install the appropriate package e.g. `argon_cffi`_.
+    The default :data:`SECURITY_PASSWORD_HASH` is "argon2" - so be sure to install `argon2_cffi`_.
+    If you opt for a different hash e.g. "bcrypt" you will need to install the appropriate package.
 .. danger::
    The examples below place secrets in source files. Never do this for your application
    especially if your source code is placed in a public repo. How you pass in secrets
    securely will depend on your deployment model - however in most cases (e.g. docker, lambda)
    using environment variables will be the easiest.
 
-.. _argon_cffi: https://pypi.org/project/argon2-cffi/
+.. _argon2_cffi: https://pypi.org/project/argon2-cffi/
 
-* :ref:`basic-sqlalchemy-application`
+* :ref:`basic-flask-sqlalchemy-application`
+* :ref:`basic-flask-sqlalchemy-lite-application`
 * :ref:`basic-sqlalchemy-application-with-session`
 * :ref:`basic-mongoengine-application`
 * :ref:`basic-peewee-application`
@@ -31,13 +36,13 @@ There are some complete (but simple) exa
 * :ref:`proxy-configuration`
 * :ref:`unit-testing`
 
-.. _basic-sqlalchemy-application:
+.. _basic-flask-sqlalchemy-application:
 
-Basic SQLAlchemy Application
-----------------------------
+Basic Flask-SQLAlchemy Application
+-----------------------------------
 
-SQLAlchemy Install requirements
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+Flask-SQLAlchemy Install requirements
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 ::
 
@@ -46,13 +51,13 @@ SQLAlchemy Install requirements
      $ pip install flask-security-too[fsqla,common]
 
 
-SQLAlchemy Application
-~~~~~~~~~~~~~~~~~~~~~~
+Flask-SQLAlchemy Application
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 The following code sample illustrates how to get started as quickly as
-possible using Flask-SQLAlchemy and the built-in model mixins:
+possible using Flask-SQLAlchemy and the built-in model mixins.
 
-::
+.. code-block:: python
 
     import os
 
@@ -67,8 +72,7 @@ possible using Flask-SQLAlchemy and the
 
     # Generate a nice key using secrets.token_urlsafe()
     app.config['SECRET_KEY'] = os.environ.get("SECRET_KEY", 'pf9Wkove4IKEAXvy-cQkeDPhv9Cb3Ag-wyJILbq_dFw')
-    # Bcrypt is set as default SECURITY_PASSWORD_HASH, which requires a salt
-    # Generate a good salt using: secrets.SystemRandom().getrandbits(128)
+    # Generate a good salt for password hashing using: secrets.SystemRandom().getrandbits(128)
     app.config['SECURITY_PASSWORD_SALT'] = os.environ.get("SECURITY_PASSWORD_SALT", '146585145368132386173505678016728509634')
 
     # have session and remember cookie be samesite (flask/flask_login)
@@ -100,7 +104,7 @@ possible using Flask-SQLAlchemy and the
 
     # Setup Flask-Security
     user_datastore = SQLAlchemyUserDatastore(db, User, Role)
-    app.security = Security(app, user_datastore)
+    security = Security(app, user_datastore)
 
     # Views
     @app.route("/")
@@ -112,8 +116,8 @@ possible using Flask-SQLAlchemy and the
     with app.app_context():
         # Create User to test with
         db.create_all()
-        if not app.security.datastore.find_user(email="test@me.com"):
-            app.security.datastore.create_user(email="test@me.com", password=hash_password("password"))
+        if not security.datastore.find_user(email="test@me.com"):
+            security.datastore.create_user(email="test@me.com", password=hash_password("password"))
         db.session.commit()
 
     if __name__ == '__main__':
@@ -127,39 +131,37 @@ or::
 
     python app.py
 
-.. _basic-sqlalchemy-application-with-session:
+.. _basic-flask-sqlalchemy-lite-application:
 
-Basic SQLAlchemy Application with session
------------------------------------------
+Basic Flask-SQLAlchemy-Lite Application
+----------------------------------------
 
-SQLAlchemy Install requirements
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+Flask-SQLAlchemy Install requirements
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-::
+This requires python >= 3.10::
 
      $ python3 -m venv pymyenv
      $ . pymyenv/bin/activate
-     $ pip install flask-security-too[common] sqlalchemy
+     $ pip install flask-security-too[common] sqlalchemy flask-sqlalchemy-lite
 
-SQLAlchemy Application (w/o Flask-SQLAlchemy)
-~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+Flask-SQLAlchemy-Lite Application
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 The following code sample illustrates how to get started as quickly as
-possible using `SQLAlchemy in a declarative way
-<https://flask.palletsprojects.com/en/2.0.x/patterns/sqlalchemy/#declarative>`_:
-
-This example shows how to split your application into 3 files: app.py, database.py
-and models.py.
+possible using Flask-SQLAlchemy-Lite and the built-in model mixins.
+Note that Flask-SQLAlchemy-Lite is a very thin wrapper above sqlalchemy.orm
+and just provides session and engine initialization. Everything else is
+pure sqlalchemy (unlike Flask-SQLAlchemy).
 
-- app.py ::
+.. code-block:: python
 
     import os
 
     from flask import Flask, render_template_string
-    from flask_security import Security, current_user, auth_required, hash_password, \
-         SQLAlchemySessionUserDatastore, permissions_accepted
-    from database import db_session, init_db
-    from models import User, Role
+    from flask_sqlalchemy_lite import SQLAlchemy
+    from flask_security import Security, SQLAlchemyUserDatastore, auth_required, hash_password
+    from flask_security.models import sqla as sqla
 
     # Create app
     app = Flask(__name__)
@@ -167,106 +169,185 @@ and models.py.
 
     # Generate a nice key using secrets.token_urlsafe()
     app.config['SECRET_KEY'] = os.environ.get("SECRET_KEY", 'pf9Wkove4IKEAXvy-cQkeDPhv9Cb3Ag-wyJILbq_dFw')
-    # Bcrypt is set as default SECURITY_PASSWORD_HASH, which requires a salt
-    # Generate a good salt using: secrets.SystemRandom().getrandbits(128)
+    # Generate a good salt for password hashing using: secrets.SystemRandom().getrandbits(128)
     app.config['SECURITY_PASSWORD_SALT'] = os.environ.get("SECURITY_PASSWORD_SALT", '146585145368132386173505678016728509634')
-    # Don't worry if email has findable domain
-    app.config["SECURITY_EMAIL_VALIDATOR_ARGS"] = {"check_deliverability": False}
 
-    # manage sessions per request - make sure connections are closed and returned
-    app.teardown_appcontext(lambda exc: db_session.close())
+    # have session and remember cookie be samesite (flask/flask_login)
+    app.config["REMEMBER_COOKIE_SAMESITE"] = "strict"
+    app.config["SESSION_COOKIE_SAMESITE"] = "strict"
+
+    # Use an in-memory db
+    app.config |= {
+        "SQLALCHEMY_ENGINES": {
+            "default": {"url": "sqlite:///:memory:", "pool_pre_ping": True},
+        },
+    }
+
+    # Create database connection object
+    db = SQLAlchemy(app)
+
+    # Define models
+    class Model(DeclarativeBase):
+        pass
+
+    # NOTE: call this PRIOR to declaring models
+    sqla.FsModels.set_db_info(base_model=Model)
+
+    class Role(Model, sqla.FsRoleMixin):
+        __tablename__ = "Role"
+        pass
+
+    class User(Model, sqla.FsUserMixin):
+        __tablename__ = "User"
+        pass
 
     # Setup Flask-Security
-    user_datastore = SQLAlchemySessionUserDatastore(db_session, User, Role)
-    app.security = Security(app, user_datastore)
+    user_datastore = FSQLALiteUserDatastore(db, User, Role)
+    security = Security(app, user_datastore)
 
     # Views
     @app.route("/")
     @auth_required()
     def home():
-        return render_template_string('Hello {{current_user.email}}!')
-
-    @app.route("/user")
-    @auth_required()
-    @permissions_accepted("user-read")
-    def user_home():
-        return render_template_string("Hello {{ current_user.email }} you are a user!")
+        return render_template_string("Hello {{ current_user.email }}")
 
     # one time setup
     with app.app_context():
-        init_db()
-        # Create a user and role to test with
-        app.security.datastore.find_or_create_role(
-            name="user", permissions={"user-read", "user-write"}
-        )
-        db_session.commit()
-        if not app.security.datastore.find_user(email="test@me.com"):
-            app.security.datastore.create_user(email="test@me.com",
-            password=hash_password("password"), roles=["user"])
-        db_session.commit()
+        # Create User to test with
+        Model.metadata.create_all(db.engine)
+        if not security.datastore.find_user(email="test@me.com"):
+            security.datastore.create_user(email="test@me.com", password=hash_password("password"))
+        db.session.commit()
 
     if __name__ == '__main__':
-        # run application (can also use flask run)
         app.run()
 
-- database.py ::
+You can run this either with::
+
+    flask run
+
+or::
+
+    python app.py
+
+.. _basic-sqlalchemy-application-with-session:
+
+Basic SQLAlchemy Application with session
+-----------------------------------------
+
+SQLAlchemy Install requirements
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+This requires python >= 3.10::
+
+     $ python3 -m venv pymyenv
+     $ . pymyenv/bin/activate
+     $ pip install flask-security-too[common] sqlalchemy
+
+SQLAlchemy Application (w/o Flask-SQLAlchemy)
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+The following code sample illustrates how to get started as quickly as
+possible using `SQLAlchemy in a declarative way
+<https://flask.palletsprojects.com/en/2.0.x/patterns/sqlalchemy/#declarative>`_:
+
+This example shows how to split your application into 3 files: app.py, database.py
+and models.py.
+
+- app.py
+    .. code-block:: python
+
+        import os
 
-    from sqlalchemy import create_engine
-    from sqlalchemy.orm import scoped_session, sessionmaker
-    from sqlalchemy.ext.declarative import declarative_base
-
-    engine = create_engine('sqlite:////tmp/test.db')
-    db_session = scoped_session(sessionmaker(autocommit=False,
-                                             autoflush=False,
-                                             bind=engine))
-    Base = declarative_base()
-    Base.query = db_session.query_property()
-
-    def init_db():
-        # import all modules here that might define models so that
-        # they will be registered properly on the metadata.  Otherwise
-        # you will have to import them first before calling init_db()
-        import models
-        Base.metadata.create_all(bind=engine)
-
-- models.py ::
-
-    from database import Base
-    from flask_security import UserMixin, RoleMixin, AsaList
-    from sqlalchemy.orm import relationship, backref
-    from sqlalchemy.ext.mutable import MutableList
-    from sqlalchemy import Boolean, DateTime, Column, Integer, \
-                        String, ForeignKey
-
-    class RolesUsers(Base):
-        __tablename__ = 'roles_users'
-        id = Column(Integer(), primary_key=True)
-        user_id = Column('user_id', Integer(), ForeignKey('user.id'))
-        role_id = Column('role_id', Integer(), ForeignKey('role.id'))
-
-    class Role(Base, RoleMixin):
-        __tablename__ = 'role'
-        id = Column(Integer(), primary_key=True)
-        name = Column(String(80), unique=True)
-        description = Column(String(255))
-        permissions = Column(MutableList.as_mutable(AsaList()), nullable=True)
-
-    class User(Base, UserMixin):
-        __tablename__ = 'user'
-        id = Column(Integer, primary_key=True)
-        email = Column(String(255), unique=True)
-        username = Column(String(255), unique=True, nullable=True)
-        password = Column(String(255), nullable=False)
-        last_login_at = Column(DateTime())
-        current_login_at = Column(DateTime())
-        last_login_ip = Column(String(100))
-        current_login_ip = Column(String(100))
-        login_count = Column(Integer)
-        active = Column(Boolean())
-        fs_uniquifier = Column(String(64), unique=True, nullable=False)
-        confirmed_at = Column(DateTime())
-        roles = relationship('Role', secondary='roles_users',
-                             backref=backref('users', lazy='dynamic'))
+        from flask import Flask, render_template_string
+        from flask_security import Security, current_user, auth_required, hash_password, \
+             SQLAlchemySessionUserDatastore, permissions_accepted
+        from database import db_session, init_db
+        from models import User, Role
+
+        # Create app
+        app = Flask(__name__)
+        app.config['DEBUG'] = True
+
+        # Generate a nice key using secrets.token_urlsafe()
+        app.config['SECRET_KEY'] = os.environ.get("SECRET_KEY", 'pf9Wkove4IKEAXvy-cQkeDPhv9Cb3Ag-wyJILbq_dFw')
+        # Generate a good salt for password hashing using: secrets.SystemRandom().getrandbits(128)
+        app.config['SECURITY_PASSWORD_SALT'] = os.environ.get("SECURITY_PASSWORD_SALT", '146585145368132386173505678016728509634')
+        # Don't worry if email has findable domain
+        app.config["SECURITY_EMAIL_VALIDATOR_ARGS"] = {"check_deliverability": False}
+
+        # manage sessions per request - make sure connections are closed and returned
+        app.teardown_appcontext(lambda exc: db_session.close())
+
+        # Setup Flask-Security
+        user_datastore = SQLAlchemySessionUserDatastore(db_session, User, Role)
+        security = Security(app, user_datastore)
+
+        # Views
+        @app.route("/")
+        @auth_required()
+        def home():
+            return render_template_string('Hello {{current_user.email}}!')
+
+        @app.route("/user")
+        @auth_required()
+        @permissions_accepted("user-read")
+        def user_home():
+            return render_template_string("Hello {{ current_user.email }} you are a user!")
+
+        # one time setup
+        with app.app_context():
+            init_db()
+            # Create a user and role to test with
+            security.datastore.find_or_create_role(
+                name="user", permissions={"user-read", "user-write"}
+            )
+            db_session.commit()
+            if not security.datastore.find_user(email="test@me.com"):
+                security.datastore.create_user(email="test@me.com",
+                password=hash_password("password"), roles=["user"])
+            db_session.commit()
+
+        if __name__ == '__main__':
+            # run application (can also use flask run)
+            app.run()
+
+- database.py
+    .. code-block:: python
+
+        from sqlalchemy import create_engine
+        from sqlalchemy.orm import scoped_session, sessionmaker
+        from sqlalchemy.ext.declarative import declarative_base
+        from flask_security.models import sqla
+
+        engine = create_engine('sqlite:////tmp/test.db')
+        db_session = scoped_session(sessionmaker(autocommit=False,
+                                                 autoflush=False,
+                                                 bind=engine))
+        Base = declarative_base()
+        # This creates the RolesUser table and is where
+        # you would pass in non-standard tables names.
+        sqla.FsModels.set_db_info(base_model=Base)
+
+
+        def init_db():
+            # import all modules here that might define models so that
+            # they will be registered properly on the metadata.  Otherwise
+            # you will have to import them first before calling init_db()
+            import models
+            Base.metadata.create_all(bind=engine)
+
+- models.py
+    .. code-block:: python
+
+        from database import Base
+        from flask_security.models import sqla as sqla
+
+        class Role(Base, sqla.FsRoleMixin):
+            __tablename__ = 'role'
+
+        class User(Base, sqla.FsUserMixin):
+            __tablename__ = 'user'
 
 You can run this either with::
 
@@ -295,9 +376,9 @@ MongoEngine Application
 
 The following code sample illustrates how to get started as quickly as
 possible using MongoEngine (of course you have to install and start up a
-local MongoDB instance):
+local MongoDB instance).
 
-::
+.. code-block:: python
 
     import os
 
@@ -321,8 +402,7 @@ local MongoDB instance):
 
     # Generate a nice key using secrets.token_urlsafe()
     app.config['SECRET_KEY'] = os.environ.get("SECRET_KEY", 'pf9Wkove4IKEAXvy-cQkeDPhv9Cb3Ag-wyJILbq_dFw')
-    # Bcrypt is set as default SECURITY_PASSWORD_HASH, which requires a salt
-    # Generate a good salt using: secrets.SystemRandom().getrandbits(128)
+    # Generate a good salt for password hashing using: secrets.SystemRandom().getrandbits(128)
     app.config['SECURITY_PASSWORD_SALT'] = os.environ.get("SECURITY_PASSWORD_SALT", '146585145368132386173505678016728509634')
     # Don't worry if email has findable domain
     app.config["SECURITY_EMAIL_VALIDATOR_ARGS"] = {"check_deliverability": False}
@@ -348,7 +428,7 @@ local MongoDB instance):
 
     # Setup Flask-Security
     user_datastore = MongoEngineUserDatastore(db, User, Role)
-    app.security = Security(app, user_datastore)
+    security = Security(app, user_datastore)
 
     # Views
     @app.route("/")
@@ -365,11 +445,11 @@ local MongoDB instance):
     # one time setup
     with app.app_context():
         # Create a user and role to test with
-        app.security.datastore.find_or_create_role(
+        security.datastore.find_or_create_role(
             name="user", permissions={"user-read", "user-write"}
         )
-        if not app.security.datastore.find_user(email="test@me.com"):
-            app.security.datastore.create_user(email="test@me.com",
+        if not security.datastore.find_user(email="test@me.com"):
+            security.datastore.create_user(email="test@me.com",
             password=hash_password("password"), roles=["user"])
 
     if __name__ == '__main__':
@@ -395,9 +475,9 @@ Peewee Application
 ~~~~~~~~~~~~~~~~~~
 
 The following code sample illustrates how to get started as quickly as
-possible using Peewee:
+possible using Peewee.
 
-::
+.. code-block:: python
 
     import os
 
@@ -413,8 +493,7 @@ possible using Peewee:
 
     # Generate a nice key using secrets.token_urlsafe()
     app.config['SECRET_KEY'] = os.environ.get("SECRET_KEY", 'pf9Wkove4IKEAXvy-cQkeDPhv9Cb3Ag-wyJILbq_dFw')
-    # Bcrypt is set as default SECURITY_PASSWORD_HASH, which requires a salt
-    # Generate a good salt using: secrets.SystemRandom().getrandbits(128)
+    # Generate a good salt for password hashing using: secrets.SystemRandom().getrandbits(128)
     app.config['SECURITY_PASSWORD_SALT'] = os.environ.get("SECURITY_PASSWORD_SALT", '146585145368132386173505678016728509634')
 
     app.config['DATABASE'] = {
@@ -453,7 +532,7 @@ possible using Peewee:
 
     # Setup Flask-Security
     user_datastore = PeeweeUserDatastore(db, User, Role, UserRoles)
-    app.security = Security(app, user_datastore)
+    security = Security(app, user_datastore)
 
     # Views
     @app.route('/')
@@ -467,8 +546,8 @@ possible using Peewee:
         for Model in (Role, User, UserRoles):
             Model.drop_table(fail_silently=True)
             Model.create_table(fail_silently=True)
-        if not app.security.datastore.find_user(email="test@me.com"):
-            app.security.datastore.create_user(email="test@me.com", password=hash_password("password"))
+        if not security.datastore.find_user(email="test@me.com"):
+            security.datastore.create_user(email="test@me.com", password=hash_password("password"))
 
     if __name__ == '__main__':
         app.run()
diff -pruN 5.4.3-1/docs/spa.rst 5.5.0-1/docs/spa.rst
--- 5.4.3-1/docs/spa.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/spa.rst	2024-07-24 02:21:26.000000000 +0000
@@ -191,7 +191,7 @@ Some background material:
 .. _Single Page Applications (spa): https://en.wikipedia.org/wiki/Single-page_application
 .. _Nginx: https://www.nginx.com/
 .. _S3: https://www.savjee.be/2018/05/Content-security-policy-and-aws-s3-cloudfront/
-.. _Flask-Talisman: https://github.com/GoogleCloudPlatform/flask-talisman
+.. _Flask-Talisman: https://pypi.org/project/flask-talisman/
 .. _CORS: https://developer.mozilla.org/en-US/docs/Web/HTTP/CORS
 .. _Flask-CORS: https://github.com/corydolphin/flask-cors
 .. _Zappa: https://github.com/Miserlou/Zappa
diff -pruN 5.4.3-1/docs/two_factor_configurations.rst 5.5.0-1/docs/two_factor_configurations.rst
--- 5.4.3-1/docs/two_factor_configurations.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/two_factor_configurations.rst	2024-07-24 02:21:26.000000000 +0000
@@ -45,8 +45,7 @@ possible using SQLAlchemy:
     app.config['DEBUG'] = True
     # Generate a nice key using secrets.token_urlsafe()
     app.config['SECRET_KEY'] = os.environ.get("SECRET_KEY", 'pf9Wkove4IKEAXvy-cQkeDPhv9Cb3Ag-wyJILbq_dFw')
-    # Bcrypt is set as default SECURITY_PASSWORD_HASH, which requires a salt
-    # Generate a good salt using: secrets.SystemRandom().getrandbits(128)
+    # Generate a good salt for password hashing using: secrets.SystemRandom().getrandbits(128)
     app.config['SECURITY_PASSWORD_SALT'] = os.environ.get("SECURITY_PASSWORD_SALT", '146585145368132386173505678016728509634')
 
     app.config['SQLALCHEMY_DATABASE_URI'] = 'sqlite://'
@@ -98,7 +97,7 @@ possible using SQLAlchemy:
 
     # Setup Flask-Security
     user_datastore = SQLAlchemyUserDatastore(db, User, Role)
-    app.security = Security(app, user_datastore)
+    security = Security(app, user_datastore)
 
     mail = Mail(app)
 
@@ -112,8 +111,8 @@ possible using SQLAlchemy:
     with app.app_context():
         # Create a user to test with
         db.create_all()
-        if not app.security.datastore.find_user(email='test@me.com'):
-            app.security.datastore.create_user(email='test@me.com', password='password')
+        if not security.datastore.find_user(email='test@me.com'):
+            security.datastore.create_user(email='test@me.com', password='password')
         db.session.commit()
 
     if __name__ == '__main__':
@@ -148,8 +147,10 @@ Theory of Operation
 +++++++++++++++++++++
 
 .. note::
-    The Two-factor feature requires that session cookies be received and sent as part of the API.
+    Confirming a code as part of user authentication requires that session cookies be received and sent as part of the API.
     This is true regardless of whether the application uses forms or JSON.
+    The ``/tf-setup`` endpoint requires freshness information which (as of 5.5.0) is available from the authentication token
+    (as well as the session) - so changing a user's 2FA method can be done without cookies.
 
 The Two-factor (2FA) API has four paths:
 
@@ -173,11 +174,11 @@ Changing 2FA Setup
 An authenticated user can change their 2FA configuration (primary_method, phone number, etc.). In order to prevent a user from being
 locked out, the new configuration must be validated before it is stored permanently. The user starts with a GET on ``/tf-setup``. This will return
 a list of configured 2FA methods the user can choose from, and the existing configuration. This must be followed with a POST on ``/tf-setup`` with the new primary
-method (and phone number if SMS). In the case of SMS, a code will be sent to the phone/device and again use ``/tf-validate`` to confirm code.
+method (and phone number if SMS). In the case of SMS or email, a code will be sent. In addition, a state_token will be returned in the response to
+the POST - this should be used to POST the code to ``/tf-setup/<state_token>``.
 In the case of setting up an authenticator app, the response to the POST will contain the QRcode image as well
 as the required information for manual entry.
-Once the code  has been successfully
-entered, the new configuration will be permanently stored.
+Once the code has been successfully entered, the new configuration will be permanently stored.
 
 Initial login/registration
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~
diff -pruN 5.4.3-1/docs/webauthn.rst 5.5.0-1/docs/webauthn.rst
--- 5.4.3-1/docs/webauthn.rst	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/docs/webauthn.rst	2024-07-24 02:21:26.000000000 +0000
@@ -16,6 +16,15 @@ and something you are (think a mobile de
 
 .. _W3C standard: https://www.w3.org/TR/webauthn-2/
 
+Getting Started
++++++++++++++++
+To add WebAuthn support to your application you will need:
+
+    - Install the `webauthn`_ package (the Flask-Security pip 'extra' [mfa] will do this).
+    - Add/modify your DB models as described :ref:`here <webauthn_model>`.
+
+.. _webauthn: https://pypi.org/project/webauthn/
+
 Key Concepts
 +++++++++++++
 
diff -pruN 5.4.3-1/examples/fsqlalchemy1/tests/test_api.py 5.5.0-1/examples/fsqlalchemy1/tests/test_api.py
--- 5.4.3-1/examples/fsqlalchemy1/tests/test_api.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/examples/fsqlalchemy1/tests/test_api.py	2024-07-24 02:21:26.000000000 +0000
@@ -1,4 +1,8 @@
 # Copyright 2019-2022 by J. Christopher Wagner (jwag). All rights reserved.
+# flake8: noqa: F402
+import pytest
+
+pytest.importorskip("flask_sqlalchemy")
 
 from fsqlalchemy1.app import Blog
 
diff -pruN 5.4.3-1/examples/unified_signin/client/client.py 5.5.0-1/examples/unified_signin/client/client.py
--- 5.4.3-1/examples/unified_signin/client/client.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/examples/unified_signin/client/client.py	2024-07-24 02:21:26.000000000 +0000
@@ -1,5 +1,5 @@
 """
-Copyright 2020-2021 by J. Christopher Wagner (jwag). All rights reserved.
+Copyright 2020-2024 by J. Christopher Wagner (jwag). All rights reserved.
 :license: MIT, see LICENSE for more details.
 
 This relies on session/session cookie for continued authentication.
@@ -84,6 +84,9 @@ def ussetup(server_url, session, passwor
     # unified sign in - setup sms with a phone number
     # Use the backdoor to grab verification SMS.
 
+    # reset freshness to show how that would work
+    resp = session.get(f"{server_url}/api/resetfresh")
+
     csrf_token = session.cookies["XSRF-TOKEN"]
     resp = session.post(
         f"{server_url}/us-setup",
diff -pruN 5.4.3-1/examples/unified_signin/server/api.py 5.5.0-1/examples/unified_signin/server/api.py
--- 5.4.3-1/examples/unified_signin/server/api.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/examples/unified_signin/server/api.py	2024-07-24 02:21:26.000000000 +0000
@@ -6,7 +6,7 @@ Copyright 2020-2024 by J. Christopher Wa
 
 from datetime import datetime, timezone
 
-from flask import Blueprint, abort, current_app, jsonify
+from flask import Blueprint, abort, current_app, jsonify, session
 from flask_security import auth_required
 
 from app import SmsCaptureSender
@@ -39,3 +39,16 @@ def popsms():
     if msg:
         return jsonify(sms=msg)
     abort(400)
+
+
+@api.route("/resetfresh", methods=["GET"])
+def resetfresh():
+    # This resets the callers session freshness field - just for testing
+    old_paa = (
+        session["fs_paa"]
+        - current_app.config["SECURITY_FRESHNESS"].total_seconds()
+        - 100
+    )
+    session["fs_paa"] = old_paa
+    session.pop("fs_gexp", None)
+    return jsonify()
diff -pruN 5.4.3-1/examples/unified_signin/server/app.py 5.5.0-1/examples/unified_signin/server/app.py
--- 5.4.3-1/examples/unified_signin/server/app.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/examples/unified_signin/server/app.py	2024-07-24 02:21:26.000000000 +0000
@@ -1,5 +1,5 @@
 """
-Copyright 2020-2022 by J. Christopher Wagner (jwag). All rights reserved.
+Copyright 2020-2024 by J. Christopher Wagner (jwag). All rights reserved.
 :license: MIT, see LICENSE for more details.
 
 A simple example of server and client utilizing unified sign in and other
@@ -13,7 +13,6 @@ This example is designed for a JSON and
 
 """
 
-import datetime
 import os
 
 from flask import Flask
@@ -75,6 +74,8 @@ def create_app():
     # We aren't interested in form-based APIs - so no need for flashing.
     app.config["SECURITY_FLASH_MESSAGES"] = False
 
+    app.config["SECURITY_AUTO_LOGIN_AFTER_CONFIRM"] = True
+
     # Allow signing in with a phone number or email
     app.config["SECURITY_USER_IDENTITY_ATTRIBUTES"] = [
         {"email": {"mapper": uia_email_mapper, "case_insensitive": True}},
@@ -108,12 +109,6 @@ def create_app():
     app.config["REMEMBER_COOKIE_SAMESITE"] = "strict"
     app.config["SESSION_COOKIE_SAMESITE"] = "strict"
 
-    # This means the first 'fresh-required' endpoint after login will always require
-    # re-verification - but after that the grace period will kick in.
-    # This isn't likely something a normal app would need/want to do.
-    app.config["SECURITY_FRESHNESS"] = datetime.timedelta(minutes=0)
-    app.config["SECURITY_FRESHNESS_GRACE_PERIOD"] = datetime.timedelta(minutes=2)
-
     # As of Flask-SQLAlchemy 2.4.0 it is easy to pass in options directly to the
     # underlying engine. This option makes sure that DB connections from the pool
     # are still valid. Important for entire application since many DBaaS options
diff -pruN 5.4.3-1/flask_security/__init__.py 5.5.0-1/flask_security/__init__.py
--- 5.4.3-1/flask_security/__init__.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/__init__.py	2024-07-24 02:21:26.000000000 +0000
@@ -12,6 +12,7 @@
 
 # flake8: noqa: F401
 from .changeable import admin_change_password
+from .change_email import ChangeEmailForm
 from .core import (
     Security,
     RoleMixin,
@@ -21,6 +22,7 @@ from .core import (
     current_user,
 )
 from .datastore import (
+    FSQLALiteUserDatastore,
     UserDatastore,
     SQLAlchemyUserDatastore,
     AsaList,
@@ -69,6 +71,8 @@ from .recovery_codes import (
     MfRecoveryCodesForm,
 )
 from .signals import (
+    change_email_confirmed,
+    change_email_instructions_sent,
     confirm_instructions_sent,
     login_instructions_sent,
     password_changed,
@@ -105,7 +109,6 @@ from .utils import (
     check_and_get_token_status,
     get_hmac,
     get_request_attr,
-    get_token_status,
     get_url,
     hash_password,
     check_and_update_authn_fresh,
@@ -136,4 +139,4 @@ from .webauthn import (
 )
 from .webauthn_util import WebauthnUtil
 
-__version__ = "5.4.3"
+__version__ = "5.5.0"
diff -pruN 5.4.3-1/flask_security/change_email.py 5.5.0-1/flask_security/change_email.py
--- 5.4.3-1/flask_security/change_email.py	1970-01-01 00:00:00.000000000 +0000
+++ 5.5.0-1/flask_security/change_email.py	2024-07-24 02:21:26.000000000 +0000
@@ -0,0 +1,232 @@
+"""
+    flask_security.change_email
+    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+    Flask-Security Change Email module
+
+    :copyright: (c) 2024-2024 by J. Christopher Wagner (jwag).
+    :license: MIT, see LICENSE for more details.
+
+    Allow user to change their email address.
+    If CHANGE_EMAIL_CONFIRM is set then the user will receive an email
+    at the new email address with a token that can be used to verify and change
+    emails. Upon success - if CHANGE_EMAIL_NOTIFY_OLD is set, an email will be sent
+    to the old email address.
+"""
+
+from __future__ import annotations
+
+import typing as t
+
+from flask import after_this_request, request
+from flask import current_app
+from flask_login import current_user
+from wtforms import SubmitField
+
+from .decorators import auth_required
+from .forms import (
+    Form,
+    UniqueEmailFormMixin,
+    build_form_from_request,
+    form_errors_munge,
+    get_form_field_label,
+)
+from .proxies import _security, _datastore
+from .quart_compat import get_quart_status
+from .signals import change_email_instructions_sent, change_email_confirmed
+from .utils import (
+    base_render_json,
+    check_and_get_token_status,
+    config_value as cv,
+    do_flash,
+    get_message,
+    get_url,
+    get_within_delta,
+    hash_data,
+    send_mail,
+    url_for_security,
+    verify_hash,
+    view_commit,
+)
+
+if t.TYPE_CHECKING:  # pragma: no cover
+    from flask.typing import ResponseValue
+
+if get_quart_status():  # pragma: no cover
+    from quart import redirect
+else:
+    from flask import redirect
+
+
+class ChangeEmailForm(Form, UniqueEmailFormMixin):
+    submit = SubmitField(label=get_form_field_label("submit"))
+
+    def __init__(self, *args, **kwargs):
+        super().__init__(*args, **kwargs)
+        self.existing_email_user = None
+
+
+@auth_required(
+    lambda: cv("API_ENABLED_METHODS"),
+    within=lambda: cv("FRESHNESS"),
+    grace=lambda: cv("FRESHNESS_GRACE_PERIOD"),
+)
+def change_email() -> ResponseValue:
+    """Start Change Email for an existing authenticated user"""
+    payload: dict[str, t.Any]
+
+    form: ChangeEmailForm = t.cast(
+        ChangeEmailForm, build_form_from_request("change_email_form")
+    )
+
+    if form.validate_on_submit():
+        _send_instructions(current_user, form.email.data)
+        if not _security._want_json(request):
+            do_flash(*get_message("CHANGE_EMAIL_SENT", email=form.email.data))
+        # Drop through..
+
+    # All paths get here
+    if (
+        request.method == "POST"
+        and cv("RETURN_GENERIC_RESPONSES")
+        and form.existing_email_user
+    ):
+        # Don't let an existing user enumerate registered emails
+        fields_to_squash: dict[str, dict[str, str]] = dict(email=dict())
+        form_errors_munge(form, fields_to_squash)
+        if not form.errors:
+            # only error is existing email - make it appear the same as if it worked
+            # except that we don't send anything - while we could inform the email
+            # that someone is trying to take it over - that could allow a user to
+            # annoy another user.
+            if not _security._want_json(request):
+                do_flash(*get_message("CHANGE_EMAIL_SENT", email=form.email.data))
+            # TODO - should we have a signal so we can tell application what is
+            # is going on (otherwise it is pretty much a black-hole).
+            # drop through - will return a successful response.
+
+    if _security._want_json(request):
+        form.user = current_user
+        payload = dict(current_email=current_user.email)
+        return base_render_json(form, additional=payload)
+
+    return _security.render_template(
+        cv("CHANGE_EMAIL_TEMPLATE"),
+        change_email_form=form,
+        current_email=current_user.email,
+        **_security._run_ctx_processor("change_email"),
+    )
+
+
+def change_email_confirm(token):
+    """
+    View function which handles a change email confirmation request.
+    This is always a GET from an email - so for 'spa' must always redirect.
+    """
+    expired, invalid, user, new_email = _verify_token_status(token)
+
+    if invalid or expired:
+        if expired:
+            m, c = get_message(
+                "CHANGE_EMAIL_EXPIRED",
+                within=cv("CHANGE_EMAIL_WITHIN"),
+            )
+        else:
+            m, c = get_message("API_ERROR")
+        if cv("REDIRECT_BEHAVIOR") == "spa":
+            return redirect(get_url(cv("CHANGE_EMAIL_ERROR_VIEW"), qparams={c: m}))
+        do_flash(m, c)
+        return redirect(
+            get_url(cv("CHANGE_EMAIL_ERROR_VIEW")) or url_for_security("change_email")
+        )
+
+    _update_user_email(user, new_email)
+    after_this_request(view_commit)
+    m, c = get_message("CHANGE_EMAIL_CONFIRMED")
+    if cv("REDIRECT_BEHAVIOR") == "spa":
+        return redirect(
+            get_url(
+                cv("POST_CHANGE_EMAIL_VIEW"),
+                qparams=user.get_redirect_qparams({c: m}),
+            )
+        )
+    do_flash(m, c)
+    return redirect(
+        get_url(cv("POST_CHANGE_EMAIL_VIEW")) or get_url(cv("POST_LOGIN_VIEW"))
+    )
+
+
+def _generate_token(user, new_email):
+    """Generates a unique confirmation token for the specified user.
+
+    :param user: The user to work with
+    :param new_email: The requested email
+    """
+    data = [str(user.fs_uniquifier), hash_data(user.email), new_email]
+    return _security.change_email_serializer.dumps(data)
+
+
+def _generate_link(user, new_email):
+    token = _generate_token(user, new_email)
+    return url_for_security("change_email_confirm", token=token, _external=True), token
+
+
+def _send_instructions(user, new_email):
+    """Sends the change email instructions email for the specified user.
+
+    :param user: The user to send the instructions to
+    :param new_email: The requested new email
+    """
+
+    link, token = _generate_link(user, new_email)
+
+    send_mail(
+        cv("CHANGE_EMAIL_SUBJECT"),
+        new_email,
+        "change_email_instructions",
+        user=user,
+        link=link,
+        token=token,
+    )
+
+    change_email_instructions_sent.send(
+        current_app._get_current_object(),
+        _async_wrapper=current_app.ensure_sync,
+        user=user,
+        new_email=new_email,
+        token=token,
+    )
+
+
+def _verify_token_status(token):
+    """Verify token and contents.
+    In general, we return pretty generic results - including checking the requested
+    new_email is still available (and if not return 'invalid').
+    """
+    expired, invalid, state = check_and_get_token_status(
+        token, "change_email", get_within_delta("CHANGE_EMAIL_WITHIN")
+    )
+    if invalid or expired:
+        return expired, invalid, None, None
+    fid, hashed_email, new_email = state
+    user = _datastore.find_user(fs_uniquifier=fid)
+    if not user or not verify_hash(hashed_email, user.email):
+        return False, True, None, None
+
+    # verify that new_email is still available
+    if _datastore.find_user(email=new_email):
+        return False, True, user, None
+    return expired, invalid, user, new_email
+
+
+def _update_user_email(user, new_email):
+    old_email = user.email
+    user.email = new_email
+    user.confirmed_at = _security.datetime_factory()
+    _datastore.put(user)
+    change_email_confirmed.send(
+        current_app._get_current_object(),
+        _async_wrapper=current_app.ensure_sync,
+        user=user,
+        old_email=old_email,
+    )
diff -pruN 5.4.3-1/flask_security/changeable.py 5.5.0-1/flask_security/changeable.py
--- 5.4.3-1/flask_security/changeable.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/changeable.py	2024-07-24 02:21:26.000000000 +0000
@@ -22,7 +22,7 @@ from .signals import password_changed
 from .utils import config_value as cv, hash_password, login_user, send_mail
 
 if t.TYPE_CHECKING:  # pragma: no cover
-    from .datastore import User
+    from flask_security import UserMixin
 
 
 def send_password_changed_notice(user):
@@ -36,7 +36,7 @@ def send_password_changed_notice(user):
 
 
 def change_user_password(
-    user: User, password: str | None, notify: bool = True, autologin: bool = True
+    user: UserMixin, password: str | None, notify: bool = True, autologin: bool = True
 ) -> None:
     """Change the specified user's password
 
@@ -68,12 +68,14 @@ def change_user_password(
         send_password_changed_notice(user)
     password_changed.send(
         current_app._get_current_object(),  # type: ignore
-        _async_wrapper=current_app.ensure_sync,
+        _async_wrapper=current_app.ensure_sync,  # type: ignore[arg-type]
         user=user,
     )
 
 
-def admin_change_password(user: User, new_passwd: str, notify: bool = True) -> None:
+def admin_change_password(
+    user: UserMixin, new_passwd: str, notify: bool = True
+) -> None:
     """
     Administratively change a user's password.
     Note that this will immediately render the user's existing sessions (and possibly
diff -pruN 5.4.3-1/flask_security/core.py 5.5.0-1/flask_security/core.py
--- 5.4.3-1/flask_security/core.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/core.py	2024-07-24 02:21:26.000000000 +0000
@@ -16,10 +16,11 @@ from __future__ import annotations
 from datetime import datetime, timedelta
 from dataclasses import dataclass
 import importlib
+import time
 import typing as t
 import warnings
 
-from flask import current_app, g
+from flask import current_app, g, session
 from flask_login import AnonymousUserMixin, LoginManager
 from flask_login import UserMixin as BaseUserMixin
 from flask_login import current_user
@@ -30,6 +31,7 @@ from werkzeug.datastructures import Immu
 from werkzeug.local import LocalProxy
 
 from .babel import FsDomain
+from .change_email import ChangeEmailForm
 from .decorators import (
     default_reauthn_handler,
     default_unauthn_handler,
@@ -112,7 +114,7 @@ if t.TYPE_CHECKING:  # pragma: no cover
     from flask.typing import ResponseValue
     import flask_login.mixins
     from authlib.integrations.flask_client import OAuth
-    from .datastore import Role, User, UserDatastore
+    from .datastore import UserDatastore
 
 
 # List of authentication mechanisms supported.
@@ -134,7 +136,7 @@ _default_config: dict[str, t.Any] = {
     "I18N_DOMAIN": "flask_security",
     "I18N_DIRNAME": "builtin",
     "EMAIL_VALIDATOR_ARGS": None,
-    "PASSWORD_HASH": "bcrypt",
+    "PASSWORD_HASH": "argon2",
     "PASSWORD_SALT": None,
     "PASSWORD_SINGLE_HASH": {
         "django_argon2",
@@ -158,17 +160,18 @@ _default_config: dict[str, t.Any] = {
         # And always last one...
         "plaintext",
     ],
+    "DEPRECATED_PASSWORD_SCHEMES": ["auto"],
     "PASSWORD_HASH_OPTIONS": {},  # Deprecated at passlib 1.7
-    "PASSWORD_HASH_PASSLIB_OPTIONS": {
-        "argon2__rounds": 10  # 1.7.1 default is 2.
-    },  # >= 1.7.1 method to pass options.
+    "PASSWORD_HASH_PASSLIB_OPTIONS": {},  # passlib >= 1.7.1 method to pass options
+    # (as part of CryptoContext.using)
     "PASSWORD_LENGTH_MIN": 8,
     "PASSWORD_COMPLEXITY_CHECKER": None,
     "PASSWORD_CHECK_BREACHED": False,
     "PASSWORD_BREACHED_COUNT": 1,
     "PASSWORD_NORMALIZE_FORM": "NFKD",
     "PASSWORD_REQUIRED": True,
-    "DEPRECATED_PASSWORD_SCHEMES": ["auto"],
+    "HASHING_SCHEMES": ["sha256_crypt", "hex_md5"],
+    "DEPRECATED_HASHING_SCHEMES": ["auto"],
     "LOGIN_URL": "/login",
     "LOGOUT_URL": "/logout",
     "REGISTER_URL": "/register",
@@ -200,6 +203,8 @@ _default_config: dict[str, t.Any] = {
     "REDIRECT_HOST": None,
     "REDIRECT_BEHAVIOR": None,
     "REDIRECT_ALLOW_SUBDOMAINS": False,
+    "REDIRECT_BASE_DOMAIN": None,
+    "REDIRECT_ALLOWED_SUBDOMAINS": [],
     "FORGOT_PASSWORD_TEMPLATE": "security/forgot_password.html",
     "LOGIN_USER_TEMPLATE": "security/login_user.html",
     "REGISTER_USER_TEMPLATE": "security/register_user.html",
@@ -223,6 +228,15 @@ _default_config: dict[str, t.Any] = {
     "SEND_PASSWORD_RESET_EMAIL": True,
     "SEND_PASSWORD_RESET_NOTICE_EMAIL": True,
     "LOGIN_WITHIN": "1 days",
+    "CHANGE_EMAIL": False,
+    "CHANGE_EMAIL_TEMPLATE": "security/change_email.html",
+    "CHANGE_EMAIL_WITHIN": "2 hours",
+    "CHANGE_EMAIL_URL": "/change-email",
+    "CHANGE_EMAIL_CONFIRM_URL": "/change-email-confirm",
+    "CHANGE_EMAIL_ERROR_VIEW": None,  # spa
+    "POST_CHANGE_EMAIL_VIEW": None,  # spa
+    "CHANGE_EMAIL_SALT": "change-email-salt",
+    "CHANGE_EMAIL_SUBJECT": _("Confirm your new email address"),
     "TWO_FACTOR_AUTHENTICATOR_VALIDITY": 120,
     "TWO_FACTOR_MAIL_VALIDITY": 300,
     "TWO_FACTOR_SMS_VALIDITY": 120,
@@ -234,6 +248,8 @@ _default_config: dict[str, t.Any] = {
         "secure": False,
         "samesite": "Strict",
     },
+    "TWO_FACTOR_SETUP_SALT": "tf-setup-salt",
+    "TWO_FACTOR_SETUP_WITHIN": "30 minutes",
     "TWO_FACTOR_RESCUE_EMAIL": True,
     "MULTI_FACTOR_RECOVERY_CODES": False,
     "MULTI_FACTOR_RECOVERY_CODES_N": 5,
@@ -283,9 +299,8 @@ _default_config: dict[str, t.Any] = {
     "PHONE_REGION_DEFAULT": "US",
     "FRESHNESS": timedelta(hours=24),
     "FRESHNESS_GRACE_PERIOD": timedelta(hours=1),
+    "FRESHNESS_ALLOW_AUTH_TOKEN": True,
     "API_ENABLED_METHODS": ["session", "token"],
-    "HASHING_SCHEMES": ["sha256_crypt", "hex_md5"],
-    "DEPRECATED_HASHING_SCHEMES": ["hex_md5"],
     "DATETIME_FACTORY": naive_utcnow,
     "TOTP_SECRETS": None,
     "TOTP_ISSUER": None,
@@ -528,6 +543,10 @@ _default_messages = {
         _("You successfully disabled two factor authorization."),
         "success",
     ),
+    "TWO_FACTOR_SETUP_EXPIRED": (
+        _("Setup must be completed within %(within)s. Please start over."),
+        "error",
+    ),
     "US_CURRENT_METHODS": (
         _("Currently active sign in options: %(method_list)s."),
         "info",
@@ -608,6 +627,21 @@ _default_messages = {
         _("Credential user handle didn't match"),
         "error",
     ),
+    "CHANGE_EMAIL_EXPIRED": (
+        _("Confirmation must be completed within %(within)s. Please start over."),
+        "error",
+    ),
+    "CHANGE_EMAIL_CONFIRMED": (
+        _("Change of email address confirmed"),
+        "success",
+    ),
+    "CHANGE_EMAIL_SENT": (
+        _(
+            "Instructions to confirm your new email address have"
+            " been sent to %(email)s."
+        ),
+        "success",
+    ),
 }
 
 
@@ -650,6 +684,7 @@ def _user_loader(user_id):
     user = _security.datastore.find_user(fs_uniquifier=str(user_id))
     if user and user.active:
         set_request_attr("fs_authn_via", "session")
+        set_request_attr("fs_paa", session.get("fs_paa", 0))
         return user
     return None
 
@@ -683,6 +718,8 @@ def _request_loader(request):
 
     if user and user.active and user.verify_auth_token(tdata):
         set_request_attr("fs_authn_via", "token")
+        if cv("FRESHNESS_ALLOW_AUTH_TOKEN"):
+            set_request_attr("fs_paa", tdata.get("fs_paa", 0))
         return user
 
     return None
@@ -780,9 +817,13 @@ class RoleMixin:
     """Mixin for `Role` model definitions"""
 
     if t.TYPE_CHECKING:  # pragma: no cover
+        id: int
+        name: str
+        description: str | None
+        permissions: list[str] | None
+        update_datetime: datetime
 
-        def __init__(self) -> None:
-            self.permissions: list[str] | None
+        def __init__(self, **kwargs): ...
 
     def __eq__(self, other):
         return self.name == other or self.name == getattr(other, "name", None)
@@ -807,6 +848,35 @@ class RoleMixin:
 class UserMixin(BaseUserMixin):
     """Mixin for `User` model definitions"""
 
+    if t.TYPE_CHECKING:  # pragma: no cover
+        # These are defined in the applications Model files.
+        id: int
+        email: str
+        username: str | None
+        password: str | None
+        active: bool
+        fs_uniquifier: str
+        fs_token_uniquifier: str
+        fs_webauthn_user_handle: str
+        confirmed_at: datetime | None
+        last_login_at: datetime
+        current_login_at: datetime
+        last_login_ip: str | None
+        current_login_ip: str | None
+        login_count: int
+        tf_primary_method: str | None
+        tf_totp_secret: str | None
+        tf_phone_number: str | None
+        mf_recovery_codes: list[str] | None
+        us_phone_number: str | None
+        us_totp_secrets: str | bytes | None
+        create_datetime: datetime
+        update_datetime: datetime
+        roles: list[RoleMixin]
+        webauthn: list[WebAuthnMixin]
+
+        def __init__(self, **kwargs): ...
+
     def get_id(self) -> str:
         """Returns the user identification attribute. 'Alternative-token' for
         Flask-Login. This is always ``fs_uniquifier``.
@@ -825,8 +895,12 @@ class UserMixin(BaseUserMixin):
 
         :raises ValueError: If ``fs_token_uniquifier`` is part of model but not set.
 
-        Optionally use a separate uniquifier so that changing password doesn't
-        invalidate auth tokens.
+        Uses ``fs_uniquifier`` or ``fs_token_uniquifier`` (if in the UserModel)
+        to identify this user. If ``fs_token_uniquifier`` is used then
+        changing password doesn't invalidate auth tokens.
+
+        Calls :meth:`.UserMixin.augment_auth_token` which applications can override
+        to add any additional information.
 
         The returned value is securely signed using the ``remember_token_serializer``
 
@@ -836,6 +910,9 @@ class UserMixin(BaseUserMixin):
         .. versionchanged:: 5.4.0
             New format - a dict with a version string. Add a token-based expiry
             option as well as a session id.
+        .. versionchanged:: 5.5.0
+            Remove session id (never set or used); added fs_paa (last authentication
+            timestamp)
         """
 
         tdata: dict[str, t.Any] = dict(ver=str(5))
@@ -845,7 +922,9 @@ class UserMixin(BaseUserMixin):
             tdata["uid"] = str(self.fs_token_uniquifier)
         else:
             tdata["uid"] = str(self.fs_uniquifier)
-        tdata["sid"] = 0  # session id
+        # Set the primary authenticated at variable. This is equivalent to
+        # what we set in the session.
+        tdata["fs_paa"] = time.time()  # equivalent of session["fs_paa"]
         tdata["exp"] = int(cv("TOKEN_EXPIRE_TIMESTAMP")(self))  # if >0 then shorter of
         # :data:SECURITY_MAX_AGE and this.
 
@@ -857,7 +936,8 @@ class UserMixin(BaseUserMixin):
 
     def augment_auth_token(self, tdata: dict[str, t.Any]) -> None:
         """Override this to add/modify parts of the auth token.
-        Additions to the dict can be made and verified in verify_auth_token()
+        Additions to the dict can be made here and verified in
+        :meth:`.UserMixin.verify_auth_token`
 
         .. versionadded:: 5.4.0
         """
@@ -879,7 +959,7 @@ class UserMixin(BaseUserMixin):
         """
         return True
 
-    def has_role(self, role: str | Role) -> bool:
+    def has_role(self, role: str | RoleMixin) -> bool:
         """Returns `True` if the user identifies with the specified role.
 
         :param role: A role name or `Role` instance"""
@@ -1004,11 +1084,27 @@ class UserMixin(BaseUserMixin):
 
 
 class WebAuthnMixin:
+    if t.TYPE_CHECKING:  # pragma: no cover
+        # These are defined in the applications Model files.
+        id: int
+        name: str
+        credential_id: bytes
+        public_key: bytes
+        sign_count: int
+        transports: list[str] | None
+        backup_state: bool
+        device_type: str
+        extensions: str | None
+        lastuse_datetime: datetime
+        usage: str
+
+        def __init__(self, **kwargs): ...
+
     def get_user_mapping(self) -> dict[str, t.Any]:
         """
         Return the filter needed by find_user() to get the user
         associated with this webauthn credential.
-        Note that this probably has to be overridden using mongoengine.
+        Note that this probably has to be overridden when using mongoengine.
 
         .. versionadded:: 5.0.0
         """
@@ -1034,10 +1130,11 @@ class Security:
     :param register_blueprint: to register the Security blueprint or not.
     :param login_form: set form for the login view
     :param verify_form: set form for re-authentication due to freshness check
+    :param change_email_form: set form for changing email address
     :param register_form: set form for the register view when
-            *SECURITY_CONFIRMABLE* is false
+            :data:`SECURITY_CONFIRMABLE` is false
     :param confirm_register_form: set form for the register view when
-            *SECURITY_CONFIRMABLE* is true
+            :data:`SECURITY_CONFIRMABLE` is true
     :param forgot_password_form: set form for the forgot password view
     :param reset_password_form: set form for the reset password view
     :param change_password_form: set form for the change password view
@@ -1086,7 +1183,8 @@ class Security:
 
     .. versionadded:: 3.4.0
         ``us_signin_form``, ``us_setup_form``, ``us_setup_validate_form``, and
-        ``us_verify_form`` added as part of the :ref:`unified-sign-in` feature.
+        ``us_verify_form`` added as part of the :ref:`configuration:unified signin`
+         feature.
 
     .. versionadded:: 3.4.0
         ``totp_cls`` added to enable applications to implement replay protection - see
@@ -1114,6 +1212,9 @@ class Security:
         ``mf_recovery_form``.
     .. versionadded:: 5.1.0
         ``mf_recovery_codes_util_cls``, ``oauth``
+    .. versionadded:: 5.5.0
+        ``change_email_form`` in support of the
+         :ref:`Change-Email<configuration:change-email>` feature.
 
     .. deprecated:: 4.0.0
         ``send_mail`` and ``send_mail_task``. Replaced with ``mail_util_cls``.
@@ -1132,8 +1233,10 @@ class Security:
         app: flask.Flask | None = None,
         datastore: UserDatastore | None = None,
         register_blueprint: bool = True,
+        *,
         login_form: t.Type[LoginForm] = LoginForm,
         verify_form: t.Type[VerifyForm] = VerifyForm,
+        change_email_form: t.Type[ChangeEmailForm] = ChangeEmailForm,
         confirm_register_form: t.Type[ConfirmRegisterForm] = ConfirmRegisterForm,
         register_form: t.Type[RegisterForm] = RegisterForm,
         forgot_password_form: t.Type[ForgotPasswordForm] = ForgotPasswordForm,
@@ -1207,6 +1310,7 @@ class Security:
             "register_form": FormInfo(cls=register_form),
             "forgot_password_form": FormInfo(cls=forgot_password_form),
             "reset_password_form": FormInfo(cls=reset_password_form),
+            "change_email_form": FormInfo(cls=change_email_form),
             "change_password_form": FormInfo(cls=change_password_form),
             "send_confirmation_form": FormInfo(cls=send_confirmation_form),
             "passwordless_login_form": FormInfo(cls=passwordless_login_form),
@@ -1237,7 +1341,7 @@ class Security:
             default_unauthz_handler
         )
         self._render_json: t.Callable[
-            [dict[str, t.Any], int, dict[str, str] | None, User | None],
+            [dict[str, t.Any], int, dict[str, str] | None, UserMixin | None],
             ResponseValue,
         ] = default_render_json
         self._want_json: t.Callable[[Request], bool] = default_want_json
@@ -1246,8 +1350,10 @@ class Security:
         self.remember_token_serializer: URLSafeTimedSerializer
         self.login_serializer: URLSafeTimedSerializer
         self.reset_serializer: URLSafeTimedSerializer
+        self.change_email_serializer: URLSafeTimedSerializer
         self.confirm_serializer: URLSafeTimedSerializer
         self.us_setup_serializer: URLSafeTimedSerializer
+        self.tf_setup_serializer: URLSafeTimedSerializer
         self.tf_validity_serializer: URLSafeTimedSerializer
         self.wan_serializer: URLSafeTimedSerializer
         self.principal: Principal
@@ -1269,10 +1375,12 @@ class Security:
         self._password_util: PasswordUtil
         self._totp_factory: Totp
         self._username_util: UsernameUtil
+        self._webauthn_util: WebauthnUtil
         self._mf_recovery_codes_util: MfRecoveryCodesUtil
 
         # Add necessary attributes here to keep mypy happy
         self.trackable: bool = False
+        self.change_email: bool = False
         self.confirmable: bool = False
         self.registerable: bool = False
         self.changeable: bool = False
@@ -1339,6 +1447,7 @@ class Security:
         form_names = [
             "login_form",
             "verify_form",
+            "change_email_form",
             "confirm_register_form",
             "register_form",
             "forgot_password_form",
@@ -1374,6 +1483,7 @@ class Security:
         attr_names = [
             "trackable",
             "registerable",
+            "change_email",
             "confirmable",
             "changeable",
             "recoverable",
@@ -1423,8 +1533,10 @@ class Security:
         self.remember_token_serializer = _get_serializer(app, "remember")
         self.login_serializer = _get_serializer(app, "login")
         self.reset_serializer = _get_serializer(app, "reset")
+        self.change_email_serializer = _get_serializer(app, "change_email")
         self.confirm_serializer = _get_serializer(app, "confirm")
         self.us_setup_serializer = _get_serializer(app, "us_setup")
+        self.tf_setup_serializer = _get_serializer(app, "two_factor_setup")
         self.tf_validity_serializer = _get_serializer(app, "two_factor_validity")
         self.wan_serializer = _get_serializer(app, "wan")
         self.principal = _get_principal(app)
@@ -1728,7 +1840,7 @@ class Security:
     def render_json(
         self,
         cb: t.Callable[
-            [dict[str, t.Any], int, dict[str, str] | None, User | None],
+            [dict[str, t.Any], int, dict[str, str] | None, UserMixin | None],
             ResponseValue,
         ],
     ) -> None:
@@ -1897,6 +2009,11 @@ class Security:
     ) -> None:
         self._add_ctx_processor("reset_password", fn)
 
+    def change_email_context_processor(
+        self, fn: t.Callable[[], dict[str, t.Any]]
+    ) -> None:
+        self._add_ctx_processor("change_email", fn)
+
     def change_password_context_processor(
         self, fn: t.Callable[[], dict[str, t.Any]]
     ) -> None:
diff -pruN 5.4.3-1/flask_security/datastore.py 5.5.0-1/flask_security/datastore.py
--- 5.4.3-1/flask_security/datastore.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/datastore.py	2024-07-24 02:21:26.000000000 +0000
@@ -11,16 +11,17 @@
 
 from __future__ import annotations
 
-from datetime import datetime
 import json
 import typing as t
 import uuid
 from copy import copy
 
+from .core import UserMixin, RoleMixin, WebAuthnMixin
 from .utils import config_value as cv
 
 if t.TYPE_CHECKING:  # pragma: no cover
     import flask_sqlalchemy
+    import flask_sqlalchemy_lite
     import mongoengine
     import sqlalchemy.orm.scoping
 
@@ -186,9 +187,9 @@ class UserDatastore:
 
     def __init__(
         self,
-        user_model: t.Type[User],
-        role_model: t.Type[Role],
-        webauthn_model: t.Type[WebAuthn] | None = None,
+        user_model: t.Type[UserMixin],
+        role_model: t.Type[RoleMixin],
+        webauthn_model: t.Type[WebAuthnMixin] | None = None,
     ):
         self.user_model = user_model
         self.role_model = role_model
@@ -202,7 +203,10 @@ class UserDatastore:
         def put(self, model):
             pass
 
-    def _prepare_role_modify_args(self, role: str | Role) -> Role | None:
+        def commit(self):
+            pass
+
+    def _prepare_role_modify_args(self, role: str | RoleMixin) -> RoleMixin | None:
         if isinstance(role, str):
             return self.find_role(role)
         return role
@@ -223,18 +227,21 @@ class UserDatastore:
 
         return kwargs
 
-    def find_user(self, **kwargs: t.Any) -> User | None:
+    def find_user(
+        self, case_insensitive: bool = False, **kwargs: t.Any
+    ) -> UserMixin | None:
         """Returns a user matching the provided parameters.
-        Besides keyword arguments used to filter the results,
-        'case_insensitive' can be passed (defaults to False)
+        A single kwarg will be poped and used to filter results. This should
+        be a unique/primary key in the User model since only a single result is
+        returned.
         """
         raise NotImplementedError
 
-    def find_role(self, role: str) -> Role | None:
+    def find_role(self, role: str) -> RoleMixin | None:
         """Returns a role matching the provided name."""
         raise NotImplementedError
 
-    def add_role_to_user(self, user: User, role: Role | str) -> bool:
+    def add_role_to_user(self, user: UserMixin, role: RoleMixin | str) -> bool:
         """Adds a role to a user.
 
         :param user: The user to manipulate.
@@ -250,7 +257,7 @@ class UserDatastore:
             return True
         return False
 
-    def remove_role_from_user(self, user: User, role: Role | str) -> bool:
+    def remove_role_from_user(self, user: UserMixin, role: RoleMixin | str) -> bool:
         """Removes a role from a user.
 
         :param user: The user to manipulate. Can be an User object or email
@@ -268,7 +275,7 @@ class UserDatastore:
         return rv
 
     def add_permissions_to_role(
-        self, role: Role | str, permissions: set | list | tuple | str
+        self, role: RoleMixin | str, permissions: set | list | tuple | str
     ) -> bool:
         """Add one or more permissions to role.
 
@@ -296,7 +303,7 @@ class UserDatastore:
         return rv
 
     def remove_permissions_from_role(
-        self, role: Role | str, permissions: set | list | tuple | str
+        self, role: RoleMixin | str, permissions: set | list | tuple | str
     ) -> bool:
         """Remove one or more permissions from a role.
 
@@ -322,13 +329,13 @@ class UserDatastore:
             self.put(role_obj)
         return rv
 
-    def toggle_active(self, user: User) -> bool:
+    def toggle_active(self, user: UserMixin) -> bool:
         """Toggles a user's active status. Always returns True."""
         user.active = not user.active
         self.put(user)
         return True
 
-    def deactivate_user(self, user: User) -> bool:
+    def deactivate_user(self, user: UserMixin) -> bool:
         """Deactivates a specified user. Returns `True` if a change was made.
 
         This will immediately disallow access to all endpoints that require
@@ -343,7 +350,7 @@ class UserDatastore:
             return True
         return False
 
-    def activate_user(self, user: User) -> bool:
+    def activate_user(self, user: UserMixin) -> bool:
         """Activates a specified user. Returns `True` if a change was made.
 
         :param user: The user to activate
@@ -354,7 +361,7 @@ class UserDatastore:
             return True
         return False
 
-    def set_uniquifier(self, user: User, uniquifier: str | None = None) -> None:
+    def set_uniquifier(self, user: UserMixin, uniquifier: str | None = None) -> None:
         """Set user's Flask-Security identity key.
         This will immediately render outstanding auth tokens,
         session cookies and remember cookies invalid.
@@ -369,7 +376,9 @@ class UserDatastore:
         user.fs_uniquifier = uniquifier
         self.put(user)
 
-    def set_token_uniquifier(self, user: User, uniquifier: str | None = None) -> None:
+    def set_token_uniquifier(
+        self, user: UserMixin, uniquifier: str | None = None
+    ) -> None:
         """Set user's auth token identity key.
         This will immediately render outstanding auth tokens invalid.
 
@@ -387,7 +396,7 @@ class UserDatastore:
             user.fs_token_uniquifier = uniquifier
             self.put(user)
 
-    def create_role(self, **kwargs: t.Any) -> Role:
+    def create_role(self, **kwargs: t.Any) -> RoleMixin:
         """
         Creates and returns a new role from the given parameters.
         Supported params (depending on RoleModel):
@@ -414,13 +423,13 @@ class UserDatastore:
         role = self.role_model(**kwargs)
         return self.put(role)
 
-    def find_or_create_role(self, name: str, **kwargs: t.Any) -> Role:
+    def find_or_create_role(self, name: str, **kwargs: t.Any) -> RoleMixin:
         """Returns a role matching the given name or creates it with any
         additionally provided parameters.
         """
         return self.find_role(name) or self.create_role(name=name, **kwargs)
 
-    def create_user(self, **kwargs: t.Any) -> User:
+    def create_user(self, **kwargs: t.Any) -> UserMixin:
         """Creates and returns a new user from the given parameters.
 
         :kwparam email: required.
@@ -462,14 +471,14 @@ class UserDatastore:
         user = self.user_model(**kwargs)
         return self.put(user)
 
-    def delete_user(self, user: User) -> None:
+    def delete_user(self, user: UserMixin) -> None:
         """Deletes the specified user.
 
         :param user: The user to delete
         """
         self.delete(user)  # type: ignore
 
-    def reset_user_access(self, user: User) -> None:
+    def reset_user_access(self, user: UserMixin) -> None:
         """
         Use this method to reset user authentication methods in the case of compromise.
         This will:
@@ -510,7 +519,7 @@ class UserDatastore:
 
     def tf_set(
         self,
-        user: User,
+        user: UserMixin,
         primary_method: str,
         totp_secret: str | None = None,
         phone: str | None = None,
@@ -542,7 +551,7 @@ class UserDatastore:
         if changed:
             self.put(user)
 
-    def tf_reset(self, user: User) -> None:
+    def tf_reset(self, user: UserMixin) -> None:
         """Disable two-factor auth for user.
 
         .. versionadded: 3.4.1
@@ -552,7 +561,7 @@ class UserDatastore:
         user.tf_phone_number = None
         self.put(user)
 
-    def mf_set_recovery_codes(self, user: User, rcs: list[str] | None) -> None:
+    def mf_set_recovery_codes(self, user: UserMixin, rcs: list[str] | None) -> None:
         """Set MF recovery codes into user record.
         Any existing codes will be erased.
 
@@ -561,11 +570,11 @@ class UserDatastore:
         user.mf_recovery_codes = rcs
         self.put(user)
 
-    def mf_get_recovery_codes(self, user: User) -> list[str]:
+    def mf_get_recovery_codes(self, user: UserMixin) -> list[str]:
         codes = getattr(user, "mf_recovery_codes", [])
         return codes if codes else []
 
-    def mf_delete_recovery_code(self, user: User, idx: int) -> bool:
+    def mf_delete_recovery_code(self, user: UserMixin, idx: int) -> bool:
         """Delete a single recovery code.
         Recovery codes are single-use - so delete after using!
 
@@ -582,7 +591,7 @@ class UserDatastore:
         except IndexError:
             return False
 
-    def us_get_totp_secrets(self, user: User) -> dict[str, str]:
+    def us_get_totp_secrets(self, user: UserMixin) -> dict[str, str]:
         """Return totp secrets.
         These are json encoded in the DB.
 
@@ -594,7 +603,9 @@ class UserDatastore:
             return {}
         return json.loads(user.us_totp_secrets)
 
-    def us_put_totp_secrets(self, user: User, secrets: dict[str, str] | None) -> None:
+    def us_put_totp_secrets(
+        self, user: UserMixin, secrets: dict[str, str] | None
+    ) -> None:
         """Save secrets. Assume to be a dict (or None)
         with keys as methods, and values as (encrypted) secrets.
 
@@ -605,7 +616,7 @@ class UserDatastore:
 
     def us_set(
         self,
-        user: User,
+        user: UserMixin,
         method: str,
         totp_secret: str | None = None,
         phone: str | None = None,
@@ -631,7 +642,7 @@ class UserDatastore:
             user.us_phone_number = phone
             self.put(user)
 
-    def us_reset(self, user: User, method: str | None = None) -> None:
+    def us_reset(self, user: UserMixin, method: str | None = None) -> None:
         """Disable unified sign in for user.
         This will disable authenticator app and SMS, and email.
         N.B. if user has no password they may not be able to authenticate at all.
@@ -655,7 +666,7 @@ class UserDatastore:
                 user.us_phone_number = None
                 self.put(user)
 
-    def us_setup_email(self, user: User) -> bool:
+    def us_setup_email(self, user: UserMixin) -> bool:
         # setup email (if allowed) for user for unified sign in.
         from .proxies import _security
 
@@ -667,7 +678,7 @@ class UserDatastore:
         return True
 
     def set_webauthn_user_handle(
-        self, user: User, user_handle: str | None = None
+        self, user: UserMixin, user_handle: str | None = None
     ) -> None:
         """Set the value for the Relaying Party's (that's us)
         UserHandle (user.id)
@@ -680,7 +691,7 @@ class UserDatastore:
 
     def create_webauthn(
         self,
-        user: User,
+        user: UserMixin,
         credential_id: bytes,
         public_key: bytes,
         name: str,
@@ -701,20 +712,20 @@ class UserDatastore:
         """
         raise NotImplementedError
 
-    def delete_webauthn(self, webauthn: WebAuthn) -> None:
+    def delete_webauthn(self, webauthn: WebAuthnMixin) -> None:
         """
         .. versionadded: 5.0.0
         """
         self.delete(webauthn)
 
-    def find_webauthn(self, credential_id: bytes) -> WebAuthn | None:
+    def find_webauthn(self, credential_id: bytes) -> WebAuthnMixin | None:
         """Returns a credential matching the id.
 
         .. versionadded: 5.0.0
         """
         raise NotImplementedError
 
-    def find_user_from_webauthn(self, webauthn: WebAuthn) -> User | None:
+    def find_user_from_webauthn(self, webauthn: WebAuthnMixin) -> UserMixin | None:
         """Returns user associated with this webauthn credential
 
         .. versionadded: 5.0.0
@@ -724,7 +735,7 @@ class UserDatastore:
         user_filter = webauthn.get_user_mapping()
         return self.find_user(**user_filter)
 
-    def webauthn_reset(self, user: User) -> None:
+    def webauthn_reset(self, user: UserMixin) -> None:
         """Reset access via webauthn credentials.
         This will DELETE all registered credentials.
         There doesn't appear to be any reason to change the user's
@@ -752,47 +763,55 @@ class SQLAlchemyUserDatastore(SQLAlchemy
     def __init__(
         self,
         db: flask_sqlalchemy.SQLAlchemy,
-        user_model: t.Type[User],
-        role_model: t.Type[Role],
-        webauthn_model: t.Type[WebAuthn] | None = None,
+        user_model: t.Type[UserMixin],
+        role_model: t.Type[RoleMixin],
+        webauthn_model: t.Type[WebAuthnMixin] | None = None,
     ):
         SQLAlchemyDatastore.__init__(self, db)
         UserDatastore.__init__(self, user_model, role_model, webauthn_model)
 
-    def find_user(self, case_insensitive: bool = False, **kwargs: t.Any) -> User | None:
-        from sqlalchemy import func as alchemyFn
+    def find_user(
+        self, case_insensitive: bool = False, **kwargs: t.Any
+    ) -> UserMixin | None:
+        from sqlalchemy import func, select
+        from sqlalchemy.orm import joinedload
+
+        attr, value = kwargs.popitem()  # only a single query attribute accepted
+        val = getattr(self.user_model, attr)
+        stmt = select(self.user_model)
 
-        query = self.user_model.query
         if cv("JOIN_USER_ROLES") and hasattr(self.user_model, "roles"):
-            from sqlalchemy.orm import joinedload
-
-            query = query.options(joinedload(self.user_model.roles))  # type: ignore
-
+            stmt = stmt.options(joinedload(self.user_model.roles))  # type: ignore
         if case_insensitive:
-            # While it is of course possible to pass in multiple keys to filter on
-            # that isn't the normal use case. If caller asks for case_insensitive
-            # AND gives multiple keys - throw an error.
-            if len(kwargs) > 1:
-                raise ValueError("Case insensitive option only supports single key")
-            attr, identifier = kwargs.popitem()
-            subquery = alchemyFn.lower(
-                getattr(self.user_model, attr)
-            ) == alchemyFn.lower(identifier)
-            return query.filter(subquery).first()
+            stmt = stmt.where(
+                func.lower(val) == func.lower(value)  # type: ignore[arg-type]
+            )
         else:
-            return query.filter_by(**kwargs).first()
+            stmt = stmt.where(val == value)  # type: ignore[arg-type]
+        return self.db.session.scalar(stmt)
 
-    def find_role(self, role: str) -> Role | None:
-        return self.role_model.query.filter_by(name=role).first()  # type: ignore
+    def find_role(self, role: str) -> RoleMixin | None:
+        from sqlalchemy import select
 
-    def find_webauthn(self, credential_id: bytes) -> WebAuthn | None:
-        return self.webauthn_model.query.filter_by(  # type: ignore
-            credential_id=credential_id
-        ).first()
+        return self.db.session.scalar(
+            select(self.role_model).where(self.role_model.name == role)  # type: ignore
+        )
+
+    def find_webauthn(self, credential_id: bytes) -> WebAuthnMixin | None:
+        from sqlalchemy import select
+
+        if not self.webauthn_model:  # pragma: no cover
+            raise NotImplementedError
+
+        return self.db.session.scalar(
+            select(self.webauthn_model).where(
+                self.webauthn_model.credential_id == credential_id  # type: ignore
+            )
+        )
 
     def create_webauthn(
         self,
-        user: User,
+        user: UserMixin,
         credential_id: bytes,
         public_key: bytes,
         name: str,
@@ -841,9 +860,9 @@ class SQLAlchemySessionUserDatastore(SQL
     def __init__(
         self,
         session: sqlalchemy.orm.scoping.scoped_session,
-        user_model: t.Type[User],
-        role_model: t.Type[Role],
-        webauthn_model: t.Type[WebAuthn] | None = None,
+        user_model: t.Type[UserMixin],
+        role_model: t.Type[RoleMixin],
+        webauthn_model: t.Type[WebAuthnMixin] | None = None,
     ):
         class PretendFlaskSQLAlchemyDb:
             """This is a pretend db object, so we can just pass in a session."""
@@ -859,8 +878,35 @@ class SQLAlchemySessionUserDatastore(SQL
             webauthn_model,
         )
 
-    def commit(self):
-        super().commit()
+
+class FSQLALiteUserDatastore(SQLAlchemyUserDatastore, UserDatastore):
+    """A UserDatastore implementation that assumes the use of
+    `Flask-SQLAlchemy-Lite <https://pypi.python.org/pypi/flask-sqlalchemy-lite/>`_
+    for datastore transactions.
+
+    :param db:
+    :param user_model: See :ref:`Models <models_topic>`.
+    :param role_model: See :ref:`Models <models_topic>`.
+    :param webauthn_model: See :ref:`Models <models_topic>`.
+    """
+
+    if t.TYPE_CHECKING:  # pragma: no cover
+        from flask_sqlalchemy_lite import SQLAlchemy
+
+    def __init__(
+        self,
+        db: flask_sqlalchemy_lite.SQLAlchemy,
+        user_model: t.Type[UserMixin],
+        role_model: t.Type[RoleMixin],
+        webauthn_model: t.Type[WebAuthnMixin] | None = None,
+    ):
+        SQLAlchemyUserDatastore.__init__(
+            self,
+            db,  # type: ignore
+            user_model,
+            role_model,
+            webauthn_model,
+        )
 
 
 class MongoEngineUserDatastore(MongoEngineDatastore, UserDatastore):
@@ -878,9 +924,9 @@ class MongoEngineUserDatastore(MongoEngi
     def __init__(
         self,
         db: mongoengine.connection,
-        user_model: t.Type[User],
-        role_model: t.Type[Role],
-        webauthn_model: t.Type[WebAuthn] | None = None,
+        user_model: t.Type[UserMixin],
+        role_model: t.Type[RoleMixin],
+        webauthn_model: t.Type[WebAuthnMixin] | None = None,
     ):
         MongoEngineDatastore.__init__(self, db)
         UserDatastore.__init__(self, user_model, role_model, webauthn_model)
@@ -910,7 +956,7 @@ class MongoEngineUserDatastore(MongoEngi
     def find_role(self, role):
         return self.role_model.objects(name=role).first()
 
-    def find_webauthn(self, credential_id: bytes) -> WebAuthn | None:
+    def find_webauthn(self, credential_id: bytes) -> WebAuthnMixin | None:
         if not self.webauthn_model:
             raise NotImplementedError
 
@@ -921,7 +967,7 @@ class MongoEngineUserDatastore(MongoEngi
 
     def create_webauthn(
         self,
-        user: User,
+        user: UserMixin,
         credential_id: bytes,
         public_key: bytes,
         name: str,
@@ -1058,7 +1104,7 @@ class PeeweeUserDatastore(PeeweeDatastor
 
     def create_webauthn(
         self,
-        user: User,
+        user: UserMixin,
         credential_id: bytes,
         public_key: bytes,
         name: str,
@@ -1137,66 +1183,3 @@ class PonyUserDatastore(PonyDatastore, U
     @with_pony_session
     def create_role(self, **kwargs):
         return super().create_role(**kwargs)
-
-
-if t.TYPE_CHECKING:  # pragma: no cover
-    # Normally - the application creates the Models and glues them together
-    # For typing we do that here since we don't know which DB interface they
-    # will pick.
-    from .core import UserMixin, RoleMixin, WebAuthnMixin
-
-    class CanonicalUserDatastore(Datastore, UserDatastore):
-        pass
-
-    class User(UserMixin):
-        id: int
-        email: str
-        username: str | None
-        password: str | None
-        active: bool
-        fs_uniquifier: str
-        fs_token_uniquifier: str
-        fs_webauthn_user_handle: str
-        confirmed_at: datetime | None
-        last_login_at: datetime
-        current_login_at: datetime
-        last_login_ip: str | None
-        current_login_ip: str | None
-        login_count: int
-        tf_primary_method: str | None
-        tf_totp_secret: str | None
-        tf_phone_number: str | None
-        mf_recovery_codes: list[str] | None
-        us_phone_number: str | None
-        us_totp_secrets: str | bytes | None
-        create_datetime: datetime
-        update_datetime: datetime
-        roles: list[Role]
-        webauthn: list[WebAuthn]
-
-        def __init__(self, **kwargs): ...
-
-    class Role(RoleMixin):
-        id: int
-        name: str
-        description: str | None
-        permissions: list[str] | None
-        update_datetime: datetime
-
-        def __init__(self, **kwargs): ...
-
-    class WebAuthn(WebAuthnMixin):
-        id: int
-        name: str
-        credential_id: bytes
-        public_key: bytes
-        sign_count: int
-        transports: list[str] | None
-        backup_state: bool
-        device_type: str
-        extensions: str | None
-        lastuse_datetime: datetime
-        user_id: int
-        usage: str
-
-        def __init__(self, **kwargs): ...
diff -pruN 5.4.3-1/flask_security/decorators.py 5.5.0-1/flask_security/decorators.py
--- 5.4.3-1/flask_security/decorators.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/decorators.py	2024-07-24 02:21:26.000000000 +0000
@@ -332,9 +332,7 @@ def auth_required(
         timedelta.total_seconds() is used for the calculations:
 
             - If > 0, then the caller must have authenticated within the time specified
-              (as measured using the session cookie).
-            - If 0 and not within the grace period (see below) the caller will
-              always be redirected to re-authenticate.
+              (as measured using the session cookie or authentication token).
             - If < 0 (the default) no freshness check is performed.
 
         Note that Basic Auth, by definition, is always 'fresh' and will never result in
@@ -422,8 +420,7 @@ def auth_required(
             for method, mechanism in mechanisms:
                 if mechanism and mechanism():
                     # successfully authenticated. Basic auth is by definition 'fresh'.
-                    # Note that using token auth is ok - but caller still has to pass
-                    # in a session cookie if freshness checking is required.
+                    # If 'within' is set - check for freshness of authentication.
                     if not check_and_update_authn_fresh(within, grace, method):
                         return _security._reauthn_handler(within, grace)
                     if eresponse := handle_csrf(method, _security._want_json(request)):
diff -pruN 5.4.3-1/flask_security/forms.py 5.5.0-1/flask_security/forms.py
--- 5.4.3-1/flask_security/forms.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/forms.py	2024-07-24 02:21:26.000000000 +0000
@@ -56,7 +56,7 @@ from .utils import (
 )
 
 if t.TYPE_CHECKING:  # pragma: no cover
-    from .datastore import User
+    from flask_security import UserMixin
 
 _default_field_labels = {
     "email": _("Email Address"),
@@ -436,7 +436,7 @@ class SendConfirmationForm(Form, UserEma
 
     def __init__(self, *args: t.Any, **kwargs: t.Any):
         super().__init__(*args, **kwargs)
-        self.user: User | None = None  # set by valid_user_email
+        self.user: UserMixin | None = None  # set by valid_user_email
         if request and request.method == "GET":
             self.email.data = request.args.get("email", None)
 
@@ -458,7 +458,7 @@ class ForgotPasswordForm(Form, UserEmail
     def __init__(self, *args: t.Any, **kwargs: t.Any):
         super().__init__(*args, **kwargs)
         self.requires_confirmation: bool = False
-        self.user: User | None = None  # set by valid_user_email
+        self.user: UserMixin | None = None  # set by valid_user_email
 
     def validate(self, **kwargs: t.Any) -> bool:
         if not super().validate(**kwargs):
@@ -487,7 +487,7 @@ class PasswordlessLoginForm(Form):
 
     def __init__(self, *args: t.Any, **kwargs: t.Any):
         super().__init__(*args, **kwargs)
-        self.user: User | None = None  # set by valid_user_email
+        self.user: UserMixin | None = None  # set by valid_user_email
 
     def validate(self, **kwargs: t.Any) -> bool:
         if not super().validate(**kwargs):
@@ -527,7 +527,7 @@ class LoginForm(Form, PasswordFormMixin,
             )
             self.password.description = html
         self.requires_confirmation: bool = False
-        self.user: User | None = None
+        self.user: UserMixin | None = None
         # ifield can be set by subclasses to skip identity checks.
         self.ifield: Field | None = None
         # If True then user has authenticated so we can show detailed errors
@@ -602,9 +602,9 @@ class VerifyForm(Form, PasswordFormMixin
 
     submit = SubmitField(get_form_field_label("verify_password"))
 
-    def __init__(self, *args: t.Any, user: User, **kwargs: t.Any):
+    def __init__(self, *args: t.Any, user: UserMixin, **kwargs: t.Any):
         super().__init__(*args, **kwargs)
-        self.user: User = user
+        self.user: UserMixin = user
 
     def validate(self, **kwargs: t.Any) -> bool:
         if not super().validate(**kwargs):  # pragma: no cover
@@ -705,7 +705,7 @@ class ResetPasswordForm(Form, NewPasswor
     """The default reset password form"""
 
     # filled in by caller
-    user: User
+    user: UserMixin
 
     submit = SubmitField(get_form_field_label("reset_password"))
 
@@ -827,7 +827,7 @@ class TwoFactorVerifyCodeForm(Form, Code
         self.window: int = 0
         self.primary_method: str = ""
         self.tf_totp_secret: str = ""
-        self.user: User | None = None  # set by view
+        self.user: UserMixin | None = None  # set by view
 
     def validate(self, **kwargs: t.Any) -> bool:
         if not super().validate(**kwargs):  # pragma: no cover
@@ -876,7 +876,7 @@ class DummyForm(Form):
 
     def __init__(self, *args: t.Any, **kwargs: t.Any):
         super().__init__(*args, **kwargs)
-        self.user: User | None = kwargs.get("user", None)
+        self.user: UserMixin | None = kwargs.get("user", None)
 
 
 def build_form_from_request(form_name: str, **kwargs: dict[str, t.Any]) -> Form:
diff -pruN 5.4.3-1/flask_security/models/fsqla.py 5.5.0-1/flask_security/models/fsqla.py
--- 5.4.3-1/flask_security/models/fsqla.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/models/fsqla.py	2024-07-24 02:21:26.000000000 +0000
@@ -11,6 +11,9 @@ BE AWARE: Once any version of this is sh
 a new version needs to be created.
 """
 
+# mypy: disable-error-code="assignment"
+# pyright: reportAssignmentType = false, reportIncompatibleVariableOverride=false
+
 from typing import cast
 from sqlalchemy import (
     Boolean,
@@ -56,7 +59,7 @@ class FsModels:
         .. note::
             This should only be used if you are utilizing the fsqla data
             models. With your own models you would need similar but slightly
-            difficult code.
+            different code.
         """
         cls.db = appdb
         cls.user_table_name = user_table_name
diff -pruN 5.4.3-1/flask_security/models/fsqla_v2.py 5.5.0-1/flask_security/models/fsqla_v2.py
--- 5.4.3-1/flask_security/models/fsqla_v2.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/models/fsqla_v2.py	2024-07-24 02:21:26.000000000 +0000
@@ -13,6 +13,9 @@ This is Version 2:
     - Make username unique (but not required).
 """
 
+# mypy: disable-error-code="assignment"
+# pyright: reportAssignmentType = false, reportIncompatibleVariableOverride=false
+
 from sqlalchemy import Column, String, Text
 from sqlalchemy.ext.declarative import declared_attr
 
diff -pruN 5.4.3-1/flask_security/models/fsqla_v3.py 5.5.0-1/flask_security/models/fsqla_v3.py
--- 5.4.3-1/flask_security/models/fsqla_v3.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/models/fsqla_v3.py	2024-07-24 02:21:26.000000000 +0000
@@ -16,6 +16,9 @@ This is Version 3:
     - Add support for list types.
 """
 
+# mypy: disable-error-code="assignment"
+# pyright: reportAssignmentType = false, reportIncompatibleVariableOverride=false
+
 from sqlalchemy import (
     Boolean,
     Column,
diff -pruN 5.4.3-1/flask_security/models/sqla.py 5.5.0-1/flask_security/models/sqla.py
--- 5.4.3-1/flask_security/models/sqla.py	1970-01-01 00:00:00.000000000 +0000
+++ 5.5.0-1/flask_security/models/sqla.py	2024-07-24 02:21:26.000000000 +0000
@@ -0,0 +1,224 @@
+"""
+Copyright 2024-2024 by J. Christopher Wagner (jwag). All rights reserved.
+:license: MIT, see LICENSE for more details.
+
+
+Complete models for all features when using SqlAlchemy.
+These are pure sqlalchemy declarative models - so should work with Flask-SQLAlchemy-Lite
+as well as just sqlalchemy (such as using a scoped session).
+
+You can change the table names by passing them in to the set_db_info() method.
+
+BE AWARE: Once any version of this is shipped no changes can be made - instead
+a new version needs to be created.
+"""
+
+# mypy: disable-error-code="assignment"
+# pyright: reportAssignmentType = false, reportIncompatibleVariableOverride=false
+
+from __future__ import annotations
+
+import datetime
+
+from sqlalchemy import (
+    Column,
+    LargeBinary,
+    String,
+    Table,
+    Text,
+    ForeignKey,
+)
+from sqlalchemy.ext.declarative import declared_attr
+from sqlalchemy.ext.mutable import MutableList
+from sqlalchemy.sql import func
+from sqlalchemy.orm import DeclarativeBase, Mapped, mapped_column, relationship
+
+from flask_security import AsaList, RoleMixin, UserMixin, WebAuthnMixin, naive_utcnow
+
+
+class FsModels:
+    """
+    Helper class for model mixins.
+    """
+
+    roles_users = None
+    fs_model_version = 1
+    base_model: DeclarativeBase
+    user_table_name = "user"
+    role_table_name = "role"
+    webauthn_table_name = "webauthn"
+
+    @classmethod
+    def set_db_info(
+        cls,
+        *,
+        base_model,
+        user_table_name="user",
+        role_table_name="role",
+        webauthn_table_name="webauthn",
+    ):
+        """Initialize Model.
+        This MUST be called PRIOR to declaring your User/Role/WebAuthn model in order
+        for table name altering to work.
+
+        .. note::
+            This should only be used if you are utilizing the sqla data
+            models. With your own models you would need similar but slightly
+            different code.
+        """
+        cls.base_model = base_model
+        cls.user_table_name = user_table_name
+        cls.role_table_name = role_table_name
+        cls.webauthn_table_name = webauthn_table_name
+        cls.roles_users = Table(
+            "roles_users",
+            cls.base_model.metadata,
+            Column(
+                "user_id", ForeignKey(f"{cls.user_table_name}.id"), primary_key=True
+            ),
+            Column(
+                "role_id", ForeignKey(f"{cls.role_table_name}.id"), primary_key=True
+            ),
+        )
+
+
+class FsRoleMixin(RoleMixin):
+    id: Mapped[int] = mapped_column(primary_key=True)
+    name: Mapped[str] = mapped_column(String(80), unique=True)
+    description: Mapped[str | None] = mapped_column(String(255))
+    # A comma separated list of strings
+    permissions: Mapped[list[str] | None] = mapped_column(  # type: ignore[assignment]
+        MutableList.as_mutable(AsaList()),
+    )
+    update_datetime: Mapped[datetime.datetime] = mapped_column(
+        server_default=func.now(),
+        onupdate=naive_utcnow,
+    )
+
+    @declared_attr
+    def users(cls):
+        return relationship(
+            "User",
+            secondary="roles_users",
+            back_populates="roles",
+        )
+
+
+class FsUserMixin(UserMixin):
+    """User information"""
+
+    # flask_security basic fields
+    id: Mapped[int] = mapped_column(primary_key=True)
+    email: Mapped[str] = mapped_column(String(255), unique=True)
+    # Make username unique but not required.
+    username: Mapped[str | None] = mapped_column(String(255), unique=True)
+    # Change password to nullable so we can tell after registration whether
+    # a user has a password or not.
+    password: Mapped[str | None] = mapped_column(String(255))
+    active: Mapped[bool] = mapped_column()
+
+    # Flask-Security user identifier
+    fs_uniquifier: Mapped[str] = mapped_column(String(64), unique=True)
+
+    # confirmable
+    confirmed_at: Mapped[datetime.datetime | None] = mapped_column()
+
+    # trackable
+    last_login_at: Mapped[datetime.datetime | None] = mapped_column()
+    current_login_at: Mapped[datetime.datetime | None] = mapped_column()
+    last_login_ip: Mapped[str | None] = mapped_column(String(64))
+    current_login_ip: Mapped[str | None] = mapped_column(String(64))
+    login_count: Mapped[int | None] = mapped_column()
+
+    # 2FA
+    tf_primary_method: Mapped[str | None] = mapped_column(String(64))
+    tf_totp_secret: Mapped[str | None] = mapped_column(String(255))
+    tf_phone_number: Mapped[str | None] = mapped_column(String(128))
+
+    # unified sign in
+    us_totp_secrets: Mapped[str | None] = mapped_column(Text)
+    # since phone can be used to authenticate - must be unique.
+    us_phone_number: Mapped[str | None] = mapped_column(String(128), unique=True)
+
+    try:
+        import webauthn as webauthn_pkg
+
+        # List of WebAuthn registrations
+        @declared_attr
+        def webauthn(cls):
+            return relationship(
+                "WebAuthn", back_populates="user", cascade="all, delete"
+            )
+
+    except ImportError:  # pragma: no cover
+        pass
+
+    # The user handle as required during registration.
+    # Note max length 64 as specified in spec.
+    fs_webauthn_user_handle: Mapped[str | None] = mapped_column(String(64), unique=True)
+
+    # MFA - one time recovery codes - comma separated.
+    mf_recovery_codes: Mapped[list[str] | None] = mapped_column(
+        MutableList.as_mutable(AsaList())
+    )
+
+    @declared_attr
+    def roles(cls):
+        # The first arg is a class name, the backref is a column name
+        return relationship(
+            "Role",
+            secondary="roles_users",
+            back_populates="users",
+        )
+
+    create_datetime: Mapped[datetime.datetime] = mapped_column(
+        server_default=func.now()
+    )
+    update_datetime: Mapped[datetime.datetime] = mapped_column(
+        server_default=func.now(),
+        onupdate=naive_utcnow,
+    )
+
+
+class FsWebAuthnMixin(WebAuthnMixin):
+    """WebAuthn"""
+
+    id: Mapped[int] = mapped_column(primary_key=True)
+    credential_id: Mapped[bytes] = mapped_column(
+        LargeBinary(1024), index=True, unique=True
+    )
+    public_key: Mapped[bytes] = mapped_column(LargeBinary)
+    sign_count: Mapped[int | None] = mapped_column(default=0)
+    transports: Mapped[list[str] | None] = mapped_column(
+        MutableList.as_mutable(AsaList())
+    )
+    backup_state: Mapped[bool] = mapped_column()  # Upcoming post V3 spec
+    device_type: Mapped[str] = mapped_column(String(64))
+
+    # a JSON string as returned from registration
+    extensions: Mapped[str | None] = mapped_column(String(255))
+    create_datetime: Mapped[datetime.datetime] = mapped_column(
+        server_default=func.now()
+    )
+    lastuse_datetime: Mapped[datetime.datetime] = mapped_column()
+    # name is provided by user - we make sure is unique per user
+    name: Mapped[str] = mapped_column(String(64))
+
+    # Usage - a credential can EITHER be for first factor or secondary factor
+    usage: Mapped[str] = mapped_column(String(64))
+
+    try:
+        import webauthn as webauthn_pkg
+
+        @declared_attr
+        def user(cls):
+            return relationship("User", back_populates="webauthn")
+
+    except ImportError:  # pragma: no cover
+        pass
+
+    @declared_attr
+    def user_id(cls) -> Mapped[int]:
+        return mapped_column(
+            ForeignKey(f"{FsModels.user_table_name}.id", ondelete="CASCADE")
+        )
diff -pruN 5.4.3-1/flask_security/oauth_provider.py 5.5.0-1/flask_security/oauth_provider.py
--- 5.4.3-1/flask_security/oauth_provider.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/oauth_provider.py	2024-07-24 02:21:26.000000000 +0000
@@ -12,7 +12,6 @@
 
 from __future__ import annotations
 import collections.abc as cabc
-import sys
 
 try:
     from authlib.integrations.flask_client import OAuth
@@ -37,10 +36,7 @@ from .utils import (
 if t.TYPE_CHECKING:  # pragma: no cover
     from flask.typing import ResponseValue
 
-if sys.version_info >= (3, 9):
-    OauthCbType = cabc.Callable[["OAuth", t.Any], tuple[str, t.Any]]
-else:
-    OauthCbType = t.Callable[["OAuth", t.Any], t.Tuple[str, t.Any]]  # pragma: no cover
+OauthCbType = cabc.Callable[["OAuth", t.Any], tuple[str, t.Any]]
 
 
 class FsOAuthProvider:
diff -pruN 5.4.3-1/flask_security/proxies.py 5.5.0-1/flask_security/proxies.py
--- 5.4.3-1/flask_security/proxies.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/proxies.py	2024-07-24 02:21:26.000000000 +0000
@@ -1,4 +1,4 @@
-# Copyright 2021 by J. Christopher Wagner (jwag). All rights reserved.
+# Copyright 2021-2024 by J. Christopher Wagner (jwag). All rights reserved.
 
 import typing as t
 
@@ -7,15 +7,14 @@ from werkzeug.local import LocalProxy
 
 if t.TYPE_CHECKING:  # pragma: no cover
     from passlib.context import CryptContext
-    from .core import Security
-    from .datastore import CanonicalUserDatastore
+    from .core import Security, UserDatastore
 
 # Convenient references
 _security: "Security" = LocalProxy(  # type: ignore
     lambda: current_app.extensions["security"]
 )
 
-_datastore: "CanonicalUserDatastore" = LocalProxy(  # type:ignore
+_datastore: "UserDatastore" = LocalProxy(  # type:ignore
     lambda: _security.datastore
 )
 
diff -pruN 5.4.3-1/flask_security/recovery_codes.py 5.5.0-1/flask_security/recovery_codes.py
--- 5.4.3-1/flask_security/recovery_codes.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/recovery_codes.py	2024-07-24 02:21:26.000000000 +0000
@@ -41,16 +41,22 @@ if t.TYPE_CHECKING:  # pragma: no cover
     from cryptography.fernet import MultiFernet
     import flask
     from flask.typing import ResponseValue
-    from .datastore import User
+    from flask_security import UserMixin
 
 
 class MfRecoveryCodesUtil:
     """Handle creation, checking, encrypting and decrypting recovery codes.
     Since these are rarely used - keep them encrypted until needed - yes
     if someone gets access to memory they can find the key...
+
+    .. versionadded:: 5.0.0
     """
 
     def __init__(self, app: flask.Flask):
+        """Initialize MfRecoveryCodesUtil.
+        If :data:`SECURITY_MULTI_FACTOR_RECOVERY_CODES_KEYS` is set then
+        initialize ``cryptor``.
+        """
         self.cryptor: MultiFernet | None = None
         keys = cv("MULTI_FACTOR_RECOVERY_CODES_KEYS", app)
         # N.B. order is important - first key is 'primary'.
@@ -65,37 +71,42 @@ class MfRecoveryCodesUtil:
             cryptors.append(Fernet(key))
         self.cryptor = MultiFernet(cryptors)
 
-    def create_recovery_codes(self, user: User) -> list[str]:
-        # Create new recovery codes and store in user record.
-        # If configured codes are stored encrypted - but plainttext
-        # versions are returned.
+    def create_recovery_codes(self, user: UserMixin) -> list[str]:
+        """Create :data:`SECURITY_MULTI_FACTOR_RECOVERY_CODES_N` new recovery codes and
+        store in user record.
+        If configured (:data:`SECURITY_MULTI_FACTOR_RECOVERY_CODES_KEYS`),
+        codes are stored encrypted - but plainttext versions are returned.
+        """
         new_codes = _security._totp_factory.generate_recovery_codes(
             cv("MULTI_FACTOR_RECOVERY_CODES_N")
         )
-        _datastore.mf_set_recovery_codes(user, self.encrypt_codes(new_codes))
+        _datastore.mf_set_recovery_codes(user, self._encrypt_codes(new_codes))
         return new_codes
 
-    def get_recovery_codes(self, user: User) -> list[str]:
+    def get_recovery_codes(self, user: UserMixin) -> list[str]:
+        """Return list of (unencrypted) recovery codes"""
         ecodes = _datastore.mf_get_recovery_codes(user)
-        return self.decrypt_codes(ecodes)
+        return self._decrypt_codes(ecodes)
 
-    def check_recovery_code(self, user: User, code: str) -> bool:
-        # Verify code is valid
+    def check_recovery_code(self, user: UserMixin, code: str) -> bool:
+        """Verify code is valid"""
         codes = _datastore.mf_get_recovery_codes(user)
-        dcodes = self.decrypt_codes(codes)
+        dcodes = self._decrypt_codes(codes)
         return code in dcodes
 
-    def delete_recovery_code(self, user: User, code: str) -> bool:
-        # codes are single use - so delete after use.
-        # encrypting code gives different answer due to time stamp.
-        # we don't want to re-encrypt other codes.
+    def delete_recovery_code(self, user: UserMixin, code: str) -> bool:
+        """codes are single use - so delete after use.
+        encrypting code gives different answer due to time stamp.
+        we don't want to re-encrypt other codes.
+        """
         codes = _datastore.mf_get_recovery_codes(user)
         if self.cryptor:
-            codes = self.decrypt_codes(codes)
+            codes = self._decrypt_codes(codes)
         idx = codes.index(code)
         return _datastore.mf_delete_recovery_code(user, idx)
 
-    def encrypt_codes(self, codes: list[str]) -> list[str]:
+    def _encrypt_codes(self, codes: list[str]) -> list[str]:
+        """Return list of encrypted codes"""
         if not self.cryptor:
             return codes
         ecodes = []
@@ -103,7 +114,10 @@ class MfRecoveryCodesUtil:
             ecodes.append(self.cryptor.encrypt(code.encode()).decode())
         return ecodes
 
-    def decrypt_codes(self, codes: list[str]) -> list[str]:
+    def _decrypt_codes(self, codes: list[str]) -> list[str]:
+        """Return list of decrypted codes.
+        Don't include in list if no longer valid.
+        """
         from cryptography.fernet import InvalidToken
 
         if not self.cryptor:
@@ -151,7 +165,7 @@ class MfRecoveryForm(Form):
     def __init__(self, *args: t.Any, **kwargs: t.Any):
         super().__init__(*args, **kwargs)
         # filled by view
-        self.user: User | None = None
+        self.user: UserMixin | None = None
 
     def validate(self, **kwargs: t.Any) -> bool:
         if not super().validate(**kwargs):  # pragma: no cover
diff -pruN 5.4.3-1/flask_security/registerable.py 5.5.0-1/flask_security/registerable.py
--- 5.4.3-1/flask_security/registerable.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/registerable.py	2024-07-24 02:21:26.000000000 +0000
@@ -133,7 +133,7 @@ def register_existing(form: ConfirmRegis
     if form.existing_email_user:
         user_not_registered.send(
             current_app._get_current_object(),  # type: ignore
-            _async_wrapper=current_app.ensure_sync,
+            _async_wrapper=current_app.ensure_sync,  # type: ignore[arg-type]
             user=form.existing_email_user,
             existing_email=True,
             existing_username=form.existing_username_user is not None,
@@ -158,7 +158,7 @@ def register_existing(form: ConfirmRegis
         # to enumerate usernames (slowly).
         user_not_registered.send(
             current_app._get_current_object(),  # type: ignore[attr-defined]
-            _async_wrapper=current_app.ensure_sync,
+            _async_wrapper=current_app.ensure_sync,  # type: ignore[arg-type]
             user=None,
             existing_email=False,
             existing_username=True,
diff -pruN 5.4.3-1/flask_security/signals.py 5.5.0-1/flask_security/signals.py
--- 5.4.3-1/flask_security/signals.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/signals.py	2024-07-24 02:21:26.000000000 +0000
@@ -5,7 +5,7 @@
     Flask-Security signals module
 
     :copyright: (c) 2012 by Matt Wright.
-    :copyright: (c) 2019-2022 by J. Christopher Wagner (jwag).
+    :copyright: (c) 2019-2024 by J. Christopher Wagner (jwag).
     :license: MIT, see LICENSE for more details.
 """
 
@@ -49,3 +49,7 @@ us_profile_changed = signals.signal("us-
 wan_registered = signals.signal("wan-registered")
 
 wan_deleted = signals.signal("wan-deleted")
+
+change_email_instructions_sent = signals.signal("change-email-instructions-sent")
+
+change_email_confirmed = signals.signal("change-email")
diff -pruN 5.4.3-1/flask_security/templates/security/_menu.html 5.5.0-1/flask_security/templates/security/_menu.html
--- 5.4.3-1/flask_security/templates/security/_menu.html	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/templates/security/_menu.html	2024-07-24 02:21:26.000000000 +0000
@@ -12,6 +12,11 @@
           <a href="{{ url_for_security('change_password') }}">{{ _fsdomain("Change Password") }}</a>
         </li>
       {% endif %}
+      {% if security.change_email %}
+        <li>
+          <a href="{{ url_for_security('change_email') }}">{{ _fsdomain("Change Registered Email") }}</a>
+        </li>
+      {% endif %}
       {% if security.two_factor %}
         <li>
           <a href="{{ url_for_security('two_factor_setup') }}">{{ _fsdomain("Two Factor Setup") }}</a>
diff -pruN 5.4.3-1/flask_security/templates/security/change_email.html 5.5.0-1/flask_security/templates/security/change_email.html
--- 5.4.3-1/flask_security/templates/security/change_email.html	1970-01-01 00:00:00.000000000 +0000
+++ 5.5.0-1/flask_security/templates/security/change_email.html	2024-07-24 02:21:26.000000000 +0000
@@ -0,0 +1,15 @@
+{% extends "security/base.html" %}
+{% from "security/_macros.html" import render_field_with_errors, render_field, render_field_errors, render_form_errors %}
+
+{% block content %}
+  {% include "security/_messages.html" %}
+  <h1>{{ _fsdomain('Change email') }}</h1>
+  <h3>{{ _fsdomain('Once submitted, an email confirmation will be sent to this new email address.') }}</h3>
+  <form action="{{ url_for_security('change_email') }}" method="post" name="change_email_form">
+    {{ change_email_form.hidden_tag() }}
+    {{ render_form_errors(change_email_form) }}
+    {{ render_field_with_errors(change_email_form.email) }}
+    {{ render_field_errors(change_email_form.csrf_token) }}
+    {{ render_field(change_email_form.submit) }}
+  </form>
+{% endblock content %}
diff -pruN 5.4.3-1/flask_security/templates/security/email/change_email_instructions.html 5.5.0-1/flask_security/templates/security/email/change_email_instructions.html
--- 5.4.3-1/flask_security/templates/security/email/change_email_instructions.html	1970-01-01 00:00:00.000000000 +0000
+++ 5.5.0-1/flask_security/templates/security/email/change_email_instructions.html	2024-07-24 02:21:26.000000000 +0000
@@ -0,0 +1,13 @@
+{# This template receives the following context:
+  link - the link that should be fetched (GET) to confirm
+  token - this token is part of confirmation link - but can be used to
+    construct arbitrary URLs for redirecting.
+  user - the entire user model object
+  security - the Flask-Security configuration
+#}
+<p>{{ _fsdomain('Please confirm your new email address by clicking on the link below:') }}</p>
+<p>
+  <a href="{{ link }}">{{ _fsdomain('Confirm my new email') }}</a>
+</p>
+<p>{{ _fsdomain('This link will expire in %(within)s.', within=config["SECURITY_CHANGE_EMAIL_WITHIN"]) }}</p>
+<p>{{ _fsdomain('Your currently registered email is %(email)s.', email=user.email) }}</p>
diff -pruN 5.4.3-1/flask_security/templates/security/email/change_email_instructions.txt 5.5.0-1/flask_security/templates/security/email/change_email_instructions.txt
--- 5.4.3-1/flask_security/templates/security/email/change_email_instructions.txt	1970-01-01 00:00:00.000000000 +0000
+++ 5.5.0-1/flask_security/templates/security/email/change_email_instructions.txt	2024-07-24 02:21:26.000000000 +0000
@@ -0,0 +1,13 @@
+{# This template receives the following context:
+  link - the link that should be fetched (GET) to confirm
+  token - this token is part of confirmation link - but can be used to
+    construct arbitrary URLs for redirecting.
+  user - the entire user model object
+  security - the Flask-Security configuration
+#}
+{{ _fsdomain('Please confirm your new email through the link below:') }}
+{{ link }}
+
+{{ _fsdomain('This link will expire in %(within)s.', within=config["SECURITY_CHANGE_EMAIL_WITHIN"]) }}
+
+{{ _fsdomain('Your currently registered email is %(email)s.', email=user.email) }}
diff -pruN 5.4.3-1/flask_security/templates/security/two_factor_setup.html 5.5.0-1/flask_security/templates/security/two_factor_setup.html
--- 5.4.3-1/flask_security/templates/security/two_factor_setup.html	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/templates/security/two_factor_setup.html	2024-07-24 02:21:26.000000000 +0000
@@ -8,6 +8,9 @@
   On successful POST:
     chosen_method: which 2FA method was chosen (e.g. sms, authenticator)
     choices: Value of SECURITY_TWO_FACTOR_ENABLED_METHODS
+    changing: boolean - True if user is trying to change/disable 2FA
+    state_token: if changing - this is the new (non-session) way to validate
+      the new 2FA method
 
     If chosen_method == 'authenticator':
       authr_qrcode: the image source for the qrcode
@@ -60,7 +63,12 @@
     {# This is the fill in code part #}
     <hr class="fs-gap">
     <div class="fs-important">{{ _fsdomain("Enter code to complete setup") }}</div>
-    <form action="{{ url_for_security('two_factor_token_validation') }}" method="post" name="two_factor_verify_code_form">
+    {% if changing %}
+      {% set faction = url_for_security('two_factor_setup_validate', token=state_token) %}
+    {% else %}
+      {% set faction = url_for_security('two_factor_token_validation') %}
+    {% endif %}
+    <form action="{{ faction }}" method="post" name="two_factor_verify_code_form">
       {{ two_factor_verify_code_form.hidden_tag() }}
       {{ render_field_with_errors(two_factor_verify_code_form.code, placeholder=_fsdomain("enter numeric code")) }}
       <div class="fs-gap">{{ render_field(two_factor_verify_code_form.submit) }}</div>
diff -pruN 5.4.3-1/flask_security/tf_plugin.py 5.5.0-1/flask_security/tf_plugin.py
--- 5.4.3-1/flask_security/tf_plugin.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/tf_plugin.py	2024-07-24 02:21:26.000000000 +0000
@@ -45,8 +45,7 @@ if t.TYPE_CHECKING:  # pragma: no cover
     import flask
     from flask.typing import ResponseValue
     from flask import Response
-    from .core import Security
-    from .datastore import User
+    from flask_security import Security, UserMixin
 
 
 class TwoFactorSelectForm(Form):
@@ -116,14 +115,14 @@ class TfPluginBase:  # pragma no cover
     ) -> None:
         raise NotImplementedError
 
-    def get_setup_methods(self, user: User) -> list[str]:
+    def get_setup_methods(self, user: UserMixin) -> list[str]:
         """
         Return a list of methods that ``user`` has setup for this second factor
         """
         raise NotImplementedError
 
     def tf_login(
-        self, user: User, json_payload: dict[str, t.Any], next_loc: str | None
+        self, user: UserMixin, json_payload: dict[str, t.Any], next_loc: str | None
     ) -> ResponseValue:
         """
         Called from first/primary authenticated views if the user successfully
@@ -169,7 +168,7 @@ class TfPlugin:
                 endpoint="tf_select",
             )(tf_select)
 
-    def method_to_impl(self, user: User, method: str) -> TfPluginBase | None:
+    def method_to_impl(self, user: UserMixin, method: str) -> TfPluginBase | None:
         # reverse map a method to the implementation.
         # N.B. again - requires that methods be unique across all implementations.
         # There is a small window that a previously setup method was removed.
@@ -179,7 +178,7 @@ class TfPlugin:
                 return impl
         return None  # pragma no cover
 
-    def get_setup_tf_methods(self, user: User) -> list[str]:
+    def get_setup_tf_methods(self, user: UserMixin) -> list[str]:
         # Return list of methods that user has setup
         methods = []
         for impl in self._tf_impls.values():
@@ -188,7 +187,7 @@ class TfPlugin:
 
     def tf_enter(
         self,
-        user: User,
+        user: UserMixin,
         remember_me: bool,
         primary_authn_via: str,
         next_loc: str | None,
@@ -246,7 +245,7 @@ class TfPlugin:
                         return simple_render_json(json_payload)
         return None
 
-    def tf_complete(self, user: User, dologin: bool) -> str | None:
+    def tf_complete(self, user: UserMixin, dologin: bool) -> str | None:
         remember = session.pop("tf_remember_login", None)
 
         if dologin:
@@ -314,7 +313,7 @@ def tf_set_validity_token_cookie(respons
     return response
 
 
-def tf_check_state(allowed_states: list[str]) -> User | None:
+def tf_check_state(allowed_states: list[str]) -> UserMixin | None:
     if (
         not all(k in session for k in ["tf_user_id", "tf_state"])
         or session["tf_state"] not in allowed_states
diff -pruN 5.4.3-1/flask_security/totp.py 5.5.0-1/flask_security/totp.py
--- 5.4.3-1/flask_security/totp.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/totp.py	2024-07-24 02:21:26.000000000 +0000
@@ -18,7 +18,7 @@ from passlib.totp import TOTP, TokenErro
 from passlib.pwd import genword
 
 if t.TYPE_CHECKING:  # pragma: no cover
-    from .datastore import User
+    from flask_security import UserMixin
 
 
 class Totp:
@@ -35,7 +35,7 @@ class Totp:
 
     """
 
-    def __init__(self, secrets: dict[str | int, str], issuer: str):
+    def __init__(self, secrets: dict[str, str] | dict[int, str], issuer: str):
         """Initialize a totp factory.
         secrets are used to encrypt the per-user totp_secret on disk.
         """
@@ -48,7 +48,8 @@ class Totp:
         """Get time-based one-time password on the basis of given secret and time
         :param totp_secret: the unique shared secret of the user
         """
-        return self._totp.from_source(totp_secret).generate().token
+        tt = self._totp.from_source(totp_secret).generate()
+        return tt.token  # type: ignore[return-value]
 
     def generate_totp_secret(self) -> str:
         """Create new user-unique totp_secret.
@@ -60,7 +61,7 @@ class Totp:
         return self._totp.new().to_json(encrypt=True)
 
     def verify_totp(
-        self, token: str, totp_secret: str, user: User, window: int = 0
+        self, token: str, totp_secret: str, user: UserMixin, window: int = 0
     ) -> bool:
         """Verifies token for specific user.
 
@@ -110,7 +111,7 @@ class Totp:
         tp = self._totp.from_source(totp_secret)
         return tp.pretty_key()
 
-    def fetch_setup_values(self, totp: str, user: User) -> dict[str, str]:
+    def fetch_setup_values(self, totp: str, user: UserMixin) -> dict[str, str]:
         """Generate various values user needs to setup authenticator app.
             Returns dict with keys:
                 'key': totp key
@@ -126,6 +127,7 @@ class Totp:
         # By convention, the URI should have the username that the user
         # logs in with.
         username = user.calc_username() or "Unknown"
+        assert self._totp.issuer
         r["username"] = username
         r["key"] = self.get_totp_pretty_key(totp)
         r["issuer"] = self._totp.issuer
@@ -176,7 +178,7 @@ class Totp:
             )
         return spwds
 
-    def get_last_counter(self, user: User) -> TotpMatch | None:
+    def get_last_counter(self, user: UserMixin) -> int | None:
         """Implement this to fetch stored last_counter from cache.
 
         :param user: User model
@@ -184,7 +186,7 @@ class Totp:
         """
         return None
 
-    def set_last_counter(self, user: User, tmatch: TotpMatch) -> None:
+    def set_last_counter(self, user: UserMixin, tmatch: TotpMatch) -> None:
         """Implement this to cache last_counter.
 
         :param user: User model
diff -pruN 5.4.3-1/flask_security/translations/af_ZA/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/af_ZA/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/af_ZA/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/af_ZA/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security-Too 4.0.0\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: Michael Bosch <michael@lonelyviking.com>\n"
 "Language: af_ZA\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Intekening Benodig"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,95 +35,95 @@ msgstr "Intekening Benodig"
 msgid "Welcome"
 msgstr "Welkom"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Bevestig asseblief jou e-pos adres"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Intekening instruksies"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Jou wagwoord is teruggestel"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Jou wagwoord is verander"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Wagwoord terugstel instruksies"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Twee-faktoor Intekening"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Twee-faktoor Redding"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Verifikasie Kode"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "Insette nie geskik vir die versoekte API nie"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Jy het nie toestemming om hierdie hulpbron te bekyk nie."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Jy moet herverifieer om toegang te kry tot hierdie eindpunt"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Dankie. Jou e-pos adres is bevestig."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Jou e-pos adres is reeds bevestig."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr ""
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s is reeds geassosieer met 'n rekening."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
@@ -128,67 +132,67 @@ msgstr ""
 "Identiteits kenmerk '%(attr)s' met waarde '%(value)s' is reeds "
 "geassosieer met 'n rekening."
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Wagwoord stem nie ooreen nie"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Wagwoorde stem nie ooreen nie"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Herleiding buite die domein is verbied"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "Instruksies om jou wagwoord terug te stel is gestuur na %(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Ongeldige wagwoord terugstellings token."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "E-pos adres benodig bevestiging"
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Bevestigings instruksies is gestuur na %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -197,77 +201,77 @@ msgstr ""
 "Jy het nie ingeteken binne %(within)s nie. Nuwe instruksies om in te "
 "teken is gestuur na %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Instruksies om in te teken is gestuur na %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Ongeldige intekenings token."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Rekening is gestremd."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "E-pos is nie voorsien nie"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Ongeldige e-pos adres"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Ongeldige kode"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Wagwoord is nie voorsien nie"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Wagwoord moet ten minste %(length)s karakters bevat"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "Wagwoord is te eenvoudig"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "Telefoon nommer is ongeldig, bv. afwesige lands kode"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Gespesifieerde verbruiker bestaan nie"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Ongeldige wagwoord"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "Voorsiende wagwoord of kode is ongeldig"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Jy het met sukses in geteken"
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Wagwoord vergeet?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
@@ -275,343 +279,359 @@ msgstr ""
 "Jy het met sukses jou wagwoord teruggestel en jy het automaties in "
 "geteken."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Jou nuwe wagwoord moet verskil van jou vorige wagwoord."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Jy het met sukses jou wagwoord verander."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Teken asseblief in om toegang te kry tot hierdie blad."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Herverifieer asseblief om toegang te kry tot hierdie blad."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Herverifikasie suksesvol"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "Jy kan slegs hierdie eindpunt bereik wanneer jy nie in geteken is nie."
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr "Mislukking met stuur van kode. Probeer asseblief later weer"
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Jy het met sukses jou twee-faktoor metode verander."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "Jy het tans nie toestemming om hierdie blad te besoek nie"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "Gemerkde metode is nie geldig nie"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "Jy het met sukses twee-faktoor verifikasie afgeskakel"
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr "Opstel moet voltooi wees binne %(within)s. Begin asseblief oor."
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr "Versoekte metode is nie geldig nie"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr "Opstel moet voltooi wees binne %(within)s. Begin asseblief oor."
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "Jy moet 'n valiede identiteit spesifiseer om in te teken"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "Gebruik hierdie kode om in te teken: %(code)s."
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "E-pos adres"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Wagwoord"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Onthou My"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Teken In"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Teken In"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Registreer"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Stuur Weer Bevestigings Instruksies"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Herstel Wagwoord"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Stel Wagwoord Terug"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Sleutel Weer Wagwoord In"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nuwe Wagwoord"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Verander Wagwoord"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Stuur Intekenings Skakel"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Bevestig Wagwoord"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Verander Metode"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Telefoon Nommer"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Verifikasie Kode"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Stuur"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Stuur Kode"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Fout(e)"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Identiteit"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Stuur Kode"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Wagkode"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "Stel up deur midde van e-pos"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr "Stel op deur midde van verifikasie toep (bv. google, lastpass, authy)"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Stel op deur midde van SMS"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Beskikbare Metodes"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -643,27 +663,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -676,29 +696,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Wagwoord vergeet"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Bevestig rekening"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Verander wagwoord"
@@ -740,7 +774,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -767,56 +801,56 @@ msgstr "Stuur weer bevestigings instruks
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr "Twee-faktoor verifikasie voeg 'n ekstra laag sekuriteit by jou rekening"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Twee-faktoor verifikasie kode"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -908,6 +942,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/ca_ES/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/ca_ES/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/ca_ES/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/ca_ES/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 3.1.0\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2019-06-16 00:12+0200\n"
 "Last-Translator: Orestes Sanchez <miceno.atreides@gmail.com>\n"
 "Language: ca_ES\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Per poder veure la pàgina sol·licitada és necessari iniciar la sessió"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,164 +35,164 @@ msgstr "Per poder veure la pàgina sol·
 msgid "Welcome"
 msgstr "Benvingut"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Si us plau, confirmeu el vostre correu electrònic"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Instruccions d'inici de la sessió"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "S'ha restablit la teva contrasenya"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "S'ha canviat la teva contrasenya"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Instruccions de recuperació de la contrasenya"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr ""
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr ""
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "No tens permís d'accés per a consultar aquest recurs."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr ""
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Moltes gràcies. S'ha confirmat el teu correu electrònic."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "El teu correu electrònic ja s'havia confirmat."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Token de confirmació no vàlid."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s ja es associat amb un compte."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "La contrasenya no coincideix"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Les contrasenyes no coincideixen"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Les redireccions a llocs web externes s'han prohibit"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr ""
 "Les instruccions per restablir la teva contrasenya s'han enviat a "
 "%(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "El token per restablir la contrasenya no és vàlid."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "El correu electrònic requereix d'una confirmació."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Les instruccions de confirmació s'han enviat a %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -197,77 +201,77 @@ msgstr ""
 "No vas iniciar la sessió abans de %(within)s. S'han enviat noves "
 "instruccions a %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "S'han enviat instruccions per l'inici de sessió a %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Token de d'inici de sessió no vàlid."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "el compte està desactivat."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "No s'ha inclòs el correu electrònic"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Adreça de correu electrònic no vàlida"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr ""
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "No s'ha inclòs la contrasenya"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, fuzzy, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "La contrasenya ha de tenir al menys %(length)s caràcters"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr ""
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr ""
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "L'usuari no existeix"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Contrasenya no vàlida"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr ""
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "La sessió s'ha iniciat amb èxit."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Has oblidat la teva contrasenya?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
@@ -275,343 +279,359 @@ msgstr ""
 "Has restablert la teva contrasenya amb èxit i s'ha iniciat la sessió "
 "automàticament."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "La nova contrasenya ha de ser diferent de l'anterior."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "La teva contrasenya s'ha modificat amb èxit."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Has d'iniciar sessió per tal d'accedir a aquesta pàgina."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Has d'iniciar una nova sessió per tal d'accedir a aquesta pàgina."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr ""
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr ""
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr ""
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr ""
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr ""
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
 #, python-format
-msgid "Currently active sign in options: %(method_list)s."
+msgid "Setup must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:535
-msgid "Requested method is not valid"
+#: flask_security/core.py:551
+#, python-format
+msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
+#: flask_security/core.py:554
+msgid "Requested method is not valid"
 msgstr ""
 
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr ""
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Correu electrònic"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Contrasenya"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Recorda'm"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Iniciar sessió"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr ""
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Registrar-se"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Reenviar les instruccions de confirmació"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Restablir la contrasenya"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Restablir la contrasenya"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Escriu la contrasenya una altra vegada"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nova contrasenya"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Canvi de contrasenya"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Enviar l'enllaç d'inici de sessió"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr ""
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr ""
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr ""
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr ""
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr ""
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr ""
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr ""
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr ""
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr ""
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr ""
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr ""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -643,27 +663,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -676,29 +696,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Contrasenya oblidada"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Confirmació de compte"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Canviar la contrasenya"
@@ -740,7 +774,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -767,56 +801,56 @@ msgstr "Reenviar instruccions de confirm
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -908,6 +942,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/da_DK/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/da_DK/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/da_DK/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/da_DK/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.1.0\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2017-03-23 14:04+0100\n"
 "Last-Translator: Leonhard Printz <leonhardprintz@protonmail.ch>\n"
 "Language: da_DK\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Login påkræveet"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,164 +35,164 @@ msgstr "Login påkræveet"
 msgid "Welcome"
 msgstr "Velkommen"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Bekræft venligst din email"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Logininstruktioner"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Din adgangskode er blevet nulstillet"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Din adgangskode er blevet ændret"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Instruktioner til nulstilling af adganskode"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr ""
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr ""
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Du har ikke adgang til denne resource."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr ""
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Mange Tak. Din email er blevet bekræftet."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Din email er allerede blevet bekræftet."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Ugyldig bekræftigelsestoken."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s er allerede brugt af en anden konto."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Adgangskode passer ikke"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Adgangskoderne passer ikke"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Omdirigering udenfor domænet er forbudt"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr ""
 "Instruktioner til nulstilling af din adgangskode er blevet sendt til "
 "%(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Ugyldig nulstillingstoken."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "Email kræver bekræftigelse."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Bekræftigelsesinstruktioner er blevet sendt til %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -197,77 +201,77 @@ msgstr ""
 "Du har ikke logget in indenfor %(within)s. Nye logininstruktioner er "
 "blevet sendt til %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Logininstruktioner er blevet sendt til %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Ugyldig logintoken."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Kontoen er deaktiveret."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Email ikke angivet"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Ugyldig email adresse"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr ""
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Adgangskode ikke angivet"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, fuzzy, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Adgangskoden skal indeholde mindst %(length)s tegn"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr ""
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr ""
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Denne bruger findes ikke"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Ugyldig adgangskode"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr ""
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Du er hermed blevet logget ind."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Glemt adgangskode?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
@@ -275,343 +279,359 @@ msgstr ""
 "Du har hermed nulstillet din adgangskode og er blevet automatisk logget "
 "ind."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Din nye adgangskode skal være anderledes end din tidligere adgangskode."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Du har hermed ændret din adgangskode."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Log in for at få adgang til denne side."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Bekræft identitet for at få adgang til denne side."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr ""
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr ""
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr ""
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr ""
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr ""
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
 #, python-format
-msgid "Currently active sign in options: %(method_list)s."
+msgid "Setup must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:535
-msgid "Requested method is not valid"
+#: flask_security/core.py:551
+#, python-format
+msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
+#: flask_security/core.py:554
+msgid "Requested method is not valid"
 msgstr ""
 
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr ""
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Email adresse"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Adgangskode"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Husk"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Login"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr ""
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Registrer"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Gensend bekræftelsesinstruktioner"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Genopret adgangskode"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Nulstil adgangskode"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Gentast adgangskode"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Ny adgangskode"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Ændre adgangskode"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Send login link"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr ""
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr ""
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr ""
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr ""
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr ""
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr ""
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr ""
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr ""
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr ""
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr ""
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr ""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -643,27 +663,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -676,29 +696,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Glemt din adgangskode"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Bekræft konto"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Ændre adgangskode"
@@ -740,7 +774,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -767,56 +801,56 @@ msgstr "Gensend bekræftelsesinstruktion
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -908,6 +942,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/de_DE/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/de_DE/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/de_DE/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/de_DE/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -10,7 +10,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 4.1.3\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2022-04-05 13:50+0200\n"
 "Last-Translator: Pascua Theus <pascua@identeco.de>\n"
 "Language: de_DE\n"
@@ -19,13 +19,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Anmeldung erforderlich"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -33,51 +37,51 @@ msgstr "Anmeldung erforderlich"
 msgid "Welcome"
 msgstr "Willkommen"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Bitte E-Mail-Adresse bestätigen"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Anmeldeanleitung"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Das Passwort wurde zurückgesetzt"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Das Passwort wurde geändert"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Anleitung zur Passwortwiederherstellung"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Zwei-Faktor-Anmeldung"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Zwei-Faktor-Wiederherstellung"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Verifizierungscode"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "Ungültige Eingabe für die angeforderte Ressource"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 "Authentifizierung fehlgeschlagen – Identität oder Passwort/Passcode "
 "ungültig"
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
@@ -85,24 +89,24 @@ msgstr ""
 "Wenn diese E-Mail-Adresse bei uns existiert, erhalten Sie eine E-Mail, in"
 " der beschrieben wird, wie Sie Ihr Passwort zurücksetzen können."
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr "Wenn diese Identität bei uns existiert, wird Ihnen ein Code zugesandt."
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Sie haben keine Berechtigung, um diese Ressource zu sehen."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 #, fuzzy
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Bitte neu authentisieren, um auf diese Seite zuzugreifen."
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
@@ -111,24 +115,24 @@ msgstr ""
 "Vielen Dank. Um Ihre E-Mail-Adresse %(email)s zu bestätigen, klicken Sie "
 "bitte auf den Link in der E-Mail, die wir gerade an Sie gesendet haben."
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Vielen Dank. Die E-Mail-Adresse wurde bestätigt."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Die E-Mail-Adresse wurde bereits bestätigt."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Ungültiger Bestätigungscode."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s ist bereits mit einem Konto verknüpft."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
@@ -137,12 +141,12 @@ msgstr ""
 "Benutzermerkmal '%(attr)s' mit Wert '%(value)s' ist bereits mit einem "
 "anderen Benutzerkonto verknüpft"
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr "Benutzer %(id)s nicht registriert"
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
@@ -151,59 +155,59 @@ msgstr ""
 "Es trat ein Fehler bei der Kommunikation mit dem OAuth-Provider auf. "
 "Bitte versuchen Sie es erneut."
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Das Passwort stimmt nicht überein"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Die Passwörter stimmen nicht überein"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Weiterleitungen außerhalb der Domain sind verboten"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr "Wiederherstellungscode ungültig"
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr "Es wurden noch keine Sicherheitscodes generiert."
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr ""
 "Eine Anleitung, um das Passwort wiederherzustellen wurde an %(email)s "
 "gesendet."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr "Sie haben ihr Passwort nicht innerhalb von %(within)s zurückgesetzt. "
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Ungültiger Passwortwiederherstellungscode."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "Die E-Mail-Adresse muss bestätigt werden."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr ""
 "Um Ihre E-Mail-Adresse %(email)s zu bestätigen, klicken Sie bitte auf den"
 " Link in der E-Mail, die wir gerade an Sie gesendet haben."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr "Sie haben Ihre E-Mail-Adresse nich innerhalb von $(within)s bestätigt."
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -212,77 +216,77 @@ msgstr ""
 "Die Anmeldung erfolgte nicht in %(within)s. Eine neue Anleitung wurde an "
 "%(email)s gesendet."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Eine Anleitung zur Anmeldung wurde an %(email)s gesendet."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Ungültiger Anmeldecode."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Konto ist deaktiviert."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Keine E-Mail-Adresse angegeben"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Ungültige E-Mail-Adresse"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Ungültiger Code"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Kein Passwort angegeben"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, fuzzy, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Das Passwort muss mindestens %(length)s Zeichen lang sein"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "Passwort ist nicht komplex genug"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr "Passwort ist öffentlich bekannt"
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr "Konnte keine Verbindung zum Dienst aufbauen, um Passwörter zu überprüfen."
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "Telefonnumer ist ungültig, eventuell fehlt die Landesvorwahl"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Der angegebene Benutzer existiert nicht"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Ungültiges Passwort"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "Übermitteltes Passwort oder Code ist ungültig"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Sie wurden angemeldet."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Passwort vergessen?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
@@ -290,7 +294,7 @@ msgstr ""
 "Das Passwort wurde erfolgreich wiederhergestellt und die Anmeldung "
 "erfolgte automatisch."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
@@ -298,90 +302,90 @@ msgstr ""
 "Sie haben Ihr Passwort erfolgreich zurückgesetzt. Bitte bestätigen Sie "
 "Ihr neues Passwort."
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Das neue Passwort muss sich vom vorherigen unterscheiden."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Das Passwort wurde erfolgreich geändert."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Bitte melden Sie sich an, um diese Seite zu sehen."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Bitte neu anmelden, um auf diese Seite zuzugreifen."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Neuanmeldung erfolgreich"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "Dieser Endpunkt ist nur für angemeldete Nutzer erlaubt."
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr "Code wurde gesendet."
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 "Zusendung des Codes fehlgeschlagen. Bitte versuchen Sie es später noch "
 "einmal."
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr "Ihr Code wurde bestätigt."
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Sie haben Ihre Zwei-Faktor-Methode erfolgreich geändert."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "Sie haben aktuell nicht die nötigen Rechte, um die Seite anzusehen"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "Ausgewählte Methode ist nicht gültig"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "Zwei-Faktor-Authentisierung wurde deaktiviert"
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr ""
+"Einrichtung muss innerhalb %(within)s abgeschlossen werden. Bitte neu "
+"beginnen."
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr "Angefragte Methode ist ungültig"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr ""
-"Einrichtung muss innerhalb %(within)s abgeschlossen werden. Bitte neu "
-"beginnen."
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "Single-User-Login erfolgreich eingerichtet"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "Sie müssen eine gültige Identität auswählen, um sich anzumelden"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "Code zur Anmeldung: %(code)s"
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
@@ -390,253 +394,269 @@ msgstr ""
 "Der Benutzername muss mindestens %(min)d und darf nicht länger als "
 "%(max)d Zeichen sein."
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr "Der Benutzername enthält ungültige Zeichen."
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr "Der Benutzername darf nur aus Buchstaben und Ziffern bestehen"
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr "Benutzername nicht angegeben"
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr "%(username)s ist bereits mit einem Benutzerkonto verknüpft."
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 "Der WebAuthn-Vorgang muss innerhalb von %(within)s beendet werden. Bitte "
 "erneut versuchen."
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr "Zum Setzen eines neuen Webauthn-Tokens ist ein Nickname erforderlich."
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr "%(name)s ist bereits mit einem Webauthn-Token verknüpft."
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr "%(name)s ist für den aktuellen Benutzer nicht eingetragen."
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr "Der Token '%(name)s' wurde entfernt."
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr "Der WebAuthn-Token '%(name)s' wurde hinzugefügt."
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr "WebAuthn-Token-ID wurde bereits eingetragen."
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr "Nicht eingetragene WebAuthn-Token-ID."
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr "WebAuthn-Token gehört zu keinem Benutzer."
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr "Konnte WebAuthn-Token nicht verifizieren: %(cause)s."
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr "WebAuthn-Token ist für diese Verwendung nicht eingetragen."
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr "Benutzerhandle des WebAuthn-Token stimmt nicht überein."
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "E-Mail-Adresse"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Passwort"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Erinnern"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Anmelden"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Anmeldung"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Registrieren"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Bestätigungslink erneut senden"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Passwort wiederherstellen"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Passwort zurücksetzen"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Passwort erneut eingeben"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Neues Passwort"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Passwort ändern"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Anmelde-Link versenden"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Password bestätigen"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Methode ändern"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Telefonnummer"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Authentisierungscode"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Bestätigen"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Code bestätigen"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Fehler"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Identität"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Sende Code"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Anmelde-Code"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr "Benutzername"
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr "Löschen"
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "Einrichtung via E-Mail"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr "Einrichtung via Authentisierungs-App"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Einrichtung via SMS"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Verfügbare Methoden"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr "Deaktiviere Zwei-Faktor-Authentisierung"
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr "Probleme beim Zugriff auf Ihr Konto / Smartphone verloren?"
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr "Kontaktiere einen Administrator"
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr "Wiederherstellungscode anzeigen"
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr "Neue Wiederherstellungscodes erzeugen"
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr "Wiederherstellungscode"
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr "Verfügbare Zwei-Faktor-Methoden:"
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr "Auswählen"
 
@@ -668,27 +688,27 @@ msgstr "Richte weitere Single-User-Login
 msgid "Delete active sign in option"
 msgstr "Löschen der aktivierten Anmeldeoption"
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr "Nickname"
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr "Benutzung"
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr "Als ersten Faktor benutzen"
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr "Als zweiten Faktor benutzen"
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr "Start"
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr "WebAuthn"
 
@@ -701,29 +721,43 @@ msgid "Sign out"
 msgstr "Abmelden"
 
 #: flask_security/templates/security/_menu.html:17
+msgid "Change Registered Email"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:22
 msgid "Two Factor Setup"
 msgstr "Zwei-Faktor-Einrichtung"
 
-#: flask_security/templates/security/_menu.html:22
+#: flask_security/templates/security/_menu.html:27
 msgid "Unified Signin Setup"
 msgstr "Single-User-Login-Einrichtung"
 
-#: flask_security/templates/security/_menu.html:27
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr "WebAuthn-Einrichtung"
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "Single-User-Login"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Passwort vergessen"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Konto bestätigen"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Passwort ändern"
@@ -765,7 +799,7 @@ msgid "Enter Recovery Code"
 msgstr "Wiederherstellungscode eingeben"
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr "Wiederherstellungscodes"
@@ -794,22 +828,22 @@ msgstr "Bestätigungslink erneut versend
 msgid "Select Two Factor Method"
 msgstr "Zwei-Faktor-Methode auswählen"
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 "Zwei-Faktor-Authentisierung bietet eine zusätzliche Sicherheitsebene für "
 "Ihr Benutzerkonto"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr "Sie müssen zusätzlich zu Benutzername und Passwort einen Code angeben"
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr "Aktivierte Zwei-Faktor-Methode: %(method)s"
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
@@ -819,36 +853,36 @@ msgstr ""
 " Sie den folgenden QR-Code (oder geben Sie den unten stehenden Code ein),"
 " um den Empfang von Codes zu beginnen"
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Zwei-Faktor-Authentisierungscode"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr "Diese Anwendung unterstützt die Einrichtung von Wiederherstellungscodes."
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr "Sie können diese hier einrichten."
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr "WebAuthn"
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr "Diese Anwendung unterstützt WebAuthn-Sicherheitsschlüssel."
@@ -946,6 +980,30 @@ msgstr "Verwenden Sie Ihren WebAuthn-Sic
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr "Bitte authentisieren Sie sich mit Ihrem WebAuthn-Sicherheitsschlüssel"
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/es_ES/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/es_ES/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/es_ES/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/es_ES/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,10 +8,10 @@
 #
 msgid ""
 msgstr ""
-"Project-Id-Version: Flask-Security 5.4.1\n"
+"Project-Id-Version: Flask-Security 5.4.3\n"
 "Report-Msgid-Bugs-To: jwag956@github.com\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
-"PO-Revision-Date: 2024-02-27 13:54+0100\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
+"PO-Revision-Date: 2024-07-08 15:04+0200\n"
 "Last-Translator: Giorgio Stampa <giorgio.stampa@sanofi.com>\n"
 "Language: es_ES\n"
 "Language-Team: \n"
@@ -19,13 +19,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr "Confirma tu nueva dirección de correo electrónico"
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Inicio de sesión necesario"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -33,51 +37,51 @@ msgstr "Inicio de sesión necesario"
 msgid "Welcome"
 msgstr "Bienvenido·a"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Confirma tu correo electrónico"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Instrucciones para iniciar sesión"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Tu contraseña ha sido restablecida"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Tu contraseña ha sido cambiada"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Instrucciones de recuperación de contraseña"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Inicio de sesión de dos factores"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Recuperación de sesión de dos factores"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Código de verificación"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "Entrada no apropiada para la API solicitada"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 "Fallo de autenticación - identidad o contraseña/código de acceso no "
 "válidos"
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
@@ -86,23 +90,23 @@ msgstr ""
 " un correo electrónico con la descripción de como restablecer tu "
 "contraseña."
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr "Si esa identidad está en nuestro sistema, se te envió un código."
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "No tienes permiso para consultar este recurso."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr "Debes autenticarte para acceder a este recurso."
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Debes volver a autenticarte para acceder a este recurso"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
@@ -111,24 +115,24 @@ msgstr ""
 "Gracias. Para confirmar tu dirección de correo electrónico %(email)s, haz"
 " clic en el enlace del mensaje que acabamos de enviarte."
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Gracias. Tu correo electrónico ha sido confirmado."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Tu correo electrónico ya ha sido confirmado."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Autentificador de confirmación inválido."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s ya está asociado a una cuenta."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
@@ -137,12 +141,12 @@ msgstr ""
 "El atributo de identidad '%(attr)s' con el valor '%(value)s' ya está "
 "asociado con una cuenta."
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr "Identidad %(id)s no registrada"
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
@@ -151,229 +155,229 @@ msgstr ""
 "Se ha producido un error al comunicarse con el proveedor de OAuth: "
 "(%(exerror)s - %(exdesc)s). Por favor inténtalo de nuevo."
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "La contraseña no coincide"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Las contraseñas no coinciden"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Las redirecciones a sitios web externos están prohibidas"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr "Código de recuperación inválido"
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr "Aún no se han generado códigos de recuperación"
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr ""
-"Las instrucciones para restablecer tu contraseña han sido enviadas a "
+"Las instrucciones para restablecer tu contraseña se han enviado a "
 "%(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr "No has restablecido tu contraseña dentro de %(within)s. "
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Autentificador de restablecimiento de contraseña inválido."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "El correo electrónico requiere confirmación."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Las instrucciones de confirmación se han enviado a %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr "No has confirmado tu correo electrónico dentro de %(within)s. "
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
 "sent to %(email)s."
 msgstr ""
 "No has iniciado sesión antes de %(within)s. Nuevas instrucciones para "
-"iniciar sesión han sido enviadas a %(email)s."
+"iniciar sesión se han enviado a %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
-msgstr "Instrucciones para iniciar sesión han sido enviadas a %(email)s."
+msgstr "Instrucciones para iniciar sesión se han enviado a %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Autenticador de inicio de sesión inválido."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Cuenta deshabilitada."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Correo electrónico no indicado"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Dirección de correo electrónico inválida"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Código inválido"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Contraseña no indicada"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "La contraseña debe tener al menos %(length)s caracteres"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "La contraseña no es lo suficientemente compleja"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr "Contraseña en la lista de contraseñas violadas"
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr "No se ha podido contactar con el sitio de contraseñas violadas"
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "El número de teléfono no es válido, p. ej. falta el código de país"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Usuario·a especificado·a no existe"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Contraseña inválida"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "La contraseña o el código facilitado son inválidos"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Has iniciado sesión."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "¿Has olvidado tu contraseña?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "Has restablecido tu contraseña y has iniciado sesión automáticamente."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr "Has restablecido tu contraseña. Autentícate con tu nueva contraseña."
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Tu nueva contraseña debe ser diferente de la antigua."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Has cambiado tu contraseña."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Debes iniciar sesión para poder acceder a esta página."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Debes iniciar sesión nuevamente para poder acceder a esta página."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Reautenticación exitosa"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "Solo puedes acceder a este recurso si no has iniciado sesión."
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr "El código se ha enviado."
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr "No se pudo enviar el código. Por favor inténtalo de nuevo más tarde"
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr "Tu código ha sido confirmado"
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Has cambiado tu método de dos factores."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "Actualmente no tienes permisos para acceder a esta página"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "El método marcado no es válido"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "Has deshabilitado la autorización de dos factores."
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr ""
+"La configuración debe completarse dentro de %(within)s. Por favor vuelve "
+"a empezar."
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr "Opciones de inicio de sesión activas actualmente: %(method_list)s."
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr "El método solicitado no es válido"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr ""
-"La configuración debe completarse dentro de %(within)s. Por favor vuelve "
-"a empezar."
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "El inicio de sesión unificado se ha configurado correctamente"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "Debes especificar una identidad válida para iniciar sesión"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "Utiliza este código para iniciar sesión: %(code)s."
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
@@ -382,255 +386,275 @@ msgstr ""
 "El nombre de usuario debe tener al menos %(min)d caracteres y menos de "
 "%(max)d caracteres"
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr "El nombre de usuario contiene caracteres no admitidos"
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr "El nombre de usuario solo puede contener letras y números"
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr "Nombre de usuario no proporcionado"
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr "%(username)s ya está asociado a una cuenta."
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 "La operación de WebAuthn debe completarse dentro de %(within)s. Por favor"
 " vuelve a empezar."
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr "Se requiere un nombre para la nueva credencial."
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr "%(name)s ya está asociado a una credencial."
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr "%(name)s no registrado con el usuario actual."
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr "Se ha eliminado la credencial WebAuthn con nombre: %(name)s"
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr "Se ha añadido la credencial WebAuthn con nombre: %(name)s"
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr "Identificador de credencial de WebAuthn ya registrado."
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr "Identificador de credencial de WebAuthn no registrado."
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr "La credencial WebAuthn no pertenece a ningún usuario."
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr "No se pudo verificar la credencial WebAuthn: %(cause)s."
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr "Credencial no registrada para este uso (primaria o secundaria)"
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr "La credencial de usuario no coincide"
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+"La confirmación debe completarse dentro de %(within)s. Por favor vuelve a"
+" empezar."
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr "Cambio de dirección de correo electrónico confirmado"
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+"Las instrucciones para confirmar tu dirección de correo electrónico se "
+"han enviado a %(email)s."
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Correo electrónico"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Contraseña"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Recordarme"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Iniciar sesión"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Iniciar sesión"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Registrarse"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Reenviar instrucciones de confirmación"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Recuperar contraseña"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Restablecer contraseña"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Escribir contraseña nuevamente"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nueva contraseña"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Cambiar la contraseña"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Enviar enlace para iniciar sesión"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Verificar contraseña"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Método de cambio"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Número de teléfono"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Código de autenticación"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Enviar"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Confirmar código"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Error(es)"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Identidad"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Enviar código"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Código de acceso"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr "Nombre de usuario"
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr "Eliminar"
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "Configurar con correo electrónico"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 "Configurar con una aplicación de autenticación (p.ej. google, lastpass, "
 "authy)"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Configurar con SMS"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr "Google Authenticator"
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr "aplicación de autenticación"
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr "correo electrónico"
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr "SMS"
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr "contraseña"
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr "ninguno"
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Métodos disponibles"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr "Deshabilitar la autenticación de dos factores"
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr "¿Problemas para acceder a tu cuenta/has perdido tu dispositivo móvil?"
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr "Contactar con el administrador"
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr "Mostrar los códigos de recuperación"
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr "Generar nuevos códigos de recuperación"
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr "Código de recuperación"
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr "Métodos de segundo factor disponibles:"
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr "Selecciona"
 
@@ -662,27 +686,27 @@ msgstr "Configurar una opción de inicio
 msgid "Delete active sign in option"
 msgstr "Eliminar la opción de inicio de sesión activa"
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr "Nombre"
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr "Uso"
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr "Uso como factor de autenticación primario"
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr "Uso como factor de autenticación secundario"
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr "Iniciar"
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr "webauthn"
 
@@ -695,29 +719,45 @@ msgid "Sign out"
 msgstr "Cerrar sesión"
 
 #: flask_security/templates/security/_menu.html:17
+msgid "Change Registered Email"
+msgstr "Cambiar el correo electrónico registrado"
+
+#: flask_security/templates/security/_menu.html:22
 msgid "Two Factor Setup"
 msgstr "Configuración de dos factores"
 
-#: flask_security/templates/security/_menu.html:22
+#: flask_security/templates/security/_menu.html:27
 msgid "Unified Signin Setup"
 msgstr "Configuración de inicio de sesión unificado"
 
-#: flask_security/templates/security/_menu.html:27
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr "Configuración de WebAuthn"
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "Inicio de sesión unificado"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Contraseña olvidada"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Confirmar cuenta"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr "Cambiar el correo electrónico"
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+"Un mensaje de confirmación se enviará a esta nueva dirección de correo "
+"electrónico."
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Cambiar la contraseña"
@@ -759,7 +799,7 @@ msgid "Enter Recovery Code"
 msgstr "Introducir código de recuperación"
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr "Códigos de recuperación"
@@ -788,22 +828,22 @@ msgstr "Reenviar instrucciones de confir
 msgid "Select Two Factor Method"
 msgstr "Selecciona un método de dos factores"
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 "La autenticación de dos factores añade una capa adicional de seguridad a "
 "tu cuenta"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr "Además de tu nombre de usuario y contraseña, deberás utilizar un código."
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr "Método de dos factores actualmente configurado: %(method)s"
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
@@ -813,36 +853,36 @@ msgstr ""
 "siguiente código QR (o ingresa manualmente el código que aparece a "
 "continuación) para comenzar a recibir códigos:"
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Código de autenticación de dos factores"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr "Introduce el código para completar la configuración"
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr "introduce el código numérico"
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr "Esta aplicación permite establecer códigos de recuperación."
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr "Se pueden configurar aquí."
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr "WebAuthn"
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr "Esta aplicación es compatible con las claves de seguridad de WebAuthn."
@@ -941,6 +981,32 @@ msgstr "Utiliza tu clave de seguridad de
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr "Por favor vuelve a autenticarte con tu clave de seguridad de WebAuthn"
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+"Confirma tu nueva dirección de correo electrónico a través del enlace de "
+"abajo:"
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr "Confirma mi nuevo correo electrónico"
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr "Este enlace caducará dentro de %(within)s."
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr "Tu correo electrónico registrado actualmente es %(email)s."
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr "Confirma tu nuevo correo electrónico a través del enlace de abajo:"
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/eu_ES/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/eu_ES/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/eu_ES/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/eu_ES/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 4.0.0\n"
 "Report-Msgid-Bugs-To: jwag956@github.com\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2020-11-28 13:41+0100\n"
 "Last-Translator: Martin Mozos <martinmozos@gmail.com>\n"
 "Language: eu_ES\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Saioa hasi behar da"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,95 +35,95 @@ msgstr "Saioa hasi behar da"
 msgid "Welcome"
 msgstr "Ongi etorri"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Mesedez berretsi zure posta elektronikoa"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Saioa hasteko argibideak"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Zure pasahitza berrezarri da"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Zure pasahitza aldatu da"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Pasahitza berreskuratzeko argibideak"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Bi faktoreko saioa hastea"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Bi faktoreko saioa berreskuratzea"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Egiaztapen kodea"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "Sarrera ez da egokia eskatutako APIarentzat"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Ez duzu baliabide hau kontsultatzeko baimenik."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Baliabide honetara sartzeko berriro autentifikatu behar duzu"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Eskerrik asko. Zure posta elektronikoa berretsi da."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Zure posta elektronikoa dagoeneko baieztatuta dago."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Berrespen token baliogabea."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s dagoeneko kontu batekin lotuta dago."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
@@ -128,67 +132,67 @@ msgstr ""
 "'%(attr)s' identitate atributua '%(value)s' balioarekin dagoeneko kontu "
 "batekin lotuta dago"
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Pasahitza ez dator bat"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Pasahitzak ez datoz bat"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Domeinutik kanpoko birbideratzeak debekatuta daude"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "Pasahitza berrezartzeko argibideak %(email)s helbidera bidali dira."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Pasahitza berrezartzeko token baliogabea."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "Mezu elektronikoak berrespena behar du."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Baieztapen argibideak %(email)s helbidera bidali dira."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -197,168 +201,168 @@ msgstr ""
 "Ez duzu saioa hasi %(within)s barruan. Saioa hasteko argibide berriak "
 "%(email)s helbidera bidali dira."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Saioa hasteko argibideak %(email)s helbidera bidali dira."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Saioa hasteko token baliogabea."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Kontua desgaituta dago."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Helbide elektronikoa beharrezkoa da"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Helbide elektroniko baliogabea"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Kode baliogabea"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Pasahitza beharrezkoa da"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Pasahitzak gutxienez %(length)s karaktere izan behar ditu"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "Pasahitza ez da nahikoa konplexua"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr "Pasahitza urratutako zerrendan"
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr "Ezin izan da urratutako pasahitzen iturburuarekin harremanetan jarri"
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "Telefono zenbakiak ez du balio, baliteke herrialde kodea faltatzea"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Zehaztutako erabiltzea ez da existitzen"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Pasahitz okerra"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "Zehaztutako pasahitzak edo kodeak ez du balio"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Behar bezala hasi duzu saioa."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Pasahitza ahaztua?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "Pasahitza berrezarri duzunez automatikoki hasi duzu saioa."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Zure pasahitz berriak zure aurreko pasahitzaren ezberdin behar du izan."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Pasahitza behar bezala aldatu duzu."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Hasi saioa orri honetara sartzeko."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Mesedez, berriro autentifikatu orri honetara sartzeko."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Berautentifikatzea osatu da"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "Saioa amaitzen ez duzunean soilik sar zaitezke baliabide honetara"
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr "Ezin izan da kodea bidali. Saiatu berriro geroago"
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Bi faktoretako metodoa ondo aldatu duzu."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "Une honetan ez duzu baimenik orrialde honetara sartzeko"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "Markatutako metodoak ez du balio"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "Bi faktoreren baimena behar bezala desgaitu duzu."
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr "Konfigurazioa %(within)s barruan osatu behar da. Mesedez, berriro hasi."
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr "Eskatutako metodoak ez du balio"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr "Konfigurazioa %(within)s barruan osatu behar da. Mesedez, berriro hasi."
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "Bateratutako saio hasierarako konfigurazioa ongi egin da"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "Saioa hasteko identitate baliagarria zehaztu behar duzu"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "Erabili kode hau saioa hasteko: %(code)s."
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
@@ -367,253 +371,269 @@ msgstr ""
 "Erabiltzaile izenak gutxienez %(min)d karaktere eta %(max)d karaktere "
 "baino gutxiago izan behar ditu"
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr "Erabiltzaile izenak legez kanpoko karaktereak ditu"
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr "Erabiltzaile izenak letrak eta zenbakiak soilik izan ditzake"
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr "Erabiltzaile izena ez da eman"
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr "%(username)s dagoeneko kontu batekin lotuta dago."
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Posta elektronikoa"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Pasahitza"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Gogorarazi"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Hasi saioa"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Hasi saioa"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Izena eman"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Bidali berrespen argibideak"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Pasahitza berreskuratu"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Pasahitza berrezarri"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Idatzi berriro pasahitza"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Pasahitz berria"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Aldatu pasahitza"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Bidali saioa hasteko esteka"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Pasahitza ziurtatu"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Aldatzeko metodoa"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Telefono zenbakia"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Autentifikazio kodea"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Bidali"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Bidali kodea"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Errorea(k)"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Identitatea"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Bidali kodea"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Pasakodea"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr "Erabiltzaile izena"
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "Konfiguratu posta elektronikoa erabiliz"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 "Konfiguratu autentifikatzaile aplikazio bat erabiliz (google, lastpass "
 "edo authy adibidez)"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Konfiguratu SMS bidez"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Eskuragarri dauden metodoak"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -645,27 +665,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -678,29 +698,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "Saio hasiera bateratua"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Pasahitza ahaztua"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Berretsi kontua"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Aldatu pasahitza"
@@ -742,7 +776,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -769,22 +803,22 @@ msgstr "Bidali berrespen argibideak"
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 "Bi faktoreko autentifikazioak segurtasun geruza gehigarri bat esleitzen "
 "dio zure kontuari"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
@@ -793,36 +827,36 @@ msgstr ""
 "Ireki autentifikazio aplikazio bat zure gailuan eta eskaneatu QR kode hau"
 " (edo idatzi beheko kodea eskuz) kodeak jasotzen hasteko:"
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Bi faktoretako autentifikazio kodea"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -914,6 +948,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/flask_security.pot 5.5.0-1/flask_security/translations/flask_security.pot
--- 5.4.3-1/flask_security/translations/flask_security.pot	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/flask_security.pot	2024-07-24 02:21:26.000000000 +0000
@@ -7,22 +7,26 @@
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: Flask-Security 5.4.0\n"
+"Project-Id-Version: Flask-Security 5.5.0\n"
 "Report-Msgid-Bugs-To: jwag956@github.com\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr ""
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -30,581 +34,597 @@ msgstr ""
 msgid "Welcome"
 msgstr ""
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr ""
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr ""
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr ""
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr ""
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr ""
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr ""
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr ""
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr ""
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr ""
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr ""
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr ""
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr ""
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr ""
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr ""
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr ""
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr ""
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr ""
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr ""
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr ""
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
 "sent to %(email)s."
 msgstr ""
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr ""
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr ""
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr ""
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr ""
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr ""
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr ""
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr ""
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr ""
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr ""
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr ""
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr ""
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr ""
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr ""
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr ""
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr ""
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr ""
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr ""
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr ""
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr ""
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr ""
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr ""
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr ""
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr ""
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr ""
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr ""
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
 #, python-format
-msgid "Currently active sign in options: %(method_list)s."
+msgid "Setup must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:535
-msgid "Requested method is not valid"
+#: flask_security/core.py:551
+#, python-format
+msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
+#: flask_security/core.py:554
+msgid "Requested method is not valid"
 msgstr ""
 
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr ""
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
-msgid "Email Address"
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
 msgstr ""
 
 #: flask_security/forms.py:62
-msgid "Password"
+msgid "Email Address"
 msgstr ""
 
 #: flask_security/forms.py:63
+msgid "Password"
+msgstr ""
+
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr ""
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr ""
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr ""
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr ""
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr ""
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr ""
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr ""
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr ""
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr ""
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr ""
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr ""
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr ""
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr ""
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr ""
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr ""
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr ""
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr ""
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr ""
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr ""
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr ""
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr ""
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr ""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -636,27 +656,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -669,29 +689,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr ""
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr ""
@@ -733,7 +767,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -760,56 +794,56 @@ msgstr ""
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -901,6 +935,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/fr_FR/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/fr_FR/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/fr_FR/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/fr_FR/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.0.1\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2017-06-08 10:13+0200\n"
 "Last-Translator: Alexandre Bulté <alexandre@bulte.net>\n"
 "Language: fr_FR\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Connexion requise"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,164 +35,164 @@ msgstr "Connexion requise"
 msgid "Welcome"
 msgstr "Bienvenue"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Merci de confirmer votre adresse email"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Instructions de connexion"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Votre mot de passe a été réinitialisé"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Votre mot de passe a été changé"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Instructions de réinitialisation de votre mot de passe"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr ""
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr ""
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Vous n'avez pas l'autorisation d'accéder à cette ressource."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Merci de vous reconnecter pour accéder à cette page."
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Merci. Votre adresse email a été confirmée."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Votre adresse email a déjà été confirmée."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Token de confirmation non valide."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "L'adresse %(email)s est déjà utilisée."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Le mot de passe ne correspond pas"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Les mots de passe ne correspondent pas"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Les redirections en dehors du domaine sont interdites"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr ""
 "Les instructions de réinitialisation de votre mot de passe ont été "
 "envoyées à %(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Token de réinitialisation non valide."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "Une confirmation de l'adresse email est requise."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Les instructions de confirmation ont été envoyées à %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -197,77 +201,77 @@ msgstr ""
 "Vous ne vous êtes pas connecté dans l'intervalle requis (%(within)s)De "
 "nouvelles instructions ont été envoyées à %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Les instructions de connexion ont été envoyées à %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Token de connexion non valide."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Le compte est désactivé."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Merci d'indiquer une adresse email"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Adresse email non valide"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Code invalide"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Merci d'indiquer un mot de passe"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, fuzzy, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Le mot de passe doit comporter au moins %(length)s caractères"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr ""
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "Numéro de téléphone non valide, par ex. code pays manquant"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Cet utilisateur n'existe pas"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Mot de passe non valide"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "Le mot de passe ou le code soumis n'est pas valide"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Vous êtes bien connecté."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Mot de passe oublié&thinsp;?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
@@ -275,345 +279,361 @@ msgstr ""
 "Vous avez bien réinitialisé votre mot de passe et avez été "
 "automatiquement connecté."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Votre nouveau mot de passe doit être différent du précédent."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Vous avez bien changé votre mot de passe."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Merci de vous connecter pour accéder à cette page."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Merci de vous reconnecter pour accéder à cette page."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Réauthentification réussie"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Vous avez réussi à modifier votre méthode à deux facteurs."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr ""
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr ""
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr ""
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr "Options de connexion actuellement actives : %(method_list)s."
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr ""
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr ""
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "Configuration de la connexion unifiée réussie"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "Vous devez spécifier une identité valide pour vous connecter"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr "Le surnom du nouvel identifiant est requis."
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr "Identifiant non enregistré pour cet usage (premier ou secondaire)"
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Adresse email"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Mot de passe"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Se souvenir de moi"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Connexion"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Sign In"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Inscription"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Renvoyer les instructions de confirmation"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Récupérer le mot de passe"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Réinitialiser le mot de passe"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Confirmer le mot de passe"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nouveau mot de passe"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Changer le mot de passe"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Envoyer le lien de connexion"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr ""
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Changer de méthode"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr ""
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Code d'Identification"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Nous faire parvenir"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Soumettre le code"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr ""
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Identité"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr ""
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Code d'accès"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 "Configuration à l'aide d'une application d'authentification (par exemple,"
 " google, lastpass, authy)"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Configurer par SMS"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr "Authentificateur Google"
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr "authentificateur"
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr "e-mail"
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr "SMS"
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr "mot de passe"
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr "aucune"
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Méthodes disponibles"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr "Désactiver l'authentification à deux facteurs"
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr "Méthodes de second facteur disponibles:"
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -645,27 +665,27 @@ msgstr "Configurer une option de connexi
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr "Surnom"
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr "Utiliser comme premier facteur d'authentification"
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr "Utiliser comme facteur d'authentification secondaire"
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr "Démarrer"
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -678,29 +698,43 @@ msgid "Sign out"
 msgstr "Déconnexion"
 
 #: flask_security/templates/security/_menu.html:17
+msgid "Change Registered Email"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:22
 msgid "Two Factor Setup"
 msgstr "Configuration à deux facteurs"
 
-#: flask_security/templates/security/_menu.html:22
+#: flask_security/templates/security/_menu.html:27
 msgid "Unified Signin Setup"
 msgstr "Configuration de la connexion unifiée"
 
-#: flask_security/templates/security/_menu.html:27
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr "Configuration de WebAuthn"
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "Connexion unifiée"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Mot de passe oublié"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Confirmer le compte"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Changer de mot de passe"
@@ -742,7 +776,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -769,60 +803,60 @@ msgstr "Renvoyer les instructions de con
 msgid "Select Two Factor Method"
 msgstr "Sélectionnez la méthode à deux facteurs"
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 "L'authentification à deux facteurs ajoute une couche de sécurité "
 "supplémentaire à votre compte"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 "En plus de votre nom d'utilisateur et de votre mot de passe, vous devrez "
 "utiliser un code."
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr "Méthode à deux facteurs actuellement configurée : %(method)s"
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr "Vous pouvez les paramétrer ici."
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr "Cette application prend en charge les clés de sécurité WebAuthn."
@@ -916,6 +950,30 @@ msgstr ""
 "Veuillez vous authentifier à nouveau à l'aide de votre clé de sécurité "
 "WebAuthn"
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/hu_HU/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/hu_HU/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/hu_HU/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/hu_HU/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 4.0.0\n"
 "Report-Msgid-Bugs-To: jwag956@github.com\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language: hu_HU\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Bejelentkezés szükséges"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,49 +35,49 @@ msgstr "Bejelentkezés szükséges"
 msgid "Welcome"
 msgstr "Üdvözöljük"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Kérjük, erősítse meg e-mail címét"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Bejelentkezési utasítások"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "A jelszava visszaállításra került"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "A jelszava megváltozott"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Jelszó visszaállítási utasítások"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Kétfaktoros Bejelentkezés"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Kétfaktoros Visszaállítás"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Ellenőrző kód"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "A bemenet nem megfelelő a kért API-hoz"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr "Sikertelen hitelesítés - azonosító vagy jelszó/kód érvénytelen"
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
@@ -81,47 +85,47 @@ msgstr ""
 "Ha ez az e-mail cím szerepel a rendszerünkben, akkor kapni fog egy "
 "e-mailt a jelszó visszaállítási menetéről."
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr "Ha ez az azonosító szerepel a rendszerünkben, akkor kódot küldtünk."
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Nincs jogosultsága ennek az erőforrásnak a megtekintéséhez."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr "A végpont eléréséhez újra hitelesíteni kell"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Köszönjük. E-mail címét megerősítettük."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Az e-mail címét már megerősítették."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Érvénytelen megerősítő token."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s már társítva van egy fiókhoz."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
@@ -130,69 +134,69 @@ msgstr ""
 "A \"%(attr)s\" azonosító attribútum \"%(value)s\" értékkel már társítva "
 "van egy fiókhoz."
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "A jelszó nem egyezik"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "A jelszavak nem egyeznek"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "A tartományon kívüli átirányítások tilosak"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr "A helyreállítási kód érvénytelen"
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr ""
 "A jelszó visszaállítására vonatkozó utasításokat elküldtük a következő "
 "címre: %(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Érvénytelen jelszó-visszaállítási token."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "Az e-mail megerősítést igényel."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "A megerősítő utasításokat elküldtük a következő címre: %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -201,170 +205,170 @@ msgstr ""
 "Nem jelentkezett be %(within)s-en belül. Új bejelentkezési utasításokat "
 "küldtünk a következő címre: %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr ""
 "A bejelentkezéshez szükséges utasításokat elküldtük a következő címre: "
 "%(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Érvénytelen bejelentkezési token."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "A fiók le van tiltva."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "E-mail nincs megadva"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Érvénytelen e-mail cím"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Érvénytelen kód"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Nincs megadva a jelszó"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "A jelszónak legalább %(length)s karakterből kell állnia"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "A jelszó nem elég összetett"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "A telefonszám nem érvényes, pl. hiányzik az országkód"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "A megadott felhasználó nem létezik"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Érvénytelen jelszó"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "A beküldött jelszó vagy kód érvénytelen"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Sikeresen bejelentkezett."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Elfelejtette jelszavát?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "Sikeresen visszaállította jelszavát, és automatikusan be is jelentkezett."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Az új jelszavának különböznie kell a korábbi jelszavától."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Sikeresen megváltoztatta a jelszavát."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Kérjük, jelentkezzen be az oldal eléréséhez."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Kérjük, hitelesítse újra az oldal eléréséhez."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Az újrahitelesítés sikeres"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "\"Csak akkor érheti el ezt a végpontot, ha nincs bejelentkezve."
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr "A kód elküldve."
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr "Nem sikerült elküldeni a kódot. Kérjük, próbálja újra később."
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr "A kódod megerősítésre került"
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Sikeresen megváltoztatta a kétfaktoros hitelesítést."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "Jelenleg nincs jogosultsága az oldal eléréséhez"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "A megjelölt metódus nem érvényes"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "Sikeresen letiltotta a kétfaktoros hitelesítést."
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr "A telepítést %(within)s időn belül be kell fejezni. Kezdje újra."
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr "A kért metódus nem érvényes"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr "A telepítést %(within)s időn belül be kell fejezni. Kezdje újra."
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "Az egységes bejelentkezés beállítása sikeres"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "A bejelentkezéshez érvényes azonositót kell megadnia"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "Használja ezt a kódot a bejelentkezéshez: %(code)s."
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
@@ -373,257 +377,273 @@ msgstr ""
 "A felhasználónévnek legalább %(min)d karakterből és kevesebb mint %(max)d"
 " karakterből kell állnia"
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr "A felhasználónév illegális karaktereket tartalmaz"
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr "A felhasználónév csak betűket és számokat tartalmazhat"
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr "A felhasználónév nincs megadva"
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr "%(username)s már hozzá van rendelve egy fiókhoz."
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr "A WebAuthn műveletet %(within)s időn belül be kell fejezni. Kezdje újra."
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr "Az új hitelesítő adatokhoz becenév szükséges."
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr "%(name)s már hozzá van rendelve egy hitelesítő adathoz."
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr "%(name)s nincs regisztrálva az aktuális felhasználónál."
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 "A WebAuthn hitelesítő adatok sikeresen törölve a következő névvel: "
 "%(name)s"
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 "Sikeresen hozzáadva a WebAuthn hitelesítő adatot a következő névvel: "
 "%(name)s"
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr "A WebAuthn hitelesítő adatazonosítója már regisztrálva."
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr "Nem regisztrált WebAuthn hitelesítő adat azonosítója."
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr "A WebAuthn hitelesítő adatok nem tartoznak egyetlen felhasználóhoz sem."
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr "Nem sikerült ellenőrizni a WebAuthn hitelesítő adatait: %(cause)s."
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 "A hitelesítő adat nincs regisztrálva ehhez a felhasználáshoz (első vagy "
 "másodlagos)"
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "E-mail"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Jelszó"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Emlékezz rám"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Bejelentkezés"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Bejelentkezés"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Regisztráció"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Megerősítő utasítások újraküldése"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Jelszó helyreállítása"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Jelszó visszaállítása"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Jelszó megerősítése"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Új jelszó"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Jelszó módosítása"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Bejelentkezési link küldése"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Jelszó ellenőrzése"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Módszer módosítása"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Telefonszám"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Hitelesítési kód"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Küldés"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Kód beküldése"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Hiba(k)"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Azonosító"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Kód küldése"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Kód"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr "Felhasználónév"
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr "Törlés"
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "Beállítás e-mail használatával"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr "Beállítás hitelesítő alkalmazás segítségével (pl. google, lastpass, authy)"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Beállítás SMS-sel"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Elérhető módszerek"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr "Kétfaktoros hitelesítés letiltása"
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr "Helyreállítási kódok megjelenítése"
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr "Új helyreállítási kódok generálása"
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr "Helyreállítási kód"
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr "Elérhető második faktoros módszerek:"
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr "Kiválasztás"
 
@@ -655,27 +675,27 @@ msgstr "Kiegészítő bejelentkezési le
 msgid "Delete active sign in option"
 msgstr "Az aktív bejelentkezési opció törlése"
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr "Becenév"
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr "Használat"
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr "Használat első hitelesítési lépésként"
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr "Használat másodlagos hitelesítési lépésként"
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -688,29 +708,43 @@ msgid "Sign out"
 msgstr "Kijelentkezés"
 
 #: flask_security/templates/security/_menu.html:17
+msgid "Change Registered Email"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:22
 msgid "Two Factor Setup"
 msgstr "Kétfaktoros beállítás"
 
-#: flask_security/templates/security/_menu.html:22
+#: flask_security/templates/security/_menu.html:27
 msgid "Unified Signin Setup"
 msgstr "Egységes bejelentkezés beállítása"
 
-#: flask_security/templates/security/_menu.html:27
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr "\"WebAuthn beállítása"
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "Egységes bejelentkezés"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Elfelejtett jelszó"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Fiók megerősítése"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Jelszó módosítása"
@@ -752,7 +786,7 @@ msgid "Enter Recovery Code"
 msgstr "Adja meg a helyreállítási kódot"
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr "Helyreállítási kódok"
@@ -781,20 +815,20 @@ msgstr "Megerősítő utasítások újra
 msgid "Select Two Factor Method"
 msgstr "Kétfaktoros módszer kiválasztása"
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr "A kétfaktoros hitelesítés extra biztonsági réteget ad fiókjához"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr "A felhasználóneve és a jelszava mellett egy kódot is kell használnia."
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
@@ -804,36 +838,36 @@ msgstr ""
 "következő QR-kódot (vagy írja be kézzel az alábbi kódot), hogy megkezdje "
 "a kódok fogadását:"
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Kétfaktoros hitelesítési kód"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr "Ez az alkalmazás támogatja a helyreállítási kódok beállítását."
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr "Itt állíthatja be."
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr "Ez az alkalmazás támogatja a WebAuthn biztonsági kulcsokat."
@@ -930,6 +964,30 @@ msgstr "Használja a WebAuthn biztonság
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr "Kérjük, hitelesítsen újra a WebAuthn biztonsági kulcs használatával"
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/hy_AM/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/hy_AM/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/hy_AM/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/hy_AM/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 4.0.0\n"
 "Report-Msgid-Bugs-To: jwag956@github.com\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2020-12-01 11:47+0400\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language: hy_AM\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Անհրաժեշտ է մուտք գործել"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,49 +35,49 @@ msgstr "Անհրաժեշտ է մուտք
 msgid "Welcome"
 msgstr "Բարի գալուստ"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Հաստատեք Ձեր էլ․փոստի հասցեն"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Մուտքի հրահանգներ"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Ձեր գաղտնաբառը վերականգնվել է"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Ձեր գաղտնաբառը փոխվեց"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Գաղտնաբառի վերականգնման հրահանգներ"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Երկու գործոնով մուտք"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Երկու գործոնով վերականգնում"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Վերահաստատման ծածկագիր"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "Մուտքը չի համապատասխանում հայցվող API֊ին"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr "Նույնականացումը ձախողվեց. ինքնությունը կամ գաղտնաբառը/ծածկագիրը անվավեր է"
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
@@ -81,47 +85,47 @@ msgstr ""
 "Եթե այդ էլ․փոստի հասցեն գտնվում է մեր համակարգում, դուք կստանաք նամակ, "
 "որտեղ նկարագրված է, թե ինչպես վերականգնել ձեր գաղտնաբառը:"
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr "Եթե այդ ինքնությունը մեր համակարգում է, ձեզ ծածկագիր է ուղարկվել:"
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Դուք այս ռեսուրսը դիտելու թույլտվություն չունեք"
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Դուք պետք է կրկին նույնականցվեք որպեսզի այստեղ մուտք գործեք"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Շնորհակալություն. Ձեր էլ․փոստի հասցեն հաստատվել է։"
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Ձեր էլ․փոստի հասցեն արդեն հաստատված է։"
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Հաստատման տոկենը անվավեր է։"
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s արդեն կապված է այլ օգտահաշվի հետ։"
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
@@ -130,67 +134,67 @@ msgstr ""
 "«%(value)s» արժեքով «%(attr)s» ինքնության հատկանիշն արդեն կապված է հաշվի "
 "հետ:"
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr "«%(id)s» ինքնությունը գրանցված չէ"
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Գաղտնաբառը չի համապատասխանում"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Գաղտնաբառերը չեն համապատասխանում"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Դոմենից դուրս վերահղումներն արգելափակված են"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr "Վերականգնման ծածկագիրը անվավեր է"
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr "Վերականգնման ծածկագրեր դեռ չեն ստեղծվել"
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "Գաղտնաբառի վերականգնման հրահանգներն ուղարկվել են %(email)s հասցեին։"
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr "Դուք չեք վերականգնել ձեր գաղտնաբառը %(within)s-ի ընթացքում:"
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Գաղտնաբառի վերականգնման տոկենը անվավեր է։"
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "Էլ․փոստի հասցեն պետք է հաստատել։"
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Հաստատման հրահանգները ուղարկվել են %(email)s հասցեին։"
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr "Դուք չեք հաստատել ձեր էլ․փոստի հասցեն %(within)s-ի ընթացքում:"
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -199,77 +203,77 @@ msgstr ""
 "Դուք մուտք չեք գործել %(within)s֊ի ընթացքում. Մուտքի նոր հրահանգները "
 "ուղարկվել են %(email)s հասցեին։"
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Մուտքի հրահանգները ուղարկվել են %(email)s հասցեին։"
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Մուտքի անվավեր տոկեն։"
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Օգտահաշիվն արգելափակված է։"
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Էլ․փոստի հասցեն տրամադրված չէ"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Անվավեր էլ․փոստի հասցե"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Անվավեր ծածկագիր"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Գաղտնաբառը տրամադրված չէ"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Գաղտնաբառը պետք է պարունակի առնվազն %(length)s նիշ"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "Գաղտնաբառը բավարար բարդ չէ"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr "Գաղտնաբառը բացված գաղտնաբառերի ցուցակում է"
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr "Չհաջողվեց կապվել բացված գաղտնաբառերի կայքի հետ"
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "Հեռախոսահամարը անվավեր է, օրինակ՝ բացակայում է երկրի կոդը"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Նշված օգտատերը գոյություն չունի"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Անվավեր գաղտնաբառ"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "Ներկայացված գաղտնաբառը կամ ծածկագիրը վավեր չէ"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Դուք բարեհաջող մուտք էք գործել։"
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Մոռացել ե՞ք գաղտնաբառը"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
@@ -277,7 +281,7 @@ msgstr ""
 "Դուք հաջողությամբ վերականգնել եք ձեր գաղտնաբառը եւ մուտք էք գործել "
 "համակարգ ինքնաբերաբար։"
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
@@ -285,339 +289,355 @@ msgstr ""
 "Դուք հաջողությամբ վերականգնել եք ձեր գաղտնաբառը: Խնդրում ենք "
 "նույնականացնել՝ օգտագործելով ձեր նոր գաղտնաբառը:"
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Ձեր նոր գաղտնաբառը պետք է տարբերվի նախկինից"
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Դուք հաջողությամբ փոխեցիք ձեր գաղտնաբառը։"
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Մուտք գործեք այս էջից օգտվելու համար։"
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Այս էջ մուտք գործելու համար անհրաժեշտ է նորից նույնականացվել:"
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Նույնականացումը հաջողված է"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "Դուք կարող եք մտնել այս վերջնակետ միայն այն ժամանակ, երբ մուտք չեք գործել"
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr "Ծածկագիրը ուղարկվել է։"
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr "Չհաջողվեց ուղարկել ծածկագիրը: Խնդրում ենք փորձել ավելի ուշ"
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr "Ձեր ծածկագիրը հաստատվեց"
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Դուք հաջողությամբ փոխեցիք ձեր երկու֊գործոն տարբերակը"
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "Ներկայումս դուք չունեք այս էջ մուտք գործելու թույլտվություն"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "Նշված տարբերակը վավեր չէ"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "Դուք հաջողությամբ անջատել եք երկու գործոնի թույլտվությունը"
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr "Կարգավորումը պետք է ավարտվի %(within)s ընթացքում։ Խնդրում ենք նորից սկսել։"
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr "Հայցվող մեթոդը վավեր չէ"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr "Կարգավորումը պետք է ավարտվի %(within)s ընթացքում։ Խնդրում ենք նորից սկսել։"
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "Միասնական մուտքի տեղադրումը հաջող է"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "Մուտք գործելու համար պետք է նշեք վավեր ինքնություն"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "Մուտքի համար օգտագործեք այս ծածկագիրը․ %(code)s։"
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr "Օգտանունը պետք է լինի առնվազն %(min)d նիշ և %(max)d նիշից պակաս"
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr "Օգտանունը պարունակում է անօրինական նիշեր"
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr "Օգտանունը կարող է պարունակել միայն տառեր և թվեր"
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr "Օգտանուն չի տրամադրվել"
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr "%(username)s արդեն կապված է օգտահաշվի հետ:"
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr "WebAuthn գործողությունը պետք է ավարտվի %(within)s։ Խնդրում եմ սկսել նորից:"
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr "Նոր հավատարմագրի մականունը պարտադիր է:"
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr "%(name)s-ն արդեն կապված է հավատարմագրի հետ:"
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr "%(name)s գրանցված չէ ընթացիկ օգտատիրոջ մոտ:"
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr "%(name)s անունով WebAuthn հավատարմագիրը հաջողությամբ ջնջվեց"
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr "%(name)s անունով WebAuthn հավատարմագիրը հաջողությամբ ավելացվեց"
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr "WebAuthn հավատարմագրի ID-ն արդեն գրանցված է"
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr "Չգրանցված WebAuthn հավատարմագրի ID:"
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr "WebAuthn հավատարմագիրը չի պատկանում որևէ օգտվողի:"
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr "Չհաջողվեց հաստատել WebAuthn հավատարմագիրը՝ %(cause)s:"
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr "Հավատարմագրերը գրանցված չեն այս օգտագործման համար (առաջին կամ երկրորդական)"
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr "Հավատարմագրերի օգտատիրոջ կապը չի համընկնում"
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Էլեկտրոնային փոստի հասցե"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Գաղտնաբառ"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Հիշիր ինձ"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Մուտք"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Մուտք գործել"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Գրանցվել"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Վերստին հաստատեք ցուցումները"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Վերականգնել գաղտնաբառը"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Զրոյացնել գաղտնաբառը"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Կրկին մուտքագրել գաղտնաբառը"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Նոր գաղտնաբառ"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Փոխել գաղտնաբառը"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Ուղարկել մուտքի հղումը"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Ստուգեք գաղտնաբառը"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Փոխել տարբերակը"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Հեռախոսահամար"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Նույնականացման ծածկագիր"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Ներկայացնել"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Ներկայացնել ծածկագիր"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Սխալ"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Ինքնություն"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Ուղարկել ծածկագիր"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Գաղտնագիր"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr "Օգտատեր"
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr "Ջնջել"
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "Կարգավորեք էլ․փոստի միջոցով"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 "Կարգավորեք օգտագործելով վավերացման ծրագիր (ինչպիսիք են՝ google, lastpass,"
 " authy)"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Կարգավորեք օգտագործելով SMS"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Առկա տարբերակներ"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr "Անջատել երկու գործոնով նույնականացումը"
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr "Ցույց տալ վերականգնման ծածկագրերը"
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr "Ստեղծեք վերականգնման նոր ծածկագրեր"
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr "Վերականգնման ծածկագիր"
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr "Երկրորդ գործոնի հասանելի մեթոդներ."
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr "Ընտրել"
 
@@ -649,27 +669,27 @@ msgstr "Կարգավորեք մուտք
 msgid "Delete active sign in option"
 msgstr "Ջնջել ակտիվ մուտքի տարբերակը"
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr "Մականուն"
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr "Կիրառում"
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr "Օգտագործեք որպես նույնականացման առաջին գործոն"
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr "Օգտագործեք որպես նույնականացման երկրորդական գործոն"
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr "Սկսել"
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr "webauthn"
 
@@ -682,29 +702,43 @@ msgid "Sign out"
 msgstr "Դուրս գալ"
 
 #: flask_security/templates/security/_menu.html:17
+msgid "Change Registered Email"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:22
 msgid "Two Factor Setup"
 msgstr "Երկու գործոնի կարգավորում"
 
-#: flask_security/templates/security/_menu.html:22
+#: flask_security/templates/security/_menu.html:27
 msgid "Unified Signin Setup"
 msgstr "Միասնական մուտքի կարգավորում"
 
-#: flask_security/templates/security/_menu.html:27
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr "WebAuthn կարգավորում"
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "Միասնական Մուտք"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Մոռացել եք գաղտնաբառը"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Հաստատել օգտահաշիվը"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Փոխել գաղտնաբառը"
@@ -746,7 +780,7 @@ msgid "Enter Recovery Code"
 msgstr "Մուտքագրեք վերականգնման ծածկագիրը"
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr "Վերականգնման ծածկագրեր"
@@ -775,22 +809,22 @@ msgstr "Ուղարկել օգտահաշ
 msgid "Select Two Factor Method"
 msgstr "Ընտրեք «երկու գործոնի» տարբերակը"
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 "Երկու գործոնով նույնականացումը ձեր հաշվին ավելացնում է անվտանգության "
 "լրացուցիչ շերտ"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr "Բացի ձեր օգտանունից և գաղտնաբառից, դուք պետք է օգտագործեք ծածկագիր:"
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr "Ներկայիս կարգավորված երկգործոն մեթոդը. %(method)s"
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
@@ -799,36 +833,36 @@ msgstr ""
 "Բացեք վավերացնող հավելվածը ձեր սարքում և սկանավորեք հետևյալ QRcode-ը (կամ"
 " մուտքագրեք ստորև նշված ծածկագիրը) ծածկագրեր ստանալու համար."
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Երկու գործոն նույնականացման ծածկագիր"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr "Այս հավելվածն օժանդակում է վերականգնման ծածկագրերի կարգավորումը:"
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr "Դուք կարող եք դրանք կարգավորել այստեղ:"
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr "WebAuthn"
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr "Այս հավելվածն օժանդակում է WebAuthn անվտանգության բանալիներին:"
@@ -927,6 +961,30 @@ msgstr ""
 "Խնդրում ենք վերանույնականցվեք՝ օգտագործելով ձեր WebAuthn անվտանգության "
 "բանալին"
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/is_IS/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/is_IS/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/is_IS/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/is_IS/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 4.0.0\n"
 "Report-Msgid-Bugs-To: jwag956@github.com\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2022-04-23 17:04+0000\n"
 "Last-Translator: \n"
 "Language: is_IS\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Innskráningar er þörf"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,241 +35,241 @@ msgstr "Innskráningar er þörf"
 msgid "Welcome"
 msgstr "Velkomin(n)"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Vinsamlegast staðfestu netfangið þitt"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Leiðbeiningar fyrir innskráningu"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Lykilorðið þitt hefur verið endurstillt"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Lykilorðinu þínu hefur verið breytt"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Leiðbeiningar um endurstillingu lykilorðs"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Tveggja þátta innskráning"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Staðfestingarkóði"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Þú hefur ekki heimild til að skoða þessa auðlind."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr ""
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Þakka þér fyrir. Netfangið þitt hefur verið staðfest."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Netfangið þitt hefur þegar verið staðfest."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Ógildur staðfestingarkóði."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s er þegar í notkun á öðrum reikningi."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Lykilorðið er ekki eins"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Lykilorðin eru ekki eins"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr ""
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr ""
 "Leiðbeiningar um hvernig þú getur endurstillt lykilorðið þitt hafa verið "
 "sendar á %(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr ""
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "Netfangið þarfnast staðfestingar."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr ""
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
 "sent to %(email)s."
 msgstr ""
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr ""
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr ""
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Aðgangurinn er óvirkur."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Netfang var ekki gefið upp"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Ógilt netfang"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Ógildur kóði"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Lykilorð var ekki gefið upp"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Lykilorð verða að vera að minnsta kosti %(length)s stafir"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "Lykilorðið er ekki nógu flókið"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr "Lykilorðið er á lista yfir brotin lykilorð"
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr "Gat ekki haft samband við síðu yfir brotin lykilorð"
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "Símanúmerið er ekki gilt, t.d. vegna þess að landakóða vantar"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr ""
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Ógilt lykilorð"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr ""
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Þér tókst að skrá þig inn."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Gleymt lykilorð?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
@@ -273,92 +277,92 @@ msgstr ""
 "Þér tókst að endurstilla lykilorðið þitt og þú hefur verið skráð(ur) inn "
 "sjálfkrafa."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Nýja lykilorðið þitt verður að vera öðruvísi en gamla lykilorðið."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Þér tókst að breyta lykilorðinu þínu."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Vinsamlegast skráðu þig inn til að opna þessa síðu."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr ""
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr ""
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr ""
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr ""
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr ""
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr ""
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
 #, python-format
-msgid "Currently active sign in options: %(method_list)s."
+msgid "Setup must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:535
-msgid "Requested method is not valid"
+#: flask_security/core.py:551
+#, python-format
+msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
+#: flask_security/core.py:554
+msgid "Requested method is not valid"
 msgstr ""
 
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr ""
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
@@ -367,251 +371,267 @@ msgstr ""
 "Notendanafnið verður að vera að minnsta kosti %(min)d stafir að lengd og "
 "styttra en %(max)d stafir"
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr "Notendanafnið inniheldur óleyfileg tákn"
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr "Notendanafnið má eingöngu innihalda bókstafi og tölustafi"
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr "Notendanafn var ekki gefið upp"
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Netfang"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Lykilorð"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Muna eftir mér"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Innskráning"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Innskráning"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Skrá mig"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Senda aftur leiðbeiningar um staðfestingu"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Endurheimta lykilorð"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Endurstilla lykilorð"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Endurtekið lykilorð"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nýtt lykilorð"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Breyta lykilorði"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr ""
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Sannreyna lykilorð"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Breyta um aðferð"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Símanúmer"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr ""
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Senda"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Senda kóða"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Villur"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Auðkenni"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Senda kóða"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr ""
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr "Notendanafn"
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr "Eyða"
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr ""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr "Velja"
 
@@ -643,27 +663,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr "Gælunafn"
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr "Notkun"
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr "Byrja"
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -676,29 +696,43 @@ msgid "Sign out"
 msgstr "Skrá út"
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Gleymt lykilorð"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Staðfesta reikning"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Breyta lykilorði"
@@ -740,7 +774,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -767,56 +801,56 @@ msgstr ""
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -908,6 +942,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/it_IT/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/it_IT/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/it_IT/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/it_IT/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -6,10 +6,10 @@
 #
 msgid ""
 msgstr ""
-"Project-Id-Version: Flask-Security 5.4.1\n"
+"Project-Id-Version: Flask-Security 5.4.3\n"
 "Report-Msgid-Bugs-To: jwag956@github.com\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
-"PO-Revision-Date: 2024-02-27 13:54+0100\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
+"PO-Revision-Date: 2024-07-08 15:04+0200\n"
 "Last-Translator: Giorgio Stampa <giorgio.stampa@sanofi.com>\n"
 "Language: it_IT\n"
 "Language-Team: \n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr "Conferma il tuo nuovo indirizzo email"
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Accesso richiesto"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,49 +35,49 @@ msgstr "Accesso richiesto"
 msgid "Welcome"
 msgstr "Benvenuto/a"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Conferma la tua email"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Istruzioni per l'accesso"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "La tua password è stata reimpostata"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "La tua password è stata cambiata"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Istruzioni per reimpostare la password"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Accesso a due fattori"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Recupero dell'accesso a due fattori"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Codice di verifica"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "Input non appropriato per l'API richiesta"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr "Autenticazione fallita - identità o password/passcode non validi"
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
@@ -81,23 +85,23 @@ msgstr ""
 "Se quell'indirizzo email è nel nostro sistema, riceverai un'email che "
 "descrive come reimpostare la tua password."
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr "Se quell'identità è nel nostro sistema, ti è stato inviato un codice."
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Non hai il permesso per visualizzare questa risorsa."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr "È necessario accedere per accedere a questa risorsa."
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr "È necessario riautenticarsi per accedere a questa risorsa"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
@@ -106,24 +110,24 @@ msgstr ""
 "Grazie. Per confermare il tuo indirizzo email %(email)s segui il link nel"
 " messaggio che ti abbiamo appena inviato."
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Grazie. La tua email è stata confermata."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "La tua email è già stata confermata."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Token di conferma non valido."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s è già associata ad un account."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
@@ -132,12 +136,12 @@ msgstr ""
 "L'attributo di identità '%(attr)s' con valore '%(value)s' è già associato"
 " ad un account."
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr "Identità %(id)s non registrata"
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
@@ -146,55 +150,55 @@ msgstr ""
 "Si è verificato un errore durante la comunicazione con il prestatore "
 "OAuth: (%(exerror)s - %(exdesc)s). Per favore prova di nuovo."
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "La password non corrisponde"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Le password non corrispondono"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "I reindirizzamenti all'esterno del dominio sono vietati"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr "Codice di ripristino non valido"
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr "Non sono ancora stati generati codici di recupero"
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "Le istruzioni per reimpostare la password sono state inviate a %(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr "Non hai reimpostato la password entro %(within)s. "
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Token di reimpostazione della password non valido."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "L'email richiede conferma."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Le istruzioni di conferma sono state inviate a %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr "Non hai confermato la tua email entro %(within)s. "
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -203,79 +207,79 @@ msgstr ""
 "Non hai effettuato l'accesso entro %(within)s. Nuove istruzioni per il "
 "login sono state inviate a %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Le istruzioni per accedere sono state inviate a %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Token di accesso non valido."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "L'account è disabilitato."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Email non fornita"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Indirizzo email non valido"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Codice non valido"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Password non fornita"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "La password deve contenere almeno %(length)s caratteri"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "Password non abbastanza complessa"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr "Password nell'elenco delle password violate"
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr "Impossibile contattare il sito delle password violate"
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr ""
 "Numero di telefono non valido, potrebbe mancare il corretto prefisso "
 "internazionale"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "L'utente specificato non esiste"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Password non valida"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "La password o il codice inviato non sono validi"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Hai effettuato l'accesso."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Password dimenticata?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
@@ -283,7 +287,7 @@ msgstr ""
 "Hai reimpostato la tua password e l'accesso è stato effettuato "
 "automaticamente."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
@@ -291,88 +295,88 @@ msgstr ""
 "Hai reimpostato la tua password. Autenticati utilizzando la nuova "
 "password."
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "La tua nuova password deve essere diversa dalla password precedente."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Hai cambiato la tua password."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Devi effettuare l'accesso per accedere a questa pagina."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Devi autenticarti nuovamente per accedere a questa pagina."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Riautenticazione riuscita"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "Puoi accedere a questa risorsa solo se non hai effettuato l'accesso."
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr "Il codice è stato inviato."
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr "Impossibile inviare il codice. Per favore prova di nuovo più tardi"
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr "Il tuo codice è stato confermato"
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Hai cambiato il tuo metodo a due fattori."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "Al momento non disponi dei permessi per accedere a questa pagina"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "Il metodo selezionato non è valido"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "Hai disabilitato l'autorizzazione a due fattori."
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr ""
+"La configurazione deve essere completata entro %(within)s. Per favore "
+"ricomincia da capo."
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr "Opzioni di accesso attualmente attive: %(method_list)s."
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr "Il metodo richiesto non è valido"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr ""
-"La configurazione deve essere completata entro %(within)s. Per favore "
-"ricomincia da capo."
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "Configurazione dell'accesso unificato riuscita"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "Devi specificare un'identità valida per accedere"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "Utilizza questo codice per accedere: %(code)s."
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
@@ -381,255 +385,275 @@ msgstr ""
 "Il nome utente deve essere composto da almeno %(min)d caratteri e meno di"
 " %(max)d caratteri"
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr "Il nome utente contiene caratteri non ammessi"
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr "Il nome utente può contenere solo lettere e numeri"
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr "Nome utente non fornito"
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr "%(username)s è già associato ad un account."
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 "L'operazione WebAuthn deve essere completata entro %(within)s. Per favore"
 " ricomincia da capo."
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr "Il nome per la nuova credenziale è obbligatorio."
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr "%(name)s è già associato ad una credenziale."
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr "%(name)s non registrato con l'utente attuale."
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr "Credenziale WebAuthn con nome: %(name)s eliminata"
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr "Credenziale WebAuthn con nome: %(name)s aggiunta"
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr "Identificativo di credenziale WebAuthn già registrato."
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr "Identificativo di credenziale WebAuthn non registrato."
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr "La credenziale WebAuthn non appartiene a nessun utente."
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr "Impossibile verificare la credenziale WebAuthn: %(cause)s."
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr "Credenziale non registrata per questo uso (primaria o secondaria)"
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr "La credenziale dell'utente non corrisponde"
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+"La conferma deve essere completata entro %(within)s. Per favore "
+"ricomincia."
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr "Cambio di indirizzo email confermato"
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+"Le istruzioni per confermare il tuo nuovo indirizzo email sono state "
+"inviate a %(email)s."
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Indirizzo email"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Password"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Ricordati di me"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Accedi"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Accedi"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Registrati"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Invia nuovamente istruzioni di conferma"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Recupera password"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Reimposta password"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Ridigita password"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nuova password"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Cambia password"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Invia link di accesso"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Verifica password"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Cambia metodo"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Numero di telefono"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Codice di autenticazione"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Invia"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Conferma codice"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Errore(i)"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Identità"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Invia codice"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Codice di accesso"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr "Nome utente"
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr "Elimina"
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "Configurazione tramite email"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 "Configurazione tramite app di autenticazione (ad es. google, lastpass, "
 "authy)"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Configurazione tramite SMS"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr "Google Authenticator"
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr "app di autenticazione"
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr "email"
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr "SMS"
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr "password"
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr "nessuno"
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Metodi disponibili"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr "Disabilitare l'autenticazione a due fattori"
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr "Problemi di accesso al tuo account?/Dispositivo mobile smarrito?"
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr "Contatta l'amministratore"
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr "Mostra i codici di ripristino"
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr "Genera nuovi codici di ripristino"
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr "Codice di ripristino"
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr "Metodi di autenticazione a due fattori disponibili:"
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr "Seleziona"
 
@@ -661,27 +685,27 @@ msgstr "Imposta opzione di accesso aggiu
 msgid "Delete active sign in option"
 msgstr "Elimina l'opzione di accesso attiva"
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr "Nome"
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr "Utilizzo"
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr "Utilizzare come fattore di autenticazione primario"
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr "Utilizzare come fattore di autenticazione secondario"
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr "Inizio"
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr "webauthn"
 
@@ -694,29 +718,43 @@ msgid "Sign out"
 msgstr "Esci"
 
 #: flask_security/templates/security/_menu.html:17
+msgid "Change Registered Email"
+msgstr "Cambia email registrata"
+
+#: flask_security/templates/security/_menu.html:22
 msgid "Two Factor Setup"
 msgstr "Imposta autenticazione a due fattori"
 
-#: flask_security/templates/security/_menu.html:22
+#: flask_security/templates/security/_menu.html:27
 msgid "Unified Signin Setup"
 msgstr "Imposta accesso unificato"
 
-#: flask_security/templates/security/_menu.html:27
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr "Imposta WebAuthn"
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "Accesso unificato"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Password dimenticata"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Conferma account"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr "Cambia email"
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr "Un messaggio di conferma sarà mandato a questo nuovo indirizzo email."
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Cambia password"
@@ -758,7 +796,7 @@ msgid "Enter Recovery Code"
 msgstr "Inserisci codice di ripristino"
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr "Codici di ripristino"
@@ -787,22 +825,22 @@ msgstr "Invia nuovamente istruzioni di c
 msgid "Select Two Factor Method"
 msgstr "Seleziona metodo a due fattori"
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 "L'autenticazione a due fattori aggiunge un ulteriore livello di sicurezza"
 " al tuo account"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr "Oltre al nome utente e alla password, dovrai utilizzare un codice."
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr "Metodo a due fattori attualmente attivo: %(method)s"
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
@@ -812,36 +850,36 @@ msgstr ""
 " codice QR (o inserisci manualmente il codice sottostante) per iniziare a"
 " ricevere i codici:"
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Codice di autenticazione a due fattori"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr "Inserisci il codice per completare la configurazione"
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr "inserisci il codice numerico"
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr "Questa applicazione supporta l'impostazione dei codici di ripristino."
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr "Si possono impostare qui."
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr "WebAuthn"
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr "Questa applicazione supporta le chiavi di sicurezza WebAuthn."
@@ -939,6 +977,30 @@ msgstr ""
 "Per favore autenticati nuovamente utilizzando la chiave di sicurezza "
 "WebAuthn"
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr "Conferma il tuo nuovo indirizzo email tramite il link sottostante:"
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr "Conferma la mia nuova email"
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr "Questo link scadrá entro %(within)s."
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr "La tua email registrata attualmente è %(email)s."
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr "Conferma la tua nuova email tramite il link sottostante:"
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/ja_JP/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/ja_JP/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/ja_JP/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/ja_JP/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.0.1\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2018-01-25 14:12+0900\n"
 "Last-Translator: \n"
 "Language: ja\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "ログインが必要です"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,582 +35,598 @@ msgstr "ログインが必要です"
 msgid "Welcome"
 msgstr "ようこそ"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "メールアドレスの検証"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "ログイン手順"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "パスワード変更"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "パスワードが変更されました。"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "パスワード再設定手順"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr ""
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr ""
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "アクセス権がありません"
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 #, fuzzy
 msgid "You must re-authenticate to access this endpoint"
 msgstr "再度ログインしてください"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "ありがとうございます。メールアドレスが検証されました。"
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "メールアドレスは検証済みです"
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "リンクが無効です"
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s のアカウントは既に作成されています"
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "パスワードが一致しません"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "入力したパスワードが一致していません"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "ドメイン外へのリダイレクトは禁止されています"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "パスワードの再設定手順が %(email)s に送信されました"
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "リンクが無効です"
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "メールアドレスの検証が必要です"
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "%(email)sにメールアドレス検証手順が再送信されました"
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
 "sent to %(email)s."
 msgstr "%(within)s以内にログインしませんでした。ログイン手順を %(email)s に再度送信しました。"
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "%(email)sにログイン手順が送信されました"
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "リンクが無効です"
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "アカウントが無効になっています"
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "メールアドレスを入力してください"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "正しいメールアドレスを入力してください"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr ""
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "パスワードを入力してください"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr ""
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr ""
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr ""
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "入力を確認してください"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "入力を確認してください"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr ""
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "ログインしました"
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "パスワードを忘れた場合"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "パスワードの再設定が完了しました。"
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "新旧パスワードが同じです"
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "パスワードが変更されました"
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "ログインしてください"
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "再度ログインしてください"
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr ""
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr ""
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr ""
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr ""
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr ""
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
 #, python-format
-msgid "Currently active sign in options: %(method_list)s."
+msgid "Setup must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:535
-msgid "Requested method is not valid"
+#: flask_security/core.py:551
+#, python-format
+msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
+#: flask_security/core.py:554
+msgid "Requested method is not valid"
 msgstr ""
 
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr ""
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "メールアドレス"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "パスワード"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "次回以降ログインを省略する"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "ログイン"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr ""
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "ユーザ登録"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "検証手順の再送信"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "再設定手順を送信"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "パスワード変更"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "パスワード再入力"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "新しいパスワード"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "変更"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "ログイン手順を送信"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr ""
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr ""
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr ""
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr ""
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr ""
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr ""
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr ""
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr ""
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr ""
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr ""
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr ""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -638,27 +658,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -671,29 +691,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "パスワードを忘れた場合"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "メールアドレスの検証"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "パスワードの変更"
@@ -735,7 +769,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -762,56 +796,56 @@ msgstr "検証手順の再送信"
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -903,6 +937,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/nl_NL/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/nl_NL/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/nl_NL/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/nl_NL/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.0.1\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2017-05-01 17:52+0200\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language: nl_NL\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Inloggen Verplicht"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,166 +35,166 @@ msgstr "Inloggen Verplicht"
 msgid "Welcome"
 msgstr "Welkom"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Gelieve uw e-mailadres te bevestigen"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Aanmeld instructies"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Uw wachtwoord werd gereset"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Uw wachtwoord werd gewijzigd"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Wachtwoord reset instructies"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Dubbele Authenticatie Aanmelding"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Dubbele Authenticatie Herstellen"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 #, fuzzy
 msgid "Verification Code"
 msgstr "Authenticatie Code"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "U heeft niet de nodige rechten om deze pagina te zien."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 #, fuzzy
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Gelieve opnieuw in te loggen om deze pagina te zien."
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Bedankt. Uw e-mailadres werd bevestigd."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Uw e-mailadres werd reeds bevestigd."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Ongeldige bevestiging token."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s is al gelinkt aan een ander account."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Wachtwoord komt niet overeen"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Wachtwoorden komen niet overeen"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Omleidingen buiten het domein zijn niet toegelaten"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "Instructies om uw wachtwoord te resetten werden verzonden naar %(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Ongeldig wachtwoord reset token."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "E-mailadres moet bevestigd worden."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr ""
 "Instructies ter bevestiging van uw e-mailadres werden verzonden naar "
 "%(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -199,422 +203,438 @@ msgstr ""
 "Je bent niet ingelogd geweest gedurende %(within)s. Nieuwe instructies om"
 " in te loggen werden verzonden naar%(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Instructies om in te loggen werden verzonden naar %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Ongeldige aanmelding."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Account is geblokkeerd."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Email niet ingevuld"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Ongeldig e-mailadres"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 #, fuzzy
 msgid "Invalid code"
 msgstr "Niet valide token"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Wachtwoord niet ingevuld"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, fuzzy, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Uw wachtwoord moet minstens %(length)s karakters bevatten"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr ""
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr ""
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Deze gebruiker bestaat niet"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Ongeldig wachtwoord"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr ""
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "U bent succesvol ingelogd."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Wachtwoord vergeten?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "U heeft uw wachtwoord succesvol gereset en bent nu automatisch ingelogd."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Uw nieuw wachtwoord moet verschillend zijn van het voorgaande wachtwoord."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Uw wachtwoord werd met succes gewijzigd."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Gelieve in te loggen om deze pagina te zien."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Gelieve opnieuw in te loggen om deze pagina te zien."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr ""
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "U heeft succesvol uw Dubbele Authenticatie methode veranderd."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "U heeft niet de juiste permissies om deze pagina te laden"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "De gemarkeerde methode is niet valide"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "U heeft succesvol Dubbele Authenticatie uitgeschakeld."
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 #, fuzzy
 msgid "Requested method is not valid"
 msgstr "De gemarkeerde methode is niet valide"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr ""
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr ""
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "E-mailadres"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "wachtwoord"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Ingelogd blijven"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Aanmelden"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr ""
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Registreer"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Verzend instructies om te bevestigen opnieuw"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Herstel wachtwoord"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "reset wachtwoord"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Type wachtwoord opnieuw"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nieuw wachtwoord"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Verander wachtwoord"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Verzend aanmeld link"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Wachtwoord Verificatie"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Verander Methode"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Telefoonnummer"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Authenticatie Code"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr ""
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr ""
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr ""
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr ""
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr ""
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 #, fuzzy
 msgid "Passcode"
 msgstr "wachtwoord"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr ""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -646,27 +666,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -679,29 +699,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Wachtwoord vergeten"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Bevestig account"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Verander wachtwoord"
@@ -743,7 +777,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -770,58 +804,58 @@ msgstr "Verzend bevestiging instructies
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 "Dubbele Authenticatie voegt een extra laag van beveiliging toe aan uw "
 "account"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Dubbele Authenticatie code"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -913,6 +947,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/pl_PL/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/pl_PL/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/pl_PL/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/pl_PL/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.0.1\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2020-11-28 10:19+0100\n"
 "Last-Translator: Kamil Daniewski <kamil.daniewski@gmail.com>\n"
 "Language: pl_PL\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Logowanie jest wymagane"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,95 +35,95 @@ msgstr "Logowanie jest wymagane"
 msgid "Welcome"
 msgstr "Witamy"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Prosimy o potwierdzenie Twojego adresu e-mail"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Instrukcje logowania"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Twoje hasło zostało zresetowane"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Twoje hasło zostało zmienione"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Instrukcje zmiany hasła"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Logowanie dwuskładnikowe"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Pomoc w logowaniu dwuskładnikowym"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Kod weryfikacyjny"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "Nieprawidłowe dane dla żądanego API"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Nie posiadasz uprawnień, aby wyświetlić tę stronę."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Musisz zalogować się ponownie, aby wyświetlić tę stronę"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Dziękujemy. Twój adres e-mail został potwierdzony."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Twój adres e-mail już został potwierdzony."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Nieprawidłowy token potwierdzania adresu e-mail."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s jest już powiązany z kontem."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
@@ -128,67 +132,67 @@ msgstr ""
 "Atrybut identyfikujący '%(attr)s' z wartością '%(value)s' jest już "
 "powiązany z kontem."
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Hasło nie pasuje"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Hasła nie pasują do siebie"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Przekierowania poza domenę są zabronione"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "Instrukcje resetowania hasła zostały wysłane na adres %(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Nieprawidłowy token resetowania hasła."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "Wymagane jest potwierdzenie adresu e-mail."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Instrukcje potwierdzenia adresu e-mail zostały wysłane na adres %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -197,425 +201,441 @@ msgstr ""
 "Nie zalogowałeś się w ciągu %(within)s. Nowe instrukcje logowania zostały"
 " wysłane na adres %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Instrukcje logowania zostały wysłane na adres %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Nieprawidłowy token logowania."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Konto jest wyłączone."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Adres e-mail nie został wprowadzony"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Nieprawidłowy adres e-mail"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Nieprawidłowy kod"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Hasło nie zostało wprowadzone"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Hasło musi zawierać co najmniej %(length)s znaków"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "Hasło nie jest wystarczająco złożone"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr "Hasło znajduje się na liście haseł wykradzionych"
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 "Nie udało się dotrzeć do podmiotu sprawdzającego hasło w bazie "
 "wykradzionych haseł"
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "Nieprawidłowiy numer telefonu (upewnij się, że zawiera kod kraju)"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Ten użytkownik nie istnieje"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Nieprawidłowe hasło"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "Hasło lub wprowadzony kod są nieprawidłowe"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Zostałeś zalogowany pomyślnie."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Zapomniałeś hasło?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "Ustawiono nowe hasło i zostałeś zalogowany pomyślnie."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Twoje nowe hasło musi być inne, niż obecne hasło."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Pomyślnie zmieniłeś hasło."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Prosimy o zalogowanie się, aby móc odwiedzić tę stronę."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Prosimy o ponowne zalogowanie się, aby móc odwiedzić tę stronę."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Ponownie zalogowano"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "Możesz odwiedzić tę stronę tylko będąc niezalogowanym."
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr "Nie udało się wysłać kodu. Prosimy spróbować później"
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Metoda logowania dwuskładnikowego została zmieniona pomyślnie."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "Nie posiadasz uprawnień, aby odwiedzić tę stronę"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "Wybrana metoda jest niewłaściwa"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "Pomyślnie wyłączyłeś logowanie dwuskładnikowe."
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr ""
+"Ustawienie musi zostać ukończone w ciągu %(within)s. Prosimy zacząć "
+"ponownie."
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr "Żądana metoda jest niewłaściwa"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr ""
-"Ustawienie musi zostać ukończone w ciągu %(within)s. Prosimy zacząć "
-"ponownie."
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "Ujednolicone logowanie przebiegło pomyślnie"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "Musisz ustawić prawidłowy identyfikator, aby się zalogować"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "Użyj tego kodu, aby się zalogować: %(code)s."
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Adres e-mail"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Hasło"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Zapamiętaj mnie"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Zaloguj"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Zaloguj"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Zarejestruj"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Ponownie wyślij instrukcje potwierdzania adresu e-mail"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Odzyskaj hasło"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Zresetuj hasło"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Przepisz hasło"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nowe hasło"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Zmień hasło"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Wyślij link logowania"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Potwierdź hasło"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Zmień metodę"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Numer telefonu"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Kod uwierzytelniania"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Wyślij"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Kod zatwierdzenia"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Błędy"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Identyfikator"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Wyślij kod"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Kod dostępu"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "Ustaw przy pomocy adresu e-mail"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 "Ustaw przy pomocy zewnętrznej aplikacji uwierzytelniania (np. Google, "
 "Lastpass, Authy)"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Ustaw przy pomocy wiadomości SMS"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Dostępne metody"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -647,27 +667,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -680,29 +700,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "Logowanie ujednolicone"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Zapomniałem hasło"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Potwierdź konto"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Zmień hasło"
@@ -744,7 +778,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -771,58 +805,58 @@ msgstr "Ponownie wyślij instrukcje potw
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 "Uwierzytelnianie dwuskładnikowe jest dodatkową warstwą bezpieczeństwa dla"
 " Twojego konta"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Kod uwierzytelniania dwuskładnikowego"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -914,6 +948,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/pt_BR/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/pt_BR/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/pt_BR/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/pt_BR/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.0.1\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2017-09-27 23:39-0300\n"
 "Last-Translator: José Neto <josenetodino@gmail.com>\n"
 "Language: pt_BR\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Login obrigatório"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,163 +35,163 @@ msgstr "Login obrigatório"
 msgid "Welcome"
 msgstr "Bem-vindo"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Por favor, confirme seu email"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Instruções de login"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Sua senha foi redefinida"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Sua senha foi alterada"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Instruções para redfinir a senha"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr ""
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr ""
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Você não tem permissão para ver este recurso"
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 #, fuzzy
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Por favor, reautentique-se para acessar esta página."
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Obrigado. Seu email foi confirmado."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "Seu email já foi confirmado."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Token de confirmação inválido."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s já está associado a uma conta."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Senha não confere"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Senhas não conferem"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Redirecionamentos para fora do domínio são proibidos"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "As instruções para redefinir sua senha foram enviadas para %(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Token de redefinição de senha inválido."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "O email requer confirmação."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "As instruções de confirmaç foram enviadas para %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -196,420 +200,436 @@ msgstr ""
 "Você não logou dentro de %(within)s. Novas instruções para logar foram "
 "enviadas para %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Instruções para logar foram enviadas para %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Token de login inválido."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Conta desabilitada."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Email não informado"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Endereço de email inválido"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 #, fuzzy
 msgid "Invalid code"
 msgstr "Senha inválida"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Senha não informada"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, fuzzy, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "A senha deve ter pelo menos 6 caracteres"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr ""
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr ""
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Usuário não existe"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Senha inválida"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr ""
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Você logou com sucesso."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Esqueceu a senha?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "Você redefiniu sua senha com sucesso e foi logado automaticamente."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Sua nova senha deve ser diferente da sua senha anterior."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Você alterou sua senha com sucesso."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Por favor, logue para acessar esta página."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Por favor, reautentique-se para acessar esta página."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr ""
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr ""
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr ""
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr ""
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr ""
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
 #, python-format
-msgid "Currently active sign in options: %(method_list)s."
+msgid "Setup must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:535
-msgid "Requested method is not valid"
+#: flask_security/core.py:551
+#, python-format
+msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
+#: flask_security/core.py:554
+msgid "Requested method is not valid"
 msgstr ""
 
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr ""
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Endereço de email"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Senha"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Lembre de mim"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Login"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr ""
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Registro"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Reenviar instruções de confirmação"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Recuperar senha"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Redefinir senha"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Reescreva a senha"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nova senha"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Alterar senha"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Enviar link de login"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr ""
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr ""
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr ""
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr ""
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr ""
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr ""
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr ""
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr ""
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr ""
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr ""
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr ""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -641,27 +661,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -674,29 +694,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Esqueceu a senha"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Confirmar conta"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Alterar senha"
@@ -738,7 +772,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -765,56 +799,56 @@ msgstr "Reenviar instruções de confirm
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -906,6 +940,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/pt_PT/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/pt_PT/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/pt_PT/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/pt_PT/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.0.1\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2018-04-27 14:00+0100\n"
 "Last-Translator: Micael Grilo <micael.grilo@outlook.com>\n"
 "Language: pt_PT\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Login obrigatório"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,165 +35,165 @@ msgstr "Login obrigatório"
 msgid "Welcome"
 msgstr "Bem-vindo"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Por favor, confirme o seu email"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Instruções de login"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "A sua palavra-passe foi redefinida"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "A sua palavra-passe foi alterada"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Instruções para redefinir a palavra-passe"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr ""
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr ""
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Não tem permissões para ver este recurso"
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 #, fuzzy
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Por favor, reautentique-se para aceder esta página."
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Obrigado. O seu email foi confirmado."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "O seu email já foi confirmado."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Token de confirmação inválido."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s já está associado a uma conta."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Palavra-passe não coincide"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Palavras-passe não coincidem"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Redirecionamentos para fora do domínio são proibidos"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr ""
 "As instruções para redefinir a sua palavra-passe foram enviadas para "
 "%(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Token de redefinição de senha inválido."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "O email requer confirmação."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "As instruções de confirmação foram enviadas para %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -198,77 +202,77 @@ msgstr ""
 "Não iniciou sessão dentro de %(within)s. Novas instruções de inicio de "
 "sessão foram enviadas para %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Instruções para o inicio de sessão foram enviadas para %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Token de login inválido."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Conta desactivada."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Email em falta"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Endereço de email inválido"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr ""
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Palavra-passe em falta"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, fuzzy, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "A palavra-passe deve ter pelo menos %(length)s caracteres"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr ""
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr ""
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Utilizador não existe"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Palavra-passe inválida"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr ""
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Sessão iniciada com sucesso."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Esqueceu a palavra-passe?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
@@ -276,343 +280,359 @@ msgstr ""
 "Redefiniu a sua palavra-passe com sucesso e iniciou sessão "
 "automaticamente."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "A sua nova palavra-passe deve ser diferente da anterior."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Alterou a sua palavra-passe com sucesso."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Por favor, inicie sessão para aceder a esta página."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Por favor, reautentique-se para aceder esta página."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr ""
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr ""
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr ""
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr ""
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr ""
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
 #, python-format
-msgid "Currently active sign in options: %(method_list)s."
+msgid "Setup must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:535
-msgid "Requested method is not valid"
+#: flask_security/core.py:551
+#, python-format
+msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
+#: flask_security/core.py:554
+msgid "Requested method is not valid"
 msgstr ""
 
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr ""
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "Endereço de email"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Palavra-passe"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Lembrar-me"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Login"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr ""
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Registo"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Reenviar instruções de confirmação"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Recuperar palavra-passe"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Redefinir palavra-passe"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Reescreva a palavra-passe"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Nova palavra-passe"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Alterar palavra-passe"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Enviar endereço de login"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr ""
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr ""
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr ""
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr ""
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr ""
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr ""
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr ""
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr ""
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr ""
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr ""
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr ""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -644,27 +664,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -677,29 +697,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Esqueceu a palavra-passe"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Confirmar conta"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Alterar palavra-passe"
@@ -741,7 +775,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -768,56 +802,56 @@ msgstr "Reenviar instruções de confirm
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -909,6 +943,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/ru_RU/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/ru_RU/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/ru_RU/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/ru_RU/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,8 +8,8 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.0.1\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
-"PO-Revision-Date: 2023-01-25 04:14+0530\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
+"PO-Revision-Date: 2024-05-26 04:58+0530\n"
 "Last-Translator: Ivan Fedorov <inbox@titaniumhocker.ru>\n"
 "Language: ru_RU\n"
 "Language-Team: Leonid R. <leovp@users.noreply.github.com>\n"
@@ -18,13 +18,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr "Подтвердите свой новый email адрес"
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Требуется авторизация"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -32,51 +36,51 @@ msgstr "Требуется автори
 msgid "Welcome"
 msgstr "Добро пожаловать"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
-msgstr "Пожалуйста, подтвердите свой адрес электронной почты"
+msgstr "Пожалуйста, подтвердите свой email"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Инструкция для входа"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Ваш пароль был сброшен"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Ваш пароль был изменён"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Инструкции для восстановления пароля"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "Двухфакторный вход"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr "Двухфакторное восстановление"
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "Код подтверждения"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "Ввод некорректен для запрошенного API"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 "Аутентификация не удалась — идентификатор или пароль/код доступа "
 "недействительны"
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
@@ -84,47 +88,49 @@ msgstr ""
 "Если этот адрес электронной почты есть в нашей системе, вы получите "
 "письмо с описанием того, как сбросить пароль."
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr "Если этот идентификатор есть в нашей системе, вам был выслан код."
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "У вас нет прав доступа к этому ресурсу."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
-msgstr ""
+msgstr "Вы должны авторизоваться, чтобы просмотреть этот ресурс."
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Пожалуйста, войдите повторно чтобы получить доступ к этой странице"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
+"Спасибо. Чтобы подтвердить свой email %(email)s, пожалуйста, нажмите на "
+"ссылку в письме, которое мы только что отправили вам."
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
-msgstr "Спасибо. Ваш почтовый адрес был подтверждён."
+msgstr "Спасибо. Ваш email был подтверждён."
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
-msgstr "Ваш почтовый адрес уже подтверждён."
+msgstr "Ваш email уже был подтверждён."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Неверный токен для подтверждения аккаунта."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s уже привязан к другому аккаунту."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
@@ -133,67 +139,69 @@ msgstr ""
 "Идентификационный атрибут '%(attr)s' со значением '%(value)s' уже "
 "ассоциирован с учетной записью."
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr "Идентификация %(id)s не зарегистрирована"
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
+"При взаимодействии с провайдером Oauth произошла ошибка: (%(exerror)s - "
+"%(exdesc)s). Пожалуйста, попробуйте ещё раз."
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Пароль не подходит"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Пароли не совпадают"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Перенаправления вне текущего домена запрещены"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr "Код восстановления недействителен"
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr "Коды восстановления еще не сгенерированы"
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "Инструкции по восстановлению пароля были отправлены на %(email)s."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
-msgstr ""
+msgstr "Вы не сбросили пароль в течение %(within)s. "
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Неверный токен для восстановления пароля."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
-msgstr "Почтовый адрес требует подтверждения."
+msgstr "Email требует подтверждения."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Инструкции по подтверждению были отправлены на %(email)s."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
-msgstr ""
+msgstr "Вы не подтвердили свое письмо в пределах %(within)s. "
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -202,170 +210,172 @@ msgstr ""
 "Вы не вошли в течение %(within)s. Новые инструкции по входу отправлены на"
 " %(email)s."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Инструкции по входу отправлены на %(email)s."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Неверный токен для входа."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Аккаунт отключён."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "Почтовый адрес не введён"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
-msgstr "Неверный почтовый адрес"
+msgstr "Неверный Email"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr "Код недействителен"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Пароль не введён"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Пароль должен содержать не менее %(length)s символов"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "Пароль недостаточно сложный"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr "Пароль в списке скомпрометированных"
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr "Не удалось соединиться с сайтом скомпрометированных паролей"
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "Номер телефона некорректен, например, отсутствует код страны"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Указанный пользователь не существует"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Неверный пароль"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "Предоставленный пароль или код недействительны"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Вы успешно вошли в систему."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Забыли пароль?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "Вы успешно сбросили пароль и автоматически вошли в систему."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
+"Вы успешно сбросили свой пароль. Пожалуйста, авторизуйтесь, используя "
+"новый пароль."
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Ваш новый пароль должен отличаться от предыдущего."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Вы успешно изменили свой пароль."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Пожалуйста, войдите чтобы получить доступ к этой странице."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Пожалуйста, войдите заново, чтобы получить доступ к этой странице."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "Повторный вход выполнен успешно"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "Вы можете получить доступ к данной странице, только если не авторизованы."
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr "Код отправлен."
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr "Не удалось отправить код. Пожалуйста, попробуйте позже"
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr "Ваш код был подтвержден"
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "Вы успешно изменили метод двухфакторной авторизации."
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "В настоящее время у вас нет доступа к данной странице"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "Отмеченный метод недействителен"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "Вы успешно отключили двухфакторную авторизацию."
 
-#: flask_security/core.py:532
-#, python-format
-msgid "Currently active sign in options: %(method_list)s."
-msgstr ""
-
-#: flask_security/core.py:535
-msgid "Requested method is not valid"
-msgstr "Запрошенный метод недействителен"
-
-#: flask_security/core.py:537
+#: flask_security/core.py:547 flask_security/core.py:556
 #, python-format
 msgid "Setup must be completed within %(within)s. Please start over."
 msgstr ""
 "Настройка должна быть завершена в течение %(within)s. Пожалуйста, начните"
 " заново."
 
-#: flask_security/core.py:540
+#: flask_security/core.py:551
+#, python-format
+msgid "Currently active sign in options: %(method_list)s."
+msgstr "Активные на данный момент варианты входа в систему: %(method_list)s."
+
+#: flask_security/core.py:554
+msgid "Requested method is not valid"
+msgstr "Запрошенный метод недействителен"
+
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "Настройка единого способа входа прошла успешно"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "Вы должны указать действительный идентификатор для входа"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "Используйте данный код для входа: %(code)s."
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
@@ -374,267 +384,287 @@ msgstr ""
 "Имя пользователя должно содержать не менее %(min)d и не более %(max)d "
 "символов"
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr "Имя пользователя содержит недопустимые символы"
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr "Имя пользователя может содержать только буквы и цифры"
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr "Имя пользователя не указано"
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr "Имя пользователя %(username)s уже связано с учётной записью."
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 "Операция WebAuthn должна быть завершена в течение %(within)s. Пожалуйста,"
 " начните сначала."
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr "Требуется псевдоним для новых учётных данных."
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr "%(name)s уже связан с учётными данными."
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr "%(name)s не зарегистрирован с текущим пользователем."
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr "Учётные данные WebAuthn с именем %(name)s успешно удалены"
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr "Учётные данные WebAuthn с именем %(name)s успешно добавлены"
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr "Учётные данные WebAuthn уже зарегистрированы."
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr "Незарегистрированный идентификатор учетных данных WebAuthn."
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr "Учётные данные WebAuthn не принадлежат ни одному пользователю."
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr "Не удалось проверить учётные данные WebAuthn: %(cause)s."
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 "Учётные данные не зарегистрированы для этого использования (первичное или"
 " вторичное)"
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr "Несовпадение учётных данных пользователя"
 
-#: flask_security/forms.py:61
-msgid "Email Address"
-msgstr "Адрес электронной почты"
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+"Подтверждение должно быть выполнено в течение %(within)s. Пожалуйста, "
+"начните сначала."
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr "Изменение email адреса подтверждено"
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+"Инструкции по подтверждению вашего нового email адреса были отправлены на"
+" %(email)s."
 
 #: flask_security/forms.py:62
+msgid "Email Address"
+msgstr "Email адрес"
+
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Пароль"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Запомнить меня"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Войти"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "Войти"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Зарегистрироваться"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Отправить повторно инструкции по подтверждению аккаунта"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Восстановить пароль"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Сбросить пароль"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Подтверждение пароля"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Новый пароль"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Сменить пароль"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Отправить ссылку для входа"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "Подтвердите пароль"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr "Изменить метод"
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "Номер телефона"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "Код аутентификации"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "Отправить"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "Отправить код"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "Ошибка(и)"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr "Идентификатор"
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "Отправить код"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr "Код доступа"
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr "Имя пользователя"
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr "Удалить"
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "Настроить с помощью электронной почты"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 "Настроить с помощью приложения для аутентификации (например google, "
 "lastpass, authy)"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "Настроить с помощью СМС"
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
-msgstr ""
+msgstr "Google Authenticator"
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
-msgstr ""
+msgstr "аутентификатор"
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
-msgstr ""
+msgstr "email"
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
-msgstr ""
+msgstr "SMS"
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
-msgstr ""
+msgstr "пароль"
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
-msgstr ""
+msgstr "ничего"
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr "Доступные методы"
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr "Отключить двухфакторную аутентификацию"
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
-msgstr ""
+msgstr "Проблемы с доступом к аккаунту?/Утеряно мобильное устройство?"
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
-msgstr ""
+msgstr "Связаться с администратором"
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr "Показать коды восстановления"
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr "Генерация новых кодов восстановления"
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr "Код восстановления"
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr "Доступные методы двухфакторной аутентификации:"
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr "Выбрать"
 
 #: flask_security/twofactor.py:135
 msgid "Send code via email"
-msgstr ""
+msgstr "Отправить код по email"
 
 #: flask_security/twofactor.py:147
 msgid "Use previously downloaded recovery code"
-msgstr ""
+msgstr "Использовать ранее загруженный код восстановления"
 
 #: flask_security/unified_signin.py:160
 msgid "Code or Password"
@@ -656,27 +686,27 @@ msgstr "Настроить дополн
 msgid "Delete active sign in option"
 msgstr "Удаление активной опции входа"
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr "Псевдоним"
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr "Использование"
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr "Использовать как первичный метод аутентификации"
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr "Использовать как вторичный метод аутентификации"
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr "Начать"
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr "webauthn"
 
@@ -689,29 +719,43 @@ msgid "Sign out"
 msgstr "Выход"
 
 #: flask_security/templates/security/_menu.html:17
+msgid "Change Registered Email"
+msgstr "Изменить зарегистрированный Email"
+
+#: flask_security/templates/security/_menu.html:22
 msgid "Two Factor Setup"
 msgstr "Настройка двухфакторной аутентификации"
 
-#: flask_security/templates/security/_menu.html:22
+#: flask_security/templates/security/_menu.html:27
 msgid "Unified Signin Setup"
 msgstr "Настройка единого входа"
 
-#: flask_security/templates/security/_menu.html:27
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr "Настройка WebAuthn"
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "Единый вход"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Забыли пароль"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Подтвердить аккаунт"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr "Изменить email"
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr "После отправки, на этот новый email адрес будет отправлено подтверждение."
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Сменить пароль"
@@ -753,7 +797,7 @@ msgid "Enter Recovery Code"
 msgstr "Введите код восстановления"
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr "Коды восстановления"
@@ -782,22 +826,22 @@ msgstr "Заново отправить
 msgid "Select Two Factor Method"
 msgstr "Выбрать метод двухфакторной аутентификации"
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 "Двухфакторная аутентификация добавляет дополнительный уровень "
 "безопасности для вашей учётной записи"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr "Помимо имени пользователя и пароля, вам нужно будет использовать код."
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr "Текущий настроенный двухфакторный метод: %(method)s"
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
@@ -807,36 +851,36 @@ msgstr ""
 "следующий QR-код (или введите код ниже вручную), чтобы начать получать "
 "коды:"
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "Код двухфакторной аутентификации"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
-msgstr ""
+msgstr "Введите код, чтобы завершить настройку"
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
-msgstr ""
+msgstr "введите цифровой код"
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr "Это приложение поддерживает настройку кодов восстановления."
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr "Вы можете настроить их здесь."
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr "WebAuthn"
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr "Это приложение поддерживает ключи безопасности WebAuthn."
@@ -856,7 +900,7 @@ msgstr "Код аутентификац
 
 #: flask_security/templates/security/two_factor_verify_code.html:22
 msgid "An email was sent to us in order to reset your application account"
-msgstr ""
+msgstr "Нам было отправлен email, чтобы сбросить настройки вашей учетной записи"
 
 #: flask_security/templates/security/us_setup.html:30
 msgid "Setup Unified Sign In"
@@ -935,6 +979,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr "Пожалуйста, повторите аутентификацию, используя ключ безопасности WebAuthn"
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr "Пожалуйста, подтвердите свой новый email адрес, нажав на ссылку ниже:"
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr "Подтвердить мой новый email"
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr "Срок действия этой ссылки истекает через %(within)s."
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr "Ваш текущий зарегистрированный email адрес — %(email)s."
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr "Пожалуйста, подтвердите свой новый email по ссылке ниже:"
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
@@ -1163,15 +1231,6 @@ msgstr "Пожалуйста, повто
 #~ msgid "You are not authenticated. Please supply the correct credentials."
 #~ msgstr "Вы не аутентифицированы. Пожалуйста, укажите корректные учётные данные."
 
-#~ msgid "Authenticator app"
-#~ msgstr ""
-
-#~ msgid "Email"
-#~ msgstr ""
-
-#~ msgid "None"
-#~ msgstr ""
-
 #~ msgid "Currently active sign in options:"
 #~ msgstr "Активные на данный момент варианты входа в систему:"
 
@@ -1183,9 +1242,6 @@ msgstr "Пожалуйста, повто
 #~ msgid "To Which Phone Number Should We Send Code To?"
 #~ msgstr "На какой номер телефона необходимо отправить код?"
 
-#~ msgid "enter code"
-#~ msgstr ""
-
 #~ msgid "A mail was sent to us in order to reset your application account"
 #~ msgstr "Нам было отправлено письмо для сброса вашей учетной записи"
 
diff -pruN 5.4.3-1/flask_security/translations/tr_TR/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/tr_TR/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/tr_TR/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/tr_TR/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -7,7 +7,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.0.1\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2018-12-20 18:48+0300\n"
 "Last-Translator: Ecmel B. Canlıer <me@ecmelberk.com>\n"
 "Language: tr_TR\n"
@@ -16,13 +16,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "Giriş yapmanız gerekmektedir"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -30,163 +34,163 @@ msgstr "Giriş yapmanız gerekmektedir"
 msgid "Welcome"
 msgstr "Hoş Geldiniz"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "Lütfen e-posta adresinizi onaylayın"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "Giriş talimatları"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "Şifreniz yenilenmiştir"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "Şifreniz değiştirilmiştir"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "Şifre yenileme talimatları"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr ""
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr ""
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr ""
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "Bu maddeyi görmeye yetkiniz yoktur."
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 #, fuzzy
 msgid "You must re-authenticate to access this endpoint"
 msgstr "Bu sayfaya erişebilmek için lütfen tekrardan giriş yapın."
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "Teşekkür ederiz. E-posta adresiniz onaylanmıştır"
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "E-posta adresiniz zaten onaylanmış."
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "Yanlış onaylama kodu."
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s başka bir hesaba bağlı."
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "Şifre yanlış"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "Şifreler uymuyor"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "Adres dışına yönlendirmeler yasaktır"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "Şifrenizi yenileme talimatları %(email)s adresine gönderilmiştir."
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "Yanlış şifre yenileme kodu."
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "E-posta onayı gerekmektedir."
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "Onaylama talimatları %(email)s adresine gönderilmiştir."
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
@@ -195,419 +199,435 @@ msgstr ""
 "%(within)s içinde giriş yapmadınız. Yeni giriş yapma talimatları "
 "%(email)s adresine gönderilmiştir."
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "Giriş yapma talimatları %(email)s adresine gönderilmiştir."
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "Yanlış giriş kodu."
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "Hesap kapalıdır."
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "E-posta verilmemiş"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "Yanlış e-posta adresi"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 msgid "Invalid code"
 msgstr ""
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "Şifre verilmemiş"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, fuzzy, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "Şifreniz en az %(length)s karakter olmalıdır"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr ""
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr ""
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr ""
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr ""
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "Böyle bir kullanıcı yok"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "Şifre yanlış"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr ""
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "Başarıyla giriş yaptınız."
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "Şifrenizi mi unuttunuz?"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "Şifreniz yenilenmiştir ve otomatik olarak giriş yapmış bulunmaktasınız."
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "Yeni şifreniz eski şifrenizden farklı olmalıdır."
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "Şifrenizi başarıyla değiştirdiniz."
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "Bu sayfaya erişebilmek için lütfen giriş yapın."
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "Bu sayfaya erişebilmek için lütfen tekrardan giriş yapın."
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr ""
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr ""
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr ""
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr ""
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr ""
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr ""
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr ""
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
 #, python-format
-msgid "Currently active sign in options: %(method_list)s."
+msgid "Setup must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:535
-msgid "Requested method is not valid"
+#: flask_security/core.py:551
+#, python-format
+msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
+#: flask_security/core.py:554
+msgid "Requested method is not valid"
 msgstr ""
 
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr ""
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr ""
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr ""
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "E-posta Adresi"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "Şifre"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "Beni Hatırla"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "Giriş Yap"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr ""
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "Kayıt Ol"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "Onaylama Talimatlarını Tekrar Gönder"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "Şifre Kurtar"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "Şifre Yenile"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "Şifre Tekrarı"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "Yeni Şifre"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "Şifre Değiştir"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "Giriş Linki Gönder"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr ""
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr ""
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr ""
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr ""
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr ""
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr ""
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr ""
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr ""
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr ""
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr ""
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr ""
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr ""
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr ""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -639,27 +659,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -672,29 +692,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "Şifremi unuttum"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "Hesabı onayla"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "Şifre değiştir"
@@ -736,7 +770,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -763,56 +797,56 @@ msgstr "Onaylama talimatlarını tekrar
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -904,6 +938,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/translations/zh_Hans_CN/LC_MESSAGES/flask_security.po 5.5.0-1/flask_security/translations/zh_Hans_CN/LC_MESSAGES/flask_security.po
--- 5.4.3-1/flask_security/translations/zh_Hans_CN/LC_MESSAGES/flask_security.po	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/translations/zh_Hans_CN/LC_MESSAGES/flask_security.po	2024-07-24 02:21:26.000000000 +0000
@@ -8,7 +8,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: Flask-Security 2.0.1\n"
 "Report-Msgid-Bugs-To: info@inveniosoftware.org\n"
-"POT-Creation-Date: 2024-02-21 18:15-0800\n"
+"POT-Creation-Date: 2024-07-22 16:40-0700\n"
 "PO-Revision-Date: 2018-08-02 19:55+0800\n"
 "Last-Translator: SteinKuo <guoming054@gmail.com>\n"
 "Language: zh_CN\n"
@@ -17,13 +17,17 @@ msgstr ""
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"Generated-By: Babel 2.14.0\n"
+"Generated-By: Babel 2.15.0\n"
 
-#: flask_security/core.py:269
+#: flask_security/core.py:239
+msgid "Confirm your new email address"
+msgstr ""
+
+#: flask_security/core.py:285
 msgid "Login Required"
 msgstr "需要登录"
 
-#: flask_security/core.py:270
+#: flask_security/core.py:286
 #: flask_security/templates/security/email/two_factor_instructions.html:1
 #: flask_security/templates/security/email/two_factor_instructions.txt:1
 #: flask_security/templates/security/email/us_instructions.html:9
@@ -31,583 +35,599 @@ msgstr "需要登录"
 msgid "Welcome"
 msgstr "欢迎"
 
-#: flask_security/core.py:271
+#: flask_security/core.py:287
 msgid "Please confirm your email"
 msgstr "请激活你的电子邮箱"
 
-#: flask_security/core.py:272
+#: flask_security/core.py:288
 msgid "Login instructions"
 msgstr "登录邮件"
 
-#: flask_security/core.py:273
+#: flask_security/core.py:289
 #: flask_security/templates/security/email/reset_notice.html:1
 #: flask_security/templates/security/email/reset_notice.txt:1
 msgid "Your password has been reset"
 msgstr "你的密码已重置"
 
-#: flask_security/core.py:274
+#: flask_security/core.py:290
 msgid "Your password has been changed"
 msgstr "你的密码已更改"
 
-#: flask_security/core.py:275
+#: flask_security/core.py:291
 msgid "Password reset instructions"
 msgstr "密码重置"
 
-#: flask_security/core.py:278
+#: flask_security/core.py:294
 msgid "Two-factor Login"
 msgstr "双因素认证登录"
 
-#: flask_security/core.py:279
+#: flask_security/core.py:295
 msgid "Two-factor Rescue"
 msgstr ""
 
-#: flask_security/core.py:327
+#: flask_security/core.py:342
 msgid "Verification Code"
 msgstr "验证码"
 
-#: flask_security/core.py:373
+#: flask_security/core.py:388
 msgid "Input not appropriate for requested API"
 msgstr "输入信息不适合所请求的API"
 
-#: flask_security/core.py:375
+#: flask_security/core.py:390
 msgid "Authentication failed - identity or password/passcode invalid"
 msgstr ""
 
-#: flask_security/core.py:379
+#: flask_security/core.py:394
 msgid ""
 "If that email address is in our system, you will receive an email "
 "describing how to reset your password."
 msgstr ""
 
-#: flask_security/core.py:386
+#: flask_security/core.py:401
 msgid "If that identity is in our system, you were sent a code."
 msgstr ""
 
-#: flask_security/core.py:389
+#: flask_security/core.py:404
 msgid "You do not have permission to view this resource."
 msgstr "你无权查看此资源！"
 
-#: flask_security/core.py:391
+#: flask_security/core.py:406
 msgid "You must sign in to view this resource."
 msgstr ""
 
-#: flask_security/core.py:395
+#: flask_security/core.py:410
 #, fuzzy
 msgid "You must re-authenticate to access this endpoint"
 msgstr "请重新进行身份验证，以访问此页面。"
 
-#: flask_security/core.py:399
+#: flask_security/core.py:414
 #, python-format
 msgid ""
 "Thank you. To confirm your email address %(email)s, please click on the "
 "link in the email we have just sent to you."
 msgstr ""
 
-#: flask_security/core.py:406
+#: flask_security/core.py:421
 msgid "Thank you. Your email has been confirmed."
 msgstr "谢谢。你的邮箱已激活！"
 
-#: flask_security/core.py:407
+#: flask_security/core.py:422
 msgid "Your email has already been confirmed."
 msgstr "你的邮箱已激活！"
 
-#: flask_security/core.py:408
+#: flask_security/core.py:423
 msgid "Invalid confirmation token."
 msgstr "无效验证码！"
 
-#: flask_security/core.py:410
+#: flask_security/core.py:425
 #, python-format
 msgid "%(email)s is already associated with an account."
 msgstr "%(email)s 已关联账户。"
 
-#: flask_security/core.py:414
+#: flask_security/core.py:429
 #, python-format
 msgid ""
 "Identity attribute '%(attr)s' with value '%(value)s' is already "
 "associated with an account."
 msgstr ""
 
-#: flask_security/core.py:421
+#: flask_security/core.py:436
 #, python-format
 msgid "Identity %(id)s not registered"
 msgstr ""
 
-#: flask_security/core.py:425
+#: flask_security/core.py:440
 #, python-format
 msgid ""
 "An error occurred while communicating with the Oauth provider: "
 "(%(exerror)s - %(exdesc)s). Please try again."
 msgstr ""
 
-#: flask_security/core.py:432
+#: flask_security/core.py:447
 msgid "Password does not match"
 msgstr "密码不匹配"
 
-#: flask_security/core.py:433
+#: flask_security/core.py:448
 msgid "Passwords do not match"
 msgstr "密码不匹配"
 
-#: flask_security/core.py:434
+#: flask_security/core.py:449
 msgid "Redirections outside the domain are forbidden"
 msgstr "禁止域名外重定向"
 
-#: flask_security/core.py:435
+#: flask_security/core.py:450
 msgid "Recovery code invalid"
 msgstr ""
 
-#: flask_security/core.py:436
+#: flask_security/core.py:451
 msgid "No recovery codes generated yet"
 msgstr ""
 
-#: flask_security/core.py:438
+#: flask_security/core.py:453
 #, python-format
 msgid "Instructions to reset your password have been sent to %(email)s."
 msgstr "重置密码邮件已发送到 %(email)s。"
 
-#: flask_security/core.py:442
+#: flask_security/core.py:457
 #, python-format
 msgid "You did not reset your password within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:445
+#: flask_security/core.py:460
 msgid "Invalid reset password token."
 msgstr "密码重置验证码无效！"
 
-#: flask_security/core.py:446
+#: flask_security/core.py:461
 msgid "Email requires confirmation."
 msgstr "请先激活邮箱。"
 
-#: flask_security/core.py:448
+#: flask_security/core.py:463
 #, python-format
 msgid "Confirmation instructions have been sent to %(email)s."
 msgstr "激活邮件已发送到  %(email)s。"
 
-#: flask_security/core.py:452
+#: flask_security/core.py:467
 #, python-format
 msgid "You did not confirm your email within %(within)s. "
 msgstr ""
 
-#: flask_security/core.py:456
+#: flask_security/core.py:471
 #, python-format
 msgid ""
 "You did not login within %(within)s. New instructions to login have been "
 "sent to %(email)s."
 msgstr "你未在 %(within)s 登录账户。新登录邮件已发送到 %(email)s。"
 
-#: flask_security/core.py:463
+#: flask_security/core.py:478
 #, python-format
 msgid "Instructions to login have been sent to %(email)s."
 msgstr "登录邮件已发送到 %(email)s。"
 
-#: flask_security/core.py:466
+#: flask_security/core.py:481
 msgid "Invalid login token."
 msgstr "无效登录验证码！"
 
-#: flask_security/core.py:467
+#: flask_security/core.py:482
 msgid "Account is disabled."
 msgstr "账户已被禁用！"
 
-#: flask_security/core.py:468
+#: flask_security/core.py:483
 msgid "Email not provided"
 msgstr "未填写电子邮箱"
 
-#: flask_security/core.py:469
+#: flask_security/core.py:484
 msgid "Invalid email address"
 msgstr "无效邮箱地址"
 
-#: flask_security/core.py:470 flask_security/core.py:516
+#: flask_security/core.py:485 flask_security/core.py:531
 #, fuzzy
 msgid "Invalid code"
 msgstr "密码不正确"
 
-#: flask_security/core.py:471
+#: flask_security/core.py:486
 msgid "Password not provided"
 msgstr "未填写密码"
 
-#: flask_security/core.py:473
+#: flask_security/core.py:488
 #, python-format
 msgid "Password must be at least %(length)s characters"
 msgstr "密码至少包含%(length)s个字符"
 
-#: flask_security/core.py:476
+#: flask_security/core.py:491
 msgid "Password not complex enough"
 msgstr "密码不够复杂"
 
-#: flask_security/core.py:477
+#: flask_security/core.py:492
 msgid "Password on breached list"
 msgstr "密码在易被泄露名单上"
 
-#: flask_security/core.py:479
+#: flask_security/core.py:494
 msgid "Failed to contact breached passwords site"
 msgstr "未能连通检测易泄露密码的网站"
 
-#: flask_security/core.py:482
+#: flask_security/core.py:497
 msgid "Phone number not valid e.g. missing country code"
 msgstr "手机号码非法。例如: 缺少国家代码"
 
-#: flask_security/core.py:483
+#: flask_security/core.py:498
 msgid "Specified user does not exist"
 msgstr "此用户不存在"
 
-#: flask_security/core.py:484
+#: flask_security/core.py:499
 msgid "Invalid password"
 msgstr "密码不正确"
 
-#: flask_security/core.py:485
+#: flask_security/core.py:500
 msgid "Password or code submitted is not valid"
 msgstr "提交的密码或代码无效"
 
-#: flask_security/core.py:486
+#: flask_security/core.py:501
 msgid "You have successfully logged in."
 msgstr "你已成功登录！"
 
-#: flask_security/core.py:487
+#: flask_security/core.py:502
 msgid "Forgot password?"
 msgstr "忘记密码？"
 
-#: flask_security/core.py:489
+#: flask_security/core.py:504
 msgid ""
 "You successfully reset your password and you have been logged in "
 "automatically."
 msgstr "你的密码已成功重置，并已自动登录。"
 
-#: flask_security/core.py:496
+#: flask_security/core.py:511
 msgid ""
 "You successfully reset your password. Please authenticate using your new "
 "password."
 msgstr ""
 
-#: flask_security/core.py:503
+#: flask_security/core.py:518
 msgid "Your new password must be different than your previous password."
 msgstr "你的新密码不能与当前密码相同。"
 
-#: flask_security/core.py:506
+#: flask_security/core.py:521
 msgid "You successfully changed your password."
 msgstr "你已成功更改密码！"
 
-#: flask_security/core.py:507
+#: flask_security/core.py:522
 msgid "Please log in to access this page."
 msgstr "请登录访问此页面。"
 
-#: flask_security/core.py:508
+#: flask_security/core.py:523
 msgid "Please reauthenticate to access this page."
 msgstr "请重新进行身份验证，以访问此页面。"
 
-#: flask_security/core.py:509
+#: flask_security/core.py:524
 msgid "Reauthentication successful"
 msgstr "成功进行重新认证"
 
-#: flask_security/core.py:511
+#: flask_security/core.py:526
 msgid "You can only access this endpoint when not logged in."
 msgstr "您只能在未登录时访问此端点。"
 
-#: flask_security/core.py:514
+#: flask_security/core.py:529
 msgid "Code has been sent."
 msgstr ""
 
-#: flask_security/core.py:515
+#: flask_security/core.py:530
 msgid "Failed to send code. Please try again later"
 msgstr "发送代码失败。请稍后再试"
 
-#: flask_security/core.py:517
+#: flask_security/core.py:532
 msgid "Your code has been confirmed"
 msgstr ""
 
-#: flask_security/core.py:519
+#: flask_security/core.py:534
 msgid "You successfully changed your two-factor method."
 msgstr "你成功改变了你的双因素验证方法。"
 
-#: flask_security/core.py:523
+#: flask_security/core.py:538
 msgid "You currently do not have permissions to access this page"
 msgstr "你现在还没有权限访问这个页面"
 
-#: flask_security/core.py:526
+#: flask_security/core.py:541
 msgid "Marked method is not valid"
 msgstr "选择的方法无效"
 
-#: flask_security/core.py:528
+#: flask_security/core.py:543
 msgid "You successfully disabled two factor authorization."
 msgstr "你成功地禁用了双因素授权。"
 
-#: flask_security/core.py:532
+#: flask_security/core.py:547 flask_security/core.py:556
+#, python-format
+msgid "Setup must be completed within %(within)s. Please start over."
+msgstr "必须在%(within)s内完成设置。请重新开始。"
+
+#: flask_security/core.py:551
 #, python-format
 msgid "Currently active sign in options: %(method_list)s."
 msgstr ""
 
-#: flask_security/core.py:535
+#: flask_security/core.py:554
 msgid "Requested method is not valid"
 msgstr "非法的请求方法"
 
-#: flask_security/core.py:537
-#, python-format
-msgid "Setup must be completed within %(within)s. Please start over."
-msgstr "必须在%(within)s内完成设置。请重新开始。"
-
-#: flask_security/core.py:540
+#: flask_security/core.py:559
 msgid "Unified sign in setup successful"
 msgstr "统一登录设置成功"
 
-#: flask_security/core.py:541
+#: flask_security/core.py:560
 msgid "You must specify a valid identity to sign in"
 msgstr "您必须指定一个有效的身份才能登录"
 
-#: flask_security/core.py:542
+#: flask_security/core.py:561
 #, python-format
 msgid "Use this code to sign in: %(code)s."
 msgstr "使用此代码登录：%(code)s"
 
-#: flask_security/core.py:544
+#: flask_security/core.py:563
 #, python-format
 msgid ""
 "Username must be at least %(min)d characters and less than %(max)d "
 "characters"
 msgstr ""
 
-#: flask_security/core.py:551
+#: flask_security/core.py:570
 msgid "Username contains illegal characters"
 msgstr ""
 
-#: flask_security/core.py:555
+#: flask_security/core.py:574
 msgid "Username can contain only letters and numbers"
 msgstr ""
 
-#: flask_security/core.py:558
+#: flask_security/core.py:577
 msgid "Username not provided"
 msgstr ""
 
-#: flask_security/core.py:560
+#: flask_security/core.py:579
 #, python-format
 msgid "%(username)s is already associated with an account."
 msgstr ""
 
-#: flask_security/core.py:564
+#: flask_security/core.py:583
 #, python-format
 msgid "WebAuthn operation must be completed within %(within)s. Please start over."
 msgstr ""
 
-#: flask_security/core.py:568
+#: flask_security/core.py:587
 msgid "Nickname for new credential is required."
 msgstr ""
 
-#: flask_security/core.py:572
+#: flask_security/core.py:591
 #, python-format
 msgid "%(name)s is already associated with a credential."
 msgstr ""
 
-#: flask_security/core.py:576
+#: flask_security/core.py:595
 #, python-format
 msgid "%(name)s not registered with current user."
 msgstr ""
 
-#: flask_security/core.py:580
+#: flask_security/core.py:599
 #, python-format
 msgid "Successfully deleted WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:584
+#: flask_security/core.py:603
 #, python-format
 msgid "Successfully added WebAuthn credential with name: %(name)s"
 msgstr ""
 
-#: flask_security/core.py:588
+#: flask_security/core.py:607
 msgid "WebAuthn credential id already registered."
 msgstr ""
 
-#: flask_security/core.py:592
+#: flask_security/core.py:611
 msgid "Unregistered WebAuthn credential id."
 msgstr ""
 
-#: flask_security/core.py:596
+#: flask_security/core.py:615
 msgid "WebAuthn credential doesn't belong to any user."
 msgstr ""
 
-#: flask_security/core.py:600
+#: flask_security/core.py:619
 #, python-format
 msgid "Could not verify WebAuthn credential: %(cause)s."
 msgstr ""
 
-#: flask_security/core.py:604
+#: flask_security/core.py:623
 msgid "Credential not registered for this use (first or secondary)"
 msgstr ""
 
-#: flask_security/core.py:608
+#: flask_security/core.py:627
 msgid "Credential user handle didn't match"
 msgstr ""
 
-#: flask_security/forms.py:61
+#: flask_security/core.py:631
+#, python-format
+msgid "Confirmation must be completed within %(within)s. Please start over."
+msgstr ""
+
+#: flask_security/core.py:635
+msgid "Change of email address confirmed"
+msgstr ""
+
+#: flask_security/core.py:639
+#, python-format
+msgid ""
+"Instructions to confirm your new email address have been sent to "
+"%(email)s."
+msgstr ""
+
+#: flask_security/forms.py:62
 msgid "Email Address"
 msgstr "邮箱地址"
 
-#: flask_security/forms.py:62
+#: flask_security/forms.py:63
 msgid "Password"
 msgstr "密码"
 
-#: flask_security/forms.py:63
+#: flask_security/forms.py:64
 msgid "Remember Me"
 msgstr "记住我"
 
-#: flask_security/forms.py:64 flask_security/templates/security/_menu.html:33
+#: flask_security/forms.py:65 flask_security/templates/security/_menu.html:38
 #: flask_security/templates/security/login_user.html:6
 #: flask_security/templates/security/send_login.html:6
 msgid "Login"
 msgstr "登录"
 
-#: flask_security/forms.py:65
+#: flask_security/forms.py:66
 #: flask_security/templates/security/email/us_instructions.html:14
 #: flask_security/templates/security/us_signin.html:6
 msgid "Sign In"
 msgstr "登录"
 
-#: flask_security/forms.py:66 flask_security/templates/security/_menu.html:43
+#: flask_security/forms.py:67 flask_security/templates/security/_menu.html:48
 #: flask_security/templates/security/register_user.html:6
 msgid "Register"
 msgstr "注册"
 
-#: flask_security/forms.py:67
+#: flask_security/forms.py:68
 msgid "Resend Confirmation Instructions"
 msgstr "重新发送邮件验证"
 
-#: flask_security/forms.py:68
+#: flask_security/forms.py:69
 msgid "Recover Password"
 msgstr "恢复密码"
 
-#: flask_security/forms.py:69
+#: flask_security/forms.py:70
 msgid "Reset Password"
 msgstr "重置密码"
 
-#: flask_security/forms.py:70
+#: flask_security/forms.py:71
 msgid "Retype Password"
 msgstr "再次确认密码"
 
-#: flask_security/forms.py:71
+#: flask_security/forms.py:72
 msgid "New Password"
 msgstr "新密码"
 
-#: flask_security/forms.py:72 flask_security/templates/security/_menu.html:12
+#: flask_security/forms.py:73 flask_security/templates/security/_menu.html:12
 msgid "Change Password"
 msgstr "更改密码"
 
-#: flask_security/forms.py:73
+#: flask_security/forms.py:74
 msgid "Send Login Link"
 msgstr "发送登录链接"
 
-#: flask_security/forms.py:74
+#: flask_security/forms.py:75
 msgid "Verify Password"
 msgstr "验证密码"
 
-#: flask_security/forms.py:75
+#: flask_security/forms.py:76
 msgid "Change Method"
 msgstr ""
 
-#: flask_security/forms.py:76
+#: flask_security/forms.py:77
 msgid "Phone Number"
 msgstr "手机号"
 
-#: flask_security/forms.py:77
+#: flask_security/forms.py:78
 msgid "Authentication Code"
 msgstr "授权码"
 
-#: flask_security/forms.py:78
+#: flask_security/forms.py:79
 msgid "Submit"
 msgstr "提交"
 
-#: flask_security/forms.py:79
+#: flask_security/forms.py:80
 msgid "Submit Code"
 msgstr "提交代码"
 
-#: flask_security/forms.py:80
+#: flask_security/forms.py:81
 msgid "Error(s)"
 msgstr "错误"
 
-#: flask_security/forms.py:81
+#: flask_security/forms.py:82
 msgid "Identity"
 msgstr ""
 
-#: flask_security/forms.py:82
+#: flask_security/forms.py:83
 msgid "Send Code"
 msgstr "发送代码"
 
-#: flask_security/forms.py:83
+#: flask_security/forms.py:84
 msgid "Passcode"
 msgstr ""
 
-#: flask_security/forms.py:84
+#: flask_security/forms.py:85
 msgid "Username"
 msgstr ""
 
-#: flask_security/forms.py:85
+#: flask_security/forms.py:86
 msgid "Delete"
 msgstr ""
 
-#: flask_security/forms.py:86
+#: flask_security/forms.py:87
 msgid "Set up using email"
 msgstr "使用电子邮件进行设置"
 
-#: flask_security/forms.py:87
+#: flask_security/forms.py:88
 msgid "Set up using an authenticator app (e.g. google, lastpass, authy)"
 msgstr "设置一个认证的app（例如：google、lastpass、authy）"
 
-#: flask_security/forms.py:90
+#: flask_security/forms.py:91
 msgid "Set up using SMS"
 msgstr "用SMS进行设置\""
 
-#: flask_security/forms.py:95
+#: flask_security/forms.py:96
 msgid "Google Authenticator"
 msgstr ""
 
-#: flask_security/forms.py:96
+#: flask_security/forms.py:97
 msgid "authenticator"
 msgstr ""
 
-#: flask_security/forms.py:97 flask_security/forms.py:98
+#: flask_security/forms.py:98 flask_security/forms.py:99
 msgid "email"
 msgstr ""
 
-#: flask_security/forms.py:99
+#: flask_security/forms.py:100
 msgid "SMS"
 msgstr ""
 
-#: flask_security/forms.py:100
+#: flask_security/forms.py:101
 msgid "password"
 msgstr ""
 
-#: flask_security/forms.py:101
+#: flask_security/forms.py:102
 msgid "none"
 msgstr ""
 
-#: flask_security/forms.py:775 flask_security/unified_signin.py:167
+#: flask_security/forms.py:780 flask_security/unified_signin.py:167
 msgid "Available Methods"
 msgstr ""
 
-#: flask_security/forms.py:777
+#: flask_security/forms.py:782
 msgid "Disable two factor authentication"
 msgstr ""
 
-#: flask_security/forms.py:861
+#: flask_security/forms.py:866
 msgid "Trouble Accessing Your Account?/Lost Mobile Device?"
 msgstr ""
 
-#: flask_security/forms.py:863
+#: flask_security/forms.py:868
 msgid "Contact Administrator"
 msgstr ""
 
-#: flask_security/recovery_codes.py:128
+#: flask_security/recovery_codes.py:142
 msgid "Show Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:130
+#: flask_security/recovery_codes.py:144
 msgid "Generate New Recovery Codes"
 msgstr ""
 
-#: flask_security/recovery_codes.py:146
+#: flask_security/recovery_codes.py:160
 msgid "Recovery Code"
 msgstr ""
 
-#: flask_security/tf_plugin.py:53
+#: flask_security/tf_plugin.py:52
 msgid "Available Second Factor Methods:"
 msgstr ""
 
-#: flask_security/tf_plugin.py:54
+#: flask_security/tf_plugin.py:53
 msgid "Select"
 msgstr ""
 
@@ -639,27 +659,27 @@ msgstr ""
 msgid "Delete active sign in option"
 msgstr ""
 
-#: flask_security/webauthn.py:123 flask_security/webauthn.py:357
+#: flask_security/webauthn.py:122 flask_security/webauthn.py:356
 msgid "Nickname"
 msgstr ""
 
-#: flask_security/webauthn.py:127
+#: flask_security/webauthn.py:126
 msgid "Usage"
 msgstr ""
 
-#: flask_security/webauthn.py:129
+#: flask_security/webauthn.py:128
 msgid "Use as a first authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:132
+#: flask_security/webauthn.py:131
 msgid "Use as a secondary authentication factor"
 msgstr ""
 
-#: flask_security/webauthn.py:219
+#: flask_security/webauthn.py:218
 msgid "Start"
 msgstr ""
 
-#: flask_security/webauthn.py:933
+#: flask_security/webauthn.py:934
 msgid "webauthn"
 msgstr ""
 
@@ -672,29 +692,43 @@ msgid "Sign out"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:17
-msgid "Two Factor Setup"
+msgid "Change Registered Email"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:22
-msgid "Unified Signin Setup"
+msgid "Two Factor Setup"
 msgstr ""
 
 #: flask_security/templates/security/_menu.html:27
+msgid "Unified Signin Setup"
+msgstr ""
+
+#: flask_security/templates/security/_menu.html:32
 msgid "WebAuthn Setup"
 msgstr ""
 
-#: flask_security/templates/security/_menu.html:38
+#: flask_security/templates/security/_menu.html:43
 msgid "Unified Sign In"
 msgstr "统一登陆"
 
-#: flask_security/templates/security/_menu.html:48
+#: flask_security/templates/security/_menu.html:53
 msgid "Forgot password"
 msgstr "忘记密码"
 
-#: flask_security/templates/security/_menu.html:53
+#: flask_security/templates/security/_menu.html:58
 msgid "Confirm account"
 msgstr "激活账户"
 
+#: flask_security/templates/security/change_email.html:6
+msgid "Change email"
+msgstr ""
+
+#: flask_security/templates/security/change_email.html:7
+msgid ""
+"Once submitted, an email confirmation will be sent to this new email "
+"address."
+msgstr ""
+
 #: flask_security/templates/security/change_password.html:6
 msgid "Change password"
 msgstr "更改密码"
@@ -736,7 +770,7 @@ msgid "Enter Recovery Code"
 msgstr ""
 
 #: flask_security/templates/security/mf_recovery_codes.html:6
-#: flask_security/templates/security/two_factor_setup.html:71
+#: flask_security/templates/security/two_factor_setup.html:79
 #: flask_security/templates/security/wan_register.html:75
 msgid "Recovery Codes"
 msgstr ""
@@ -763,56 +797,56 @@ msgstr "重新发送激活邮件"
 msgid "Select Two Factor Method"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:24
+#: flask_security/templates/security/two_factor_setup.html:27
 msgid "Two-factor authentication adds an extra layer of security to your account"
 msgstr "双因素认证为您的账户增加了一层额外的安全保障。"
 
-#: flask_security/templates/security/two_factor_setup.html:25
+#: flask_security/templates/security/two_factor_setup.html:28
 msgid "In addition to your username and password, you'll need to use a code."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:29
+#: flask_security/templates/security/two_factor_setup.html:32
 #, python-format
 msgid "Currently setup two-factor method: %(method)s"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:48
+#: flask_security/templates/security/two_factor_setup.html:51
 #: flask_security/templates/security/us_setup.html:61
 msgid ""
 "Open an authenticator app on your device and scan the following QRcode "
 "(or enter the code below manually) to start receiving codes:"
 msgstr "打开设备上的身份验证应用，扫描以下二维码(或手动输入以下代码)开始接收代码："
 
-#: flask_security/templates/security/two_factor_setup.html:51
+#: flask_security/templates/security/two_factor_setup.html:54
 msgid "Two factor authentication code"
 msgstr "双因素验证代码"
 
-#: flask_security/templates/security/two_factor_setup.html:62
+#: flask_security/templates/security/two_factor_setup.html:65
 msgid "Enter code to complete setup"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:65
+#: flask_security/templates/security/two_factor_setup.html:73
 #: flask_security/templates/security/two_factor_verify_code.html:10
 msgid "enter numeric code"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:73
+#: flask_security/templates/security/two_factor_setup.html:81
 #: flask_security/templates/security/wan_register.html:77
 msgid "This application supports setting up recovery codes."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:74
 #: flask_security/templates/security/two_factor_setup.html:82
+#: flask_security/templates/security/two_factor_setup.html:90
 #: flask_security/templates/security/us_setup.html:89
 #: flask_security/templates/security/wan_register.html:78
 msgid "You can set them up here."
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:79
+#: flask_security/templates/security/two_factor_setup.html:87
 msgid "WebAuthn"
 msgstr ""
 
-#: flask_security/templates/security/two_factor_setup.html:81
+#: flask_security/templates/security/two_factor_setup.html:89
 #: flask_security/templates/security/us_setup.html:88
 msgid "This application supports WebAuthn security keys."
 msgstr ""
@@ -904,6 +938,30 @@ msgstr ""
 msgid "Please Re-Authenticate Using Your WebAuthn Security Key"
 msgstr ""
 
+#: flask_security/templates/security/email/change_email_instructions.html:8
+msgid "Please confirm your new email address by clicking on the link below:"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:10
+msgid "Confirm my new email"
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:12
+#: flask_security/templates/security/email/change_email_instructions.txt:11
+#, python-format
+msgid "This link will expire in %(within)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.html:13
+#: flask_security/templates/security/email/change_email_instructions.txt:13
+#, python-format
+msgid "Your currently registered email is %(email)s."
+msgstr ""
+
+#: flask_security/templates/security/email/change_email_instructions.txt:8
+msgid "Please confirm your new email through the link below:"
+msgstr ""
+
 #: flask_security/templates/security/email/change_notice.html:1
 #: flask_security/templates/security/email/change_notice.txt:1
 msgid "Your password has been changed."
diff -pruN 5.4.3-1/flask_security/twofactor.py 5.5.0-1/flask_security/twofactor.py
--- 5.4.3-1/flask_security/twofactor.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/twofactor.py	2024-07-24 02:21:26.000000000 +0000
@@ -40,8 +40,7 @@ from .signals import (
 
 if t.TYPE_CHECKING:  # pragma: no cover
     import flask
-    from .core import Security
-    from .datastore import User
+    from flask_security import Security, UserMixin
     from flask.typing import ResponseValue
 
 
@@ -102,6 +101,7 @@ def complete_two_factor_process(user, pr
     # if we are changing two-factor method
     dologin = False
     if is_changing:
+        # As of 5.5.0 this is the legacy path (using session data)
         completion_message = "TWO_FACTOR_CHANGE_METHOD_SUCCESSFUL"
         tf_profile_changed.send(
             current_app._get_current_object(),
@@ -123,7 +123,7 @@ def complete_two_factor_process(user, pr
     return completion_message, token
 
 
-def set_rescue_options(form: TwoFactorRescueForm, user: User) -> dict[str, str]:
+def set_rescue_options(form: TwoFactorRescueForm, user: UserMixin) -> dict[str, str]:
     # Based on config - set up options for rescue.
     # Note that this modifies the passed in Form as well as returns
     # a dict that can be returned as part of a JSON response.
@@ -175,14 +175,14 @@ class CodeTfPlugin(TfPluginBase):
     ) -> None:
         pass
 
-    def get_setup_methods(self, user: User) -> list[str]:
+    def get_setup_methods(self, user: UserMixin) -> list[str]:
         if is_tf_setup(user):
             assert user.tf_primary_method is not None
             return [user.tf_primary_method]
         return []
 
     def tf_login(
-        self, user: User, json_payload: dict[str, t.Any], next_loc: str | None
+        self, user: UserMixin, json_payload: dict[str, t.Any], next_loc: str | None
     ) -> ResponseValue:
         """Helper for two-factor authentication login
 
diff -pruN 5.4.3-1/flask_security/unified_signin.py 5.5.0-1/flask_security/unified_signin.py
--- 5.4.3-1/flask_security/unified_signin.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/unified_signin.py	2024-07-24 02:21:26.000000000 +0000
@@ -79,9 +79,9 @@ from .utils import (
     get_message,
     get_url,
     get_within_delta,
+    handle_already_auth,
     is_user_authenticated,
     localize_callback,
-    json_error_response,
     login_user,
     lookup_identity,
     propagate_next,
@@ -94,7 +94,7 @@ from .webauthn import has_webauthn
 
 if t.TYPE_CHECKING:  # pragma: no cover
     from flask.typing import ResponseValue
-    from .datastore import User
+    from flask_security import UserMixin
 
 if get_quart_status():  # pragma: no cover
     from quart import redirect
@@ -147,7 +147,7 @@ class _UnifiedPassCodeForm(Form):
     """Common form for signin and verify/reauthenticate."""
 
     # filled in by caller
-    user: User
+    user: UserMixin
 
     # Filled in here
     authn_via: str
@@ -364,7 +364,7 @@ class UnifiedSigninSetupValidateForm(For
     """The unified sign in setup validation form"""
 
     # These 2 filled in by view
-    user: User
+    user: UserMixin
     totp_secret: str
 
     passcode = StringField(
@@ -539,33 +539,20 @@ def us_signin() -> ResponseValue:
     Unified sign in view.
     This takes an identity (as configured in USER_IDENTITY_ATTRIBUTES)
     and a passcode (password or OTP).
-
-    Allow already authenticated users. For GET this is useful for
-    single-page-applications on refresh - session still active but need to
-    access user info and csrf-token.
-    For POST - redirects to POST_LOGIN_VIEW (forms) or returns 400 (json).
     """
-
-    if is_user_authenticated(current_user) and request.method == "POST":
-        # Just redirect current_user to POST_LOGIN_VIEW (or next).
-        # While its tempting to try to logout the current user and login the
-        # new requested user - that simply doesn't work with CSRF.
-
-        # While this is close to anonymous_user_required - it differs in that
-        # it uses get_post_login_redirect which correctly handles 'next'.
-        # TODO: consider changing anonymous_user_required to also call
-        # get_post_login_redirect - not sure why it never has?
-        if _security._want_json(request):
-            payload = json_error_response(
-                errors=get_message("ANONYMOUS_USER_REQUIRED")[0]
-            )
-            return _security._render_json(payload, 400, None, None)
-        else:
-            return redirect(get_post_login_redirect())
-
     form = t.cast(UnifiedSigninForm, build_form_from_request("us_signin_form"))
     form.submit.data = True
     form.submit_send_code.data = False
+    code_methods = _compute_code_methods()
+    payload = {
+        "available_methods": cv("US_ENABLED_METHODS"),
+        "code_methods": code_methods,
+        "identity_attributes": get_identity_attributes(),
+    }
+
+    if is_user_authenticated(current_user):
+        return handle_already_auth(form, payload=payload)
+
     # Clean out any potential old session info - in case of previous
     # aborted 2FA attempt.
     tf_clean_session()
@@ -590,28 +577,23 @@ def us_signin() -> ResponseValue:
             return base_render_json(form, include_auth_token=True)
 
         return redirect(get_post_login_redirect())
-    elif request.method == "POST" and cv("RETURN_GENERIC_RESPONSES"):
+
+    # Here on GET or failed POST validate
+    if request.method == "POST" and cv("RETURN_GENERIC_RESPONSES"):
         rinfo = dict(
             identity=dict(replace_msg="GENERIC_AUTHN_FAILED"),
             passcode=dict(replace_msg="GENERIC_AUTHN_FAILED"),
         )
         form_errors_munge(form, rinfo)
 
-    # Here on GET or failed POST validate
-    code_methods = _compute_code_methods()
+    if request.method == "GET":
+        # set CSRF COOKIE if configured. This is the equivalent of forms and
+        # base_render_json always sending the csrf_token
+        session["fs_cc"] = "set"
+
     if _security._want_json(request):
-        payload = {
-            "available_methods": cv("US_ENABLED_METHODS"),
-            "code_methods": code_methods,
-            "identity_attributes": get_identity_attributes(),
-        }
         return base_render_json(form, include_user=False, additional=payload)
 
-    if is_user_authenticated(current_user):
-        # Basically a no-op if authenticated - just perform the same
-        # post-login redirect as if user just logged in.
-        return redirect(get_post_login_redirect())
-
     # On error - wipe code
     form.passcode.data = None
 
@@ -783,7 +765,9 @@ def us_setup() -> ResponseValue:
     setup_methods = _compute_setup_methods()
     active_methods = _compute_active_methods(current_user)
     form.chosen_method.choices = [
-        c for c in form.setup_choices if c[0] not in active_methods
+        c
+        for c in form.setup_choices
+        if c[0] not in active_methods and c[0] in setup_methods
     ]
     form.delete_method.choices = [
         c for c in form.delete_choices if c[0] in active_methods
@@ -821,7 +805,9 @@ def us_setup() -> ResponseValue:
                 "US_CURRENT_METHODS", method_list=current_methods
             )[0]
             form.chosen_method.choices = [
-                c for c in form.setup_choices if c[0] not in active_methods
+                c
+                for c in form.setup_choices
+                if c[0] not in active_methods and c[0] in setup_methods
             ]
             form.delete_method.choices = [
                 c for c in form.delete_choices if c[0] in active_methods
@@ -829,7 +815,7 @@ def us_setup() -> ResponseValue:
             form.delete_method.data = None
             us_profile_changed.send(
                 current_app._get_current_object(),  # type: ignore
-                _async_wrapper=current_app.ensure_sync,
+                _async_wrapper=current_app.ensure_sync,  # type: ignore[arg-type]
                 user=current_user,
                 methods=delete_method,
                 delete=True,
@@ -918,6 +904,10 @@ def us_setup() -> ResponseValue:
             **_security._run_ctx_processor("us_setup"),
         )
 
+    phone_number = None
+    if "sms" in cv("US_ENABLED_METHODS"):
+        phone_number = current_user.us_phone_number
+
     # Get here on initial new setup (GET)
     # Or failure of POST
     if _security._want_json(request):
@@ -926,12 +916,12 @@ def us_setup() -> ResponseValue:
             "available_methods": cv("US_ENABLED_METHODS"),
             "active_methods": active_methods,
             "setup_methods": setup_methods,
-            "phone": current_user.us_phone_number,
+            "phone": phone_number,
         }
         return base_render_json(form, include_user=False, additional=payload)
 
     # Show user existing phone number
-    form.phone.data = current_user.us_phone_number
+    form.phone.data = phone_number
     form.chosen_method.data = None
     form.delete_method.data = None
     return _security.render_template(
@@ -982,18 +972,19 @@ def us_setup_validate(token: str) -> Res
 
         us_profile_changed.send(
             current_app._get_current_object(),  # type: ignore
-            _async_wrapper=current_app.ensure_sync,
+            _async_wrapper=current_app.ensure_sync,  # type: ignore[arg-type]
             user=current_user,
             methods=[method],
             delete=False,
         )
         if _security._want_json(request):
+            phone_number = None
+            if "sms" in cv("US_ENABLED_METHODS"):
+                phone_number = current_user.us_phone_number
             return base_render_json(
                 form,
                 include_user=False,
-                additional=dict(
-                    chosen_method=method, phone=current_user.us_phone_number
-                ),
+                additional=dict(chosen_method=method, phone=phone_number),
             )
         else:
             do_flash(*get_message("US_SETUP_SUCCESSFUL"))
diff -pruN 5.4.3-1/flask_security/username_util.py 5.5.0-1/flask_security/username_util.py
--- 5.4.3-1/flask_security/username_util.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/username_util.py	2024-07-24 02:21:26.000000000 +0000
@@ -45,7 +45,7 @@ class UsernameUtil:
         Given a username - check for allowable character categories.
         This is broken out so applications can easily override this method only.
 
-        By default allow letters and numbers (using unicodedata.category).
+        By default, allow letters and numbers (using unicodedata.category).
 
         Returns None if allowed, error message if not allowed.
         """
diff -pruN 5.4.3-1/flask_security/utils.py 5.5.0-1/flask_security/utils.py
--- 5.4.3-1/flask_security/utils.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/utils.py	2024-07-24 02:21:26.000000000 +0000
@@ -25,10 +25,12 @@ import urllib.error
 import warnings
 
 from flask import (
+    Response,
     after_this_request,
     current_app,
     flash,
     g,
+    redirect,
     request,
     render_template,
     session,
@@ -50,9 +52,9 @@ from .proxies import _security, _datasto
 from .signals import user_authenticated
 
 if t.TYPE_CHECKING:  # pragma: no cover
-    from flask import Flask, Response
+    from flask import Flask
     from flask.typing import ResponseValue
-    from .datastore import User
+    from flask_security import UserMixin
 
 localize_callback = LocalProxy(lambda: _security.i18n_domain.gettext)
 
@@ -138,7 +140,7 @@ def find_csrf_field_name():
     return None
 
 
-def is_user_authenticated(user: User | None) -> bool:
+def is_user_authenticated(user: UserMixin | None) -> bool:
     """
     return True if user is authenticated.
 
@@ -158,7 +160,7 @@ def is_user_authenticated(user: User | N
 
 
 def login_user(
-    user: User,
+    user: UserMixin,
     remember: bool | None = None,
     authn_via: list[str] | None = None,
 ) -> bool:
@@ -205,13 +207,13 @@ def login_user(
 
     identity_changed.send(
         current_app._get_current_object(),  # type: ignore[attr-defined]
-        _async_wrapper=current_app.ensure_sync,
+        _async_wrapper=current_app.ensure_sync,  # type: ignore[arg-type]
         identity=Identity(user.fs_uniquifier),
     )
 
     user_authenticated.send(
         current_app._get_current_object(),  # type: ignore[attr-defined]
-        _async_wrapper=current_app.ensure_sync,
+        _async_wrapper=current_app.ensure_sync,  # type: ignore[arg-type]
         user=user,
         authn_via=authn_via,
     )
@@ -267,21 +269,21 @@ def check_and_update_authn_fresh(
                   will set a grace period for which freshness won't be checked.
                   The intent here is that the caller shouldn't get part-way though
                   a set of operations and suddenly be required to authenticate again.
+                  This is not supported for authentication tokens.
     :param method: Optional - if set and == "basic" then will always return True.
                   (since basic-auth sends username/password on every request)
 
     If within.total_seconds() is negative, will always return True (always 'fresh').
     This effectively just disables this entire mechanism.
 
+    within.total_seconds() == 0 results in undefined behavior.
+
     If "fs_gexp" is in the session and the current timestamp is less than that,
     return True and extend grace time (i.e. set fs_gexp to current time + grace).
 
-    If not within the grace period, and within.total_seconds() is 0,
-    return False (not fresh).
-
-    Be aware that for this to work, sessions and therefore session cookies
-    must be functioning and being sent as part of the request. If the required
-    state isn't in the session cookie then return False (not 'fresh').
+    Be aware that for this to work, state is required to be sent from the client.
+    Flask security adds this state to the session (cookie) and the auth token.
+    Without this state, 'False' is always returned - (not fresh).
 
     .. warning::
         Be sure the caller is already authenticated PRIOR to calling this method.
@@ -290,6 +292,10 @@ def check_and_update_authn_fresh(
 
     .. versionchanged:: 4.0.0
         Added `method` parameter.
+
+    .. versionchanged:: 5.5.0
+        Grab 'Primary Authenticated At' from  request_attrs
+        which is set from either session or auth token
     """
 
     if method == "basic":
@@ -299,8 +305,8 @@ def check_and_update_authn_fresh(
         # this means 'always fresh'
         return True
 
-    if "fs_paa" not in session:
-        # No session, you can't play.
+    if not (paa := get_request_attr("fs_paa")):
+        # No recorded primary authenticated at time, you can't play.
         return False
 
     now = naive_utcnow()
@@ -313,12 +319,7 @@ def check_and_update_authn_fresh(
             session["fs_gexp"] = grace_ts
             return True
 
-    # Special case 0 - return False always, but set grace period.
-    if within.total_seconds() == 0:
-        session["fs_gexp"] = grace_ts
-        return False
-
-    authn_time = naive_utcfromtimestamp(session["fs_paa"])
+    authn_time = naive_utcfromtimestamp(paa)
     # allow for some time drift where it's possible authn_time is in the future
     # but let's be cautious and not allow arbitrary future times
     delta = now - authn_time
@@ -361,7 +362,7 @@ def verify_password(password: str | byte
     return _pwd_context.verify(password, password_hash)
 
 
-def verify_and_update_password(password: str | bytes, user: User) -> bool:
+def verify_and_update_password(password: str | bytes, user: UserMixin) -> bool:
     """Returns ``True`` if the password is valid for the specified user.
 
     Additionally, the hashed password in the database is updated if the
@@ -386,7 +387,7 @@ def verify_and_update_password(password:
         # Try with original password.
         verified = _pwd_context.verify(password, user.password)
 
-    if verified and _pwd_context.needs_update(user.password):
+    if verified and (user.password is None or _pwd_context.needs_update(user.password)):
         user.password = hash_password(password)
         _datastore.put(user)
     return verified
@@ -482,7 +483,7 @@ def parse_auth_token(auth_token: str) ->
     # Version 5 and up are already a dict (with a version #)
     if isinstance(raw_data, dict):
         # new format - starting at ver=5
-        if not all(k in raw_data for k in ["ver", "uid", "exp", "sid"]):
+        if not all(k in raw_data for k in ["ver", "uid", "exp"]):
             raise ValueError("Token missing keys")
         tdata = raw_data
         if ts := tdata.get("exp"):
@@ -581,34 +582,15 @@ def url_for_security(endpoint: str, **va
 
 
 def validate_redirect_url(url: str) -> bool:
-    """Validate that the URL for redirect is relative.
-    Allowing an absolute redirect is a security issue - a so-called open-redirect.
-    Note that by default Werkzeug will always take this URL and make it relative
-    when setting the Location header - but that behavior can be overridden.
-
-    The complexity here is that urlsplit() does pretty well, but browsers even today
-    May 2021 are very lenient in what they accept as URLs - for example:
-        next=\\\\github.com
-        next=%5C%5C%5Cgithub.com
-        next=/////github.com
-        next=%20\\\\github.com
-        next=%20///github.com
-        next=%20//github.com
-        next=%19////github.com - i.e. browser will strip control chars
-        next=%E2%80%8A///github.com - doesn't redirect! That is a unicode thin space.
-
-    All will result in a null netloc and scheme from urlsplit - however many browsers
-    will gladly strip off uninteresting characters and convert backslashes to forward
-    slashes - and the cases above will actually cause a redirect to github.com
-    Sigh.
-
-    Some articles claim that a relative url has to start with a '/' - but that isn't
-    strictly true. From: https://datatracker.ietf.org/doc/html/rfc3986#section-5
-    a relative path can start with a "//", "/", a non-colon, or be empty. So it seems
-    that all the above URLs are valid.
-    By the time we get the URL, it has been unencoded - so we can't really determine
-    if it is 'valid' since it appears that '/'s can appear in the URL if escaped.
+    """Validate redirect URL
+    In the default configuration only redirects to the same domain (and scheme)
+    are allowed.
+    The REDIRECT_ALLOW_SUBDOMAINS allows ANY subdomain of SERVER_NAME
+     to be a redirect target.
+    The REDIRECT_BASE_DOMAIN and REDIRECT_ALLOWED_SUBDOMAINS allow specifying 'side'
+    redirects.
     """
+
     if url is None or url.strip() == "":
         return False
     url_next = urlsplit(url)
@@ -624,8 +606,14 @@ def validate_redirect_url(url: str) -> b
             )
         ):
             return True
-        else:
-            return False
+        base_domain = config_value("REDIRECT_BASE_DOMAIN")
+        if base_domain:
+            allowable = [
+                f"{sub}.{base_domain}"
+                for sub in config_value("REDIRECT_ALLOWED_SUBDOMAINS")
+            ]
+            return url_next.netloc in allowable
+        return False
     return True
 
 
@@ -637,6 +625,33 @@ def get_post_action_redirect(
     sent to Flask::redirect() - and we need to be sure that it can't be
     interpreted as a user-input external URL - that would mean we would
     have an 'open-redirect' vulnerability.
+
+    Allowing an absolute redirect is a security issue - a so-called open-redirect.
+
+    The complexity here is that urlsplit() does pretty well, but browsers even today
+    May 2021 are very lenient in what they accept as URLs - for example:
+        next=\\\\github.com
+        next=%5C%5C%5Cgithub.com
+        next=/////github.com
+        next=%20\\\\github.com
+        next=%20///github.com
+        next=%20//github.com
+        next=%19////github.com - i.e. browser will strip control chars
+        next=%E2%80%8A///github.com - doesn't redirect! That is a unicode thin space.
+
+    All will result in a null netloc and scheme from urlsplit - however many browsers
+    will gladly strip off uninteresting characters and convert backslashes to forward
+    slashes - and the cases above will actually cause a redirect to github.com
+    Sigh.
+
+    Some articles claim that a relative url has to start with a '/' - but that isn't
+    strictly true. From: https://datatracker.ietf.org/doc/html/rfc3986#section-5
+    a relative path can start with a "//", "/", a non-colon, or be empty. So it seems
+    that all the above URLs are valid.
+    By the time we get the URL, it has been unencoded - so we can't really determine
+    if it is 'valid' since it appears that '/'s can appear in the URL if escaped.
+
+    The solution is to simply 'quote' the path.
     """
     rurl = propagate_next(find_redirect(config_key), next_loc)
     (scheme, netloc, path, query, fragment) = urlsplit(rurl)
@@ -890,7 +905,7 @@ def get_identity_attributes(app: Flask |
 
 
 def get_identity_attribute(attr: str, app: Flask | None = None) -> dict[str, t.Any]:
-    """Given an user_identity_attribute, return the defining dict.
+    """Given a user_identity_attribute, return the defining dict.
     A bit annoying since USER_IDENTITY_ATTRIBUTES is a list of dict
     where each dict has just one key.
     """
@@ -909,7 +924,7 @@ def lookup_identity(identity):
     """
     Lookup identity in DB.
     This loops through, in order, :py:data:`SECURITY_USER_IDENTITY_ATTRIBUTES`,
-    and first calls the mapper function to validate/normalize.
+    and first calls the mapper function to normalize.
     Then the db.find_user is called on the specified user model attribute.
     """
     for mapping in config_value("USER_IDENTITY_ATTRIBUTES"):
@@ -925,8 +940,8 @@ def lookup_identity(identity):
 
 
 def uia_phone_mapper(identity: str) -> str | None:
-    """Used to match identity as a phone number. This is a simple proxy
-    to :py:class:`PhoneUtil`
+    """Used to normalize a phone number. This is a simple proxy
+    to :py:meth:`PhoneUtil.get_canonical_form`
 
     See :py:data:`SECURITY_USER_IDENTITY_ATTRIBUTES`.
 
@@ -937,7 +952,9 @@ def uia_phone_mapper(identity: str) -> s
 
 
 def uia_email_mapper(identity: str) -> str | None:
-    """Used to match identity as an email.
+    """Used to normalize identity as an email.
+    This is a simple proxy
+    to :py:meth:`MailUtil.normalize`
 
     :return: Normalized email or None if not valid email.
 
@@ -953,8 +970,8 @@ def uia_email_mapper(identity: str) -> s
 
 
 def uia_username_mapper(identity: str) -> str | None:
-    """Used to match identity as a username. This is a simple proxy
-    to :py:class:`UsernameUtil`
+    """Used to normalize a username. This is a simple proxy
+    to :py:meth:`UsernameUtil.normalize`
 
     See :py:data:`SECURITY_USER_IDENTITY_ATTRIBUTES`.
 
@@ -1034,7 +1051,7 @@ def csrf_cookie_handler(response: Respon
     elif current_app.config["WTF_CSRF_TIME_LIMIT"]:
         current_cookie = request.cookies.get(csrf_cookie_name, None)
         if current_cookie:
-            # Lets make sure it isn't expired if app doesn't set TIME_LIMIT to None.
+            # Let's make sure it isn't expired if app doesn't set TIME_LIMIT to None.
             try:
                 csrf.validate_csrf(current_cookie)
             except ValidationError:
@@ -1342,3 +1359,31 @@ def pwned(password: str) -> int:
 
     entries = dict(map(convert_password_tuple, raw.upper().split("\r\n")))
     return entries.get(sha1[5:].upper(), 0)
+
+
+def handle_already_auth(form, payload=None):
+    """
+    Allow already authenticated users. For GET this is useful for
+    single-page-applications on refresh - session still active but need to
+    access user info and csrf-token.
+    For GET with forms - redirect to POST_LOGIN_VIEW.
+    For POST - redirects to POST_LOGIN_VIEW (forms) or returns 400 (json).
+
+    This does NOT use get_post_login_redirect() so that it doesn't look at
+    'next' - which can cause infinite redirect loops
+    (see test_basic::test_authenticated_loop)
+
+    While it's tempting to try to logout the current user and login the
+    new requested user - that simply doesn't work with CSRF.
+    """
+    if _security._want_json(request):
+        if request.method == "POST":
+            payload = json_error_response(
+                errors=get_message("ANONYMOUS_USER_REQUIRED")[0]
+            )
+            return _security._render_json(payload, 400, None, None)
+        else:
+            form.user = current_user
+            return base_render_json(form, additional=payload)
+    else:
+        return redirect(get_url(config_value("POST_LOGIN_VIEW")))
diff -pruN 5.4.3-1/flask_security/views.py 5.5.0-1/flask_security/views.py
--- 5.4.3-1/flask_security/views.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/views.py	2024-07-24 02:21:26.000000000 +0000
@@ -28,6 +28,7 @@
 
 """
 
+from __future__ import annotations
 from functools import partial
 import time
 import typing as t
@@ -35,6 +36,7 @@ import typing as t
 from flask import (
     Blueprint,
     after_this_request,
+    current_app,
     jsonify,
     request,
     session,
@@ -42,6 +44,7 @@ from flask import (
 from flask_login import current_user
 
 from .changeable import change_user_password
+from .change_email import change_email, change_email_confirm
 from .confirmable import (
     confirm_email_token_status,
     confirm_user,
@@ -66,6 +69,7 @@ from .forms import (
 from .passwordless import login_token_status, send_login_instructions
 from .proxies import _security, _datastore
 from .quart_compat import get_quart_status
+from .signals import tf_profile_changed
 from .unified_signin import (
     us_signin,
     us_signin_send_code,
@@ -96,6 +100,7 @@ from .twofactor import (
 from .utils import (
     base_render_json,
     check_and_update_authn_fresh,
+    check_and_get_token_status,
     config_value as cv,
     do_flash,
     get_identity_attributes,
@@ -105,10 +110,11 @@ from .utils import (
     get_post_register_redirect,
     get_post_verify_redirect,
     get_request_attr,
+    get_within_delta,
     get_url,
+    handle_already_auth,
     hash_password,
     is_user_authenticated,
-    json_error_response,
     localize_callback,
     login_user,
     logout_user,
@@ -153,35 +159,14 @@ def _ctx(endpoint):
 
 
 @unauth_csrf()
-def login() -> "ResponseValue":
-    """View function for login view
-
-    Allow already authenticated users. For GET this is useful for
-    single-page-applications on refresh - session still active but need to
-    access user info and csrf-token.
-    For POST - redirects to POST_LOGIN_VIEW (forms) or returns 400 (json).
-    """
+def login() -> ResponseValue:
+    """View function for login view"""
     form = t.cast(LoginForm, build_form_from_request("login_form"))
 
     if is_user_authenticated(current_user):
-        # Just redirect current_user to POST_LOGIN_VIEW.
-        # While its tempting to try to logout the current user and login the
-        # new requested user - that simply doesn't work with CSRF.
-
-        # This does NOT use get_post_login_redirect() so that it doesn't look at
-        # 'next' - which can cause infinite redirect loops
-        # (see test_common::test_authenticated_loop)
-        if _security._want_json(request):
-            if request.method == "POST":
-                payload = json_error_response(
-                    errors=get_message("ANONYMOUS_USER_REQUIRED")[0]
-                )
-                return _security._render_json(payload, 400, None, None)
-            else:
-                form.user = current_user
-                return base_render_json(form)
-        else:
-            return redirect(get_url(cv("POST_LOGIN_VIEW")))
+        return handle_already_auth(
+            form, payload={"identity_attributes": get_identity_attributes()}
+        )
 
     # Clean out any potential old session info - in case of previous
     # aborted 2FA attempt.
@@ -216,6 +201,11 @@ def login() -> "ResponseValue":
             fields_to_squash["username"] = dict(replace_msg="GENERIC_AUTHN_FAILED")
         form_errors_munge(form, fields_to_squash)
 
+    if request.method == "GET":
+        # set CSRF COOKIE if configured. This is the equivalent of forms and
+        # base_render_json always sending the csrf_token
+        session["fs_cc"] = "set"
+
     if _security._want_json(request):
         payload = {
             "identity_attributes": get_identity_attributes(),
@@ -227,6 +217,7 @@ def login() -> "ResponseValue":
         and cv("REQUIRES_CONFIRMATION_ERROR_VIEW")
         and not cv("RETURN_GENERIC_RESPONSES")
     ):
+        # Validation failed BECAUSE user needs to confirm
         assert form.user_authenticated
         do_flash(*get_message("CONFIRMATION_REQUIRED"))
         return redirect(
@@ -292,7 +283,7 @@ def logout():
 
 @anonymous_user_required
 @unauth_csrf()
-def register() -> "ResponseValue":
+def register() -> ResponseValue:
     """View function which handles a registration request."""
 
     # For some unknown historic reason - if you don't require confirmation
@@ -747,9 +738,9 @@ def two_factor_setup():
     """
     form = t.cast(TwoFactorSetupForm, build_form_from_request("two_factor_setup_form"))
 
-    if not is_user_authenticated(current_user):
+    changing = is_user_authenticated(current_user)
+    if not changing:
         # This is the initial login case
-        # We can also get here from setup if they want to change TODO: how?
         if not all(k in session for k in ["tf_user_id", "tf_state"]) or session[
             "tf_state"
         ] not in ["setup_from_login", "validating_profile"]:
@@ -799,10 +790,20 @@ def two_factor_setup():
         session["tf_totp_secret"] = totp
         session["tf_primary_method"] = pm
         session["tf_state"] = "validating_profile"
+        # currently - state_token only works for changing TFA - not initial login
+        state_token = None
+        if changing:
+            state = {
+                "totp_secret": totp,
+                "method": pm,
+                "phone": phone,
+            }
+            state_token = _security.tf_setup_serializer.dumps(state)
         json_response = {
-            "tf_state": "validating_profile",
+            "tf_state": "validating_profile",  # deprecated in 5.5.0
             "tf_primary_method": pm,  # old
             "tf_method": pm,
+            "tf_state_token": state_token,
         }
         if phone:
             #  TODO dont save here - wait until complete
@@ -853,13 +854,13 @@ def two_factor_setup():
             primary_method=localize_callback(
                 _setup_methods_xlate[getattr(user, "tf_primary_method", None)]
             ),
+            changing=changing,
+            state_token=state_token,
             **qrcode_values,
             **_ctx("tf_setup"),
         )
 
     # We get here on GET and POST with failed validation.
-    # For things like phone number - we've already done one POST
-    # that succeeded and now it failed - so retain the initial info
     choices = cv("TWO_FACTOR_ENABLED_METHODS")
     if (not cv("TWO_FACTOR_REQUIRED")) and user.tf_primary_method is not None:
         choices.insert(0, "disable")
@@ -881,15 +882,90 @@ def two_factor_setup():
         two_factor_setup_form=form,
         two_factor_verify_code_form=code_form,
         choices=choices,
-        chosen_method=form.setup.data,
+        chosen_method=None,
         primary_method=localize_callback(
             _setup_methods_xlate[getattr(user, "tf_primary_method", None)]
         ),
+        changing=changing,
+        state_token=None,
         two_factor_required=cv("TWO_FACTOR_REQUIRED"),
         **_ctx("tf_setup"),
     )
 
 
+@auth_required(lambda: cv("API_ENABLED_METHODS"))
+def two_factor_setup_validate(token: str) -> ResponseValue:
+    """
+    Validate new setup.
+    The token is the state variable which is signed and timed
+    and contains all the state that once confirmed will be stored in the user record.
+    Unlike the code in two_factor_token_validation - this works w/o a session.
+    It also is JUST for setting up/changing two factor for an authenticated user.
+    """
+    form = t.cast(
+        TwoFactorVerifyCodeForm, build_form_from_request("two_factor_verify_code_form")
+    )
+
+    expired, invalid, state = check_and_get_token_status(
+        token, "tf_setup", get_within_delta("TWO_FACTOR_SETUP_WITHIN")
+    )
+    if invalid:
+        m, c = get_message("API_ERROR")
+    if expired:
+        m, c = get_message(
+            "TWO_FACTOR_SETUP_EXPIRED", within=cv("TWO_FACTOR_SETUP_WITHIN")
+        )
+    if invalid or expired:
+        tf_clean_session()  # until we completely remove session based setup/state
+        if _security._want_json(request):
+            form.form_errors.append(m)
+            return base_render_json(form, include_user=False)
+        do_flash(m, c)
+        return redirect(url_for_security("two_factor_setup"))
+
+    totp_secret = state["totp_secret"]
+    method = state["method"]
+    phone = state["phone"]
+    form.tf_totp_secret = totp_secret
+    form.primary_method = method
+    form.user = current_user
+
+    if form.validate_on_submit():
+        tf_clean_session()  # until we completely remove session based setup/state
+        after_this_request(view_commit)
+        _datastore.tf_set(current_user, method, totp_secret, phone)
+        # TODO: should validity cookie be removed? extended? left alone?
+        # Currently - leave it alone - meaning cookie still set.
+
+        tf_profile_changed.send(
+            current_app._get_current_object(),  # type: ignore[attr-defined]
+            _async_wrapper=current_app.ensure_sync,
+            user=current_user,
+            method=method,
+        )
+
+        if _security._want_json(request):
+            return base_render_json(
+                form,
+                include_user=False,
+                additional=dict(
+                    tf_method=method,
+                    tf_primary_method=method,
+                    tf_phone=current_user.tf_phone_number,
+                ),
+            )
+        else:
+            do_flash(*get_message("TWO_FACTOR_CHANGE_METHOD_SUCCESSFUL"))
+            return redirect(get_url(cv("TWO_FACTOR_POST_SETUP_VIEW")))
+
+    # Code not correct/outdated.
+    if _security._want_json(request):
+        return base_render_json(form, include_user=False)
+    m, c = get_message("TWO_FACTOR_INVALID_TOKEN")
+    do_flash(m, c)
+    return redirect(url_for_security("two_factor_setup"))
+
+
 @unauth_csrf()
 def two_factor_token_validation():
     """View function for two-factor token validation
@@ -1154,6 +1230,11 @@ def create_blueprint(app, state, import_
             endpoint="two_factor_setup",
         )(two_factor_setup)
         bp.route(
+            two_factor_setup_url + slash_url_suffix(two_factor_setup_url, "<token>"),
+            methods=["POST"],
+            endpoint="two_factor_setup_validate",
+        )(two_factor_setup_validate)
+        bp.route(
             two_factor_token_validation_url,
             methods=["GET", "POST"],
             endpoint="two_factor_token_validation",
@@ -1187,6 +1268,19 @@ def create_blueprint(app, state, import_
             endpoint="change_password",
         )(change_password)
 
+    if state.change_email:
+        change_email_url = cv("CHANGE_EMAIL_URL", app=app)
+        bp.route(
+            change_email_url,
+            methods=["GET", "POST"],
+            endpoint="change_email",
+        )(change_email)
+        bp.route(
+            change_email_url + slash_url_suffix(change_email_url, "<token>"),
+            methods=["GET"],
+            endpoint="change_email_confirm",
+        )(change_email_confirm)
+
     if state.confirmable:
         confirm_url = cv("CONFIRM_URL", app=app)
         bp.route(confirm_url, methods=["GET", "POST"], endpoint="send_confirmation")(
diff -pruN 5.4.3-1/flask_security/webauthn.py 5.5.0-1/flask_security/webauthn.py
--- 5.4.3-1/flask_security/webauthn.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/webauthn.py	2024-07-24 02:21:26.000000000 +0000
@@ -109,8 +109,7 @@ from .utils import (
 if t.TYPE_CHECKING:  # pragma: no cover
     import flask
     from flask.typing import ResponseValue
-    from .core import Security
-    from .datastore import User, WebAuthn
+    from flask_security import Security, UserMixin, WebAuthnMixin
 
 if get_quart_status():  # pragma: no cover
     from quart import redirect
@@ -218,7 +217,7 @@ class WebAuthnSigninForm(Form, NextFormM
     remember = BooleanField(get_form_field_label("remember_me"))
     submit = SubmitField(label=get_form_field_xlate(_("Start")), id="wan_signin")
 
-    user: User | None = None
+    user: UserMixin | None = None
     # set by caller - is this a second factor authentication?
     is_secondary: bool
 
@@ -260,8 +259,8 @@ class WebAuthnSigninResponseForm(Form, N
     is_verify: bool
     # returned to caller
     authentication_verification: VerifiedAuthentication
-    user: User | None = None
-    cred: WebAuthn | None = None
+    user: UserMixin | None = None
+    cred: WebAuthnMixin | None = None
     # Set to True if this authentication qualifies as 'multi-factor'
     mf_check: bool = False
 
@@ -373,7 +372,7 @@ class WebAuthnDeleteForm(Form):
 class WebAuthnVerifyForm(Form):
     submit = SubmitField(label=get_form_field_label("submit"), id="wan_verify")
 
-    user: User
+    user: UserMixin
 
     def validate(self, **kwargs: t.Any) -> bool:
         if not super().validate(**kwargs):
@@ -464,7 +463,7 @@ def webauthn_register() -> ResponseValue
         )
 
     current_creds = []
-    cred: WebAuthn
+    cred: WebAuthnMixin
     for cred in current_user.webauthn:
         cl = {
             "name": cred.name,
@@ -549,7 +548,7 @@ def webauthn_register_response(token: st
         )
         wan_registered.send(
             current_app._get_current_object(),  # type: ignore
-            _async_wrapper=current_app.ensure_sync,
+            _async_wrapper=current_app.ensure_sync,  # type: ignore[arg-type]
             user=current_user,
             name=state["name"],
         )
@@ -568,7 +567,7 @@ def webauthn_register_response(token: st
     return redirect(url_for_security("wan_register"))
 
 
-def _signin_common(user: User | None, usage: list[str]) -> tuple[t.Any, str]:
+def _signin_common(user: UserMixin | None, usage: list[str]) -> tuple[t.Any, str]:
     """
     Common code between signin and verify - once form has been verified.
     """
@@ -598,7 +597,9 @@ def _signin_common(user: User | None, us
     }
 
     o_json = json.loads(webauthn.options_to_json(options))
-    state_token = t.cast(str, _security.wan_serializer.dumps(state))
+    state_token = t.cast(  # type: ignore[redundant-cast]
+        str, _security.wan_serializer.dumps(state)
+    )
     return o_json, state_token
 
 
@@ -767,7 +768,7 @@ def webauthn_delete() -> ResponseValue:
 
         wan_deleted.send(
             current_app._get_current_object(),  # type: ignore
-            _async_wrapper=current_app.ensure_sync,
+            _async_wrapper=current_app.ensure_sync,  # type: ignore[arg-type]
             user=current_user,
             name=cred.name,
         )
@@ -873,7 +874,7 @@ def webauthn_verify_response(token: str)
     return redirect(url_for_security("wan_verify"))
 
 
-def is_cred_usable(cred: WebAuthn, usage: str | list[str]) -> bool:
+def is_cred_usable(cred: WebAuthnMixin, usage: str | list[str]) -> bool:
     # Return True is cred can be used for the requested usage/verify
     if not isinstance(usage, list):
         usage = [usage]
@@ -881,7 +882,7 @@ def is_cred_usable(cred: WebAuthn, usage
     return cred.usage in usage
 
 
-def has_webauthn(user: User, usage: str | list[str]) -> bool:
+def has_webauthn(user: UserMixin, usage: str | list[str]) -> bool:
     # Return True if ``user`` has one or more keys with requested usage.
     # Usage: either "first" or "secondary"
     if not isinstance(usage, list):
@@ -894,7 +895,7 @@ def has_webauthn(user: User, usage: str
 
 
 def create_credential_list(
-    user: User, usage: list[str]
+    user: UserMixin, usage: list[str]
 ) -> list[PublicKeyCredentialDescriptor]:
     # Return a list of registered credentials - filtered by whether they apply to our
     # authentication state (first or secondary)
@@ -928,13 +929,13 @@ class WebAuthnTfPlugin(TfPluginBase):
         """
         pass
 
-    def get_setup_methods(self, user: User) -> list[str]:
+    def get_setup_methods(self, user: UserMixin) -> list[str]:
         if has_webauthn(user, "secondary"):
             return [_("webauthn")]
         return []
 
     def tf_login(
-        self, user: User, json_payload: dict[str, t.Any], next_loc: str | None
+        self, user: UserMixin, json_payload: dict[str, t.Any], next_loc: str | None
     ) -> ResponseValue:
         session["tf_state"] = "ready"
         if not _security._want_json(request):
diff -pruN 5.4.3-1/flask_security/webauthn_util.py 5.5.0-1/flask_security/webauthn_util.py
--- 5.4.3-1/flask_security/webauthn_util.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/flask_security/webauthn_util.py	2024-07-24 02:21:26.000000000 +0000
@@ -30,7 +30,7 @@ except ImportError:  # pragma: no cover
 
 if t.TYPE_CHECKING:  # pragma: no cover
     import flask
-    from .datastore import User
+    from flask_security import UserMixin
 
 
 class WebauthnUtil:
@@ -60,7 +60,7 @@ class WebauthnUtil:
         return request.host_url.rstrip("/")
 
     def registration_options(
-        self, user: User, usage: str, existing_options: dict[str, t.Any]
+        self, user: UserMixin, usage: str, existing_options: dict[str, t.Any]
     ) -> dict[str, t.Any]:
         """
         :param user: User object - could be used to configure on a per-user basis.
@@ -76,7 +76,7 @@ class WebauthnUtil:
         return existing_options
 
     def authenticator_selection(
-        self, user: User, usage: str
+        self, user: UserMixin, usage: str
     ) -> AuthenticatorSelectionCriteria:
         """
         :param user: User object - could be used to configure on a per-user basis.
@@ -120,7 +120,7 @@ class WebauthnUtil:
 
     def authentication_options(
         self,
-        user: User | None,
+        user: UserMixin | None,
         usage: list[str],
         existing_options: dict[str, t.Any],
     ) -> dict[str, t.Any]:
@@ -138,7 +138,7 @@ class WebauthnUtil:
         return existing_options
 
     def user_verification(
-        self, user: User | None, usage: list[str]
+        self, user: UserMixin | None, usage: list[str]
     ) -> UserVerificationRequirement:
         """
         As part of signin - do we want/need user verification.
diff -pruN 5.4.3-1/mypy.ini 5.5.0-1/mypy.ini
--- 5.4.3-1/mypy.ini	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/mypy.ini	2024-07-24 02:21:26.000000000 +0000
@@ -1,11 +1,10 @@
 [mypy]
-plugins = sqlalchemy.ext.mypy.plugin
 
 pretty = True
 show_error_codes = True
 
 # this sucks - but most of our packages don't yet have types.
-ignore_missing_imports = True
+disable_error_code = import-untyped
 
 no_implicit_optional = True
 disallow_incomplete_defs = True
@@ -23,3 +22,10 @@ warn_unused_configs = True
 [mypy-flask_security.cli]
 # Due to click 8.1.4
 ignore_errors = True
+
+[mypy-quart.*]
+ignore_missing_imports = True
+[mypy-flask_mail.*]
+ignore_missing_imports = True
+[mypy-twilio.*]
+ignore_missing_imports = True
diff -pruN 5.4.3-1/pyproject.toml 5.5.0-1/pyproject.toml
--- 5.4.3-1/pyproject.toml	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/pyproject.toml	2024-07-24 02:21:26.000000000 +0000
@@ -11,7 +11,7 @@ keywords = ["flask security"]
 # license = "MIT"
 maintainers = [{ name = "Chris Wagner", email = "jwag.wagner+github@gmail.com"}]
 authors = [{ name = "Matt Wright"}, { name = "Chris Wagner", email = "jwag.wagner+github@gmail.com"}]
-requires-python = ">=3.8"
+requires-python = ">=3.9"
 urls.Documentation = "https://flask-security-too.readthedocs.io"
 urls.Homepage = "https://github.com/Flask-Middleware/flask-security"
 urls.Source = "https://github.com/Flask-Middleware/flask-security"
@@ -27,7 +27,6 @@ classifiers=[
     "Topic :: Internet :: WWW/HTTP :: Dynamic Content",
     "Topic :: Software Development :: Libraries :: Python Modules",
     "Programming Language :: Python :: 3",
-    "Programming Language :: Python :: 3.8",
     "Programming Language :: Python :: 3.9",
     "Programming Language :: Python :: 3.10",
     "Programming Language :: Python :: 3.11",
@@ -41,8 +40,8 @@ dynamic = [
 ]
 dependencies = [
     # flask dependencies include werkzeug, jinja2, itsdangerous, click, blinker
-    "Flask>=2.3.2",
-    "Flask-Login>=0.6.2",
+    "Flask>=3.0.0",
+    "Flask-Login>=0.6.3",
     "Flask-Principal>=0.4.0",
     "Flask-WTF>=1.1.2",
     "email-validator>=2.0.0",
@@ -54,16 +53,17 @@ dependencies = [
 
 [project.optional-dependencies]
 babel = ["babel>=2.12.1", "flask_babel>=3.1.0"]
-fsqla = ["flask_sqlalchemy>=3.0.3", "sqlalchemy>=2.0.12", "sqlalchemy-utils>=0.41.1"]
-common = ["bcrypt>=4.0.1", "flask_mailman>=0.3.0", "bleach>=6.0.0"]
+fsqla = ["flask_sqlalchemy>=3.1.0", "sqlalchemy>=2.0.18", "sqlalchemy-utils>=0.41.1"]
+common = ["argon2_cffi>=21.3.0", "bcrypt>=4.0.1", "flask_mailman>=0.3.0", "bleach>=6.0.0"]
 mfa = ["cryptography>=40.0.2", "qrcode>=7.4.2", "phonenumberslite>=8.13.11", "webauthn>=2.0.0"]
 low = [
     # Lowest supported versions
-    "Flask==2.3.2",
-    "Flask-SQLAlchemy==3.0.3",
+    "Flask==3.0.0",
+    "Flask-SQLAlchemy==3.1.0",
+    "Flask-SQLAlchemy-Lite==0.1.0;python_version>='3.10'",
     "Flask-Babel==3.1.0",
     "Flask-Mailman==0.3.0",
-    "Flask-Login==0.6.2",
+    "Flask-Login==0.6.3",
     "Flask-WTF==1.1.2",
     "peewee==3.16.2",
     "argon2_cffi==21.3.0",
@@ -84,10 +84,10 @@ low = [
     "requests",
     # passlib required setuptools
     "setuptools",
-    "sqlalchemy==2.0.12",
+    "sqlalchemy==2.0.18",
     "sqlalchemy-utils==0.41.1",
     "webauthn==2.0.0",
-    "werkzeug==2.3.3",
+    "werkzeug==3.0.1",
     "zxcvbn==4.4.28"
 ]
 
@@ -96,3 +96,8 @@ version = {attr = "flask_security.__vers
 
 [tool.djlint]
     ignore="H005,H006"  # lang, img height/width
+
+[tool.pyright]
+    include=["flask_security", "tests/view_scaffold.py"]
+    analyzeUnannotatedFunctions = "none"
+    reportMissingImports = false
diff -pruN 5.4.3-1/pytest.ini 5.5.0-1/pytest.ini
--- 5.4.3-1/pytest.ini	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/pytest.ini	2024-07-24 02:21:26.000000000 +0000
@@ -16,6 +16,7 @@ markers =
     webauthn
     flask_async
     csrf
+    change_email
 
 filterwarnings =
     error
diff -pruN 5.4.3-1/requirements/dev.txt 5.5.0-1/requirements/dev.txt
--- 5.4.3-1/requirements/dev.txt	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/requirements/dev.txt	2024-07-24 02:21:26.000000000 +0000
@@ -7,17 +7,17 @@ psycopg2-binary
 pymysql
 pre-commit
 tox
-sqlalchemy[mypy]
+sqlalchemy
 types-requests
 
 # for dev - might not install Flask-Security - list those dependencies here
 flask
-flask_wtf
-flask_login
+flask-wtf
+flask-login
 wtforms
 markupsafe
 passlib
 blinker
-email-validator
+email_validator
 itsdangerous
 importlib_resources>=5.10.0
diff -pruN 5.4.3-1/requirements/docs.txt 5.5.0-1/requirements/docs.txt
--- 5.4.3-1/requirements/docs.txt	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/requirements/docs.txt	2024-07-24 02:21:26.000000000 +0000
@@ -1,6 +1,6 @@
-Pallets-Sphinx-Themes~=2.1
-Sphinx~=7.2
-sphinx-issues==3.0.1
+Pallets-Sphinx-Themes
+Sphinx
+sphinx-issues
 packaging
 Flask-Login
 Flask-SQLAlchemy
diff -pruN 5.4.3-1/requirements/tests.txt 5.5.0-1/requirements/tests.txt
--- 5.4.3-1/requirements/tests.txt	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/requirements/tests.txt	2024-07-24 02:21:26.000000000 +0000
@@ -5,7 +5,8 @@ Flask-Mailman
 Flask-Principal
 peewee; python_version < '3.12'
 Flask-SQLAlchemy
-argon2_cffi
+Flask-SQLAlchemy-Lite; python_version >= '3.10'
+argon2-cffi
 authlib
 bcrypt
 bleach
diff -pruN 5.4.3-1/tests/conftest.py 5.5.0-1/tests/conftest.py
--- 5.4.3-1/tests/conftest.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/conftest.py	2024-07-24 02:21:26.000000000 +0000
@@ -16,6 +16,7 @@ import tempfile
 import time
 import typing as t
 from datetime import datetime
+import sys
 from urllib.parse import urlsplit
 
 from passlib.ifc import PasswordHash
@@ -26,7 +27,13 @@ from flask import request as flask_reque
 from flask_mailman import Mail
 from flask_wtf import CSRFProtect
 
+try:
+    from sqlalchemy.orm import Mapped
+except ImportError:
+    pass
+
 from flask_security import (
+    FSQLALiteUserDatastore,
     MongoEngineUserDatastore,
     PeeweeUserDatastore,
     PonyUserDatastore,
@@ -40,7 +47,6 @@ from flask_security import (
     auth_token_required,
     http_auth_required,
     get_request_attr,
-    naive_utcnow,
     roles_accepted,
     roles_required,
     permissions_accepted,
@@ -123,6 +129,7 @@ def app(request: pytest.FixtureRequest)
 
     for opt in [
         "changeable",
+        "change_email",
         "recoverable",
         "registerable",
         "trackable",
@@ -301,6 +308,11 @@ def app(request: pytest.FixtureRequest)
     def echo_json():
         return jsonify(flask_request.get_json())
 
+    @app.route("/json_auth", methods=["POST"])
+    @auth_required()
+    def echo_jsonauth():
+        return jsonify(flask_request.get_json())
+
     @app.route("/unauthz", methods=["GET", "POST"])
     def unauthz():
         return render_template("index.html", content="Unauthorized")
@@ -494,7 +506,66 @@ def sqlalchemy_setup(request, app, tmpdi
 
 
 @pytest.fixture()
+def fsqlalite_datastore(request, app, tmpdir, realdburl):
+    return fsqlalite_setup(request, app, tmpdir, realdburl)
+
+
+def fsqlalite_setup(request, app, tmpdir, realdburl):
+    pytest.importorskip("flask_sqlalchemy_lite")
+    from flask_sqlalchemy_lite import SQLAlchemy
+    from sqlalchemy.orm import DeclarativeBase, mapped_column
+    from flask_security.models import sqla as sqla
+
+    if realdburl:
+        db_url, db_info = _setup_realdb(realdburl)
+    else:
+        db_url = "sqlite:///:memory:"
+    app.config |= {
+        "SQLALCHEMY_ENGINES": {
+            "default": {"url": db_url, "pool_pre_ping": True},
+        },
+    }
+    db = SQLAlchemy(app)
+
+    class Model(DeclarativeBase):
+        pass
+
+    sqla.FsModels.set_db_info(base_model=Model)
+
+    class Role(Model, sqla.FsRoleMixin):
+        __tablename__ = "role"
+
+    class WebAuthn(Model, sqla.FsWebAuthnMixin):
+        __tablename__ = "webauthn"
+
+    class User(Model, sqla.FsUserMixin):
+        __tablename__ = "user"
+        security_number: Mapped[t.Optional[int]] = mapped_column(  # type: ignore
+            unique=True
+        )
+
+        def get_security_payload(self) -> dict[str, t.Any]:
+            # Make sure we still properly hook up to flask's JSON extension
+            # which handles datetime
+            return {"email": str(self.email), "last_update": self.update_datetime}
+
+    with app.app_context():
+        Model.metadata.create_all(db.engine)
+
+    def tear_down():
+        with app.app_context():
+            Model.metadata.drop_all(db.engine)
+            if realdburl:
+                _teardown_realdb(db_info)
+
+    request.addfinalizer(tear_down)
+    return FSQLALiteUserDatastore(db, User, Role, WebAuthn)
+
+
+@pytest.fixture()
 def sqlalchemy_session_datastore(request, app, tmpdir, realdburl):
+    if sys.version_info < (3, 10):
+        pytest.skip("requires python3.10 or higher")
     return sqlalchemy_session_setup(request, app, tmpdir, realdburl)
 
 
@@ -505,78 +576,48 @@ def sqlalchemy_session_setup(request, ap
     pytest.importorskip("sqlalchemy")
     from sqlalchemy import create_engine
     from sqlalchemy.orm import (
+        mapped_column,
         scoped_session,
         sessionmaker,
-        relationship,
-        backref,
         declarative_base,
     )
     from sqlalchemy.ext.declarative import declared_attr
-    from sqlalchemy.ext.mutable import MutableList
-    from sqlalchemy.sql import func
     from sqlalchemy import (
-        Boolean,
-        DateTime,
         Column,
         Integer,
-        LargeBinary,
-        String,
-        Text,
         ForeignKey,
     )
-    from flask_security import AsaList
+    from flask_security.models import sqla as sqla
 
-    f, path = tempfile.mkstemp(
-        prefix="flask-security-test-db", suffix=".db", dir=str(tmpdir)
-    )
-
-    app.config["SQLALCHEMY_DATABASE_URI"] = "sqlite:///" + path
+    if realdburl:
+        db_url, db_info = _setup_realdb(realdburl)
+        engine = db_info["engine"]
+    else:
+        db_url = "sqlite:///:memory:"
+        engine = create_engine(db_url, **engine_kwargs)
 
-    engine = create_engine(app.config["SQLALCHEMY_DATABASE_URI"], **engine_kwargs)
     db_session = scoped_session(
         sessionmaker(autocommit=False, autoflush=False, bind=engine)
     )
     app.teardown_appcontext(lambda exc: db_session.close())
     Base = declarative_base()
-    Base.query = db_session.query_property()
+    # Note that in this case we don't call set_db_info since we are using
+    # normal table names AND we need our own RolesUsers table since we modified the
+    # PK names.
 
-    class WebAuthn(Base, WebAuthnMixin):
+    class WebAuthn(Base, sqla.FsWebAuthnMixin):
         __tablename__ = "webauthn"
 
-        id = Column(Integer, primary_key=True)
-        credential_id = Column(
-            LargeBinary(1024), index=True, unique=True, nullable=False
-        )
-        public_key = Column(LargeBinary, nullable=False)
-        sign_count = Column(Integer, default=0)
-        transports = Column(MutableList.as_mutable(AsaList()), nullable=True)
-
-        # a JSON string as returned from registration
-        extensions = Column(String(255), nullable=True)
-        create_datetime = Column(
-            type_=DateTime, nullable=False, server_default=func.now()
-        )
-        lastuse_datetime = Column(type_=DateTime, nullable=False)
-        # name is provided by user - we make sure is unique per user
-        name = Column(String(64), nullable=False)
-        usage = Column(String(64), nullable=False)
-        backup_state = Column(Boolean, nullable=False)  # Upcoming post V3 spec
-        device_type = Column(String(64), nullable=False)
-
         @declared_attr
-        def myuser_id(cls):
-            return Column(
-                Integer,
-                ForeignKey("user.myuserid", ondelete="CASCADE"),
-                nullable=False,
-            )
+        def user_id(self) -> Mapped[int]:
+            return mapped_column(ForeignKey("user.myuserid", ondelete="CASCADE"))
 
         def get_user_mapping(self) -> dict[str, t.Any]:
             """
             Return the filter needed by find_user() to get the user
             associated with this webauthn credential.
             """
-            return dict(myuserid=self.myuser_id)
+            return dict(myuserid=self.user_id)
 
     class RolesUsers(Base):
         __tablename__ = "roles_users"
@@ -584,57 +625,19 @@ def sqlalchemy_session_setup(request, ap
         user_id = Column("user_id", Integer(), ForeignKey("user.myuserid"))
         role_id = Column("role_id", Integer(), ForeignKey("role.myroleid"))
 
-    class Role(Base, RoleMixin):
+    class Role(Base, sqla.FsRoleMixin):
         __tablename__ = "role"
-        myroleid = Column(Integer(), primary_key=True)
-        name = Column(String(80), unique=True)
-        description = Column(String(255))
-        permissions = Column(MutableList.as_mutable(AsaList()), nullable=True)
-        update_datetime = Column(
-            DateTime,
-            nullable=False,
-            server_default=func.now(),
-            onupdate=naive_utcnow,
-        )
+        myroleid: Mapped[int] = mapped_column(primary_key=True)  # type: ignore
+        id: Mapped[int] = mapped_column(nullable=True)  # type: ignore
 
-    class User(Base, UserMixin):
+    class User(Base, sqla.FsUserMixin):
         __tablename__ = "user"
-        myuserid = Column(Integer, primary_key=True)
-        fs_uniquifier = Column(String(64), unique=True, nullable=False)
-        fs_webauthn_user_handle = Column(String(64), unique=True, nullable=True)
-        email = Column(String(255), unique=True)
-        username = Column(String(255), unique=True, nullable=True)
-        password = Column(String(255))
-        security_number = Column(Integer, unique=True)
-        last_login_at = Column(DateTime())
-        current_login_at = Column(DateTime())
-        tf_primary_method = Column(String(255), nullable=True)
-        tf_totp_secret = Column(String(255), nullable=True)
-        tf_phone_number = Column(String(255), nullable=True)
-        mf_recovery_codes = Column(MutableList.as_mutable(AsaList()), nullable=True)
-        us_totp_secrets = Column(Text, nullable=True)
-        us_phone_number = Column(String(64), nullable=True, unique=True)
-        last_login_ip = Column(String(100))
-        current_login_ip = Column(String(100))
-        login_count = Column(Integer)
-        active = Column(Boolean())
-        confirmed_at = Column(DateTime())
-        roles = relationship(
-            "Role",
-            secondary="roles_users",
-            backref=backref("users", lazy="dynamic", cascade_backrefs=False),
-        )
-        update_datetime = Column(
-            DateTime,
-            nullable=False,
-            server_default=func.now(),
-            onupdate=naive_utcnow,
+        myuserid: Mapped[int] = mapped_column(primary_key=True)  # type: ignore
+        id: Mapped[int] = mapped_column(nullable=True)  # type: ignore
+        security_number: Mapped[t.Optional[int]] = mapped_column(  # type: ignore
+            unique=True
         )
 
-        @declared_attr
-        def webauthn(cls):
-            return relationship("WebAuthn", backref="users", cascade="all, delete")
-
         def get_security_payload(self):
             # Make sure we still properly hook up to flask's JSON extension
             # which handles datetime
@@ -644,9 +647,10 @@ def sqlalchemy_session_setup(request, ap
         Base.metadata.create_all(bind=engine)
 
     def tear_down():
-        db_session.close()
-        os.close(f)
-        os.remove(path)
+        with app.app_context():
+            Base.metadata.drop_all(bind=engine)
+            if realdburl:
+                _teardown_realdb(db_info)
 
     request.addfinalizer(tear_down)
 
@@ -871,6 +875,17 @@ def sqlalchemy_app(
 
 
 @pytest.fixture()
+def fsqlalite_app(
+    app: SecurityFixture, fsqlalite_datastore: FSQLALiteUserDatastore
+) -> t.Callable[[], SecurityFixture]:
+    def create() -> SecurityFixture:
+        app.security = Security(app, datastore=fsqlalite_datastore)
+        return app
+
+    return create
+
+
+@pytest.fixture()
 def sqlalchemy_session_app(app, sqlalchemy_session_datastore):
     def create():
         app.security = Security(app, datastore=sqlalchemy_session_datastore)
@@ -922,11 +937,21 @@ def client_nc(request, sqlalchemy_app):
     return app.test_client(use_cookies=False)
 
 
-@pytest.fixture(params=["cl-sqlalchemy", "c2", "cl-mongo", "cl-peewee"])
+@pytest.fixture(
+    params=[
+        "cl-fsqlalchemy",
+        "cl-sqla-session",
+        "cl-mongo",
+        "cl-peewee",
+        "cl-fsqlalite",
+    ]
+)
 def clients(request, app, tmpdir, realdburl, realmongodburl):
-    if request.param == "cl-sqlalchemy":
+    if request.param == "cl-fsqlalchemy":
         ds = sqlalchemy_setup(request, app, tmpdir, realdburl)
-    elif request.param == "c2":
+    elif request.param == "cl-sqla-session":
+        if sys.version_info < (3, 10):
+            pytest.skip("requires python3.10 or higher")
         ds = sqlalchemy_session_setup(request, app, tmpdir, realdburl)
     elif request.param == "cl-mongo":
         ds = mongoengine_setup(request, app, tmpdir, realmongodburl)
@@ -935,6 +960,9 @@ def clients(request, app, tmpdir, realdb
     elif request.param == "cl-pony":
         # Not working yet.
         ds = pony_setup(request, app, tmpdir, realdburl)
+    elif request.param == "cl-fsqlalite":
+        ds = fsqlalite_setup(request, app, tmpdir, realdburl)
+
     app.security = Security(app, datastore=ds)
     populate_data(app)
     if request.param == "cl-peewee":
@@ -968,12 +996,21 @@ def get_message_local(app):
 
 
 @pytest.fixture(
-    params=["sqlalchemy", "sqlalchemy-session", "mongoengine", "peewee", "pony"]
+    params=[
+        "sqlalchemy",
+        "sqlalchemy-session",
+        "mongoengine",
+        "peewee",
+        "pony",
+        "fsqlalite",
+    ]
 )
 def datastore(request, app, tmpdir, realdburl, realmongodburl):
     if request.param == "sqlalchemy":
         rv = sqlalchemy_setup(request, app, tmpdir, realdburl)
     elif request.param == "sqlalchemy-session":
+        if sys.version_info < (3, 10):
+            pytest.skip("requires python3.10 or higher")
         rv = sqlalchemy_session_setup(request, app, tmpdir, realdburl)
     elif request.param == "mongoengine":
         rv = mongoengine_setup(request, app, tmpdir, realmongodburl)
@@ -981,6 +1018,8 @@ def datastore(request, app, tmpdir, real
         rv = peewee_setup(request, app, tmpdir, realdburl)
     elif request.param == "pony":
         rv = pony_setup(request, app, tmpdir, realdburl)
+    elif request.param == "fsqlalite":
+        rv = fsqlalite_setup(request, app, tmpdir, realdburl)
     return rv
 
 
diff -pruN 5.4.3-1/tests/templates/custom_security/change_email.html 5.5.0-1/tests/templates/custom_security/change_email.html
--- 5.4.3-1/tests/templates/custom_security/change_email.html	1970-01-01 00:00:00.000000000 +0000
+++ 5.5.0-1/tests/templates/custom_security/change_email.html	2024-07-24 02:21:26.000000000 +0000
@@ -0,0 +1,3 @@
+CUSTOM CHANGE EMAIL
+{{ global }}
+{{ foo }}
diff -pruN 5.4.3-1/tests/templates/security/email/change_email_instructions.txt 5.5.0-1/tests/templates/security/email/change_email_instructions.txt
--- 5.4.3-1/tests/templates/security/email/change_email_instructions.txt	1970-01-01 00:00:00.000000000 +0000
+++ 5.5.0-1/tests/templates/security/email/change_email_instructions.txt	2024-07-24 02:21:26.000000000 +0000
@@ -0,0 +1,12 @@
+{# This template receives the following context:
+  link - the link that should be fetched (GET) to confirm
+  token - this token is part of confirmation link - but can be used to
+    construct arbitrary URLs for redirecting.
+  user - the entire user model object
+  security - the Flask-Security configuration
+#}
+Link:{{ link }}
+Email:{{ user.email }}
+Token:{{ token }}
+RegisterBlueprint:{{ security.register_blueprint }}
+Within:{{ config["SECURITY_CHANGE_EMAIL_WITHIN"] }}
diff -pruN 5.4.3-1/tests/test_basic.py 5.5.0-1/tests/test_basic.py
--- 5.4.3-1/tests/test_basic.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_basic.py	2024-07-24 02:21:26.000000000 +0000
@@ -24,11 +24,11 @@ from freezegun import freeze_time
 from tests.test_utils import (
     authenticate,
     capture_flashes,
+    capture_queries,
     check_location,
     get_auth_token_version_3x,
     get_form_action,
     get_form_input,
-    get_num_queries,
     hash_password,
     init_app_with_options,
     is_authenticated,
@@ -152,15 +152,17 @@ def test_authenticate_with_subdomain_nex
     data = dict(email="matt@lp.com", password="password")
     response = client.post("/login?next=http://sub.lp.com", data=data)
     assert response.status_code == 302
+    assert response.location == "http://sub.lp.com"
 
 
+@pytest.mark.settings(subdomain="auth")
 def test_authenticate_with_root_domain_next(app, client, get_message):
     app.config["SERVER_NAME"] = "lp.com"
-    app.config["SECURITY_SUBDOMAIN"] = "auth"
     app.config["SECURITY_REDIRECT_ALLOW_SUBDOMAINS"] = True
     data = dict(email="matt@lp.com", password="password")
-    response = client.post("/login?next=http://lp.com", data=data)
+    response = client.post("http://auth.lp.com/login?next=http://lp.com", data=data)
     assert response.status_code == 302
+    assert response.location == "http://lp.com"
 
 
 def test_authenticate_with_invalid_subdomain_next(app, client, get_message):
@@ -178,6 +180,44 @@ def test_authenticate_with_subdomain_nex
     assert get_message("INVALID_REDIRECT") in response.data
 
 
+@pytest.mark.settings(
+    redirect_base_domain="bigidea.org", redirect_allowed_subdomains=["my.photo", "blog"]
+)
+def test_allow_subdomains(app, client, get_message):
+    app.config["SERVER_NAME"] = "app.bigidea.org"
+    data = dict(email="matt@lp.com", password="password")
+    # not in subdomain allowed list
+    response = client.post("/login?next=http://blog2.bigidea.org", data=data)
+    assert get_message("INVALID_REDIRECT") in response.data
+
+    response = client.post("/login?next=http://my.photo.bigidea.org/image", data=data)
+    assert response.location == "http://my.photo.bigidea.org/image"
+
+
+@pytest.mark.settings(
+    redirect_base_domain="bigidea.org", redirect_allowed_subdomains=[]
+)
+def test_redirect_allow_subdomains(app, client, get_message):
+    app.config["SERVER_NAME"] = "bigidea.org"
+    data = dict(email="matt@lp.com", password="password")
+    response = client.post("/login?next=http://blog2.bigidea.org", data=data)
+    assert get_message("INVALID_REDIRECT") in response.data
+    response = client.post("/login?next=http://bigidea.org/imin", data=data)
+    assert response.location == "http://bigidea.org/imin"
+
+
+@pytest.mark.settings(
+    post_login_view="http://blog.bigidea.org/post_login",
+    redirect_base_domain="bigidea.org",
+    redirect_allowed_subdomains=["my.photo", "blog"],
+)
+def test_view_redirect(app, client, get_message):
+    app.config["SERVER_NAME"] = "bigidea.org"
+    data = dict(email="matt@lp.com", password="password")
+    response = client.post("/login", data=data)
+    assert response.location == "http://blog.bigidea.org/post_login"
+
+
 def test_authenticate_case_insensitive_email(app, client):
     response = authenticate(client, "MATT@lp.com", follow_redirects=True)
     assert b"Welcome matt@lp.com" in response.data
@@ -199,6 +239,16 @@ def test_get_already_authenticated(clien
     response = client.get("/login", follow_redirects=True)
     assert b"Post Login" in response.data
 
+    # should still get extra goodies
+    headers = {"Accept": "application/json", "Content-Type": "application/json"}
+    response = client.get("/login", headers=headers)
+    assert response.status_code == 200
+
+    jresponse = response.json["response"]
+    assert all(a in jresponse for a in ["identity_attributes"])
+    assert "authentication_token" not in jresponse["user"]
+    assert all(a in jresponse["user"] for a in ["email", "last_update"])
+
 
 @pytest.mark.settings(post_login_view="/post_login")
 def test_get_already_authenticated_next(client):
@@ -1070,6 +1120,7 @@ def test_verifying_token_from_version_4x
 
 def test_change_token_uniquifier(app):
     pytest.importorskip("sqlalchemy")
+    pytest.importorskip("flask_sqlalchemy")
 
     # make sure that existing token no longer works once we change the token uniquifier
     from sqlalchemy import Column, String
@@ -1123,6 +1174,7 @@ def test_change_token_uniquifier(app):
 
 def test_null_token_uniquifier(app):
     pytest.importorskip("sqlalchemy")
+    pytest.importorskip("flask_sqlalchemy")
 
     # If existing record has a null fs_token_uniquifier, should be set on first use.
     from sqlalchemy import Column, String
@@ -1170,18 +1222,16 @@ def test_null_token_uniquifier(app):
 def test_token_query(app, client_nc):
     # Verify that when authenticating with auth token (and not session)
     # that there is just one DB query to get user.
-    with app.app_context():
+    with capture_queries(app.security.datastore) as queries:
         response = json_authenticate(client_nc)
+        assert len(queries) == 1
         token = response.json["response"]["user"]["authentication_token"]
-        assert get_num_queries(app.security.datastore) == 1
-
-    with app.app_context():
         response = client_nc.get(
             "/token",
             headers={"Content-Type": "application/json", "Authentication-Token": token},
         )
         assert response.status_code == 200
-        assert get_num_queries(app.security.datastore) == 1
+    assert len(queries) == 2
 
 
 def test_session_query(in_app_context):
@@ -1196,15 +1246,13 @@ def test_session_query(in_app_context):
 
     response = json_authenticate(myclient)
     token = response.json["response"]["user"]["authentication_token"]
-    current_nqueries = get_num_queries(myapp.security.datastore)
-
-    response = myclient.get(
-        "/token",
-        headers={"Content-Type": "application/json", "Authentication-Token": token},
-    )
-    assert response.status_code == 200
-    end_nqueries = get_num_queries(myapp.security.datastore)
-    assert current_nqueries is None or end_nqueries == (current_nqueries + 2)
+    with capture_queries(myapp.security.datastore) as queries:
+        response = myclient.get(
+            "/token",
+            headers={"Content-Type": "application/json", "Authentication-Token": token},
+        )
+        assert response.status_code == 200
+    assert len(queries) == 2
 
 
 @pytest.mark.changeable()
diff -pruN 5.4.3-1/tests/test_change_email.py 5.5.0-1/tests/test_change_email.py
--- 5.4.3-1/tests/test_change_email.py	1970-01-01 00:00:00.000000000 +0000
+++ 5.5.0-1/tests/test_change_email.py	2024-07-24 02:21:26.000000000 +0000
@@ -0,0 +1,230 @@
+"""
+    test_change_email
+    ~~~~~~~~~~~~~~~~~
+
+    Change email functionality tests
+
+    :copyright: (c) 2024-2024 by J. Christopher Wagner (jwag).
+    :license: MIT, see LICENSE for more details.
+"""
+
+from contextlib import contextmanager
+from datetime import date, timedelta
+import re
+from urllib.parse import urlsplit
+
+import pytest
+from freezegun import freeze_time
+from tests.test_utils import (
+    authenticate,
+    capture_flashes,
+    is_authenticated,
+    json_authenticate,
+    logout,
+)
+from flask_security import hash_password
+from flask_security.signals import (
+    change_email_instructions_sent,
+    change_email_confirmed,
+)
+
+pytestmark = pytest.mark.change_email()
+
+
+@contextmanager
+def capture_change_email_requests():
+    change_email_requests = []
+
+    def _on(app, **data):
+        change_email_requests.append(data)
+
+    change_email_instructions_sent.connect(_on)
+
+    try:
+        yield change_email_requests
+    finally:
+        change_email_instructions_sent.disconnect(_on)
+
+
+@pytest.mark.settings(change_email_error_view="/change-email")
+def test_ce(app, clients, get_message):
+    client = clients
+
+    @change_email_confirmed.connect_via(app)
+    def _on(app, **kwargs):
+        assert kwargs["old_email"] == "matt@lp.com"
+        assert kwargs["user"].email == "matt2@lp.com"
+
+    authenticate(client, email="matt@lp.com")
+
+    with capture_change_email_requests() as ce_requests:
+        response = client.post("/change-email", data={"email": "<EMAIL>"})
+        assert get_message("INVALID_EMAIL_ADDRESS") in response.data
+        assert not app.mail.outbox
+
+        response = client.post("/change-email", data=dict(email="matt2@lp.com"))
+        msg = get_message("CHANGE_EMAIL_SENT", email="matt2@lp.com")
+        assert msg in response.data
+        assert "matt2@lp.com" == ce_requests[0]["new_email"]
+        token = ce_requests[0]["token"]
+    assert len(app.mail.outbox) == 1
+    assert app.config["SECURITY_CHANGE_EMAIL_WITHIN"] in app.mail.outbox[0].body
+
+    response = client.get("/change-email/" + token, follow_redirects=True)
+    assert get_message("CHANGE_EMAIL_CONFIRMED") in response.data
+    assert is_authenticated(client, get_message)
+
+    logout(client)
+    authenticate(client, email="matt2@lp.com")
+    assert is_authenticated(client, get_message)
+
+    # try using link again - should fail
+    with capture_flashes() as flashes:
+        client.get("/change-email/" + token, follow_redirects=True)
+    assert flashes[0]["message"].encode("utf-8") == get_message("API_ERROR")
+
+
+def test_ce_json(app, client, get_message):
+    headers = {"Accept": "application/json", "Content-Type": "application/json"}
+
+    @change_email_confirmed.connect_via(app)
+    def _on(app, **kwargs):
+        assert kwargs["old_email"] == "matt@lp.com"
+        assert kwargs["user"].email == "matt2@lp.com"
+
+    json_authenticate(client, email="matt@lp.com")
+
+    with capture_change_email_requests() as ce_requests:
+        response = client.post("/change-email", json={"email": "<EMAIL>"})
+        assert response.json["response"]["errors"][0].encode("utf=8") == get_message(
+            "INVALID_EMAIL_ADDRESS"
+        )
+        assert not app.mail.outbox
+
+        response = client.post("/change-email", json=dict(email="matt2@lp.com"))
+        assert response.status_code == 200
+        assert response.json["response"]["current_email"] == "matt@lp.com"
+        assert "matt2@lp.com" == ce_requests[0]["new_email"]
+        token = ce_requests[0]["token"]
+    assert len(app.mail.outbox) == 1
+
+    response = client.get(
+        "/change-email/" + token, headers=headers, follow_redirects=True
+    )
+    assert get_message("CHANGE_EMAIL_CONFIRMED") in response.data
+    assert is_authenticated(client, get_message)
+
+    logout(client)
+    authenticate(client, email="matt2@lp.com")
+    assert is_authenticated(client, get_message)
+
+
+@pytest.mark.settings(
+    change_email_within="1 milliseconds", change_email_error_view="/change-email"
+)
+def test_expired_token(client, get_message):
+    # Note that we need relatively new-ish date since session cookies also expire.
+    with freeze_time(date.today() + timedelta(days=-1)):
+        authenticate(client, email="matt@lp.com")
+        with capture_change_email_requests() as ce_requests:
+            client.post("/change-email", data=dict(email="matt2@lp.com"))
+
+        assert "matt2@lp.com" == ce_requests[0]["new_email"]
+        token = ce_requests[0]["token"]
+
+    response = client.get("/change-email/" + token, follow_redirects=True)
+    msg = get_message("CHANGE_EMAIL_EXPIRED", within="1 milliseconds")
+    assert msg in response.data
+
+
+def test_template(app, client, get_message):
+    # Check contents of email template - this uses a test template
+    # in order to check all context vars since the default template
+    # doesn't have all of them.
+
+    authenticate(client, email="matt@lp.com")
+    with capture_change_email_requests() as ce_requests:
+        client.post("/change-email", data=dict(email="matt2@lp.com"))
+        # check email
+        outbox = app.mail.outbox
+        assert outbox[0].to[0] == "matt2@lp.com"
+        matcher = re.findall(r"\w+:.*", outbox[0].body, re.IGNORECASE)
+        # should be 4 - link, email, token, config item
+        assert matcher[1].split(":")[1] == "matt@lp.com"
+        assert matcher[2].split(":")[1] == ce_requests[0]["token"]
+        assert matcher[3].split(":")[1] == "True"  # register_blueprint
+        assert matcher[4].split(":")[1] == "2 hours"
+
+        # check link
+        _, link = matcher[0].split(":", 1)
+        response = client.get(link, follow_redirects=True)
+        assert get_message("CHANGE_EMAIL_CONFIRMED") in response.data
+
+
+@pytest.mark.settings(return_generic_responses=True)
+def test_generic_response(app, client, get_message):
+    authenticate(client, email="matt@lp.com")
+    with capture_change_email_requests():
+        # first try bad formatted email - should get detailed error
+        response = client.post("/change-email", json={"email": "<EMAIL>"})
+        assert response.json["response"]["errors"][0].encode("utf=8") == get_message(
+            "INVALID_EMAIL_ADDRESS"
+        )
+
+        # try existing email - should get same response as if it 'worked'
+        response = client.post("/change-email", data=dict(email="gal@lp.com"))
+        msg = get_message("CHANGE_EMAIL_SENT", email="gal@lp.com")
+        assert msg in response.data
+        # but no email was actually sent
+        assert not app.mail.outbox
+
+
+@pytest.mark.settings(
+    redirect_host="myui.com:8090",
+    redirect_behavior="spa",
+    post_change_email_view="/change-email-redirect",
+    change_email_error_view="/change-email-error",
+)
+def test_spa_get(app, client, get_message):
+    json_authenticate(client, email="matt@lp.com")
+
+    with capture_change_email_requests() as ce_requests:
+        response = client.post("/change-email", data=dict(email="matt2@lp.com"))
+        msg = get_message("CHANGE_EMAIL_SENT", email="matt2@lp.com")
+        assert msg in response.data
+        assert "matt2@lp.com" == ce_requests[0]["new_email"]
+        token = ce_requests[0]["token"]
+    response = client.get("/change-email/" + token, follow_redirects=False)
+    assert response.status_code == 302
+    split = urlsplit(response.headers["Location"])
+    assert "myui.com:8090" == split.netloc
+    assert "/change-email-redirect" == split.path
+
+    # again - should be an error
+    response = client.get("/change-email/" + token, follow_redirects=False)
+    assert response.status_code == 302
+    split = urlsplit(response.headers["Location"])
+    assert "myui.com:8090" == split.netloc
+    assert "/change-email-error" == split.path
+
+
+@pytest.mark.settings(change_email_error_view="/change-email")
+def test_ce_race(app, client, get_message):
+    # test that if an email is taken between the link being sent and
+    # the user confirming - they get an error
+
+    authenticate(client, email="matt@lp.com")
+
+    with capture_change_email_requests() as ce_requests:
+        client.post("/change-email", data=dict(email="matt2@lp.com"))
+        token = ce_requests[0]["token"]
+
+    with app.app_context():
+        app.security.datastore.create_user(
+            email="matt2@lp.com",
+            password=hash_password("password"),
+        )
+        app.security.datastore.commit()
+    with capture_flashes() as flashes:
+        client.get("/change-email/" + token, follow_redirects=True)
+    assert flashes[0]["message"].encode("utf-8") == get_message("API_ERROR")
diff -pruN 5.4.3-1/tests/test_changeable.py 5.5.0-1/tests/test_changeable.py
--- 5.4.3-1/tests/test_changeable.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_changeable.py	2024-07-24 02:21:26.000000000 +0000
@@ -4,7 +4,7 @@
 
     Changeable tests
 
-    :copyright: (c) 2019-2023 by J. Christopher Wagner (jwag).
+    :copyright: (c) 2019-2024 by J. Christopher Wagner (jwag).
     :license: MIT, see LICENSE for more details.
 """
 
@@ -14,10 +14,8 @@ import pytest
 from flask import Flask
 import markupsafe
 
-from flask_security.core import UserMixin
+from flask_security import PasswordUtil, UserMixin, password_changed, user_authenticated
 from flask_security.forms import _default_field_labels
-from flask_security.password_util import PasswordUtil
-from flask_security.signals import password_changed, user_authenticated
 from flask_security.utils import localize_callback
 from tests.test_utils import (
     authenticate,
@@ -34,7 +32,8 @@ from tests.test_utils import (
 pytestmark = pytest.mark.changeable()
 
 
-def test_changeable_flag(app, client, get_message):
+def test_changeable_flag(app, clients, get_message):
+    client = clients
     recorded = []
 
     @password_changed.connect_via(app)
@@ -259,6 +258,8 @@ def test_change_invalidates_auth_token(a
 
 
 def test_auth_uniquifier(app):
+    pytest.importorskip("sqlalchemy")
+    pytest.importorskip("flask_sqlalchemy")
     # If add fs_token_uniquifier to user model - change password shouldn't invalidate
     # auth tokens.
     from sqlalchemy import Column, String
diff -pruN 5.4.3-1/tests/test_confirmable.py 5.5.0-1/tests/test_confirmable.py
--- 5.4.3-1/tests/test_confirmable.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_confirmable.py	2024-07-24 02:21:26.000000000 +0000
@@ -201,9 +201,7 @@ def test_expired_confirmation_token(clie
 
 
 @pytest.mark.registerable()
-def test_email_conflict_for_confirmation_token(
-    app, client, get_message, sqlalchemy_datastore
-):
+def test_email_conflict_for_confirmation_token(app, client, get_message):
     with capture_registrations() as registrations:
         data = dict(email="mary@lp.com", password="awesome sunset", next="")
         client.post("/register", data=data, follow_redirects=True)
@@ -214,8 +212,8 @@ def test_email_conflict_for_confirmation
     # Change the user's email
     user.email = "tom@lp.com"
     with app.app_context():
-        sqlalchemy_datastore.put(user)
-        sqlalchemy_datastore.commit()
+        app.security.datastore.put(user)
+        app.security.datastore.commit()
 
     response = client.get("/confirm/" + token, follow_redirects=True)
     msg = get_message("INVALID_CONFIRMATION_TOKEN")
diff -pruN 5.4.3-1/tests/test_context_processors.py 5.5.0-1/tests/test_context_processors.py
--- 5.4.3-1/tests/test_context_processors.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_context_processors.py	2024-07-24 02:21:26.000000000 +0000
@@ -15,8 +15,10 @@ from tests.test_utils import authenticat
 @pytest.mark.registerable()
 @pytest.mark.confirmable()
 @pytest.mark.changeable()
+@pytest.mark.change_email()
 @pytest.mark.settings(
     login_without_confirmation=True,
+    change_email_template="custom_security/change_email.html",
     change_password_template="custom_security/change_password.html",
     login_user_template="custom_security/login_user.html",
     reset_password_template="custom_security/reset_password.html",
@@ -108,6 +110,15 @@ def test_context_processors(client, app)
     assert "global" in email.body
     assert "bar-mail" in email.body
 
+    @app.security.change_email_context_processor
+    def change_email():
+        return {"foo": "bar-change-email"}
+
+    authenticate(client)
+    response = client.get("/change-email")
+    assert b"global" in response.data
+    assert b"bar-change-email" in response.data
+
 
 @pytest.mark.passwordless()
 @pytest.mark.settings(send_login_template="custom_security/send_login.html")
diff -pruN 5.4.3-1/tests/test_datastore.py 5.5.0-1/tests/test_datastore.py
--- 5.4.3-1/tests/test_datastore.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_datastore.py	2024-07-24 02:21:26.000000000 +0000
@@ -9,8 +9,9 @@
     :license: MIT, see LICENSE for more details.
 """
 
+import pytest
 from pytest import raises, skip, importorskip
-from tests.test_utils import init_app_with_options, get_num_queries, is_sqlalchemy
+from tests.test_utils import init_app_with_options, capture_queries
 
 from flask_security import (
     RoleMixin,
@@ -97,31 +98,42 @@ def test_activate_returns_false_if_alrea
     assert not datastore.activate_user(user)
 
 
-def test_find_user(app, datastore):
-    init_app_with_options(app, datastore)
+@pytest.mark.parametrize(
+    "ds",
+    ["sqlalchemy_datastore", "fsqlalite_datastore", "sqlalchemy_session_datastore"],
+)
+def test_find_user(request, app, ds):
+    ds = request.getfixturevalue(ds)
+    init_app_with_options(app, ds)
 
     with app.app_context():
-        user_id = datastore.find_user(email="gene@lp.com").fs_uniquifier
+        user_id = ds.find_user(email="gene@lp.com").fs_uniquifier
 
-        current_nqueries = get_num_queries(datastore)
-        assert user_id == datastore.find_user(security_number=889900).fs_uniquifier
-        end_nqueries = get_num_queries(datastore)
-        if current_nqueries is not None:
-            if is_sqlalchemy(datastore):
-                # This should have done just 1 query across all attrs.
-                assert end_nqueries == (current_nqueries + 1)
+        with capture_queries(ds) as queries:
+            assert user_id == ds.find_user(security_number=889900).fs_uniquifier
+        assert len(queries) == 1
+        assert queries[0].is_select
 
-        assert user_id == datastore.find_user(username="gene").fs_uniquifier
+        assert user_id == ds.find_user(username="gene").fs_uniquifier
 
 
-def test_find_user_multikey(app, datastore):
-    init_app_with_options(app, datastore)
+@pytest.mark.parametrize(
+    "ds",
+    ["sqlalchemy_datastore", "fsqlalite_datastore", "sqlalchemy_session_datastore"],
+)
+@pytest.mark.settings(join_user_roles=False)
+def test_find_user_no_joined_load(request, app, ds):
+    ds = request.getfixturevalue(ds)
+    init_app_with_options(app, ds)
 
     with app.app_context():
-        with raises(ValueError):
-            datastore.find_user(
-                case_insensitive=True, email="gene@lp.com", security_number=889900
-            )
+        with capture_queries(ds) as queries:
+            user = ds.find_user(security_number=889900)
+            assert len(user.roles) == 1
+        assert len(queries) == 2
+        assert queries[0].is_select
+        assert queries[0].statement.column_descriptions[0]["name"] == "User"
+        assert queries[1].statement.column_descriptions[0]["name"] == "Role"
 
 
 def test_find_role(app, datastore):
@@ -151,23 +163,25 @@ def test_add_role_to_user(app, datastore
         assert datastore.remove_role_from_user(user, "editor") is False
 
 
-def test_create_user_with_roles(app, datastore):
-    init_app_with_options(app, datastore)
+@pytest.mark.parametrize(
+    "ds",
+    ["sqlalchemy_datastore", "fsqlalite_datastore", "sqlalchemy_session_datastore"],
+)
+def test_create_user_with_roles(request, app, ds):
+    ds = request.getfixturevalue(ds)
+    init_app_with_options(app, ds)
 
     with app.app_context():
-        role = datastore.find_role("admin")
-        datastore.commit()
-
-        user = datastore.create_user(
+        role = ds.find_role("admin")
+        user = ds.create_user(
             email="dude@lp.com", username="dude", password="password", roles=[role]
         )
-        datastore.commit()
-        current_nqueries = get_num_queries(datastore)
-        user = datastore.find_user(email="dude@lp.com")
-        assert user.has_role("admin") is True
-        end_nqueries = get_num_queries(datastore)
-        # Verify that getting user and role is just one DB query
-        assert current_nqueries is None or end_nqueries == (current_nqueries + 1)
+        ds.commit()
+        with capture_queries(ds) as queries:
+            user = ds.find_user(email="dude@lp.com")
+            assert user.has_role("admin") is True
+        assert len(queries) == 1
+        assert queries[0].is_select
 
 
 def test_create_user_no_side_effects(app, datastore):
@@ -399,7 +413,7 @@ def test_modify_permissions_multi(app, d
 
 def test_uuid(app, request, tmpdir, realdburl):
     """Test that UUID extension of postgresql works as a primary id for users"""
-    importorskip("sqlalchemy")
+    importorskip("flask_sqlalchemy")
     import uuid
     from flask_sqlalchemy import SQLAlchemy
     from sqlalchemy import Boolean, Column, DateTime, Integer, ForeignKey, String
@@ -592,6 +606,7 @@ def test_mf_recovery_codes(app, datastor
 
 def test_permissions_fsqla_v2(app):
     importorskip("sqlalchemy")
+    importorskip("flask_sqlalchemy")
     # Make sure folks with fsqla_v2 work with new AsList column type
     from sqlalchemy import insert
     from flask_sqlalchemy import SQLAlchemy
@@ -641,6 +656,7 @@ def test_permissions_fsqla_v2(app):
 
 def test_permissions_41(request, app, realdburl):
     importorskip("sqlalchemy")
+    importorskip("flask_sqlalchemy")
     # Check compatibility with 4.1 DB
     from sqlalchemy import Column, insert
     from flask_sqlalchemy import SQLAlchemy
@@ -699,3 +715,51 @@ def test_permissions_41(request, app, re
     with app.app_context():
         r1 = ds.find_role("r1")
         assert r1.get_permissions() == {"read", "write"}
+
+
+def test_fsqlalite_table_name(app):
+    importorskip("flask_sqlalchemy_lite")
+    from flask_sqlalchemy_lite import SQLAlchemy
+    from sqlalchemy.orm import DeclarativeBase
+    from flask_security.models import sqla as sqla
+    from flask_security import FSQLALiteUserDatastore
+
+    app.config |= {
+        "SQLALCHEMY_ENGINES": {
+            "default": "sqlite:///:memory:",
+        },
+    }
+    db = SQLAlchemy(app)
+
+    class Model(DeclarativeBase):
+        pass
+
+    sqla.FsModels.set_db_info(
+        base_model=Model,
+        user_table_name="myuser",
+        role_table_name="myrole",
+        webauthn_table_name="mywebauthn",
+    )
+
+    class Role(Model, sqla.FsRoleMixin):
+        __tablename__ = "myrole"
+
+    class WebAuthn(Model, sqla.FsWebAuthnMixin):
+        __tablename__ = "mywebauthn"
+
+    class User(Model, sqla.FsUserMixin):
+        __tablename__ = "myuser"
+
+    with app.app_context():
+        Model.metadata.create_all(db.engine)
+
+    ds = FSQLALiteUserDatastore(db, User, Role, WebAuthn)
+    app.security = Security(app, datastore=ds)
+
+    with app.app_context():
+        ds.create_role(name="r1")
+        ds.create_user(email="me@lp.com", roles=["r1"])
+        ds.commit()
+        user = ds.find_user(email="me@lp.com")
+        assert user
+        Model.metadata.drop_all(db.engine)
diff -pruN 5.4.3-1/tests/test_hashing.py 5.5.0-1/tests/test_hashing.py
--- 5.4.3-1/tests/test_hashing.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_hashing.py	2024-07-24 02:21:26.000000000 +0000
@@ -3,6 +3,9 @@
     ~~~~~~~~~~~~
 
     hashing tests
+
+    :copyright: (c) 2019-2024 by J. Christopher Wagner (jwag).
+    :license: MIT, see LICENSE for more details.
 """
 
 import timeit
@@ -15,26 +18,33 @@ from passlib.hash import argon2, pbkdf2_
 from flask_security.utils import hash_password, verify_password, get_hmac
 
 
-def test_verify_password_bcrypt_double_hash(app, sqlalchemy_datastore):
+def test_verify_password_double_hash(app, sqlalchemy_datastore):
     init_app_with_options(
         app,
         sqlalchemy_datastore,
         **{
-            "SECURITY_PASSWORD_HASH": "bcrypt",
+            "SECURITY_PASSWORD_HASH": "argon2",
+            "SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS": {"argon2__rounds": 1},
             "SECURITY_PASSWORD_SALT": "salty",
             "SECURITY_PASSWORD_SINGLE_HASH": False,
         },
     )
     with app.app_context():
-        assert verify_password("pass", hash_password("pass"))
+        hashed_pwd = hash_password("pass")
+        assert verify_password("pass", hashed_pwd)
+        assert "t=1" in hashed_pwd
 
+        # Verify double hash
+        assert verify_password("pass", argon2.hash(get_hmac("pass")))
 
-def test_verify_password_bcrypt_single_hash(app, sqlalchemy_datastore):
+
+def test_verify_password_single_hash(app, sqlalchemy_datastore):
     init_app_with_options(
         app,
         sqlalchemy_datastore,
         **{
-            "SECURITY_PASSWORD_HASH": "bcrypt",
+            "SECURITY_PASSWORD_HASH": "argon2",
+            "SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS": {"argon2__rounds": 1},
             "SECURITY_PASSWORD_SALT": None,
             "SECURITY_PASSWORD_SINGLE_HASH": True,
         },
@@ -48,11 +58,12 @@ def test_verify_password_single_hash_lis
         app,
         sqlalchemy_datastore,
         **{
-            "SECURITY_PASSWORD_HASH": "bcrypt",
+            "SECURITY_PASSWORD_HASH": "argon2",
+            "SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS": {"argon2__rounds": 1},
             "SECURITY_PASSWORD_SALT": "salty",
             "SECURITY_PASSWORD_SINGLE_HASH": ["django_pbkdf2_sha256", "plaintext"],
             "SECURITY_PASSWORD_SCHEMES": [
-                "bcrypt",
+                "argon2",
                 "pbkdf2_sha256",
                 "django_pbkdf2_sha256",
                 "plaintext",
@@ -73,9 +84,10 @@ def test_verify_password_backward_compat
         app,
         sqlalchemy_datastore,
         **{
-            "SECURITY_PASSWORD_HASH": "bcrypt",
+            "SECURITY_PASSWORD_HASH": "argon2",
+            "SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS": {"argon2__rounds": 1},
             "SECURITY_PASSWORD_SINGLE_HASH": False,
-            "SECURITY_PASSWORD_SCHEMES": ["bcrypt", "plaintext"],
+            "SECURITY_PASSWORD_SCHEMES": ["argon2", "plaintext"],
         },
     )
     with app.app_context():
@@ -85,26 +97,15 @@ def test_verify_password_backward_compat
         assert verify_password("pass", plaintext.hash("pass"))
 
 
-def test_verify_password_bcrypt_rounds_too_low(app, sqlalchemy_datastore):
-    with raises(ValueError) as exc_msg:
-        init_app_with_options(
-            app,
-            sqlalchemy_datastore,
-            **{
-                "SECURITY_PASSWORD_HASH": "bcrypt",
-                "SECURITY_PASSWORD_SALT": "salty",
-                "SECURITY_PASSWORD_HASH_OPTIONS": {"bcrypt": {"rounds": 3}},
-            },
-        )
-    assert all(s in str(exc_msg.value) for s in ["rounds", "too low"])
-
-
 def test_login_with_bcrypt_enabled(app, sqlalchemy_datastore):
     init_app_with_options(
         app,
         sqlalchemy_datastore,
         **{
             "SECURITY_PASSWORD_HASH": "bcrypt",
+            "SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS": {
+                "bcrypt__rounds": 4,  # minimum so test is faster
+            },
             "SECURITY_PASSWORD_SALT": "salty",
             "SECURITY_PASSWORD_SINGLE_HASH": False,
         },
@@ -119,28 +120,13 @@ def test_missing_hash_salt_option(app, s
             app,
             sqlalchemy_datastore,
             **{
-                "SECURITY_PASSWORD_HASH": "bcrypt",
+                "SECURITY_PASSWORD_HASH": "argon2",
                 "SECURITY_PASSWORD_SALT": None,
                 "SECURITY_PASSWORD_SINGLE_HASH": False,
             },
         )
 
 
-def test_verify_password_argon2(app, sqlalchemy_datastore):
-    init_app_with_options(
-        app,
-        sqlalchemy_datastore,
-        **{"SECURITY_PASSWORD_HASH": "argon2", "SECURITY_PASSWORD_SINGLE_HASH": False},
-    )
-    with app.app_context():
-        hashed_pwd = hash_password("pass")
-        assert verify_password("pass", hashed_pwd)
-        assert "t=10" in hashed_pwd
-
-        # Verify double hash
-        assert verify_password("pass", argon2.hash(get_hmac("pass")))
-
-
 def test_verify_password_argon2_opts(app, sqlalchemy_datastore):
     init_app_with_options(
         app,
@@ -148,7 +134,7 @@ def test_verify_password_argon2_opts(app
         **{
             "SECURITY_PASSWORD_HASH": "argon2",
             "SECURITY_PASSWORD_HASH_PASSLIB_OPTIONS": {
-                "argon2__rounds": 4,
+                "argon2__rounds": 1,
                 "argon2__salt_size": 16,
                 "argon2__hash_len": 16,
             },
@@ -156,7 +142,7 @@ def test_verify_password_argon2_opts(app
     )
     with app.app_context():
         hashed_pwd = hash_password("pass")
-        assert "t=4" in hashed_pwd
+        assert "t=1" in hashed_pwd
         assert verify_password("pass", hashed_pwd)
 
 
diff -pruN 5.4.3-1/tests/test_misc.py 5.5.0-1/tests/test_misc.py
--- 5.4.3-1/tests/test_misc.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_misc.py	2024-07-24 02:21:26.000000000 +0000
@@ -292,11 +292,11 @@ def test_change_hash_type(app, sqlalchem
         **{
             "SECURITY_PASSWORD_HASH": "plaintext",
             "SECURITY_PASSWORD_SALT": None,
-            "SECURITY_PASSWORD_SCHEMES": ["bcrypt", "plaintext"],
+            "SECURITY_PASSWORD_SCHEMES": ["argon2", "plaintext"],
         },
     )
 
-    app.config["SECURITY_PASSWORD_HASH"] = "bcrypt"
+    app.config["SECURITY_PASSWORD_HASH"] = "argon2"
     app.config["SECURITY_PASSWORD_SALT"] = "salty"
 
     app.security = Security(
@@ -1079,6 +1079,24 @@ def test_authn_freshness_grace(app, clie
 
 
 def test_authn_freshness_nc(app, client_nc, get_message):
+    # By default, auth token carries the fs_paa time.
+    @auth_required(within=30)
+    def myview():
+        return Response(status=200)
+
+    app.add_url_rule("/myview", view_func=myview, methods=["GET"])
+
+    response = json_authenticate(client_nc)
+    token = response.json["response"]["user"]["authentication_token"]
+    h = {"Authentication-Token": token}
+
+    # This should fail - should be a redirect
+    response = client_nc.get("/myview", headers=h, follow_redirects=False)
+    assert response.status_code == 200
+
+
+@pytest.mark.settings(freshness_allow_auth_token=False)
+def test_authn_freshness_nc_no(app, client_nc, get_message):
     # If don't send session cookie - then freshness always fails
     @auth_required(within=30)
     def myview():
diff -pruN 5.4.3-1/tests/test_recoverable.py 5.5.0-1/tests/test_recoverable.py
--- 5.4.3-1/tests/test_recoverable.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_recoverable.py	2024-07-24 02:21:26.000000000 +0000
@@ -354,7 +354,7 @@ def test_bad_reset_token(client, get_mes
     assert get_message("INVALID_RESET_PASSWORD_TOKEN") in response.data
 
 
-def test_reset_token_deleted_user(app, client, get_message, sqlalchemy_datastore):
+def test_reset_token_deleted_user(app, client, get_message):
     with capture_reset_password_requests() as requests:
         client.post("/reset", data=dict(email="gene@lp.com"), follow_redirects=True)
 
@@ -364,8 +364,8 @@ def test_reset_token_deleted_user(app, c
     with app.app_context():
         # load user (and role) to get into session so cascade delete works.
         user = app.security.datastore.find_user(email="gene@lp.com")
-        sqlalchemy_datastore.delete(user)
-        sqlalchemy_datastore.commit()
+        app.security.datastore.delete(user)
+        app.security.datastore.commit()
 
     response = client.post(
         "/reset/" + token,
diff -pruN 5.4.3-1/tests/test_recovery_codes.py 5.5.0-1/tests/test_recovery_codes.py
--- 5.4.3-1/tests/test_recovery_codes.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_recovery_codes.py	2024-07-24 02:21:26.000000000 +0000
@@ -4,7 +4,7 @@
 
     recovery code tests
 
-    :copyright: (c) 2022-2023 by J. Christopher Wagner (jwag).
+    :copyright: (c) 2022-2024 by J. Christopher Wagner (jwag).
     :license: MIT, see LICENSE for more details.
 """
 
@@ -24,9 +24,10 @@ pytestmark = pytest.mark.two_factor()
 
 
 @pytest.mark.settings(multi_factor_recovery_codes=True)
-def test_rc_json(app, client, get_message):
+def test_rc_json(app, clients, get_message):
     # Test recovery codes
     # gal has two-factor already setup for 'sms'
+    client = clients
     headers = {"Accept": "application/json", "Content-Type": "application/json"}
     tf_authenticate(app, client)
 
diff -pruN 5.4.3-1/tests/test_registerable.py 5.5.0-1/tests/test_registerable.py
--- 5.4.3-1/tests/test_registerable.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_registerable.py	2024-07-24 02:21:26.000000000 +0000
@@ -18,15 +18,13 @@ from tests.test_utils import (
     logout,
 )
 
-from flask_security import Security
-from flask_security.core import UserMixin
+from flask_security import Security, UserMixin, user_registered, user_not_registered
 from flask_security.forms import (
     ConfirmRegisterForm,
     RegisterForm,
     StringField,
     _default_field_labels,
 )
-from flask_security.signals import user_registered, user_not_registered
 from flask_security.utils import localize_callback
 
 pytestmark = pytest.mark.registerable()
@@ -517,7 +515,8 @@ def test_form_error(app, client, get_mes
 
 @pytest.mark.settings(username_enable=True)
 @pytest.mark.unified_signin()
-def test_username(app, client, get_message):
+def test_username(app, clients, get_message):
+    client = clients
     data = dict(
         email="dude@lp.com",
         username="dude",
diff -pruN 5.4.3-1/tests/test_two_factor.py 5.5.0-1/tests/test_two_factor.py
--- 5.4.3-1/tests/test_two_factor.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_two_factor.py	2024-07-24 02:21:26.000000000 +0000
@@ -8,9 +8,10 @@
     :license: MIT, see LICENSE for more details.
 """
 
-from datetime import timedelta
+from datetime import date, timedelta
 import re
 
+from freezegun import freeze_time
 import markupsafe
 from passlib.totp import TOTP
 import pytest
@@ -19,6 +20,7 @@ from flask_security import (
     SQLAlchemyUserDatastore,
     SmsSenderFactory,
     reset_password_instructions_sent,
+    tf_profile_changed,
     uia_email_mapper,
 )
 from tests.test_utils import (
@@ -33,6 +35,7 @@ from tests.test_utils import (
     get_form_input,
     get_session,
     is_authenticated,
+    json_authenticate,
     logout,
 )
 
@@ -302,9 +305,10 @@ def test_two_factor_illegal_state(app, c
 
 
 @pytest.mark.settings(two_factor_required=True)
-def test_two_factor_flag(app, client, get_message):
+def test_two_factor_flag(app, clients, get_message):
     # trying to verify code without going through two-factor
     # first login function
+    client = clients
     wrong_code = b"000000"
     response = client.post(
         "/tf-validate", data=dict(code=wrong_code), follow_redirects=True
@@ -868,6 +872,130 @@ def test_opt_in(app, client, get_message
         assert signalled_identity[0] == user.fs_uniquifier
 
 
+def test_opt_in_nc(app, client_nc, get_message):
+    """
+    Test tf-setup without cookies
+    """
+    response = json_authenticate(client_nc, "jill@lp.com")
+    assert response.status_code == 200
+    token = response.json["response"]["user"]["authentication_token"]
+    headers = {"Authentication-Token": token, "Accept": "application/json"}
+
+    sms_sender = SmsSenderFactory.createSender("test")
+    data = dict(setup="sms", phone="+442083661177")
+    response = client_nc.post("/tf-setup", json=data, headers=headers)
+    assert response.status_code == 200
+    state_token = response.json["response"]["tf_state_token"]
+    assert sms_sender.get_count() == 1
+    code = sms_sender.messages[0].split()[-1]
+
+    # send bad token
+    response = client_nc.post(
+        "/tf-setup/not-a-token", json=dict(code=code), headers=headers
+    )
+    assert response.status_code == 400
+    assert response.json["response"]["errors"][0].encode("utf-8") == get_message(
+        "API_ERROR"
+    )
+
+    # send bad code
+    response = client_nc.post(
+        f"/tf-setup/{state_token}", json=dict(code=12345), headers=headers
+    )
+    assert response.status_code == 400
+    assert response.json["response"]["errors"][0].encode("utf-8") == get_message(
+        "TWO_FACTOR_INVALID_TOKEN"
+    )
+
+    # Validate token - this should complete 2FA setup
+    @tf_profile_changed.connect_via(app)
+    def pc(sender, user, method, **kwargs):
+        assert method == "sms"
+        assert user.tf_phone_number == "+442083661177"
+
+    response = client_nc.post(
+        f"/tf-setup/{state_token}", json=dict(code=code), headers=headers
+    )
+    assert response.status_code == 200
+
+    response = client_nc.get("/tf-setup", headers=headers)
+    assert response.json["response"]["tf_method"] == "sms"
+    assert response.json["response"]["tf_phone_number"] == "+442083661177"
+
+
+def test_opt_in_nc_expired(app, client_nc, get_message):
+    """
+    Test tf-setup without cookies - expired token
+    """
+    with freeze_time(
+        date.today() + timedelta(days=-1)
+    ):  # older than TWO_FACTOR_SETUP_WITHIN
+        response = json_authenticate(client_nc, "jill@lp.com")
+        assert response.status_code == 200
+        token = response.json["response"]["user"]["authentication_token"]
+        headers = {"Authentication-Token": token, "Accept": "application/json"}
+
+        sms_sender = SmsSenderFactory.createSender("test")
+        data = dict(setup="sms", phone="+442083661177")
+        response = client_nc.post("/tf-setup", json=data, headers=headers)
+        assert response.status_code == 200
+        state_token = response.json["response"]["tf_state_token"]
+    assert sms_sender.get_count() == 1
+    code = sms_sender.messages[0].split()[-1]
+
+    # Validate token - this should complete 2FA setup
+    response = client_nc.post(
+        f"/tf-setup/{state_token}", json=dict(code=code), headers=headers
+    )
+    assert response.status_code == 400
+    assert response.json["response"]["errors"][0].encode("utf-8") == get_message(
+        "TWO_FACTOR_SETUP_EXPIRED",
+        within=app.config["SECURITY_TWO_FACTOR_SETUP_WITHIN"],
+    )
+
+
+def test_opt_in_state_token(app, client, get_message):
+    """
+    Test using forms and new state_token approach (rather than sessions to store
+    intermediate state)
+    """
+    authenticate(client, "jill@lp.com")
+
+    # opt-in for SMS 2FA
+    sms_sender = SmsSenderFactory.createSender("test")
+    data = dict(setup="sms", phone="+442083661177")
+    response = client.post("/tf-setup", data=data, follow_redirects=True)
+    assert b"Enter code to complete setup" in response.data
+    assert sms_sender.get_count() == 1
+    code = sms_sender.messages[0].split()[-1]
+    verify_url = get_form_action(response, 1)  # this will be with state_token
+
+    # send in bad token
+    response = client.post(
+        "/tf-setup/not-a-token", data=dict(code=code), follow_redirects=True
+    )
+    assert check_location(app, response.history[0].location, "/tf-setup")
+    assert get_message("API_ERROR") in response.data
+
+    # send in bad code
+    response = client.post(verify_url, data=dict(code=12345), follow_redirects=True)
+    assert check_location(app, response.history[0].location, "/tf-setup")
+    assert get_message("TWO_FACTOR_INVALID_TOKEN") in response.data
+
+    # Validate token - this should complete 2FA setup
+    response = client.post(verify_url, data=dict(code=code), follow_redirects=True)
+    assert b"You successfully changed" in response.data
+    assert check_location(app, response.history[0].location, "/tf-setup")
+
+    # Upon completion, session cookie shouldn't have any two factor stuff in it.
+    session = get_session(response)
+    assert not tf_in_session(session)
+
+    response = client.get("/tf-setup")
+    assert b"Disable two factor" in response.data
+    assert b"Currently setup two-factor method: SMS" in response.data
+
+
 def test_opt_out_json(app, client):
     headers = {"Accept": "application/json", "Content-Type": "application/json"}
 
@@ -986,8 +1114,9 @@ def test_admin_setup_reset(app, client,
 
 
 @pytest.mark.settings(two_factor_required=True)
-def test_datastore(app, client, get_message):
+def test_datastore(app, clients, get_message):
     # Test that user record is properly set after proper 2FA setup.
+    client = clients
     sms_sender = SmsSenderFactory.createSender("test")
     data = dict(email="gene@lp.com", password="password")
     response = client.post(
@@ -1208,6 +1337,7 @@ def test_bad_sender(app, client, get_mes
 
 def test_replace_send_code(app, get_message):
     pytest.importorskip("sqlalchemy")
+    pytest.importorskip("flask_sqlalchemy")
 
     # replace tf_send_code - and have it return an error to check that.
     from flask_sqlalchemy import SQLAlchemy
@@ -1362,6 +1492,7 @@ def test_setup_nofresh(app, client, get_
 @pytest.mark.settings(two_factor_enabled_methods=["email"])
 def test_no_sms(app, get_message):
     pytest.importorskip("sqlalchemy")
+    pytest.importorskip("flask_sqlalchemy")
 
     # Make sure that don't require tf_phone_number if SMS isn't an option.
     from sqlalchemy import (
@@ -1407,29 +1538,24 @@ def test_no_sms(app, get_message):
     app.security = Security(app, datastore=ds)
 
     with app.app_context():
-        client = app.test_client()
-
         ds.create_user(
             email="trp@lp.com",
             password=hash_password("password"),
         )
         ds.commit()
 
-        data = dict(email="trp@lp.com", password="password")
-        client.post("/login", data=data, follow_redirects=True)
+    client = app.test_client()
+    data = dict(email="trp@lp.com", password="password")
+    client.post("/login", data=data, follow_redirects=True)
 
-        response = client.post(
-            "/tf-setup", data=dict(setup="email"), follow_redirects=True
-        )
-        msg = b"Enter code to complete setup"
-        assert msg in response.data
+    response = client.post("/tf-setup", data=dict(setup="email"), follow_redirects=True)
+    msg = b"Enter code to complete setup"
+    assert msg in response.data
 
-        code = app.mail.outbox[0].body.split()[-1]
-        # submit right token and show appropriate response
-        response = client.post(
-            "/tf-validate", data=dict(code=code), follow_redirects=True
-        )
-        assert b"You successfully changed your two-factor method" in response.data
+    code = app.mail.outbox[0].body.split()[-1]
+    # submit right token and show appropriate response
+    response = client.post("/tf-validate", data=dict(code=code), follow_redirects=True)
+    assert b"You successfully changed your two-factor method" in response.data
 
 
 @pytest.mark.settings(two_factor_post_setup_view="/post_setup_view")
@@ -1505,3 +1631,92 @@ def test_setup_csrf_header(app, client):
         "tf-setup", json=dict(setup="disable"), headers={"X-CSRF-Token": csrf_token}
     )
     assert response.status_code == 200
+
+
+@pytest.mark.csrf(csrfprotect=True)
+@pytest.mark.settings(CSRF_COOKIE_NAME="XSRF-Token")
+def test_csrf_2fa_login_cookie(app, client):
+    # Use XSRF-Token cookie for entire login sequence
+    sms_sender = SmsSenderFactory.createSender("test")
+    response = client.get(
+        "/login", data={}, headers={"Content-Type": "application/json"}
+    )
+    assert client.get_cookie("XSRF-Token")
+    csrf_token = response.json["response"]["csrf_token"]
+    assert csrf_token == client.get_cookie("XSRF-Token").value
+
+    response = client.post(
+        "/login",
+        json=dict(email="gal@lp.com", password="password"),
+        headers={
+            "Content-Type": "application/json",
+            "X-CSRF-Token": client.get_cookie("XSRF-Token").value,
+        },
+    )
+    assert b'"code": 200' in response.data
+    session = get_session(response)
+    assert session["tf_state"] == "ready"
+
+    assert sms_sender.get_count() == 1
+    code = sms_sender.messages[0].split()[-1]
+
+    response = client.post(
+        "/tf-validate",
+        json=dict(code=code),
+        headers={
+            "Content-Type": "application/json",
+            "X-CSRF-Token": client.get_cookie("XSRF-Token").value,
+        },
+    )
+    assert response.status_code == 200
+
+    # verify original session csrf_token still works.
+    response = client.post(
+        "/json_auth",
+        json=dict(label="label"),
+        headers={"Content-Type": "application/json", "X-CSRF-Token": csrf_token},
+    )
+    assert response.status_code == 200
+
+    # use XSRF_Cookie to send in csrf_token
+    response = client.post(
+        "/json_auth",
+        json=dict(label="label"),
+        headers={
+            "Content-Type": "application/json",
+            "X-CSRF-Token": client.get_cookie("XSRF-Token").value,
+        },
+    )
+    assert response.status_code == 200
+    assert response.json["label"] == "label"
+
+
+@pytest.mark.csrf(ignore_unauth=True, csrfprotect=True)
+@pytest.mark.settings(CSRF_COOKIE_NAME="XSRF-Token")
+def test_csrf_2fa_nounauth_cookie(app, client):
+    # use CSRF cookie when ignoring unauth endpoints
+    sms_sender = SmsSenderFactory.createSender("test")
+    response = client.post(
+        "/login",
+        json=dict(email="gal@lp.com", password="password"),
+        headers={"Content-Type": "application/json"},
+    )
+
+    code = sms_sender.messages[0].split()[-1]
+    response = client.post(
+        "/tf-validate",
+        json=dict(code=code),
+        headers={"Content-Type": "application/json"},
+    )
+    assert response.status_code == 200
+
+    response = client.post(
+        "/json_auth",
+        json=dict(label="label"),
+        headers={
+            "Content-Type": "application/json",
+            "X-CSRF-Token": client.get_cookie("XSRF-Token").value,
+        },
+    )
+    assert response.status_code == 200
+    assert response.json["label"] == "label"
diff -pruN 5.4.3-1/tests/test_unified_signin.py 5.5.0-1/tests/test_unified_signin.py
--- 5.4.3-1/tests/test_unified_signin.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_unified_signin.py	2024-07-24 02:21:26.000000000 +0000
@@ -4,7 +4,7 @@
 
     Unified signin tests
 
-    :copyright: (c) 2019-2023 by J. Christopher Wagner (jwag).
+    :copyright: (c) 2019-2024 by J. Christopher Wagner (jwag).
     :license: MIT, see LICENSE for more details.
 
 """
@@ -29,9 +29,11 @@ from tests.test_utils import (
     check_location,
     check_xlation,
     get_form_action,
+    get_session,
     is_authenticated,
     logout,
     reset_fresh,
+    reset_fresh_auth_token,
     setup_tf_sms,
 )
 from tests.test_webauthn import HackWebauthnUtil, reg_2_keys
@@ -557,20 +559,25 @@ def test_admin_setup_reset(app, client_n
 
 
 @pytest.mark.settings(post_login_view="/post_login")
-def test_get_already_authenticated(client):
+def test_get_already_authenticated(app, client):
     response = authenticate(client, follow_redirects=True)
     assert b"Welcome matt@lp.com" in response.data
-    response = client.get("/us-signin", follow_redirects=True)
+    # This should ignore next
+    response = client.get("/us-signin?next=/page1", follow_redirects=True)
     assert b"Post Login" in response.data
 
+    # should still get extra goodies
+    headers = {"Accept": "application/json", "Content-Type": "application/json"}
+    response = client.get("/us-signin", headers=headers)
+    assert response.status_code == 200
 
-@pytest.mark.settings(post_login_view="/post_login")
-def test_get_already_authenticated_next(client):
-    response = authenticate(client, follow_redirects=True)
-    assert b"Welcome matt@lp.com" in response.data
-    # This should override post_login_view
-    response = client.get("/us-signin?next=/page1", follow_redirects=True)
-    assert b"Page 1" in response.data
+    jresponse = response.json["response"]
+    assert all(
+        a in jresponse
+        for a in ["code_methods", "identity_attributes", "available_methods"]
+    )
+    assert "authentication_token" not in jresponse["user"]
+    assert all(a in jresponse["user"] for a in ["email", "last_update"])
 
 
 @pytest.mark.settings(post_login_view="/post_login")
@@ -580,12 +587,6 @@ def test_post_already_authenticated(clie
     data = dict(email="matt@lp.com", password="password")
     response = client.post("/us-signin", data=data, follow_redirects=True)
     assert b"Post Login" in response.data
-    response = client.post("/us-signin?next=/page1", data=data, follow_redirects=True)
-    assert b"Page 1" in response.data
-    # should work in form as well
-    ndata = dict(email="matt@lp.com", password="password", next="/page1")
-    response = client.post("/us-signin", data=ndata, follow_redirects=True)
-    assert b"Page 1" in response.data
 
     headers = {"Accept": "application/json", "Content-Type": "application/json"}
     response = client.post("/us-signin", json=data, headers=headers)
@@ -716,7 +717,8 @@ def test_verify_link_spa(app, client, ge
     assert is_authenticated(client, get_message)
 
 
-def test_setup(app, client, get_message):
+def test_setup(app, clients, get_message):
+    client = clients
     set_email(app)
     us_authenticate(client)
     response = client.get("us-setup")
@@ -871,9 +873,11 @@ def test_setup_json(app, client_nc, get_
     user_identity_attributes=UIA_EMAIL_PHONE,
 )
 def test_setup_json_no_session(app, client_nc, get_message):
-    # Test that with normal config freshness is required so must have session.
+    # Test that with normal config freshness is required and we can use auth_token
+    # for that
     set_email(app)
-    token = us_authenticate(client_nc)
+    us_authenticate(client_nc)
+    token = reset_fresh_auth_token(app, app.config["SECURITY_FRESHNESS"])
     headers = {
         "Authentication-Token": token,
         "Accept": "application/json",
@@ -884,6 +888,26 @@ def test_setup_json_no_session(app, clie
     assert response.json["response"]["reauth_required"]
     assert "WWW-Authenticate" not in response.headers
 
+    # re-verify
+    client_nc.post(
+        "/us-verify/send-code",
+        json=dict(identity="matt@lp.com", chosen_method="email"),
+        headers=headers,
+    )
+    outbox = app.mail.outbox
+    matcher = re.match(r".*Token:(\d+).*", outbox[1].body, re.IGNORECASE | re.DOTALL)
+    code = matcher.group(1)
+    response = client_nc.post(
+        "/us-verify?include_auth_token", json=dict(passcode=code), headers=headers
+    )
+    assert response.status_code == 200
+    token = response.json["response"]["user"]["authentication_token"]
+    headers["Authentication-Token"] = token
+
+    # should work now
+    response = client_nc.get("/us-setup", headers=headers)
+    assert response.status_code == 200
+
 
 @pytest.mark.settings(api_enabled_methods=["basic"])
 def test_setup_basic(app, client, get_message):
@@ -982,7 +1006,8 @@ def test_unique_phone(app, client, get_m
 
 
 @pytest.mark.settings(freshness=timedelta(minutes=0))
-def test_verify(app, client, get_message):
+def test_verify(app, clients, get_message):
+    client = clients
     # Test setup when re-authenticate required
     # With  freshness set to 0 - the first call should require reauth (by
     # redirecting); but the second should work due to grace period.
@@ -1636,6 +1661,7 @@ def test_bad_sender(app, client, get_mes
 @pytest.mark.registerable()
 def test_replace_send_code(app, get_message):
     pytest.importorskip("sqlalchemy")
+    pytest.importorskip("flask_sqlalchemy")
 
     from flask_sqlalchemy import SQLAlchemy
     from flask_security.models import fsqla_v2 as fsqla
@@ -1660,19 +1686,18 @@ def test_replace_send_code(app, get_mess
     ds = SQLAlchemyUserDatastore(db, User, Role)
     app.security = Security(app, datastore=ds)
 
-    with app.app_context():
-        client = app.test_client()
+    client = app.test_client()
+
+    # since we don't use client fixture - have to add user
+    data = dict(email="trp@lp.com", password="password")
+    response = client.post("/register", data=data, follow_redirects=True)
+    assert b"Welcome trp@lp.com" in response.data
+    logout(client)
 
-        # since we don't use client fixture - have to add user
-        data = dict(email="trp@lp.com", password="password")
-        response = client.post("/register", data=data, follow_redirects=True)
-        assert b"Welcome trp@lp.com" in response.data
-        logout(client)
-
-        set_phone(app, email="trp@lp.com")
-        data = dict(identity="trp@lp.com", chosen_method="sms")
-        response = client.post("/us-signin/send-code", data=data, follow_redirects=True)
-        assert b"Code has been sent" in response.data
+    set_phone(app, email="trp@lp.com")
+    data = dict(identity="trp@lp.com", chosen_method="sms")
+    response = client.post("/us-signin/send-code", data=data, follow_redirects=True)
+    assert b"Code has been sent" in response.data
 
 
 @pytest.mark.settings(us_enabled_methods=["password"])
@@ -2214,3 +2239,143 @@ def test_empty_password_xlate(app, clien
             ).encode()
             in response.data
         )
+
+
+@pytest.mark.two_factor()
+@pytest.mark.csrf(csrfprotect=True)
+@pytest.mark.settings(CSRF_COOKIE_NAME="XSRF-Token")
+def test_csrf_2fa_us_cookie(app, client):
+    # Use XSRF-Token cookie for entire login sequence
+    sms_sender = SmsSenderFactory.createSender("test")
+    response = client.get(
+        "/us-signin", data={}, headers={"Content-Type": "application/json"}
+    )
+    assert client.get_cookie("XSRF-Token")
+    csrf_token = response.json["response"]["csrf_token"]
+    assert csrf_token == client.get_cookie("XSRF-Token").value
+
+    # verify requires CSRF
+    response = client.post(
+        "/us-signin",
+        json=dict(identity="gal@lp.com", passcode="password"),
+        headers={"Content-Type": "application/json"},
+    )
+    assert response.status_code == 400
+    assert response.json["response"]["errors"][0] == "The CSRF token is missing."
+
+    response = client.post(
+        "/us-signin",
+        json=dict(identity="gal@lp.com", passcode="password"),
+        headers={
+            "Content-Type": "application/json",
+            "X-CSRF-Token": client.get_cookie("XSRF-Token").value,
+        },
+    )
+    assert b'"code": 200' in response.data
+    session = get_session(response)
+    assert session["tf_state"] == "ready"
+
+    assert sms_sender.get_count() == 1
+    code = sms_sender.messages[0].split()[-1]
+
+    response = client.post(
+        "/tf-validate",
+        json=dict(code=code),
+        headers={
+            "Content-Type": "application/json",
+            "X-CSRF-Token": client.get_cookie("XSRF-Token").value,
+        },
+    )
+    assert response.status_code == 200
+
+    # verify original session csrf_token still works.
+    response = client.post(
+        "/json_auth",
+        json=dict(label="label"),
+        headers={"Content-Type": "application/json", "X-CSRF-Token": csrf_token},
+    )
+    assert response.status_code == 200
+
+    # use XSRF_Cookie to send in csrf_token
+    response = client.post(
+        "/json_auth",
+        json=dict(label="label"),
+        headers={
+            "Content-Type": "application/json",
+            "X-CSRF-Token": client.get_cookie("XSRF-Token").value,
+        },
+    )
+    assert response.status_code == 200
+    assert response.json["label"] == "label"
+
+
+@pytest.mark.settings(us_enabled_methods=["password", "email"])
+def test_us_setup_email(app, client, get_message):
+    set_email(app)
+    us_authenticate(client)
+    chosen_methods_choices = []
+
+    def recorder(template, us_setup_form, **kwargs):
+        chosen_methods_choices.extend(us_setup_form.chosen_method.choices)
+        return "ok"
+
+    app.security.render_template = recorder
+
+    client.get("/us-setup")
+
+    assert len(chosen_methods_choices) == 0
+
+
+@pytest.mark.settings(us_enabled_methods=["email", "authenticator"])
+def test_us_setup_authenticator(app, client, get_message):
+    set_email(app)
+    us_authenticate(client)
+    chosen_methods_choices = []
+
+    def recorder(template, us_setup_form, **kwargs):
+        chosen_methods_choices.extend(us_setup_form.chosen_method.choices)
+        return "ok"
+
+    app.security.render_template = recorder
+
+    client.get("/us-setup")
+
+    assert len(chosen_methods_choices) == 1
+    assert chosen_methods_choices[0][0] == "authenticator"
+
+
+@pytest.mark.settings(us_enabled_methods=["email", "sms"])
+def test_us_setup_sms(app, client, get_message):
+    set_email(app)
+    us_authenticate(client)
+    chosen_methods_choices = []
+
+    def recorder(template, us_setup_form, **kwargs):
+        chosen_methods_choices.extend(us_setup_form.chosen_method.choices)
+        return "ok"
+
+    app.security.render_template = recorder
+
+    client.get("/us-setup")
+
+    assert len(chosen_methods_choices) == 1
+    assert chosen_methods_choices[0][0] == "sms"
+
+
+@pytest.mark.settings(us_enabled_methods=["email", "sms", "authenticator"])
+def test_us_setup_authenticator_sms(app, client, get_message):
+    set_email(app)
+    us_authenticate(client)
+    chosen_methods_choices = []
+
+    def recorder(template, us_setup_form, **kwargs):
+        chosen_methods_choices.extend(us_setup_form.chosen_method.choices)
+        return "ok"
+
+    app.security.render_template = recorder
+
+    client.get("/us-setup")
+
+    assert len(chosen_methods_choices) == 2
+    assert chosen_methods_choices[0][0] == "authenticator"
+    assert chosen_methods_choices[1][0] == "sms"
diff -pruN 5.4.3-1/tests/test_utils.py 5.5.0-1/tests/test_utils.py
--- 5.4.3-1/tests/test_utils.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/test_utils.py	2024-07-24 02:21:26.000000000 +0000
@@ -12,15 +12,12 @@ from __future__ import annotations
 
 from contextlib import contextmanager
 import re
+import time
 
 from flask.json.tag import TaggedJSONSerializer
 from flask.signals import message_flashed
 
 from flask_security import Security, SmsSenderBaseClass, SmsSenderFactory, UserMixin
-from flask_security.datastore import (
-    SQLAlchemyUserDatastore,
-    SQLAlchemySessionUserDatastore,
-)
 from flask_security.signals import (
     login_instructions_sent,
     reset_password_instructions_sent,
@@ -173,6 +170,22 @@ def reset_fresh(client, within):
     return old_paa
 
 
+def reset_fresh_auth_token(app, within, email="matt@lp.com"):
+    # Assumes client authenticated.
+    # Returns a new auth token that will force the NEXT request,
+    # if protected with a freshness check to require a fresh authentication
+    with app.test_request_context("/"):
+        user = app.security.datastore.find_user(email=email)
+        tdata = dict(ver=str(5))
+        if hasattr(user, "fs_token_uniquifier"):
+            tdata["uid"] = str(user.fs_token_uniquifier)
+        else:
+            tdata["uid"] = str(user.fs_uniquifier)
+        tdata["fs_paa"] = time.time() - within.total_seconds() - 100
+        tdata["exp"] = int(app.config.get("SECURITY_TOKEN_EXPIRE_TIMESTAMP")(user))
+        return app.security.remember_token_serializer.dumps(tdata)
+
+
 def get_form_action(response, ordinal=0):
     # Return the URL that the form WOULD post to - this is useful to check
     # how our templates actually work (e.g. propagation of 'next')
@@ -278,21 +291,17 @@ def init_app_with_options(app, datastore
     populate_data(app)
 
 
-def get_num_queries(datastore):
-    """Return # of queries executed during test.
-    return None if datastore doesn't support this.
-    """
-    if is_sqlalchemy(datastore):
-        from flask_sqlalchemy.record_queries import get_recorded_queries
+@contextmanager
+def capture_queries(datastore):
+    from sqlalchemy import event
 
-        return len(get_recorded_queries())
-    return None
+    queries = []
 
+    @event.listens_for(datastore.db.session, "do_orm_execute")
+    def _do_orm_execute(orm_execute_state):
+        queries.append(orm_execute_state)
 
-def is_sqlalchemy(datastore):
-    return isinstance(datastore, SQLAlchemyUserDatastore) and not isinstance(
-        datastore, SQLAlchemySessionUserDatastore
-    )
+    yield queries
 
 
 class SmsTestSender(SmsSenderBaseClass):
diff -pruN 5.4.3-1/tests/view_scaffold.py 5.5.0-1/tests/view_scaffold.py
--- 5.4.3-1/tests/view_scaffold.py	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tests/view_scaffold.py	2024-07-24 02:21:26.000000000 +0000
@@ -27,18 +27,19 @@ import os
 import typing as t
 
 from flask import Flask, flash, render_template_string, request, session
-from flask_sqlalchemy import SQLAlchemy
 from flask_wtf import CSRFProtect
 
 from flask_security import (
     MailUtil,
     Security,
+    UserDatastore,
+    UserMixin,
     WebauthnUtil,
     auth_required,
     current_user,
     SQLAlchemyUserDatastore,
+    FSQLALiteUserDatastore,
 )
-from flask_security.models import fsqla_v3 as fsqla
 from flask_security.signals import (
     us_security_token_sent,
     tf_security_token_sent,
@@ -79,7 +80,77 @@ class FlashMailUtil(MailUtil):
 SET_LANG = False
 
 
-def create_app():
+def fsqla_datastore(app):
+    from flask_sqlalchemy import SQLAlchemy
+    from flask_security.models import fsqla_v3 as fsqla
+    from sqlalchemy_utils import database_exists, create_database
+
+    # Create database models and hook up.
+    app.config["SQLALCHEMY_TRACK_MODIFICATIONS"] = False
+    app.config.setdefault("SQLALCHEMY_DATABASE_URI", "sqlite:///:memory:")
+    db = SQLAlchemy(app)
+    fsqla.FsModels.set_db_info(db)
+
+    class Role(db.Model, fsqla.FsRoleMixin):
+        pass
+
+    class User(db.Model, fsqla.FsUserMixin):
+        pass
+
+    class WebAuthn(db.Model, fsqla.FsWebAuthnMixin):
+        pass
+
+    with app.app_context():
+        if not database_exists(db.engine.url):
+            create_database(db.engine.url)
+        db.create_all()
+    return SQLAlchemyUserDatastore(db, User, Role, WebAuthn)
+
+
+def fsqla_lite_datastore(app: Flask) -> FSQLALiteUserDatastore:
+    from sqlalchemy.orm import DeclarativeBase
+    from flask_sqlalchemy_lite import SQLAlchemy
+    from flask_security.models import sqla as sqla
+    from sqlalchemy_utils import database_exists, create_database
+
+    # Create database models and hook up.
+    app.config.setdefault("SQLALCHEMY_DATABASE_URI", "sqlite:///:memory:")
+
+    app.config |= {
+        "SQLALCHEMY_ENGINES": {
+            "default": {
+                "url": app.config["SQLALCHEMY_DATABASE_URI"],
+                "pool_pre_ping": True,
+            },
+        },
+    }
+    db = SQLAlchemy(app)
+
+    class Model(DeclarativeBase):
+        pass
+
+    sqla.FsModels.set_db_info(base_model=Model)
+
+    class Role(Model, sqla.FsRoleMixin):
+        __tablename__ = "role"
+        pass
+
+    class User(Model, sqla.FsUserMixin):
+        __tablename__ = "user"
+        pass
+
+    class WebAuthn(Model, sqla.FsWebAuthnMixin):
+        __tablename__ = "web_authn"  # N.B. this is name that Flask-SQLAlchemy gives.
+        pass
+
+    with app.app_context():
+        if not database_exists(db.engine.url):
+            create_database(db.engine.url)
+        Model.metadata.create_all(db.engine)
+    return FSQLALiteUserDatastore(db, User, Role, WebAuthn)
+
+
+def create_app() -> Flask:
     # Use real templates - not test templates...
     app = Flask("view_scaffold", template_folder="../")
     app.config["DEBUG"] = True
@@ -134,6 +205,7 @@ def create_app():
     # Turn on all features (except passwordless since that removes normal login)
     for opt in [
         "changeable",
+        "change_email",
         "recoverable",
         "registerable",
         "trackable",
@@ -159,24 +231,12 @@ def create_app():
             app.config[ev] = _find_bool(os.environ.get(ev))
 
     CSRFProtect(app)
-    # Create database models and hook up.
-    app.config["SQLALCHEMY_TRACK_MODIFICATIONS"] = False
-    app.config.setdefault("SQLALCHEMY_DATABASE_URI", "sqlite:///:memory:")
-    db = SQLAlchemy(app)
-    fsqla.FsModels.set_db_info(db)
-
-    class Role(db.Model, fsqla.FsRoleMixin):
-        pass
-
-    class User(db.Model, fsqla.FsUserMixin):
-        pass
-
-    class WebAuthn(db.Model, fsqla.FsWebAuthnMixin):
-        pass
 
     # Setup Flask-Security
-    user_datastore = SQLAlchemyUserDatastore(db, User, Role, WebAuthn)
-    app.security = Security(
+    # user_datastore = fsqla_datastore(app)
+    user_datastore = fsqla_lite_datastore(app)
+
+    security = Security(
         app,
         user_datastore,
         webauthn_util_cls=TestWebauthnUtil,
@@ -209,7 +269,9 @@ def create_app():
         pass
 
     @user_registered.connect_via(app)
-    def on_user_registered(myapp, user, confirm_token, **extra):
+    def on_user_registered(
+        myapp: Flask, user: UserMixin, confirm_token: str, **extra: dict[str, t.Any]
+    ) -> None:
         flash(f"To confirm {user.email} - go to /confirm/{confirm_token}")
 
     @user_not_registered.connect_via(app)
@@ -255,7 +317,7 @@ def create_app():
             {% include "security/_menu.html" %}
             """,
             email=current_user.email,
-            security=app.security,
+            security=security,
         )
 
     @app.route("/basicauth")
@@ -271,9 +333,11 @@ def create_app():
     return app
 
 
-def add_user(ds, email, password, roles):
+def add_user(
+    ds: UserDatastore, email: str, password: str, role_names: list[str]
+) -> None:
     pw = hash_password(password)
-    roles = [ds.find_or_create_role(rn) for rn in roles]
+    roles = [ds.find_or_create_role(rn) for rn in role_names]
     ds.commit()
     user = ds.create_user(
         email=email, password=pw, active=True, confirmed_at=naive_utcnow()
@@ -286,12 +350,12 @@ def add_user(ds, email, password, roles)
 
 if __name__ == "__main__":
     myapp = create_app()
+    security: Security = myapp.extensions["security"]
 
     with myapp.app_context():
-        myapp.security.datastore.db.create_all()
         test_acct = "test@test.com"
-        if not myapp.security.datastore.find_user(email=test_acct):
-            add_user(myapp.security.datastore, test_acct, "password", ["admin"])
+        if not security.datastore.find_user(email=test_acct):
+            add_user(security.datastore, test_acct, "password", ["admin"])
             print("Created User: {} with password {}".format(test_acct, "password"))
 
     myapp.run(port=5001)
diff -pruN 5.4.3-1/tox.ini 5.5.0-1/tox.ini
--- 5.4.3-1/tox.ini	2024-03-23 01:46:00.000000000 +0000
+++ 5.5.0-1/tox.ini	2024-07-24 02:21:26.000000000 +0000
@@ -1,6 +1,7 @@
 [tox]
+basepython = python3.11
 envlist =
-    py{38,39,310,311,312,py39}-{low,release}
+    py{39,310,311,312,py39}-{low,release}
     mypy
     async
     nowebauthn
@@ -10,7 +11,7 @@ envlist =
     docs
     coverage
     makedist
-skip_missing_interpreters = true
+skip_missing_interpreters = false
 
 [testenv]
 allowlist_externals = tox
@@ -22,14 +23,14 @@ commands =
     tox -e compile_catalog
     pytest -W ignore --basetemp={envtmpdir} {posargs:tests}
 
-[testenv:py{38,39,310,311,312}-release]
+[testenv:py{39,310,311,312}-release]
 deps =
     -r requirements/tests.txt
 commands =
     tox -e compile_catalog
     pytest --basetemp={envtmpdir} {posargs:tests}
 
-[testenv:py{38,39,310,311,312,py39}-low]
+[testenv:py{39,310,311,312,py39}-low]
 deps =
     pytest
 extras = low
@@ -45,6 +46,7 @@ deps =
     git+https://github.com/pallets/flask@main#egg=flask
     git+https://github.com/pallets/flask-sqlalchemy@main#egg=flask-sqlalchemy
     git+https://github.com/pallets/jinja@main#egg=jinja2
+    git+https://github.com/pallets-eco/flask-principal@main#egg=flask-principal
     git+https://github.com/wtforms/wtforms@master#egg=wtforms
     git+https://github.com/maxcountryman/flask-login@main#egg=flask-login
 commands =
@@ -52,7 +54,6 @@ commands =
     pytest --basetemp={envtmpdir} {posargs:tests}
 
 [testenv:async]
-basepython = python3.11
 deps =
     -r requirements/tests.txt
 commands =
@@ -61,7 +62,6 @@ commands =
     pytest --basetemp={envtmpdir} {posargs:tests}
 
 [testenv:nowebauthn]
-basepython = python3.9
 deps =
     -r requirements/tests.txt
 commands =
@@ -70,7 +70,6 @@ commands =
     pytest --basetemp={envtmpdir} {posargs:tests}
 
 [testenv:nobabel]
-basepython = python3.9
 deps =
     -r requirements/tests.txt
 commands =
@@ -78,7 +77,6 @@ commands =
     pytest --basetemp={envtmpdir} {posargs:tests}
 
 [testenv:noauthlib]
-basepython = python3.9
 deps =
     -r requirements/tests.txt
 commands =
@@ -86,8 +84,15 @@ commands =
     tox -e compile_catalog
     pytest --basetemp={envtmpdir} {posargs:tests}
 
+[testenv:noflasksqlalchemy]
+deps =
+    -r requirements/tests.txt
+commands =
+    pip uninstall -y flask_sqlalchemy flask_sqlalchemy_lite
+    tox -e compile_catalog
+    pytest --basetemp={envtmpdir} {posargs:tests}
+
 [testenv:style]
-basepython = python3.11
 deps = pre-commit
 skip_install = true
 commands =
@@ -95,13 +100,11 @@ commands =
     pre-commit run --all-files --show-diff-on-failure
 
 [testenv:docs]
-basepython = python3.11
 deps = -r requirements/docs.txt
 commands = sphinx-build -W -b html -d {envtmpdir}/doctrees docs {envtmpdir}/html
 
 
 [testenv:coverage]
-basepython = python3.11
 deps =
     -r requirements/tests.txt
 commands =
@@ -119,7 +122,6 @@ commands =
     pytest --basetemp={envtmpdir} {posargs}
 
 [testenv:makedist]
-basepython = python3.11
 deps =
     -r requirements/tests.txt
     build
@@ -132,12 +134,10 @@ commands =
     check-wheel-contents dist
 
 [testenv:mypy]
-basepython = python3.11
 deps =
     -r requirements/tests.txt
     types-setuptools
     mypy
-    sqlalchemy[mypy]
 commands =
     mypy --install-types --non-interactive flask_security tests
 
@@ -153,7 +153,7 @@ deps =
     jinja2
 skip_install = true
 commands =
-    pybabel extract --version 5.4.3 --keyword=_fsdomain --project=Flask-Security \
+    pybabel extract --version 5.5.0 --keyword=_fsdomain --project=Flask-Security \
         -o flask_security/translations/flask_security.pot \
         --msgid-bugs-address=jwag956@github.com --mapping-file=babel.ini \
         --add-comments=NOTE flask_security
